//教师成绩分析

//教师成绩列表
var chnNumChar = {
	零: 0,
	一: 1,
	二: 2,
	三: 3,
	四: 4,
	五: 5,
	六: 6,
	七: 7,
	八: 8,
	九: 9
};
var chnNameValue = {
	十: {
		value: 10,
		secUnit: false
	},
	百: {
		value: 100,
		secUnit: false
	},
	千: {
		value: 1000,
		secUnit: false
	},
	万: {
		value: 10000,
		secUnit: true
	},
	亿: {
		value: 100000000,
		secUnit: true
	}
}
//”一“=>”1“
function ChineseToNumber(chnStr) {
	var rtn = 0;
	var section = 0;
	var number = 1;
	var secUnit = false;
	var str = chnStr.split('');
	for(var i = 0; i < str.length; i++) {
		var num = chnNumChar[str[i]];
		if(typeof num !== 'undefined') {
			number = num;
			if(i === str.length - 1) {
				section += number;
			}
		} else {
			var unit = chnNameValue[str[i]].value;
			secUnit = chnNameValue[str[i]].secUnit;
			if(secUnit) {
				section = (section + number) * unit;
				rtn += section;
				section = 0;
			} else {
				section += (number * unit);
			}
			number = 0;
		}
	}
	return rtn + section;
}
//ChineseToNumber("一");
var teaAchieveIndex = (function (c, $) {
	var pageNo = 1;
	var pageSize = 10;
	var examType;
	var vmAchieveIdx = new Vue({
        el: '#teaAchieve',
        data: {
        	listData:[],
        	listType:[]
        },
        methods: {
        	goDetail:function(id,classId,grade,subjectId){
        		window.WebviewUtil.show('teaStuList', {
        			detailId:id,
        			classId:classId,
        			grade:grade,//统计用
        			subjectId:subjectId,//统计用
        		});
        	}
        },
        filters: {
        	dealGrade:function(val){
        		return val.substr(0,1);
        	},
        	dealClass:function(val){
        		return "("+ChineseToNumber(val.substr(0,val.length-1))+")"+val.substr(-1)
        	},
        }
    });
    
    //获取列表数据
	function getAchieveList(isDownRefresh) {
		if(isDownRefresh) { //下拉
			pageNo = 1;
			var obj = {
				pageNo:pageNo,
				pageSize:pageSize,
				examType:examType,
			}
			console.log('obj===='+JSON.stringify(obj))
			c.DataUtil.getListTestTeacher(obj, function(res) {
				plus.nativeUI.closeWaiting();
				console.log('【===成绩分析列表===】' + JSON.stringify(res));
				res = res || {};
				res.data.rows = res.data.rows || [];
				mui('#refreshContainer').pullRefresh().endPulldown(); //结束下拉
				if(res.success && res.data.rows.length) {
					maxPage = Math.ceil((res.data.records)/pageSize);
					vmAchieveIdx.listData = res.data.rows;
					mui('#refreshContainer').pullRefresh().refresh(true);//重置上拉加载
					if(maxPage == 1) { //无下一页数据
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
					}
				} else if(res.success && res.data.rows.length == 0) {
					vmAchieveIdx.listData = [];
					mui.toast('没有记录');
				} else {
					mui.toast(ERROR_CONFIG[res.SystemCode]);
					return;
				}
			}, function(xhr, type, error) {
				plus.nativeUI.closeWaiting();
				mui('#refreshContainer').pullRefresh().endPulldown(); //结束下拉刷新
				mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
				$.toast('服务器异常，请稍后重试！');
			});
		} else {
			pageNo++;
            var obj={
                pageNo:pageNo,
                pageSize:pageSize,
                examType:examType,
            }
            if(maxPage == 1){
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			c.DataUtil.getListTestTeacher(obj, function(res) {
				plus.nativeUI.closeWaiting();
				console.log('【===教师版成绩分析列表 下一页===】' + JSON.stringify(res));
				res = res || {};
				res.data.rows = res.data.rows || [];
				if(res.data.rows.length) {
					var temp = res.data.rows;
					vmAchieveIdx.listData = vmAchieveIdx.listData.concat(temp);
					if(maxPage<=pageNo){
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					}else{
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
					}
				} else {
					mui.toast(ERROR_CONFIG[res.SystemCode]);
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
				}
			},function(){
				plus.nativeUI.closeWaiting();
                plus.nativeUI.toast("请求出错");
			});
		}
	}
	
	function initPage(){
		plus.nativeUI.showWaiting();
		window.DataUtil.getTeaAchieveType(function(res) {
			plus.nativeUI.closeWaiting();
			console.log('===教师版成绩分析类型===' + JSON.stringify(res));
			vmAchieveIdx.listType = res.data.TEST_TYPE;
			examType = res.data.TEST_TYPE[0].dictValue;
			new BScroll('#topTabList', {
				scrollX: true
			});
		});
	}
	
	function bindEventHandler(){
		//tab点击
		mui("#topTabList").on('tap', '.mui-control-item', function() {
			var self = this;
			var tabList = self.parentNode.children;
			examType = self.dataset.target;
			for(var i = 0; i < tabList.length; i++) {
				tabList[i].classList.remove('active');
			}
			self.classList.add('active');
			getAchieveList(true);//作业考试试题
		});
	}
	
	return {
        init: function () {
            initPage();
            bindEventHandler();
        },
        getAchieveList:getAchieveList,
    }
})(window, mui);

var teaStuList = (function (c, $) {
	var classId,//班级id
		detailId,//详情id
		grade,//统计要的
		subjectId;//统计要的
	var _data;
	var vmStuList = new Vue({
        el: '#teaStuList',
        data: {
        	listData:[],
			topSize:'55px'
        },
		
        methods: {
        	goDetail:function(id){
        		console.log('id====studentId=='+id)
        		window.WebviewUtil.show('achieveDetail', {
	    			studentId:id,
	    		});
        	},
        	search:function(){
        		var value = document.getElementById('searchAll').value;
        		vmStuList.listData = searchFn(value,_data);
        		document.activeElement.blur();
				if(mui.os.ios){
				var target = document.getElementById("searchBox");
				target.style.top = vmStuList.topSize;
				}
        	},
			justPosition:function(e){
				// setTimeout(function(){
				// if(mui.os.ios&&document.body.scrollTop>120){
				// 	console.log("scrollTop"+document.body.scrollTop);
				// var target = document.getElementById("searchBox");
				// target.style.top = '7px'
				// }
				// if(mui.os.ios){
				// document.body.scrollTop-=200;
				// }
				// },500);
			},
			resetPosition:function(e){
				// if(mui.os.ios){
				// var target = document.getElementById("searchBox");
				// 
				// target.style.top = this.topSize;
				// }
			}
        },
        filters: {
        	
        }
    });
    
    function searchFn(val,arr){
    	return arr.filter(function(ele,index){
            return ele.studentName.indexOf(val) > -1
        })
    }
	function initPage(){
		plus.nativeUI.showWaiting();
		//教师班级学生列表
		c.DataUtil.getClassLists(detailId, function(data) {
			plus.nativeUI.closeWaiting();
			console.log('===教师班级学生列表===' + JSON.stringify(data));
			if (data.SystemCode==1) {
				vmStuList.listData = data.data;
				_data = data.data;
			} else{
				mui.toast(ERROR_CONFIG[data.SystemCode]);
				return;
			}
		}, function(xhr, type, error){
			plus.nativeUI.closeWaiting();
			mui.toast('服务器异常，请稍后重试！');
			return;
		})
	}
	function bindEventHandler(){
		document.getElementById('goStatistics').addEventListener('tap',function(){
			window.WebviewUtil.show('teastatistics', {
    			detailId:detailId,
				grade:grade,
				subjectId:subjectId,
    		});
		});
		window.addEventListener('touchmove', function(e) {
			if(mui.os.ios){
				console.log("touchmove:"+vmStuList.topSize);
			var target = document.getElementById("searchBox");
			if(target){
			target.style.top = vmStuList.topSize;
			}
			}
		}, true);
	}
	
	return {
        init: function () {
        	classId=plus.webview.currentWebview().classId;
			detailId=plus.webview.currentWebview().detailId;
			grade=plus.webview.currentWebview().grade;
			subjectId=plus.webview.currentWebview().subjectId;
            initPage();
            bindEventHandler();
        }
    }
})(window, mui);

var teaStatistics = (function (c, $) {
	var detailId,//详情id
		grade,//统计要的
		subjectId;//统计要的
	var vmStatistics = new Vue({
        el: '#Statistics',
        data: {
        	listData:[]
        },
        methods: {
        	
        },
        filters: {
        	
        }
    });
    function dealData(res){
    	res.data.forEach(function(item,idx,arr){
    		item.percent = 'percent'+idx;
    	})
    	return res;
    }
	function initPage() {
		plus.nativeUI.showWaiting();
		//班级成绩分析
		c.DataUtil.statisticsScore(detailId, grade, subjectId, function(data) {
			plus.nativeUI.closeWaiting();
			console.log('===班级成绩分析===' + JSON.stringify(data));
			data = dealData(data);
			if(data.SystemCode == 1) {
				vmStatistics.listData = data.data
			} else {
				mui.toast(ERROR_CONFIG[data.SystemCode]);
				return;
			}
		}, function(xhr, type, error) {
			plus.nativeUI.closeWaiting();
			mui.toast('服务器异常，请稍后重试！');
			return;
		})
	}
	function bindEventHandler(){
		
	}
	
	return {
        init: function () {
			detailId=plus.webview.currentWebview().detailId;
			grade=plus.webview.currentWebview().grade;
			subjectId=plus.webview.currentWebview().subjectId;
            initPage();
        }
    }
})(window, mui);


var TeaMarkIdx = (function(c, $) {
	var _data; //存储接口数据
	var personal = []; //个人得分
	var classname = []; //班级得分
	var gradename = []; //年级得分
	var indicator = []; //雷达图条目
	var gradeId, //详情id
		studentId; //学生id
	var userType = 1; //教师用户
	var personalScore = null, //个人得分
		classScore = null, //班级得分
		gradeScore = null; // 年级得分
	var personalPro = [], //个人进度条统计数组
		classPro = [], //班级进度条统计数组
		gradePro = []; //年级进度条统计数组
	var chartType = "2"; //1是条形图2是雷达图
	var activeType = "1"; //第一次进入默认’个人‘
	var userInfo;
	var vmAchieveDetail = new Vue({
        el: '#AchieveDetail',
        data: {
        	listData:[]
        },
        methods: {
        	
        },
        filters: {
        	
        }
    });
	//初始化页面
	function initPage() {
		plus.nativeUI.showWaiting();
		getRadarData();
	}
	//第一次进入展示页面
	function radiaDataHandler(res) {
		document.getElementById("m_markdetail").style.display = 'block';
		document.getElementById("studentName").innerText = res.data.studentAchievement.studentName;
		document.getElementById("classAndCode").innerHTML = res.data.studentAchievement.studentName + '&nbsp;&nbsp;' + res.data.studentAchievement.studentCode;
		personalScore = res.data.studentAchievement.countMark;
		classScore = res.data['classAchievement'].countMark;
		gradeScore = res.data['gradeAchievement'].countMark;
		console.log(personalScore + '====' + classScore + '===' + gradeScore)
		document.getElementById('type').innerText = '个人';
		document.getElementById('score').innerText = personalScore + '';
		res.data.studentAchievement.examQuestionsList.forEach(function(item, idx, arr) {
			personalPro.push({
				text: item.questionName,
				rate: item.goalRate,
				ptype:'ptype'+idx
			})
			item.goalRate = parseFloat(item.goalRate)
			personal.push(item.goalRate);
			indicator.push({
				text: item.questionName,
				max: 100
			})
		})
		console.log('===个人===' + JSON.stringify(personal));
		console.log('===个人进度条===' + JSON.stringify(personalPro));
		res.data.gradeAchievement.examQuestionsList.forEach(function(item, idx, arr) {
			gradePro.push({
				text: item.questionName,
				rate: item.goalRate,
				ptype:'ptype'+idx
			})
			item.goalRate = parseFloat(item.goalRate)
			gradename.push(item.goalRate);
		})
		console.log('===年级===' + JSON.stringify(gradename));
		console.log('===年级进度条===' + JSON.stringify(gradePro));
		res.data.classAchievement.examQuestionsList.forEach(function(item, idx, arr) {
			classPro.push({
				text: item.questionName,
				rate: item.goalRate,
				ptype:'ptype'+idx
			})
			item.goalRate = parseFloat(item.goalRate)
			classname.push(item.goalRate)
		})
		console.log('===班级===' + JSON.stringify(classname));
		console.log('===班级进度条===' + JSON.stringify(classPro));
		var color = '#3392fc';
		chartInit(personal, color);
		vmAchieveDetail.listData = personalPro;
	}

	function getBarData() {
		var res = {};
		_data = res;
		chartView("1", _data.data, activeType);
	}
	//获取雷达图
	function getRadarData() {
		c.DataUtil.achievementRadar(studentId, function(res) {
			plus.nativeUI.closeWaiting();
			console.log('===教师雷达图===' + JSON.stringify(res));
			_data = res;
			if(res.SystemCode == 1) {
				radiaDataHandler(_data);
			} else {
				mui.toast(ERROR_CONFIG[res.SystemCode]);
				return;
			}
		}, function(xhr, type, error) {
			plus.nativeUI.closeWaiting();
			document.getElementById("m_markdetail").innerHTML = '';
			mui.toast('服务器异常，请稍后重试！');
			return;
		})
	}

	var barKey = "product";
	var domain = "examQuestionsList";
	//画图
	function _drawBar(data, srcData) {
		var myChart;
		var domMain = document.getElementById('main');
		var option = {
			legend: {},
			tooltip: {},
			dataset: {
				dimensions: data.dimensions,
				source: data.source
			},
			xAxis: {
				type: 'category',
				axisLabel:{
					interval:0,
					rotate:45
				}
			},
			yAxis: {},
			series: data.series,
			color: ["#3392fc", "#6c5ed9", "#5fc62c"]
		};
		if(data.source.length>=10){
			option.dataZoom=[
		        {
		            id: 'dataZoomX',
		            type: 'slider',
		            xAxisIndex: [0],
		            filterMode: 'filter',
		        },
		    ];
		} else {
			option.dataZoom =[];
		}
		myChart = echarts.init(domMain);
		myChart.setOption(option, true);
	}

	function getDimensions(type) {
		if(type == "1") {
			return ['product', '个人'];
		} else if(type == "2") {
			return ['product', '班级'];
		} else if(type == "3") {
			return ['product', '年级'];
		} else {
			return ['product', '个人', '班级', '年级'];
		}
	}

	function _getArrItem(dimension, arr) {
		var ret = 0;
		if(arr && arr.length) {
			var temp = arr.filter(function(item) {
				return item.questionName == dimension;
			});
			if(temp && temp.length) {
				ret = temp[0].goalRate;
			}
		}
		return ret;
	}

	function getDimensionData(dimension, data) {
		var horizonMap = {
			"studentAchievement": "个人",
			"classAchievement": "班级",
			"gradeAchievement": "年级"
		};
		var domain = "examQuestionsList";
		var ret = {};
		ret[barKey] = dimension;
		var obj = {};
		var dataArr = [];
		var defaultArr = [];
		for(var i in data) {
			obj = data[i];
			dataArr = obj[domain];
			ret[horizonMap[i]] = _getArrItem(dimension, dataArr);
		}
		return ret;
	}

	function chartDataHandler(data, srcData) {
		var ret = [];
		var dataArr = [];
		var defaultArr = [];
		var dimensions = getXfiled(srcData);
		for(var i = 0; i < dimensions.length; i++) {
			var obj = getDimensionData(dimensions[i], data);
			ret.push(obj);
		}
		return ret;
	}
	//获取柱状图横轴项
	function getXfiled(data) {
		var ret = [];
		for(var i in data) {
			if(data[i][domain]) {
				ret = data[i][domain].sort(function(a, b) {
					return a.questionSort > b.questionSort;
				}).map(function(item) {
					return item.questionName
				});
				return ret;
			}
		}
		return ret;
	}
	//绘制柱状图
	function barchart(data, type) {
		var domianMap = {
			1: "studentAchievement",
			2: "classAchievement",
			3: "gradeAchievement"
		};
		var dimensions = getDimensions(type);
		var typeMap = {
			1: "个人",
			2: "班级",
			3: "年级"
		};
		var domainData = {};
		if(domianMap[type]) {
			domainData[domianMap[type]] = data[domianMap[type]];
		} else {
			domainData = data;
		}
		var series = [];
		var source = chartDataHandler(domainData, data);
		var len = dimensions.length;
		if(len && len > 1) {
			for(var i = 0; i < len - 1; i++) {
				series.push({
					type: 'bar'
				})
			}
		}
		_drawBar({
			dimensions: dimensions,
			source: source,
			series: series,
		}, data);
	}
	//雷达图
	function radiaChart(data, type) {
		if(type == '1') {
			var color = '#3392fc';
			chartInit(personal, color);
		} else if(type == '2') {
			var color = '#6c5ed9';
			chartInit(classname, color);
		} else if(type == '3') {
			var color = '#5fc62c'
			chartInit(gradename, color);
		} else {
			var params = {
				series: [{
					name: '雷达图',
					type: 'radar',
					data: [{
							value: personal,
							name: '成绩',
							lineStyle: {
								normal: {
									color: '#3392fc'
								}
							}
						},
						{
							value: classname,
							name: '成绩',
							lineStyle: {
								normal: {
									color: '#6c5ed9'
								}
							}
						},
						{
							value: gradename,
							name: '成绩',
							lineStyle: {
								normal: {
									color: '#5fc62c'
								}
							}
						}
					]
				}]
			};
			chartAllInit(params);
		}
	}

	function chartView(chartType, data, type) {
		if(chartType == "1") {
			barchart(data, type);
		} else {
			radiaChart(data, type);
		}
	}
	//“个人”，“班级”，“年级”-雷达图
	function chartInit(valuedata, color) {
		var myChart;
		var domMain = document.getElementById('main');
		var option = {
			title: {
				text: ''
			},
			tooltip: {
				trigger: 'axis'
			},
			legend: {
				data: ['']
			},
			radar: [{
					indicator: indicator,
					center: ['50%', '50%'],
					radius: 80,
					startAngle: 90,
					splitNumber: 4,
					shape: 'circle',
					name: {
						textStyle: {
							color: '#3392fc'
						},
						formatter: function(text) {
							text = text.replace(/\S{5}/g, function(match) {
								return match + '\n'
							})
							return '[' + text + ']'
						},
					},

				},
			],
			series: [{
				name: '雷达图',
				type: 'radar',
				data: [{
					value: valuedata,
					name: '成绩',
					lineStyle: {
						normal: {
							color: color
						}
					}

				}]
			}],

		};
		myChart = echarts.init(domMain);
		myChart.setOption(option, true);
	}

	//“对比”-雷达图
	function chartAllInit(data, personal, classname, gradename) {
		var myChart;
		var domMain = document.getElementById('main');
		var option = {
			title: {
				text: ''
			},
			tooltip: {
				trigger: 'axis'
			},
			legend: {
				data: ['']
			},
			radar: [{
					indicator: indicator,
					center: ['50%', '50%'],
					radius: 80,
					startAngle: 90,
					splitNumber: 4,
					shape: 'circle',
					name: {
						textStyle: {
							color: '#3392fc'
						},
						formatter: function(text) {
							text = text.replace(/\S{5}/g, function(match) {
								return match + '\n'
							})
							return '[' + text + ']'
						},
					},

				},

			],
			series: data.series
		};
		myChart = echarts.init(domMain);
		myChart.setOption(option, true);
	}

	//绑定事件
	function bindEventHandler() {
		mui("#chart").on('tap', '.list', function() {
			document.getElementById('avg').style.display = 'block';
			document.getElementById('avglist').style.display = 'block';
			var index = this.dataset.itemindex;
			var itemTarget = this.dataset.target;
			var tabList = document.getElementById('chart').getElementsByTagName('span');
			for(var i = 0; i < tabList.length; i++) {
				tabList[i].classList.remove('active');
			}
			tabList[index].classList.add('active');
			if(itemTarget == 'personal') {
				document.getElementById('score').innerText = personalScore + '';
				document.getElementById('type').innerText = '个人';
				vmAchieveDetail.listData = personalPro;
			} else if(itemTarget == 'classname') {
				document.getElementById('score').innerText = classScore + '';
				document.getElementById('type').innerText = '班级';
				vmAchieveDetail.listData = classPro;
			} else if(itemTarget == 'gradename') {
				document.getElementById('score').innerText = gradeScore + '';
				document.getElementById('type').innerText = '年级';
				vmAchieveDetail.listData = gradePro;
			} else {
				document.getElementById('avglist').style.display = 'none';
				document.getElementById('avg').style.display = 'none';
			}
			activeType = (parseInt(index) + 1).toString();
			chartView(chartType, _data.data, activeType);
		});

		document.getElementById('changeCharts').addEventListener('tap', function() {
			chartType = chartType == '2' ? '1' : '2';
			console.log('==chartType===' + chartType)
			chartView(chartType, _data.data, activeType);
		})
	}
	return {
		init: function() {
			userInfo = JSON.parse(plus.storage.getItem('userInfo'));
			console.log('userInfo=========='+JSON.stringify(userInfo))
			studentId = plus.webview.currentWebview().studentId;
			initPage();
			bindEventHandler();
		}
	}
})(window, mui);