/*
 *家长端课外练习列表
 * 
 * 
 * */

var mainIndex = (function(c, $) {
	var canNext = false;
	var pageNo = 1;
	var pageSize = 10;
	var total = 0;
	var ajaxName = 'ivityList';
	var vmAnList = new Vue({
		el: '#listContentMain',
		data: {
			picHost: IMAGE_GET_CONFIG,
			picHostOSS: IMAGE_GET_CONFIG_OSS,
			listData: [],
			ivityType: '',
		},
		methods: {
			goAdd: function() { //新增课外练习
				window.WebviewUtil.show('afterClassExerciseAdd');
			},
			goSummary: function() { //汇总
				window.WebviewUtil.show('goSummary');
			},
			goDetail: function(id) { //详情
				console.log(id);
				window.WebviewUtil.show('afterClassExerciseDetail', {
					detailId: id
				});
			},
		},
		computed: {

		},
		filters: {

		}
	});

	function getParams() {
		return {
			pageNo: pageNo,
			pageSize: pageSize,
			ivityType: vmAnList.ivityType,
		}
	}

	function setParams(val) {
		pageNo = val;
	}

	function hasNext() {
		return pageNo < total;
	}

	function initList(isDown) {
		if(isDown) {
			setParams(1);
			console.log('===getParams===' + JSON.stringify(getParams()));
			c.DataUtil[ajaxName](getParams(), function(data) {
				console.log('===家长端课外练习列表===' + JSON.stringify(data));
				data = data || {};
				total = data.total || 0;
				data.rows = data.rows || [];
				mui('#refreshContainer').pullRefresh().endPulldown();
				if(data.rows.length) {
					vmAnList.listData = data.rows;
					mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
					canNext = hasNext();
					if(!canNext) { //无下一页数据
						console.log("禁用上拉1");
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						console.log("禁用上拉2");
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
						setParams(pageNo + 1);
					}
				} else {
					console.log("禁用上拉3");
					mui.toast("没有记录");
					vmAnList.listData = [];
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
					canNext = false;
					$.toast(ERROR_CONFIG[data.SystemCode]);
					return;
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		} else {
			if(!canNext) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			c.DataUtil[ajaxName](getParams(), function(data) {
				console.log('==下一页==' + JSON.stringify(data));
				data = data || {};
				total = data.total || 0;
				data.rows = data.rows || [];
				if(data.rows.length) {
					vmAnList.listData = vmAnList.listData.concat(data.rows);
					canNext = hasNext();
					if(!canNext) {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					} else {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
						setParams(pageNo + 1);
					}
				} else {
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});

		}
	}

	function bindEvent() {
		mui('#refreshContainer').on('tap', '.j-cancel', function() { //删除
			var _that = this;
			var deleteId = _that.dataset.id;
			var index = _that.dataset.index;
			var li = _that.parentNode.parentNode;
			console.log('index====' + index);
			mui.confirm('确认删除该条课外作业？', '提示', ['确认', '取消'], function(e) {
				if(e.index == 1 || e.index == -1) {
					return;
				} else {
					$.swipeoutClose(li);
					window.DataUtil.deleteIvity(deleteId, function(res) {
						console.log('【课外作业列表删除】' + JSON.stringify(res));
						if(res.SystemCode == 1) {
							setTimeout(function() {
								vmAnList.listData.splice(index, 1);
								$.toast('删除成功');
								if(vmAnList.listData.length == 0) {
									$.toast("暂无数据");
								}
							}, 300); //使删除归位
						} else {
							$.toast('接口ok，状态no')
						}
					}, function(res) {
						plus.nativeUI.toast("请求出错");
					})
				}
			});
		});

		window.addEventListener('reflush', function() {
			console.log('提交返回刷新页面====' + vmAnList.type);
			initList(true);
		});
	}

	return {
		init: function() {
			vmAnList.ivityType = plus.webview.currentWebview().typeVal || '';
			console.log('vmAnList.ivityType====' + vmAnList.ivityType);
			bindEvent()
		},
		initList: initList
	}
}(window, mui));

/*
 *家长端课外练习新增
 * 
 * 
 * */

var addExerciseHtml = (function(c, $) {
	var maxNum = 6;
	var baseUrl = "_downloads/camera/";
	var audiosUrl = "_downloads/audio/";
	var audiosRecord = null; //录音
	var player = null; //播放
	var audioFile;
	var timename;//定时器
	var isSet = false;
	var capLock = true;
	var vmAdd = new Vue({
		el: '#addExercise',
		data: {
			picHost: IMAGE_GET_CONFIG,
			picHostOSS: IMAGE_GET_CONFIG_OSS,
			listData: [],
			fileIds: [],
			audios: [],
			videoIds: [], //视频展示
			videoIdsUp: [], //视频上传
			title: '',
			ivityType: '',
			subjects: '',
			subjectId: '',
			content: '',
			arrTitle: [],
			arrSubjects: [],
			vidcePopupShow: '0', //音频录入弹出框展示
			stopSource:"1",
			showvideo:'0',
			addVideoFirstFrame:'',//视频第一帧
		},
		updated: function() {
			//bindVideoEvent();
		},
		methods: {
			SelectTitle: function() {
				select_picker(vmAdd.arrTitle, 1)
			},
			SelectSubjects: function() {
				select_picker(vmAdd.arrSubjects)
			},
			addPicture: function(e) { //添加图片
				document.activeElement.blur();
				if(vmAdd.fileIds.length >= maxNum) {
					$.toast("已选图片数量已达" + maxNum + "张");
					return;
				}
				var that = this;
				e.stopPropagation();
				plus.nativeUI.actionSheet({
					title: "添加图片附件",
					cancel: "取消",
					buttons: [{
							title: '从手机选择'
						},
						{
							title: '拍照'
						},
					]
				}, function(e) {
					switch(e.index) {
						case 1:
							getPic(that); //相册选择
							break;
						case 2:
							getPhoto(that); //拍照
							break;
					}
				});
			},
			addVideo: function(e) { //添加视频
				document.activeElement.blur();
				if(vmAdd.videoIds.length >= 1) {
					$.toast("已选视频数量已达1个");
					return;
				}
				var that = this;
				e.stopPropagation();
				plus.nativeUI.actionSheet({
					title: "添加视频附件",
					cancel: "取消",
					buttons: [{
							title: '从手机选择'
						},
						{
							title: '摄像'
						},
					]
				}, function(e) {
					switch(e.index) {
						case 1:
							getPic(that, 1); //相册选择
							break;
						case 2:
							getVideoIng(that); //摄像
							break;
					}
				});
			},
			submit: function() { //提交
				document.activeElement.blur();
				if(!validate()) return;
				$.confirm('是否确认提交', '提示', ['确认', '取消'], function(e) {
					if(e.index == 0) {
						plus.nativeUI.showWaiting();
						loop(function(data) {
							loopAudio(function(tempA) {
								loopVideo(data, tempA, submitData)()
							})()

						})()
					};
				});
			},
			startRecord: function() {
				vmAdd.vidcePopupShow = 1;
				if(audiosRecord == null) {
					$.toast("手机录音没准备好，稍后重试");
					return;
				}
				audiosRecord.record({
					filename: audiosUrl
				}, function(recordFile) {
					if(vmAdd.stopSource=="1"){
						audioFile = recordFile;
						vmAdd.audios.push(recordFile);
						$.toast("录音成功");
						player = plus.audio.createPlayer(audioFile);
						var count=0;
						timename = setInterval(function(){
							if(count<3){
								if(player.getDuration()){
									count=0;
									console.log('player.p.getDuration()===='+player.getDuration());
									clearInterval(timename);
									document.getElementById('playTime').innerHTML = Math.round(player.getDuration()) +'s';
								}else{
									count++;
								}
							}else{
								clearInterval(timename);
							}
						},1000)
					}
				}, function(e) {
					vmAdd.vidcePopupShow = 0;
					audiosRecord.stop();
					$.toast("录音失败，重新再录");
				});
			},
			stopRecord: function() {
				vmAdd.vidcePopupShow = 0;
				vmAdd.stopSource= "1";
				audiosRecord.stop();
			},
			startPlay: function() {
				if(plus.audio == undefined) {
					$.toast("手机录音没准备好，请稍后再试");
				}
				console.log('player.getDuration()===='+player.getDuration());
				player.play(function() {
					$.toast("播放成功");
				}, function(e) {
					$.toast("播放失败");
				});
			},
			cancelAudio: function(e) {
				if(e){
					e.stopPropagation();
					e.preventDefault();
				}
				if(timename){
					clearInterval(timename);
				}
				vmAdd.stopSource = "2";
				vmAdd.vidcePopupShow = 0;
				audioFile = '';
				vmAdd.audios = [];
				audiosRecord.stop();
			},
			cancelvideo: function(e) {
				e.stopPropagation();
				e.preventDefault();
				vmAdd.videoIds = [];
				vmAdd.videoIdsUp = [];
				vmAdd.addVideoFirstFrame ='';
			},
			imgFilter: function(val, type) {
				return imgFilter(val, type)
			},
			showBigVideo:function(){
				vmAdd.showvideo = 1;
			},
			cancelBigVideo:function(){
				vmAdd.showvideo = 0;
				document.getElementById("example_video_1").pause();
			},
		},
		computed: {

		},
	});

	function submitData(data, tempA, temp) {
		var params = {
			ivityType: vmAdd.ivityType,
			subjectId: vmAdd.subjectId,
			content: vmAdd.content,
			pictureId: data.join(",") || '',
			soundRecording: tempA.join(",") || '',
			videoId: temp.join(",") || '',
		};
		console.log("c.DataUtil.ivitySubmit" + JSON.stringify(params));
		c.DataUtil.ivitySubmit(params, function(res) {
			console.log("ivitySubmit" + JSON.stringify(res));
			plus.nativeUI.closeWaiting();
			if(res.SystemCode == 1) {
				$.toast('提交成功');
				setTimeout(function() {
					$.fire(plus.webview.currentWebview().opener(), 'reflush', {});
					plus.webview.currentWebview().close();
				}, 200);
			} else if(res.SystemCode == 10019) {
				$.toast('当天该类型该科目已提交过');
			} else {
				$.toast('提交失败');
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			$.toast("接口失败");
		});
	};

	//图片
	function loop(callBack) {
		var i = 0;
		var temp = [];
		return function() {
			var me = arguments.callee;
			var photos = vmAdd.fileIds || [];
			if(photos.length) {
				if(i < photos.length) {
					if(photos[i].match("file:")) {
						window.MethodUtil.uploadImages(photos[i], function(data) {
							//temp.push(data.pk);//uploadImage
							temp.push(data.data[0]); //uploadImages
							i++;
							me(i, callBack);
						});
					} else {
						temp.push(photos[i]);
						i++;
						me(i, callBack);
					}

				} else {
					callBack(temp);
				}
			} else {
				callBack(temp);
			}
		}
	};
	//音频上传
	function loopAudio(callBack) {
		var i = 0;
		var tempAudio = [];
		return function() {
			var me = arguments.callee;
			var photos = vmAdd.audios || [];
			if(photos.length) {
				if(i < photos.length) {
					window.MethodUtil.uploadImages(photos[i], function(data) {
						tempAudio.push(data.data[0]);
						i++;
						me(i, callBack);
					}, 1); //1为音频
				} else {
					callBack(tempAudio);
				}
			} else {
				callBack(tempAudio);
			}
		}
	};

	//视频上传
	function loopVideo(tempPic, tempAudio, callBack) {
		var i = 0;
		var tempVideo = [];
		return function() {
			var me = arguments.callee;
			var photos = vmAdd.videoIdsUp || [];
			console.log("photos" + JSON.stringify(photos));
			if(photos.length) {
				if(i < photos.length) {
					window.MethodUtil.uploadImages(photos[i], function(data) {
						tempVideo.push(data.data[0]);
						i++;
						me(i, callBack);
					}, 2); //2为音频
				} else {
					callBack && callBack(tempPic, tempAudio, tempVideo);
				}
			} else {
				callBack && callBack(tempPic, tempAudio, tempVideo);
			}
		}
	};

	function getCamera(callback) {
		c.MethodUtil.getCamera(function(path) {
			zipPhoto(path, callback);
		});
	};

	function zipPhoto(path, callback) {
		c.MethodUtil.compressImage(path, baseUrl + _getpath(path),
			function(zipEvent) {
				callback(path, zipEvent);
			});
	};

	function getPhoto(that) {
		getCamera(function(path, zipEvent) {
			vmAdd.fileIds.push(zipEvent.target);
		});
	};

	function _getpath(path) {
		return path.substring(path.lastIndexOf('/'));
	};

	function getPic(that, type) {
		if(type == 1) { //视频
			var max = 1;
			var videoCount = vmAdd.videoIds.length;
			flag = max - videoCount;
			if(videoCount < max) {
				plus.gallery.pick(function(e) {
					console.log("gallery"+JSON.stringify(e));
						vmAdd.videoIdsUp.push(e);
						vmAdd.videoIds.push(e);
						isSet = false;
						capLock = true;
						setTimeout(function(){
							bindVideoEvent();
							
						},255);
					},
					function() {
						plus.nativeUI.toast('取消选择视频');
					}, {
						filter: 'video',
						multiple: false,
						maximum: flag,
						system: false,
						onmaxed: function() {
							plus.nativeUI.toast("最多只能选取" + max + "个视频");
							return;
						}
					});
			} else {
				plus.nativeUI.toast("已经选取" + max + "个视频");
				return;
			}
		} else { //图片
			var max = maxNum || 3;
			var photosCount = vmAdd.fileIds.length;
			flag = max - photosCount;
			if(photosCount < max) {
				plus.gallery.pick(function(e) {
						for(var item in e.files) {
							var path = e.files[item];
							zipPhoto(path, function(path, zipEvent) {
								vmAdd.fileIds.push(zipEvent.target);
							});
						}
					},
					function() {
						plus.nativeUI.toast('取消选择图片');
					}, {
						filter: 'image',
						multiple: true,
						maximum: flag,
						system: false,
						onmaxed: function() {
							plus.nativeUI.toast("最多只能选取" + max + "张图片");
							return;
						}
					});
			} else {
				plus.nativeUI.toast("已经选取" + max + "张图片");
				return;
			}
		}

	}

	function imgFilter(item, type) {
		var preSuffixOSS = "&r.type=resize&r.h=100";
		var preSuffix = '?renditions=fill-130x130-c100';
		var suffix = preSuffix;
		var ret = "";
		if(item.match("//")) {
			ret = item;

		} else {
			if(isNaN(item) || item.length > 8) {
				ret = vmAdd.picHostOSS + item + '?format=jpeg';
				suffix = preSuffixOSS;
			} else {
				ret = vmAdd.picHost + item;
			}
		}
		ret = ret + (type == 1 ? suffix : '');
		return ret;
	}

	//视频
	var isFn = function(val) {
		return typeof val == 'function';
	};

	function getVideo(callback) {
		c.MethodUtil.getVideo(callback);
	};

	function fileRead(e, callback) {
		plus.io.resolveLocalFileSystemURL(e, function(entry) {
			console.log("entry"+entry);
			isFn(callback) && callback(e, entry);
		});
	}

	function getVideoIng() {
		getVideo(function(e) {
			fileRead(e, function(path, entry) {
				vmAdd.videoIdsUp.push(path);
				vmAdd.videoIds.push(entry.toLocalURL());
				isSet = false;
				capLock = true;
				setTimeout(function(){
					bindVideoEvent();
				},255);
			});
		});
	}

	//类别与期数的选择
	function select_picker(data, diff) {
		if(diff == 1) { //标题
			var picker = new mui.PopPicker();
			picker.setData(data);
			picker.show(function(selectItems) {
				console.log(JSON.stringify(selectItems));
				vmAdd.title = selectItems[0].text;
				vmAdd.ivityType = selectItems[0].value;
				picker.dispose();
			});
			picker.pickers[0].setSelectedValue(vmAdd.ivityType, 0);
		} else { //科目
			var picker = new mui.PopPicker();
			picker.setData(data);
			picker.show(function(selectItems) {
				console.log(JSON.stringify(selectItems));
				vmAdd.subjects = selectItems[0].text;
				vmAdd.subjectId = selectItems[0].value;
				picker.dispose();
			});
			picker.pickers[0].setSelectedValue(vmAdd.subjectId, 0);
		}
	};

	function initPage() {
		plus.nativeUI.showWaiting();
		c.DataUtil.findIvityType(function(res) { //获取标题
			plus.nativeUI.closeWaiting();
			console.log("==findIvityType==" + JSON.stringify(res));
			var data = res.typeList || [];
			for(var i = 0; i < data.length; i++) {
				vmAdd.arrTitle.push({
					value: data[i].ivityType,
					text: data[i].ivityTypeName
				});
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});
		c.DataUtil.findClassType(function(res) { //获取科目
			plus.nativeUI.closeWaiting();
			console.log("==findClassType==" + JSON.stringify(res));
			var data = res.typeList || [];
			for(var i = 0; i < data.length; i++) {
				vmAdd.arrSubjects.push({
					value: data[i].subjectId,
					text: data[i].subjectName
				});
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});
	}

	function bindEvent() {
		//删除图片
		mui(document).on('tap', '.img_cancel', function(e) {
			e.stopPropagation();
			var liElem = this.parentNode;
			var idx = liElem.dataset.idx;
			vmAdd.fileIds.splice(idx, 1);
		});
	}

	function onPlusReady() {
		audiosRecord = plus.audio.getRecorder();
	}

	//验证
	function validate() {
		if(!vmAdd.title) {
			$.toast('请选择类型');
			return false;
		}
		if(!vmAdd.subjects) {
			$.toast('请填写科目');
			return false;
		}
		if(!(vmAdd.fileIds.length > 0 || vmAdd.videoIds.length > 0 || vmAdd.audios.length > 0)) {
			$.toast('图片，视频，音频至少上传一种');
			return false;
		}
		return true;
	}
	function bindVideoEvent() {
		var videos = document.querySelectorAll("video");
		if(videos) {
			videos.forEach(function(item, idx) {
				if(mui.os.ios){
					item.autoplay = false;
				}else{
					item.autoplay = true;
				}
				
				item.load();
				item.addEventListener("loadeddata", function() {
					console.log("loadeddata");
					console.log("loadeddata"+item.currentTime);
					captureImage(item, idx);
				},false);
				if(mui.os.android){
				item.addEventListener("timeupdate", function() {
					if(vmAdd.showvideo=="1"){
						item.muted = false;
					}else{
						item.muted =true;	
					}
					console.log("vmAdd.showvideo"+isSet);
					if(vmAdd.showvideo!="1"&&!isSet&&capLock){
						capLock = false;
						console.log("videoCapture");
						captureImage(item, idx);
						isSet = true;
					}
					if(isSet&&vmAdd.showvideo!="1"){
						item.pause();
						item.currentTime = 0;
					}	
				},false);
				}
			});
			
		}
	};
	
	var captureImage = function(video, idx) {
		console.log("captureImage");
		var scale = 0.8;
		var canvas = document.createElement("canvas"); // 创建一个画布
		canvas.width = video.videoWidth * scale;
		canvas.height = video.videoHeight * scale;
		canvas.getContext('2d').drawImage(video, 0, 0, canvas.width, canvas.height); // getContext:设置画布环境；drawImage:画画 
		var img = document.createElement("img");
		try{
			var src = canvas.toDataURL("image/png");
			console.log("captureImage3"+src);
			img.src = src; // 获取图片的url
				console.log("captureImage4");
			if(src&&src!="data:,"){
				video.poster = src;
				vmAdd.addVideoFirstFrame = src;
				console.log("picSrc"+src);
			}
			capLock = true;
		}catch(e){
			console.log("problem"+JSON.stringify(e));
			capLock = true;
		}
	};
	
	return {
		init: function() {
			initPage();
			bindEvent();
			onPlusReady();
		}
	}
}(window, mui));

/*
 *家长端课外练习详情
 * 
 * 
 * */

var detailIndex = (function(c, $) {
	var timename;
	var myAudio;
	var vmDetail = new Vue({
		el: '#detailExercise',
		data: {
			picHost: IMAGE_GET_CONFIG,
			picHostOSS: IMAGE_GET_CONFIG_OSS,
			detailId: '',
			listData: '',
			p:'',
			showAudio:'1',//1点击播放，2点击暂停，3恢复播放
			playTime:'',
			showvideo:'0',//点击小图，0不展示，1展示视频
		},
		methods: {
			palySoundRecording: function() {
				vmDetail.showAudio = 2;
				if(vmDetail.p&&vmDetail.p.play){
					if(plus.audio == undefined) {
						$.toast("音频还没有加载好!");
					}
					vmDetail.p.play(function() {
						$.toast("播放结束");
						vmDetail.showAudio = 1;
					}, function(e) {
						vmDetail.showAudio = 1;
						// $.toast("播放错误: " + e.message);
						console.log("播放错误: " + JSON.stringify(e));
					});
				}
			},
			pauseSoundRecording: function(){//暂停播放
				vmDetail.showAudio = 3;
				vmDetail.p.pause();
			},
			resumeSoundRecording: function(){//恢复播放
				vmDetail.showAudio = 2;
				vmDetail.p.resume();
			},
			imgFilter: function(val, type) {
				return imgFilter(val, type)
			},
			showBigVideo:function(){
				vmDetail.showvideo = 1;
			},
			cancelBigVideo:function(){
				vmDetail.showvideo = 0;
				document.getElementById("example_video_1").pause();
			},
		},
		updated: function() {
			bindVideoEvent();
		},
		computed: {
			isMultiple: function() {
				if(this.listData.pictureId && this.listData.soundRecording && this.listData.videoId) {
					return(this.listData.pictureId.length + this.listData.soundRecording.length + this.listData.videoId.length) > 1
				} else {
					return false
				}
			}
		},
		filters: {
			sliceTime: function(val) {
				return val ? val.slice(0, 10) : '';
			}
		}
	});

	function initPage() {
		console.log('课外详情+++++++detailId====' + vmDetail.detailId);
		plus.nativeUI.showWaiting();
		window.DataUtil.findDetailById(vmDetail.detailId, function(res) {
			console.log('课外详情===' + JSON.stringify(res));
			res = res || {};
			res.mobileIvityStudent = res.mobileIvityStudent || {};
			plus.nativeUI.closeWaiting();
			if(res.SystemCode == '1') {
				vmDetail.listData = dealData(res.mobileIvityStudent);
				loopGetVideo(vmDetail.listData.videoId, function(videoInfo) {//处理视频
					console.log("videoInfo" + JSON.stringify(videoInfo));
					vmDetail.listData.videoId = videoInfo;
				})();
				loopGetVideo(vmDetail.listData.soundRecording, function(vioceInfo) {//处理音频
					console.log("vioceInfo" + JSON.stringify(vioceInfo));
					if(plus.os.name == "iOS"){
						if(vioceInfo.length>0){
							downloadMp3toLocalByUrl(vioceInfo[0].postSrc,vioceInfo[0].src,function(){
								getShowTime();
							});
						}
					}else{
						vmDetail.listData.soundRecording = vioceInfo;
						if(vioceInfo.length>0){
							vmDetail.p = plus.audio.createPlayer(vioceInfo[0].src);
							getShowTime();
						}
					}
				})();
			} else if(res.SystemCode == '10001'){
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("该作业已被删除");
			} else {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});
	}
	//获取音频时长字段
	function getShowTime(){
		console.log('=getShowTime=');
		var count=0;
		timename = setInterval(function(){
			if(count<3){
				if(vmDetail.p.getDuration()){
				count=0;
				vmDetail.playTime = Math.round(vmDetail.p.getDuration())+'s';
				console.log('vmDetail.playTime)===='+vmDetail.playTime);
				clearInterval(timename);
				}else{
					count++;
				}
			}else{
				clearInterval(timename);
			}
		},1000)
	}
	
	
	function downloadMp3toLocalByUrl(mp3Id,loadUrl,callback,relativePath){
		console.log('ios下载音频地址');
		console.log("mp3Id"+mp3Id+"\n"+"loadUrl"+loadUrl+"\n");
	    /*联网下载mp3*/  
	    //创建下载任务  
	    var dtask = plus.downloader.createDownload(loadUrl, {}, function(d, status) {  
	        if (status == 200) {  
	            //下载成功并播放音频  
	            console.log("下载成功");  
	            var mp3src = getImgFromLocal(mp3Id, d.filename); 
				 // console.log("d.filename"+d.filename);
				 // console.log("mp3src"+mp3src);
	            if ( plus.audio == undefined ) {  
	                mui.toast( "音频播放器加载失败." );  
	            }  
				vmDetail.p = plus.audio.createPlayer(d.filename);
				callback();
	        } else {  
	            //下载失败,需删除本地临时文件,否则下次进来时会检查到图片已存在  
	            console.log("下载失败status=" + status+"=="+relativePath);  
	            //dtask.abort();//文档描述:取消下载,删除临时文件;(但经测试临时文件没有删除,故使用delFile()方法删除);  
	            if (relativePath!=null)  
	            {  
	                delFile(relativePath);  
	            }  
	        }  
	    });  
	    //启动下载任务  
	    dtask.start();  
	}  
	
	/*删除指定文件*/  
	function delFile(relativePath) {  
	    plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {  
	        entry.remove(function(entry) {  
	            console.log("文件删除成功==" + relativePath);  
	    }, function(e) {  
	        console.log("文件删除失败=" + relativePath);  
	        });  
	    });  
	}  
	
	 /*获取本地mp3文件最终路径完整地址  
	 * mp3Id mp3文件id  
	 * relativePath 本地相对路径 例如:"_downloads/demo.mp3"  
	 */  
	function getImgFromLocal(mp3Id, relativePath) {  
	    //本地相对路径("_downloads/logo.jpg")转成SD卡绝对路径("/storage/emulated/0/Android/data/io.dcloud.HBuilder/.HBuilder/downloads/logo.jpg");  
	    var sd_path = plus.io.convertLocalFileSystemURL(relativePath);  
	    //返回路径全地址  
	   return sd_path;  
	}
	
	//处理数据
	function dealData(data) {
		if(data.content.indexOf("\n") != -1) {
			data.content = c.MethodUtil.replaceLB(data.content);
		}
		if(data.pictureId) {
			data.pictureId = data.pictureId.split(',');
		} else {
			data.pictureId = [];
		}
		if(data.soundRecording) {
			data.soundRecording = data.soundRecording.split(',');
		} else {
			data.soundRecording = [];
		}
		if(data.videoId) {
			data.videoId = data.videoId.split(',');
		} else {
			data.videoId = [];
		}
		console.log('data===' + JSON.stringify(data));
		return data;
	}
	var captureImage = function(video, idx) {
		console.log("captureImage");
		var scale = 0.8;
		var canvas = document.createElement("canvas"); // 创建一个画布
		canvas.width = video.videoWidth * scale;
		canvas.height = video.videoHeight * scale;
		canvas.getContext('2d').drawImage(video, 0, 0, canvas.width, canvas.height); // getContext:设置画布环境；drawImage:画画 
		var img = document.createElement("img");
		var src = canvas.toDataURL("image/png");
		img.src = src; // 获取图片的url
		//video.poster = src;
	};

	function bindVideoEvent() {
		var videos = document.querySelectorAll("video");
		if(videos) {
			videos.forEach(function(item, idx) {
				item.load();
				item.addEventListener("loadeddata", function() {
					captureImage(item, idx);
				});
//				item.addEventListener("error", window.methodUtil.videoError);
			});
		}
	}

	function loopGetVideo(arr, callback) {
		var i = 0;
		var temp = [];
		console.log("loopGetVideoArr"+JSON.stringify(arr));
		return function() {
			var me = arguments.callee;
			if(i < arr.length) {
				window.DataUtil.getOSSFile(arr[i], function(res) {
					console.log("gotOSSFILE" + JSON.stringify(res));
					temp.push({
						src: "http://" + res.data.filePath,
						postSrc: arr[i]
					});
					i++;
					me();
				});
			} else {
				if(typeof callback == "function") {
					callback(temp);
				}
			}
		}

	}
	
	function onPlusReady() {
		audiosRecord = plus.audio.getRecorder();
	}
	function imgFilter(item, type) {
		var preSuffixOSS = "&r.type=resize&r.h=100";
		var preSuffix = '?renditions=fill-130x130-c100';
		var suffix = preSuffix;
		var ret = "";
		if(item.match("//")) {
			ret = item;
		} else {
			if(isNaN(item) || item.length > 8) {
				ret = vmDetail.picHostOSS + item + '?format=jpeg';
				suffix = preSuffixOSS;
			} else {
				ret = vmDetail.picHost + item;
			}
		}
		ret = ret + (type == 1 ? suffix : '');
		return ret;
	}

	return {
		init: function() {
			vmDetail.detailId = plus.webview.currentWebview().detailId;
			initPage();
			onPlusReady();
		},
	}
}(window, mui));