function ChineseToNumber(chnStr) {
	var rtn = 0;
	var section = 0;
	var number = 1;
	var secUnit = false;
	var str = chnStr.split('');
	for(var i = 0; i < str.length; i++) {
		var num = chnNumChar[str[i]];
		if(typeof num !== 'undefined') {
			number = num;
			if(i === str.length - 1) {
				section += number;
			}
		} else {
			var unit = chnNameValue[str[i]].value;
			secUnit = chnNameValue[str[i]].secUnit;
			if(secUnit) {
				section = (section + number) * unit;
				rtn += section;
				section = 0;
			} else {
				section += (number * unit);
			}
			number = 0;
		}
	}
	return rtn + section;
}

var chnNumChar = {//匹配中文到数字
	零: 0,
	一: 1,
	二: 2,
	三: 3,
	四: 4,
	五: 5,
	六: 6,
	七: 7,
	八: 8,
	九: 9
};
var chnNameValue = {
	十: {
		value: 10,
		secUnit: false
	},
	百: {
		value: 100,
		secUnit: false
	},
	千: {
		value: 1000,
		secUnit: false
	},
	万: {
		value: 10000,
		secUnit: true
	},
	亿: {
		value: 100000000,
		secUnit: true
	}
}



/*
 *教师端课外练习汇总详情
 * 
 * 
 * */

var summaryDetail = (function(c, $) {
	var vmSummaryDetail = new Vue({
		el: '#summaryDetail',
		data: {
			picHost: IMAGE_GET_CONFIG,
			picHostOSS: IMAGE_GET_CONFIG_OSS,
			listData: [],
			studentId:'',
			name:'',
			flag:'1',
			itemData:'',
			showTitle:'我的课外作业',
			startTime:'',
			endTime:'',
			subjectId:'',
		},
		methods: {
			goTypeList: function(type) {
				if(this.studentId==''){
					window.WebviewUtil.show('afterClassExerciseType',{
						typeVal:type
					});
				}
				
			},
			changeType:function(val){
				console.log('vaal==='+val)
				vmSummaryDetail.flag = val;
				vmSummaryDetail.startTime = '';
				vmSummaryDetail.endTime = '';
				getPeriodTime();
				// getCalendar();
			},
		},
		computed: {
			
		},
		filters: {
			
		}
	});
	
	function showTitle(){
		if(vmSummaryDetail.studentId){
			vmSummaryDetail.showTitle = vmSummaryDetail.name +'课外作业';
			console.log("==vmSummaryDetail.showTitle==" + vmSummaryDetail.showTitle);
		}
		
	}


	function initPage() {
		plus.nativeUI.showWaiting();
		showTitle();
		c.DataUtil.findIvityByUserId(vmSummaryDetail.studentId,vmSummaryDetail.subjectId,function(res) { //汇总一
			plus.nativeUI.closeWaiting();
			console.log("==findIvityByUserId==" + JSON.stringify(res));
			vmSummaryDetail.itemData = res;
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});
		getPeriodTime();
		getCalendar();
	}
	

	function getPeriodTime(){//汇总详情的下半部分
		var params ={
			flag:vmSummaryDetail.flag,
			startTime:vmSummaryDetail.startTime,
			endTime:vmSummaryDetail.endTime,
			studentId:vmSummaryDetail.studentId,
			subjectId:vmSummaryDetail.subjectId,
		}
		plus.nativeUI.showWaiting();
		console.log('params===='+JSON.stringify(params));
		c.DataUtil.findIvityByFlag(params,function(res) { //汇总二
			plus.nativeUI.closeWaiting();
			console.log("==findIvityByFlag==" + JSON.stringify(res));
			vmSummaryDetail.listData = res.typeList||[];
			var chartData = getChartData(vmSummaryDetail.listData);//雷达图数据
			chartAllInit(chartData);
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});
	}
	
	function getCalendar(){
		var dateRange = new pickerDateRange('date_demo3', {
			isTodayValid: true,
			startDate : vmSummaryDetail.startTime,
			endDate : vmSummaryDetail.endTime,
			defaultText: ' 至 ',
			theme: 'ta',
			calendars:1,
			noCalendar:false,
			success: function(obj) {
				vmSummaryDetail.flag = '0';
				vmSummaryDetail.startTime = obj.startDate;
				vmSummaryDetail.endTime = obj.endDate;
				getPeriodTime();
			},
			beforeInit:function(){
				console.log("beforeInit");
				
				this.setDates(vmSummaryDetail.startTime,vmSummaryDetail.endTime);
			}
		});
	}
	
	//“对比”-雷达图
	function chartAllInit(data) {
		var myChart;
		var domMain = document.getElementById('main');
		var option = {
			    title: {
			        text: ''
			    },
			    legend: {
			        data:['个人交作业量','班级平均交作业量']
			    },
			    radar: [{
					indicator: data.indicator,
					center: ['50%', '60%'],
					radius: 80,
					startAngle: 90,
					splitNumber: 4,
					shape: 'circle',
					name: {
						textStyle: {
							color: '#3392fc',
							fontSize:'20px',
						},
						formatter: function(text) {
							if(text){
								text = text.replace(/\S{8}/g, function(match) {
									return match + '\n'
								})
								return text
							}else{
								return '';
							}
						},
					},

				},],
			    series: [
			        {
			            name: '雷达图',
			            type: 'radar',
			            itemStyle: {
			                emphasis: {
			                    lineStyle: {
			                        width: 4
			                    }
			                }
			            },
			            data: [
							{
							    value: data.averageNum,//data.averageNum
							    name: '班级平均交作业量',
							    areaStyle: {
							        normal: {
							            color: 'rgba(255, 255, 255, 0.5)'
							        }
							    }
							},
			                {
			                    value: data.personNum,//data.personNum
			                    name: '个人交作业量',
			                    lineStyle: {
			                        normal: {
			                            type: 'dashed'
			                        }
			                    }
			                }
			            ]
			        },
			    ]
			};
		myChart = echarts.init(domMain);
		myChart.setOption(option, true);
	}
	//雷达图数据方法
	function getChartData(data){
		var indicator=[];
		var personNum=[];
		var averageNum=[];
		if(data&&data.length>0){
			for(var i=0;i<data.length;i++){
				indicator.push({text:data[i].ivityTypeName||'',max:1});
				personNum.push(data[i].typeCount/(data[i].typeCount*1+data[i].avgCount*1)||0);
				averageNum.push(data[i].avgCount/(data[i].typeCount*1+data[i].avgCount*1)||0);
			}
		}
		var ret = {
			indicator:indicator,
			personNum:personNum,
			averageNum:averageNum,
		}
		console.log('ret==='+JSON.stringify(ret));
		return ret;
	}
	
	

	return {
		init: function() {
			vmSummaryDetail.studentId = plus.webview.currentWebview().studentId||'';
			vmSummaryDetail.name = plus.webview.currentWebview().studentName||'';
			vmSummaryDetail.subjectId = plus.webview.currentWebview().subjectId||'';
			initPage();
		},
	}
}(window, mui));



/*
 *教师端课外练习汇总列表
 * 
 * 
 * */

var summaryIndex = (function(c, $) {
	var canNext = false;
	var pageNo = 1;
	var pageSize = 10;
	var total = 0;
	var ajaxName ='findListByClassId';
	var vmAnList = new Vue({
		el: '#listContentMain',
		data: {
			picHost: IMAGE_GET_CONFIG,
			picHostOSS: IMAGE_GET_CONFIG_OSS,
			listData: [],
			classList:[],
			classId:'',
			actYear:'',
			subjectId:'',
			flag:'1',
			itemActive:'',
		},
		methods: {
			changeType:function(flag){
				vmAnList.flag = flag;
				initList(true);
			},
			getTypeList:function(obj,idx){
				vmAnList.actYear = obj.actYear;
				vmAnList.classId = obj.classId;
				vmAnList.subjectId = obj.subjectId;
				vmAnList.itemActive = idx;
				initList(true);
			},
			teaGosummary:function(stuId,subId,name){
				window.WebviewUtil.show('goSummary',{
					studentId:stuId,
					studentName:name,
					subjectId:subId,
				});
			},
			goDetail:function(e,id){
				e.stopPropagation();
				e.preventDefault();
				console.log('教师端id==='+id);
				if(id){
					window.WebviewUtil.show('afterClassExerciseDetail', {
						detailId: id
					});
				}else{
					$.toast('该同学未提交作业');
				}
				
			}
		},
		computed: {
			
		},
		filters: {
			getGrade: function(val){
				return val ? val.slice(0,val.length-2):'';
			},
			ChineseToNumber: function(val) {
				var ret = "";
				if(val) {
					var len = val.length;
					var pre = val.substr(0, len - 1);
					var suffix = val.substr(len - 1);
					ret = ChineseToNumber(pre) + suffix;
				}
				return ret;
			}
		}
	});

	function getParams() {
		return {
			pageNo: pageNo,
			pageSize: pageSize,
			actYear:vmAnList.actYear,
			classId:vmAnList.classId,
			subjectId:vmAnList.subjectId,
			flag:vmAnList.flag,
		}
	}

	function setParams(val) {
		pageNo = val;
	}

	function hasNext() {
		return pageNo < total;
	}

	function initList(isDown) {
		if(isDown) {
			setParams(1);
			console.log('===getParams===' + JSON.stringify(getParams()));
			plus.nativeUI.showWaiting();
			c.DataUtil[ajaxName](getParams(), function(data) {
				plus.nativeUI.closeWaiting();
				console.log('===教师端练习列表===' + JSON.stringify(data));
				data = data || {};
				total = data.total || 0;
				data.rows = data.rows || [];
				mui('#refreshContainer').pullRefresh().endPulldown();
				if(data.rows.length) {
					vmAnList.listData = data.rows;
					mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
					canNext = hasNext();
					if(!canNext) { //无下一页数据
						console.log("禁用上拉1");
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						console.log("禁用上拉2");
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
						setParams(pageNo + 1);
					}
				} else {
					console.log("禁用上拉3");
					mui.toast("没有记录");
					vmAnList.listData = [];
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
					canNext = false;
					$.toast(ERROR_CONFIG[data.SystemCode]);
					return;
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		} else {
			if(!canNext) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			plus.nativeUI.showWaiting();
			c.DataUtil[ajaxName](getParams(), function(data) {
				plus.nativeUI.closeWaiting();
				console.log('==下一页==' + JSON.stringify(data));
				data = data || {};
				total = data.total || 0;
				data.rows = data.rows || [];
				if(data.rows.length) {
					vmAnList.listData = vmAnList.listData.concat(data.rows);
					canNext = hasNext();
					if(!canNext) {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					} else {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
						setParams(pageNo + 1);
					}
				} else {
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});

		}
	}
	
	function bindEvent() {
		
	}
	
	function initPage() {
		plus.nativeUI.showWaiting();
		c.DataUtil.getUserLeaderClass(function(res) {
			plus.nativeUI.closeWaiting();
			console.log("==getUserLeaderClass班级列表==" + JSON.stringify(res));
			vmAnList.classList = res.classList||[];
			vmAnList.classId = res.classList[0].classId;
			vmAnList.subjectId = res.classList[0].subjectId;
			vmAnList.actYear = res.classList[0].actYear;
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});
	
	}
	
	return {
		init: function() {
			initPage();
			bindEvent();
		},
		initList: initList
	}
}(window, mui));







