/*
 * 说明：考勤异常页面逻辑
 * 创建人：ls
 * 创建时间：2018/03/31 11:30
 * 修改人：ls
 * 修改时间：
 */

//考勤异常列表
var attendanceExpectionList = (function(c, $) {
	var nextUrl = "";
	var vmAttendanceExpection = new Vue({
		el: '#attendanceExpection',
		data: {
			list: [],
			picHost: IMAGE_GET_CONFIG
		},
		methods: {},
		filters: {
			moment: function(data) {
				return c.MethodUtil.getDate(data);
			}
		}
	});
	//处理列表图片和换行数据
	function dealData(data) {
		for(i = 0; i < data.length; i++) {
			//换行
			if(data[i].exceptionContent.indexOf("\n") != -1) {

				data[i].exceptionContent = c.MethodUtil.replaceLB(data[i].exceptionContent);
			}
			if(data[i].remarks.indexOf("\n") != -1) {

				data[i].remarks = c.MethodUtil.replaceLB(data[i].remarks);
			}
		}
		return data;
	}
	//获取列表数据
	function getattendanceExpectionList(isRefresh) {
		if(isRefresh) { //下拉刷新
			c.DataUtil.getAttendanceExceptionListData(c.API_CONFIG.attendanceExpectionList, function(res) {
				// console.log('【考勤数据异常列表】' + JSON.stringify(res));
				$(c.GlOBAL_CONFIG.containerId).pullRefresh().endPulldown(); //结束下拉刷新
				if(res.SystemCode == 1) {
					if(res.data == undefined || res.data == null) {
						plus.nativeUI.toast(c.ERROR_CONFIG['10001']);
						return;
					} else {
						vmAttendanceExpection.list = dealData(res.data.varList);
						$(c.GlOBAL_CONFIG.containerId).pullRefresh().refresh(true); //重置上拉加载
						nextUrl = res.data.nextUrl;
					}
					if(nextUrl == '') { //无下一页数据
						$(c.GlOBAL_CONFIG.containerId).pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						$(c.GlOBAL_CONFIG.containerId).pullRefresh().enablePullupToRefresh(); //启用上拉
						$(c.GlOBAL_CONFIG.containerId).pullRefresh().refresh(true); //重置上拉
					}
				} else {
					plus.nativeUI.toast(ERROR_CONFIG[data.SystemCode]);
					return;
				}
			}, function(xhr, type, err) {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast(c.ERROR_CONFIG['0']);
			});

		} else { //上拉加载
			if(nextUrl == "") {
				$(c.GlOBAL_CONFIG.containerId).pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			// console.log('考勤异常列表nextUrl====' + nextUrl);
			c.DataUtil.getAttendanceExceptionListData(c.HOST_CONFIG + nextUrl, function(res) {
				// console.log('【考勤异常下一页】===' + JSON.stringify(data));
				if(res.SystemCode == 1) {

					temp = dealData(res.data.varList);
					vmAttendanceExpection.list = window.MethodUtil.getCombineObj(vmAttendanceExpection.list, temp);
					nextUrl = res.data.nextUrl;
					if(nextUrl == "") {
						$(c.GlOBAL_CONFIG.containerId).pullRefresh().endPullupToRefresh(true);
					} else {
						$(c.GlOBAL_CONFIG.containerId).pullRefresh().endPullupToRefresh(false);
					}
				} else {
					plus.nativeUI.toast(ERROR_CONFIG[data.SystemCode]);
					$(c.GlOBAL_CONFIG.containerId).pullRefresh().disablePullupToRefresh();
				}
			}, function(xhr, type, err) {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast(c.ERROR_CONFIG['0']);
			});
		}
	}

	//初始化页面
	function initPage() {
		window.addEventListener('refreshlist', function() {
			getattendanceExpectionList(true);
		})
	}

	//绑定事件
	function bindEventHandler() {

		document.getElementById('attendanceExceptionAdd').addEventListener('tap', function() {
			document.activeElement.blur();
			window.WebviewUtil.show('addAttendanceExpection');
		});
	}

	return {
		init: function() {
			bindEventHandler();
			initPage();
		},
		getattendanceExpectionList: getattendanceExpectionList
	}
})(window, mui);

//考勤异常保存
var attendanceExceptionAdd = (function(c, $) {
	var attendanceExceptionType = '', //打开类型
		attendanceExceptionTime, //打卡时间
		attendanceExceptionReason; //考勤原因
	var flag = "0";
	var initTime;
	var pageId = "";
	var typeArr;
	var disposeRuser = '';
	var approvepersonFristId=document.getElementById('approvepersonFristId');
	//获取详情数据
	function getClockDetail() {
		c.DataUtil.getClockDetail({
				id: pageId
			}, function(res) {
				console.log('【考勤数据详情】' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					if(res.data == undefined || res.data == null) {

					} else {
						attendanceExceptionType = res.data.clockType;
						attendanceExceptionTime = res.data.clockTime;
						document.getElementById('attendanceExceptionTime').innerText = attendanceExceptionTime;
						document.getElementById('attendanceExceptionTime').style.color = "#000";
						document.getElementById('attendanceExceptionType').innerText = typeArr[attendanceExceptionType].text;
						document.getElementById('attendanceExceptionType').style.color = "#000";
						flag = "1";
					}
				}

			},
			function(xhr, type, err) {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast(c.ERROR_CONFIG['0']);
			});

	}

	function setClockType() {
		typeArr = [{
			text: '上班打卡',
			value: '0'
		}, {
			text: '下班打卡',
			value: '1'
		}];
	}

	function bindEvent() {
		
		//点击进入选择人员页面
		mui('.add_leave_bottom').on('tap', '.flow_item', function() {
			var nodeName = 'attendance';
			window.WebviewUtil.show('leaveSelect', {
				nodeName: nodeName
			});
		});
		
		document.getElementById('attendanceExceptionType').addEventListener('tap', function() {
			var _this = this;
			var pickerType = new $.PopPicker(); //初始化popPicker组件
			pickerType.setData(typeArr);
			document.activeElement.blur();
			pickerType.show(function(selectItems) {
				attendanceExceptionType = selectItems[0].value;
				// console.log("类型:" + selectItems[0].value);
				_this.style.color = '#000';
				_this.innerText = selectItems[0].text;
				pickerType.dispose();
			});
			pickerType.pickers[0].setSelectedIndex(attendanceExceptionType); //设置默认选中
		});
		document.getElementById('attendanceExceptionTime').addEventListener('tap', function() {
			var _this = this;
			var cfg = {};
			if(flag == "1") {
				cfg.type = "time";
				var initTime = attendanceExceptionTime.substr(0,10);
			}
			var picker = new $.DtPicker(cfg); //初始化DtPicker组件
			document.activeElement.blur();
			picker.show(function(selectItems) {
				// console.log("时间:" + selectItems.value);
				if(flag == "1") {
					attendanceExceptionTime = initTime + " " + selectItems.value;

				} else {
					attendanceExceptionTime = selectItems.value;
				}
				// attendanceExceptionTime = new Date(selectItems.value.replace(/-/g, "/"));
				var timestamp = c.MethodUtil.getTimeStamp(attendanceExceptionTime);

				if(timestamp > Date.parse(new Date())) {
					plus.nativeUI.toast(c.ERROR_CONFIG['1012']);
					return;
				}
				// console.log('打卡时间 attendanceExceptionTime==' + attendanceExceptionTime);
				_this.style.color = '#000';
				_this.innerText = attendanceExceptionTime;
				picker.dispose();
			});

			picker.setSelectedValue(attendanceExceptionTime);

		});
			document.getElementById('submit').addEventListener('tap', function() {
			attendanceExceptionReason = c.MethodUtil.delAllTrim(document.getElementById('explain').value); //考勤异常原因
			var attendanceExceptionObj = [{
				value: attendanceExceptionTime,
				title: c.ERROR_CONFIG['1013']
			}, {
				value: attendanceExceptionType,
				title: c.ERROR_CONFIG['1014']
			}, {
				value: attendanceExceptionReason,
				title: c.ERROR_CONFIG['1015']
			}];
			if(!c.MethodUtil.trimTitle(attendanceExceptionObj)) { //判断数据是否为空
				return;
			};

			if(attendanceExceptionReason.length > 100) {
				plus.nativeUI.toast(c.ERROR_CONFIG['1009']);
				return;
			}
			if(!c.MethodUtil.filterEmoji(attendanceExceptionReason)) {
				return;
			}
			disposeRuser=approvepersonFristId.innerText;
			if(disposeRuser == ''){
				mui.toast('请选则审批人');
				return;
			}
			//获取表单数据
			$.confirm(c.TITLE_CONFIG['cfmTip'], c.TITLE_CONFIG['cfmTtitle'], c.TITLE_CONFIG['cfmButton'], function(e) {
				if(e.index == 1 || e.index == -1) {
					return;
				} else {
					plus.nativeUI.showWaiting(c.TITLE_CONFIG['submit']);
					var obj = {
						clockType: attendanceExceptionType,
						clockTime: attendanceExceptionTime,
						statement: attendanceExceptionReason,
						workSignId:pageId,
						disposeRuser:disposeRuser
					}
					c.DataUtil.saveAttendanceExpection(obj, function(data) {
						plus.nativeUI.closeWaiting();
						console.log("===新增考勤参数===" + JSON.stringify(obj));
						console.log("===新增考勤异常===" + JSON.stringify(data));
						if(data.SystemCode == 1) {
							mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
							plus.nativeUI.toast(c.TITLE_CONFIG['success']);
							var self = plus.webview.currentWebview();
							var opener = self.opener();
							console.log('data.data====='+data.data)
							$.fire(opener, "refreshlist", {
								id: data.data
							});
							$.back();
						} else if(data.SystemCode == '10001') {
							plus.nativeUI.closeWaiting();
							plus.nativeUI.toast(c.ERROR_CONFIG['1010']);
						} else if(data.SystemCode == '10002') {
							plus.nativeUI.closeWaiting();
							plus.nativeUI.toast(c.ERROR_CONFIG['1011']);
						} else {
							plus.nativeUI.toast(ERROR_CONFIG[data.SystemCode]);
						}
					}, function(xhr, type, err) {
						plus.nativeUI.closeWaiting();
						plus.nativeUI.toast(c.ERROR_CONFIG['0']);
					});
				}
			});

		});
	}
	//初始化界面
	function initPage() {
		//初始化打卡时间start
		pageId = plus.webview.currentWebview().pageId;
		getClockDetail();
		setClockType();
		//获取选择人员的数据
		window.addEventListener('selectPeople', function(e) {
			approvepersonFristId.innerText = e.detail.selectId;
			document.getElementById('peopleName').innerText = e.detail.selectName;
		});
		

	}
	

	return {
		init: function() {
			initPage();
			bindEvent();
		}
	}

})(window, mui);