"use strict";

var schoolCalendarList = (function(c, $) {
	var curDate = moment().format("YYYY-MM-DD");

	function markDate(data) {
		var ret = [];
		var retObj = {};
		var temp;
         if(data.length){
		for(var i = 0; i < data.length; i++) {
			temp = data[i];
			if(!retObj[temp['holidayDate']]) {
				var obj = {};
				obj.date = temp['holidayDate'];
				obj.holidayType = [];
				if(obj.holidayType.indexOf(temp.holidayType) == -1) {
					obj.holidayType.push(temp.holidayType);
				}
				retObj[temp['holidayDate']] = obj;
			} else {
				if(retObj[temp['holidayDate']].holidayType.indexOf(temp.holidayType) == -1) {
					retObj[temp['holidayDate']].holidayType.push(temp.holidayType);
				}
			}
		}
		for(var date in retObj) {
			if(retObj[date].holidayType.length >= 2) {
				retObj[date].type = "3";
			} else {
				retObj[date].type = retObj[date].holidayType.join(",")
			}
			ret.push(retObj[date]);
		}
		}
		console.log("markDate" + JSON.stringify(ret));
		return ret;
	};
	var vmIndexList = new Vue({
		el: '#listContentMain',
		data: {
			list: [],
			ready: false
		},
		methods: {
			calendar_add: function() {
				console.log("calendar_add");
				window.WebviewUtil.show('addCalendar')
			},
			del: function(id, index) {
				console.log("id" + id);
				$.confirm("确认删除", '提示', ['确认', '取消'], function(e) {
					if(e.index == 0) {
						$.swipeoutClose(li);
						plus.nativeUI.showWaiting('删除中...');
						c.DataUtil.holidayDelete({
							id: id
						}, function(res) {
							console.log("c.DataUtil.holidayDelete" + JSON.stringify(res));
							plus.nativeUI.closeWaiting();
							if(res.SystemCode) {
								vmIndexList.list.splice(index, 1);
								mui.toast("删除成功");
							} else {
								mui.toast("删除失败");
							}
						}, function(xhr) {
							plus.nativeUI.closeWaiting();
							$.toast('提交失败，请稍后重试')
							console.log('error=' + xhr.status);
						});
					}
				});

			},
			handleClick: function(id, type) {
				var nextPage = "calendarDetail";
				console.log("handleClick" + type);
				if(type == "2") {
					nextPage = "addCalendar";
				}
				window.WebviewUtil.show(nextPage, {
					pageId: id
				});

			}
		},
		filters: {
			subStr: function(val) {
				return val.slice(11)
			},
			preStr: function(val) {
				var parts = val.replace(":", "-").replace(" ", "-").split("-");
				return parts[1] + "-" + parts[2];
			}
		}
	});
	var getList = function() {
		console.log("curDate" + curDate);
		var params = {
			holidayDay: curDate
		};
		console.log("c.DataUtil.holidayListBefore" + c.DataUtil.holidayList);
		c.DataUtil.holidayList(params, function(res) {
			console.log("c.DataUtil.holidayList" + JSON.stringify(res));
			if(res.SystemCode == "1" && res.holidayList && res.holidayList.length) {
				vmIndexList.list = res.holidayList;
			} else {
				vmIndexList.list = [];
			}
		}, function() {
			vmIndexList.list = [];
		});
	};

	var _init = function() {
		var self = this;
		// 初始化日历

		var calendar = new Calendar({
			// swiper滑动容器
			container: "#calendar",
			// 上一月节点
			pre: ".pre",
			// 下一月节点
			next: ".next",
			// 回到今天
			backToToday: ".backToday",
			// 业务数据改变
			dataRequest: function(currdate, callback, _this) {
				console.log("currdate" + currdate);
				var params = {
					holidayMonth: currdate.substr(0, 7)
				};
				try{
				c.DataUtil.holidayMouthList(params, function(res) {
					console.log("c.DataUtil.holidayMouthList" + JSON.stringify(res));
					var data = markDate(res.holidayMonthList || []);
					callback && callback(data);
				}, function() {
					console.log("c.DataUtil.holidayMouthListError");
					callback && callback([]);
				});
				}catch(e){
					console.log("dataRequest.holidayMouthListError");
					callback && callback([]);
				}
				//				var data = [{
				//					"date": "2018-08-18",
				//					type: "1",
				//				}, {
				//					"date": "2018-08-17",
				//					type: "2"
				//				}, {
				//					"date": "2018-08-16",
				//					type: "3"
				//				}];
				//				callback && callback(data);
			},
			// 点击日期事件
			onItemClick: function(item) {
				var defaultDate = item.date;
				// 设置标题
				setTitle(defaultDate);
				curDate = item.date;
				getList();
			},
			// 滑动回调
			swipeCallback: function(item) {
				var defaultDate = item.date;
				// 设置标题
				setTitle(defaultDate);
			},
			// 调试
			isDebug: false
		});
		// 设置标题
		var titleNode = document.querySelector('.mid span');

		function setTitle(date) {
			titleNode.innerText = date;
		}
		getList();
	};
	var bindEvent = function() {
		window.addEventListener('success', function() {
			_init();
		});
	};
	
	 //绑定事件
    function bindEventHandler () {
    	//点击删除
    	mui(document).on('tap', '.mui-btn-red', function() {
			var deleteId = this.dataset.id;
			var index = this.dataset.index;
			var li = this.parentNode.parentNode;
				$.confirm("确认删除", '提示', ['确认', '取消'], function(e) {
					if(e.index == 0) {
						$.swipeoutClose(li);
						plus.nativeUI.showWaiting('删除中...');
						c.DataUtil.holidayDelete({
							id: deleteId
						}, function(res) {
							console.log("c.DataUtil.holidayDelete" + JSON.stringify(res));
							plus.nativeUI.closeWaiting();
							if(res.SystemCode) {
								vmIndexList.list.splice(index, 1);
								mui.toast("删除成功");
							} else {
								mui.toast("删除失败");
							}
						}, function(xhr) {
							plus.nativeUI.closeWaiting();
							$.toast('提交失败，请稍后重试')
							console.log('error=' + xhr.status);
						});
					}
				});

			

		});
    
    
    }
	
	
	
	var init = function() {
		_init();
		bindEvent();
		bindEventHandler();
		
	};




  
	return {
		init: init
		
	}
})(window, mui);