var classPhotoList = (function(c, $) {
	var classPhotoListVue = new Vue({
		el: '#refreshContainer',
		data: {
			listData: [],
		},
		methods: {
			openDetail: function(id) {
				console.log('id====' + id);
				window.WebviewUtil.show('classPhotoDetail', {
					itemId: id
				});
			},
		},
		filters: {

		}
	});
	var pageSize = 10, //10 条一页
		maxPage, //最大页数
		pageNo = 1; //从第一页开始
	function getParams() {
		return {
			pageNo: pageNo,
			pageSize: pageSize,
		}
	}
	//初始化页面
	function initPage() {
		window.addEventListener('refreshlistData', function() {
			getAlbumList(true);
		})
	}
	//获取列表数据
	function getAlbumList(isRefresh) {
		if(isRefresh) { //下拉刷新
			pageNo = 1;
			if(mui('#refreshContainer') && mui('#refreshContainer').pullRefresh && mui('#refreshContainer').pullRefresh().disablePullupToRefresh) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
			}
			console.log('getParams()====' + JSON.stringify(getParams()));
			c.DataUtil.getAlbumList(getParams(), function(data) {
				console.log('【班级相册列表】' + JSON.stringify(data));
				mui('#refreshContainer').pullRefresh().endPulldown(); //结束下拉刷新
				if(data.SystemCode == 1) {
					if(data.page.rows.length == 0) {
						classPhotoListVue.listData = [];
						mui.toast('没有数据');
						return;
					}
					maxPage = Math.ceil((data.page.records) / pageSize);
					classPhotoListVue.listData = data.page.rows;
					mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
					if(maxPage == 1) { //无下一页数据
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
					}
				} else if(data.SystemCode == 10001) {
					mui.toast(ERROR_CONFIG[data.SystemCode]);
					classPhotoListVue.listData = [];
				} else {
					mui.toast(ERROR_CONFIG[data.SystemCode]);
					return;
				}
			}, function(xhr, type, error) {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
				console.log('xhr===' + xhr.status);
				console.log('type===' + type);
				console.log('error===' + error);

			});

		} else { //上拉加载
			pageNo++;
			if(maxPage == 1) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			c.DataUtil.getAlbumList(getParams(), function(data) {
				console.log('【班级相册列表下一页】===' + JSON.stringify(data));
				if(data.SystemCode == 1) {
					temp = data.page.rows;
					classPhotoListVue.listData = classPhotoListVue.listData.concat(temp);
					if(maxPage <= pageNo) {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					} else {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
					}
				} else {
					mui.toast(ERROR_CONFIG[data.SystemCode]);
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		}

	}
	//绑定事件
	function bindEventHandler() {
		//点击进入新增页面
		document.getElementById('classPhoto_add').addEventListener('tap', function() {
			window.WebviewUtil.show('classPhotoAdd', {});
		});
		//点击删除按钮
		mui('#refreshContainer').on('tap', '.mui-btn-red', function() {
			var _that = this;
			var deleteId = _that.dataset.id;
			var index = _that.dataset.index;
			var li = _that.parentNode.parentNode;
			var obj = {
				id: deleteId
			};
			console.log('obj====' + JSON.stringify(obj));
			mui.confirm('确认删除该条班级相册？', '提示', ['确认', '取消'], function(e) {
				if(e.index == 1 || e.index == -1) {
					return;
				} else {
					$.swipeoutClose(li);
					window.DataUtil.deleteAlbum(obj, function(res) {
						console.log('【班级相册列表删除】' + JSON.stringify(res));
						if(res.SystemCode == 1) {
							setTimeout(function() {
								classPhotoListVue.listData.splice(index, 1);
								mui.toast("删除成功");
								if(classPhotoListVue.listData.length==0){
									mui.toast("暂无数据");
								}
							}, 300); //使删除归位
						} else {
							mui.toast(ERROR_CONFIG[res.SystemCode]);
						}
					}, function(res) {
						plus.nativeUI.toast("请求出错");
					})
				}
			});
		});
	}

	return {
		init: function() {
			bindEventHandler();
			initPage();
		},
		getAlbumList: getAlbumList
	}
})(window, mui);

//新增班级相册
var classPhotoAdd = (function(c, $) {
	var classPhotoAddVue = new Vue({
		el: '#addClassPhoto',
		data: {
			listData: [],
			photoNum: '0',
			gradeArr: [],
			classArr: [],
			gradeId: '',
			graderText: '请选择年级',
			classId: '',
			classText: '请选择班级',

		},
		methods: {
			//年级选择器
			gradePicker: function() {

				if(classPhotoAddVue.gradeArr.length == 0) {
					mui.toast('请稍等年级信息还未加载完');
					return;
				}
				document.activeElement.blur();
				var picker = new $.PopPicker(); //初始化popPicker组件
				picker.setData(classPhotoAddVue.gradeArr);
				picker.show(function(selectItems) {
					classPhotoAddVue.gradeId = selectItems[0].value;
					console.log('classPhotoAddVue.gradeId===' + classPhotoAddVue.gradeId)
					classPhotoAddVue.graderText = selectItems[0].text;
					classPhotoAddVue.classId = '';
					classPhotoAddVue.classText = '请选择班级';
					picker.dispose();
				});
				picker.pickers[0].setSelectedValue(classPhotoAddVue.gradeId, 0); //设置默认文本
			},
			//班级选择器
			classPicker: function() {
				if(classPhotoAddVue.gradeId) {
					classPhotoAddVue.classArr = classPhotoAddVue.gradeArr.filter(function(element) {
						return classPhotoAddVue.gradeId == element.value;
					});
					console.log('classPhotoAddVue.classArr====' + JSON.stringify(classPhotoAddVue.classArr))
					classPhotoAddVue.classArr = classPhotoAddVue.classArr[0].classRecord;
					document.activeElement.blur();
					var pickerClass = new $.PopPicker(); //初始化popPicker组件
					pickerClass.setData(classPhotoAddVue.classArr);
					pickerClass.show(function(selectItems) {
						classPhotoAddVue.classId = selectItems[0].value;
						console.log('classPhotoAddVue.classId===' + classPhotoAddVue.classId)
						classPhotoAddVue.classText = selectItems[0].text;
						pickerClass.dispose();
					});
					pickerClass.pickers[0].setSelectedValue(classPhotoAddVue.classId, 0); //设置默认文本
				} else {
					mui.toast('请先选择年级');
					return;
				}

			},
		},
		filters: {

		}
	});
	var photosCount = 0, //已选图片
		flag = 6; //图片选择不得超过35张
	var photosSrc = []; //图片路径
	//初始化页面
	function initPage() {

		c.DataUtil.getGrade(function(res) {
			console.log("获取年级班级" + JSON.stringify(res));
			plus.nativeUI.closeWaiting();
			if(res.SystemCode == 1) {
				if(res.album) {
					console.log('111111');
					classPhotoAddVue.classId = res.album.classId;
					classPhotoAddVue.gradeId = res.album.gradeId;
					classPhotoAddVue.graderText = res.album.className.substring(0, 3);
					classPhotoAddVue.classText = res.album.className.substring(3);
					console.log('res.album==' + '1==' + classPhotoAddVue.classId + '2===' + classPhotoAddVue.gradeId + '3===' + classPhotoAddVue.graderText + '4===' + classPhotoAddVue.classText);
				}
				classPhotoAddVue.gradeArr = res.resultList;
			}
		}, function() {
			plus.nativeUI.closeWaiting();
		});

	}
	//调取相机拍照
	function getPhoto() {
		if(photosCount < 6) {
			window.MethodUtil.getCamera(function(path) {
				zipPicture(path); //压缩图片
			});
		} else {
			classPhotoAddVue.photoNum = 6;
			plus.nativeUI.toast('已经选取6张图片');
		}
	}
	//取相册图片
	function getPic() {
		 flag = flag - photosCount;
		if(photosCount < 6) {
			plus.gallery.pick(function(e) {
				for(var item in e.files) {
					var path = e.files[item];
					zipPicture(path); //压缩图片
				}
			}, function() {
				plus.nativeUI.toast('取消选择图片');
			}, {
				filter: 'image',
				multiple: true,
				maximum: flag,
				system: false,
				onmaxed: function() {
					classPhotoAddVue.photoNum = 6;
					plus.nativeUI.toast('最多只能选取6张图片');
					return;
				}
			});
		} else {
			classPhotoAddVue.photoNum = 6;
			plus.nativeUI.toast("已经选取6张图片");
			return;
		}
	}
	//压缩图片
	function zipPicture(path) {
		plus.zip.compressImage({
			src: path,
			dst: "_downloads/camera/" + path.split('/')[path.split('/').length - 1],
			overwrite: true,
			quality: 20
		}, function(event) {
			if(photosCount < 6) {
				var currentNode = document.getElementById("addPicBtn");
				var newNode = document.createElement("li");
				newNode.className = 'add_pic';
				newNode.innerHTML = '<img class="repair_photo_item" src="' +
					event.target +
					'" /><img class="icon_remove" src="../../assets/images/annoucement/cancel.png" />';
				document.getElementById('publishPhotoList').insertBefore(newNode, currentNode);
				photosCount++;
				classPhotoAddVue.photoNum = photosCount;
			} else {
				classPhotoAddVue.photoNum = 6;
				plus.nativeUI.toast("最多选取6张图片");
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});
	}

	function loop(callBack) {

		var i = 0;
		var temp = [];

		return function() {
			var me = arguments.callee;
			var photos = photosSrc || [];
			if(photos.length) {
				if(i < photos.length) {
					window.MethodUtil.uploadImages(photos[i], function(data) {
						temp.push(data.data[0]);
						i++;
						me(i, callBack);
					});
				} else {
					//vmAdd.fileIds = temp;
					callBack(temp);
				}
			} else {
				callBack(temp);
			}
		}
	};

	function submitData(temp) {
		var params = {
			classId: classPhotoAddVue.classId,
			gradeId: classPhotoAddVue.gradeId,
			className: classPhotoAddVue.graderText + classPhotoAddVue.classText,
			pictureId: temp.join(","),
		};
		console.log("params" + JSON.stringify(params));
		c.DataUtil.saveClassPhoto(params, function(res) {
			console.log("提交===" + JSON.stringify(res));
			plus.nativeUI.closeWaiting();
			if(res.SystemCode == 1) {
				$.toast("提交成功");
				$.fire(plus.webview.currentWebview().opener(), 'refreshlistData', {});
				plus.webview.currentWebview().close();
			} else {
				$.toast("提交失败");
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			$.toast("提交失败");
		});
	}
	//绑定事件
	function bindEventHandler() {

		document.getElementById('addPicBtn').addEventListener('tap', function(e) {
			e.stopPropagation();
			if(photosCount == 6) {
				classPhotoAddVue.photoNum = 6;
				mui.toast('最多只能添加6张图片');
				return;
			} else {
				plus.nativeUI.actionSheet({
					title: "添加图片附件",
					cancel: "取消",
					buttons: [{
							title: '从手机选择'
						},
						{
							title: '拍照'
						},
					]
				}, function(e) {
					switch(e.index) {
						case 1:
							getPic(); //相册选择
							break;
						case 2:
							getPhoto(); //拍照
							break;
					}
				});
			}
		});
		//图片右上角红色删除图片
		mui("#publishPhotoList").on('tap', '.icon_remove', function(e) {
			e.stopPropagation();
			this.parentNode.remove();
			photosCount--;
			classPhotoAddVue.photoNum = photosCount;
		});
		mui(document).on("tap", ".submit", function() {

			//返回图片地址
			$('.repair_photo_item').each(function() {
				photosSrc.push(this.getAttribute('src'));
			});
			if(classPhotoAddVue.gradeId == '') {
				mui.toast('请选择年级信息');
				return;
			}
			if(classPhotoAddVue.classId == '') {
				mui.toast('请选择班级信息');
				return;
			}
			if(photosSrc.length == 0) {
				mui.toast('请选择图片');
				return;
			}

			$.confirm("是否确认提交?", '提示', ['确认', '取消'], function(e) {
				if(e.index == 0) {
					plus.nativeUI.showWaiting('提交中...');
					loop(submitData)();
				}

			});

		});

	}

	return {
		init: function() {
			initPage();
			bindEventHandler();

		}
	}
})(window, mui);

//详情页
var classPhotoDetail = (function(c, $) {
	var classPhotoDetailVue = new Vue({
		el: '#classPhotoDetail',
		data: {
			listData: [],
			className: '',
		},
		methods: {

		},
		filters: {

		}
	});
	var itemId;
	//初始化页面
	function initPage(itemId) {
		var obj = {
			id: itemId
		}
		console.log('obj====' + JSON.stringify(obj))
		window.DataUtil.classPhotoDetail(obj, function(data) {
			console.log(" ===班级相册详情=== " + JSON.stringify(data));
			if(data.SystemCode == 1) {
				plus.nativeUI.closeWaiting();
				var picArr;
				var photo = [];
				if(data.classAlbum.pictureId) {
					picArr = data.classAlbum.pictureId.split(',');

					picArr.forEach(function(item) {
						photo.push(c.IMAGE_GET_CONFIG_OSS + item + '?format=jpeg');
					});
				}
				classPhotoDetailVue.listData = photo;
				classPhotoDetailVue.className = data.classAlbum.className;
				console.log('classPhotoDetailVue.listData===' + JSON.stringify(classPhotoDetailVue.listData))

			}
		}, function(xhr, type, error) {
			console.log(xhr.responseText);
		});

	}

	//绑定事件
	function bindEventHandler() {

	}

	return {
		init: function() {
			var self = plus.webview.currentWebview();
			itemId = self.itemId;
			bindEventHandler();
			initPage(itemId);
		}
	}
})(window, mui);