var textSection = function(cfg) {
	var elem = document.getElementById("text-section");
	var okBtn = elem.querySelector("#okBtn");
	var noBtn = elem.querySelector("#cancel");
	var inputElem = elem.querySelector("#input-elem");
	var _show = function() {
		elem.style.display = "";
	};

	var getText = function() {
		return inputElem.value;
	};
	var _hide = function() {
		elem.style.display = "none";
	};
	var isFirefox = !!document.getBoxObjectFor || 'mozInnerScreenX' in window,
		isOpera = !!window.opera && !!window.opera.toString().indexOf('Opera'),
		addEvent = function(elem, type, callback) {
			elem.addEventListener ?
				elem.addEventListener(type, callback, false) :
				elem.attachEvent('on' + type, callback);
		},
		removeEvent = function(elem, type, callback) {
			elem.removeEventListener ?
				elem.removeEventListener(type, callback, false) :
				elem.detachEvent('on' + type, callback);
		};
	var okFn = function() {
		if(typeof cfg.okFn == "function") {
			cfg.okFn();
		}
	};
	var cancelFn = function() {
		_hide();
		if(typeof cfg.noFn == "function") {
			cfg.noFn();
		}
	};
	var bindEvent = function() {
		console.log("textSection");

		if(okBtn) {
			console.log("textSection");
			removeEvent(okBtn, "tap", okFn);
			addEvent(okBtn, "tap", okFn);
		}
		if(noBtn) {
			removeEvent(noBtn, "tap", cancelFn);
			addEvent(noBtn, "tap", cancelFn);
		}
	};

	function　 init() {
		console.log("init");
		if(okBtn) {
			okBtn.innerHTML = cfg.okText || "确定";
		}
		if(noBtn) {
			noBtn.innerHTML = cfg.cancelText || '取消';
		}
		bindEvent();
		_show();
	}
	init();

	return {
		show: _show,
		hide: _hide,
		getText: getText
	}

};

var Clock = (function(c, $) {
	var env = "dist";
	var mySwiper;
	var iMeiCfg = {
		"dist": "http://10.143.192.10:8080/fileserver/getCardNumber/get",
		"dev": "http://192.168.241.48:8180/hhpt/client/user/getCode"
	};
	var ajaxLock = false;
    var timeClock;  //计时器
	function _blur() {
		document.activeElement.blur();
	}
	function setClock(geolocation){
		if(timeClock){
			clearInterval(timeClock);
		}
		timeClock = setInterval(function(){
			if(geolocation&&geolocation.getCurrentPosition){
				geolocation.getCurrentPosition();
			}
			if(vmIndexList){
				vmIndexList.nowTime = new Date().getTime(); 
			}
			
		},1000*60);
	}

	function initMap() {
		var mapObj = new AMap.Map('container', {
			zoom: 17, // 默认缩放比例
			zoomEnable: false, // 禁止缩放
			touchZoom: false, //关闭手势缩放地图
			dragEnable: false, //禁止鼠标拖拽平移
		});
		mapObj.plugin('AMap.Geolocation', function() {
			var geolocation = new AMap.Geolocation({
				enableHighAccuracy: true, //是否使用高精度定位，默认:true
				timeout: 10000, //超过10秒后停止定位，默认：无穷大
				maximumAge: 0, //定位结果缓存0毫秒，默认：0
				convert: true, //自动偏移坐标，偏移后的坐标为高德坐标，默认：true
				showButton: true, //显示定位按钮，默认：true
				buttonPosition: 'LB', //定位按钮停靠位置，默认：'LB'，左下角
				buttonOffset: new AMap.Pixel(10, 30), //定位按钮与设置的停靠位置的偏移量，默认：Pixel(10, 20)
				showMarker: true, //定位成功后在定位到的位置显示点标记，默认：true
				showCircle: true, //定位成功后用圆圈表示定位精度范围，默认：true
				panToLocation: true, //定位成功后将定位到的位置作为地图中心点，默认：true
				zoomToAccuracy: true //定位成功后调整地图视野范围使定位位置及精度范围视野内可见，默认：false
			});
			mapObj.addControl(geolocation);
			geolocation.getCurrentPosition();
			
			AMap.event.addListener(geolocation, 'complete', function(posi) {
				console.log('==高德定位==' + JSON.stringify(posi));
				//				vmIndexList.isSetGPS = true;
				vmIndexList.position = posi.position;
				vmIndexList.positionName = posi.formattedAddress || '';
				setClock(geolocation);
			}); //返回定位信息
			AMap.event.addListener(geolocation, 'error', function(err) {
				//console.log('==定位失败==' + JSON.stringify(err));
				var str = '定位失败,';
				str += '错误信息：'
				switch(err.info) {
					case 'PERMISSION_DENIED':
						str += '您阻止了定位操作';
						break;
					case 'POSITION_UNAVAILBLE':
						str += '无法获得当前位置';
						break;
					case 'TIMEOUT':
						str += '定位超时';
						break;
					default:
						str += '未知错误';
						break;
				}
				mui.toast(str);
				setClock(geolocation);

			}); //返回定位出错信息
		});

	}
	//提交
	function subClock(imei) {
		if(ajaxLock) return;
		var langtitude = (vmIndexList.position || {}).lng || '';
		var latitude = (vmIndexList.position || {}).lat || '';
		var paramObj = {
			longitude: langtitude,
			latitude: latitude,
			clockType: vmIndexList.clockType,
			IMEI: imei || '',
			cid: plus.push.getClientInfo().clientid
		};
		console.log(JSON.stringify(paramObj));
		ajaxLock = true;
		plus.nativeUI.showWaiting('打卡中...');
		window.DataUtil.systemClock(paramObj, function(res) {
			plus.nativeUI.closeWaiting();
			ajaxLock = false;
			console.log('【上下班打卡】===' + JSON.stringify(res));
			if(res.SystemCode == 1) {
				initPage();
				plus.nativeUI.toast("打卡成功");
			} else if(res.SystemCode == 202) {
				initPage();
				plus.nativeUI.toast("打卡成功");
			} else if(res.SystemCode == 10002) {
				plus.nativeUI.toast("不可重复打卡");
			} else if(res.SystemCode == 10004) {
				plus.nativeUI.toast("无权限打卡");
			} else {
				mui.toast(ERROR_CONFIG[res.SystemCode]);
				return;
			};
		}, function(xhr, type, error) {
			ajaxLock = false;
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		})
	}

	function getTimePart(val) {
		var day;
		if(val) {
			if(String(val).search(/-/g) > -1) { //有‘-’
				val = val.replace(/-/g, "/"); //兼容ios
			}
			day = new Date(val);
		} else {
			day = new Date();
		}
		return {
			y: day.getFullYear(),
			m: day.getMonth() + 1,
			d: day.getDate(),
			h: day.getHours() > 9 ? day.getHours() : ("0" + day.getHours()),
			mm: day.getMinutes() > 9 ? day.getMinutes() : ("0" + day.getMinutes())
		}
	}

	function dateFormat(val) {
		var date = "";
		var time = "";
		var now = new Date();
		var curYear = now.getFullYear();
		var desTime = getTimePart(val);
		date = (curYear == desTime.y) ? (desTime.m + "月" + desTime.d + "日") : (desTime.y + "年" + desTime.m + "月" + desTime.d + "日");
		time = desTime.h + ":" + desTime.mm;
		return {
			date: date,
			time: time
		};
	}

	function getImei(bool) {
		var curDate = (new Date()).valueOf(); //当前时间的时间戳
		var xhr = new plus.net.XMLHttpRequest();
		var url = iMeiCfg[env];
		console.log("iMeiURL" + url);
		xhr.timeout = 3000;
		xhr.onreadystatechange = function() {
			console.log('xhr.ready' + xhr.readyState);
			switch(xhr.readyState) {
				case 4:
					if(xhr.status == 200) {
						console.log("===串码校内===" + xhr.responseText);
						var IMEI = JSON.parse(xhr.responseText).IMEI;
						if(IMEI) {
							console.log("校内网");
							setWifiName("校内网");
							bool && subClock(IMEI);

						} else {
							bool && subClock('');
						};
					} else {
						console.log("请求出错：" + xhr.readyState);
						bool && subClock('');
					}
					break;
				default:
					//其他
					break;
			}
		}
		xhr.open("GET", url);
		xhr.send();

	}

	function bindEventHandler() {
		if(document.getElementById('clock_record')) {
			document.getElementById('clock_record').addEventListener('tap', function() {
				window.WebviewUtil.show('clockLeaderMy');
			});
		}
		window.addEventListener("refreshlist", function(e) {
			initPage();

		});
		window.addEventListener("refreshlistSpecial", function(e) {
			initPage();

		});
		onNetWorkChange();
		mui(document).on("tap",".mui-action-back",function(e){
			e.preventDefault();
			e.stopPropagation();
			mui.back();
		});
	}

	function checkNetwork(wificallback, mbcallback, callback, noTip) {
		var netType = plus.networkinfo.getCurrentType();
		switch(netType) {
			case plus.networkinfo.CONNECTION_ETHERNET: //无线网
			case plus.networkinfo.CONNECTION_WIFI:
				vmIndexList.onWifi = true;
				setWifiName("已连接无线网");
				if(typeof wificallback == "function") {
					wificallback(noTip);
				}
				break;
				//2G,3G,4G
			case plus.networkinfo.CONNECTION_CELL2G:
			case plus.networkinfo.CONNECTION_CELL3G:
			case plus.networkinfo.CONNECTION_CELL4G:
				clearWifiInfo();
				if(typeof mbcallback == "function") {
					mbcallback(noTip);
				}
				return;
				break;
			default:
				clearWifiInfo();
				if(typeof callback == "function") {
					callback(noTip);
				}
				return;
				break;
		}
	}

	function networkConfirm() {
		mui.confirm('您没有在WIFI环境下，是否切换', '提示', ['去设置', '不用了'], function(e) {
			if(e.index == 0) { //去设置
				if(mui.os.android) {
					var main = plus.android.runtimeMainActivity();
					var Intent = plus.android.importClass("android.content.Intent");
					var mIntent = new Intent('android.settings.WIFI_SETTINGS');
					main.startActivity(mIntent);
				} else {
					plus.runtime.openURL("app-settings:");
				}
			} else { //点击的是不用了
				subClock();
			}
		});
	}

	function checkLocation() {
		if(!vmIndexList.position) {
			plus.nativeUI.toast('没有获取到您的定位，不能打卡');
			return false;
		}
		return true;
	}

	function setWifiName(val) {
		vmIndexList.wifiName = val;
	}

	function clearWifiInfo() {
		vmIndexList.onWifi = false;
		setWifiName("");
	}

	function _innerWifiCallback() {

		getImei(true);
	}

	function _netchangeWifi(noTip) {
		if(!noTip) {
			mui.toast("网络环境变化,已切换至无线网");
		}
		getImei(false);
	}

	function _netchangemb(noTip) {
		if(!noTip) {
			mui.toast("网络环境变化,已切换至手机网络");
		}
		clearWifiInfo();
	}

	function _networkchange(noTip) {
		if(!noTip) {
			mui.toast("未连接到网络");
		}
		clearWifiInfo();
	}

	function _outerWifiCallback() {
		subClock();
	}

	function _innermbCallback() {
		mui.toast("请切换WIFI网络打卡");
	}

	function _outermbCallback() {
		networkConfirm();
	}

	function _innerCallback() {
		mui.toast("请切换WIFI网络打卡");
	}

	function _outerCallback() {
		mui.toast("请检查网络环境");
	}

	function inschoolFn() {
		checkNetwork(_innerWifiCallback, _innermbCallback, _innerCallback);
	}

	function outerschoolFn() {
		checkNetwork(_outerWifiCallback, _outermbCallback, _outerCallback);
	}

	function onNetWorkChange() {
		document.addEventListener("netchange", function() {
			checkNetwork(_netchangeWifi, _netchangemb, _networkchange);
		}, false);
	}

	function initPicker() {
		if(!vmIndexList.picker) {
			vmIndexList.picker = new mui.PopPicker(); //初始化popPicker组件
			vmIndexList.picker.setData([{
				value: '0',
				text: '上班打卡'
			}]);
		}
	}

	function afterPickerSelect(selectItems) {
		vmIndexList.clockType = selectItems[0].value;
		if(!vmIndexList.isInner) {
			if(!vmIndexList.position) {
				plus.nativeUI.toast('没有获取到您的定位，不能打卡');
				return;
			}
			outerschoolFn();
		} else {
			inschoolFn();
		}
	}

	function showPicker() {
		initPicker();
		vmIndexList.picker.show(function(selectItems) {
			afterPickerSelect(selectItems);
		});
	}

	function goClock() {}
	var vmIndexList = new Vue({
		el: '#clockMain',
		data: {
			listData: [],
			wifiName: '',
			onWifi: '',
			positionName: '',
			position: null,
			picker: null,
			username: '',
			nowTime: new Date().getTime(),
			nowTimeList: [],
			isSetGPS: false, //是否打开GPS
			clockType: '',
			isInner: true
		},
		updated: function() {

		},
		methods: {
			changeClockType: function(desType) {
				_blur();
				if(desType == "2") {
					mySwiper.slideNext();

					vmIndexList.isInner = false;
					console.log("isInner");

				} else {
					mySwiper.slidePrev();
					console.log("isOuter");
					vmIndexList.isInner = true;
				}
			},
			checking_in: function(isInner) {
				vmIndexList.isInner = isInner;
				showPicker();
			},
			exceptionHandle: function(item) {
				exceptionHandle(item);
			},
			abnormal: function(id, type, canAbnormal, hasExist) {
				if(type == "0") {
					if(!canAbnormal) {
						mui.toast("该记录无法进行异常申请");
						return;
					} else {
						if(hasExist) {
							mui.toast("该记录已申请考勤异常,请查看");
							return;
						}
					}
				}
				var nextPage = (type == "1" ? "clockException" : "addAttendanceExpection");
				WebviewUtil.show(nextPage, {
					pageId: id
				});
			},
			goRecord: function() {
				window.WebviewUtil.show('clockLeaderMy');
			},
			back:function(){
				 console.log("goBack");
				mui.back();
			}
		},
		filters: {
			moment: function(data) {
				return c.MethodUtil.getDate(data);
			},
			substr: function(val) {
				return val.substr(0, 10)
			},
			dateFormat: function(val, key) {
				return dateFormat(val)[key];
			},
			weekFormat: function(val) {
				return weekFormat(val);
			},
			exceptionFormat: function(item) {
				return exceptionFormat(item);
			}

		}
	});

	function exceptionFormat(item) {
		if(item.isException == '1' && (item.isSchool == 1 && item.exceptionType == 0)) {
			return "校外打卡";
		}
		if(item.exceptionType == 1) {
			return "打卡异常"
		}
		if(item.isException != '1' && item.isLate == 1) {
			return "迟到";
		}
	}

	function valid(text) {
		if(text == "") {
			mui.toast("请填写考勤异常原因");
			return false;
		}
		if(!window.MethodUtil.filterEmoji(text)) {
			return false;
		}
		return true;
	}

	function submitException(item, cxt) {
		var cnt = cxt.getText();
		var workSignId = item.id;
		if(!valid(cnt)) return;
		plus.nativeUI.showWaiting("提交中...");
		window.DataUtil.saveAttendanceExpection({
			workSignId: workSignId,
			statement: cnt
		}, function(res) {
			plus.nativeUI.closeWaiting();
			if(res.systemCode == 1) {
				console.log("saveAttendanceExpection" + JSON.stringify(res));
				cxt.hide();
				initPage();
				mui.toast("提交成功");
			} else {
				mui.toast("提交失败");
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			mui.toast("提交失败");
		});
	}

	function showText(item) {
		var textObj = textSection({
			okBtn: "确认打卡",
			okFn: function() {
				submitException(item, textObj);
			}
		});
	}

	function exceptionHandle(item) {
		if(!item.abnormalId && item.exceptionType == 0) {
			showText(item);
		} else {
			mui.toast('该异常无法进行异常申请');
		}
	}

	function weekFormat(val) {
		var day;
		if(val) {
			if(String(val).search(/-/g) > -1) { //有‘-’
				val = val.replace(/-/g, "/"); //兼容ios
			}
			day = new Date(val);
		} else {
			day = new Date();
		}
		var num = day.getDay();
		var ref = {
			"0": "日",
			"1": "一",
			"2": "二",
			"3": "三",
			"4": "四",
			"5": "五",
			"6": "六"
		};
		return ref[num];
	}
	var getNetworkInfo = function() {
		//		var info = plus.networkinfo;

	};
	var networkWaiting = function() {
		var UIApplication = plus.ios.import("UIApplication");
		var sharedApplication = UIApplication.sharedApplication();
		sharedApplication.setNetworkActivityIndicatorVisible(true);
		plus.ios.deleteObject(sharedApplication);
	};
	var netWorkChange = function() {

	};

	var getWifiName = function() {
		if(mui.os.android) {
			var wifiManager, wifiInfo;
			var Context = plus.android.importClass("android.content.Context");
			var WifiManager = plus.android.importClass("android.net.wifi.WifiManager");
			var WifiInfo = plus.android.importClass("android.net.wifi.WifiInfo");
			wifiManager = plus.android.runtimeMainActivity().getSystemService(Context.WIFI_SERVICE);
			wifiInfo = wifiManager.getConnectionInfo();
			var ssid = wifiInfo.getSSID() || '';
			if(ssid.length == 0) {
				return null;
			}
			//一些手机上获取SSID是有值的，但是实际IP为空，真实为未连接  
			var i = parseInt(wifiInfo.getIpAddress());
			var ipStr = (i & 0xFF) + "." +
				((i >> 8) & 0xFF) + "." +
				((i >> 16) & 0xFF) + "." +
				(i >> 24 & 0xFF);
			if(ipStr == "0.0.0.0") {
				return null;
			}

			if(ssid != "<unknown ssid>" && ssid.toUpperCase() != "0X") {
				return ssid.replace(/\"/g, "");
			}
			return null;
		}
		return null;
	};

	function intToIp(i) {
		return(i & 0xFF) + "." + ((i >> 8) & 0xFF) + "." + ((i >> 16) & 0xFF) + "." + ((i >> 24) & 0xFF);
	}

	function initPage() {
		window.DataUtil.getByUserAndDay(function(res) {
			console.log('【当前打卡记录】===' + JSON.stringify(res));
			if(res.SystemCode == 1) {
				vmIndexList.listData = res.data;
			}
		}, function(xhr, type, error) {
			plus.nativeUI.toast("请求出错");
		})
	}

	function init() {
		console.log("init");
		var phoneCID = plus.push.getClientInfo().clientid;
		console.log('phoneCID=======' + phoneCID);
		mySwiper = new Swiper('.swiper-container');
		//判断开启定位服务
		var gpsArr = [initMap];
		window.MethodUtil.openSetting(gpsArr);
		vmIndexList.username = window.MethodUtil.getUserInfo().userName;
		initPage();
		bindEventHandler();
		checkNetwork(_netchangeWifi, _netchangemb, _networkchange, true);
	}
	return {
		init: init
	}
})(window, mui);