//日报管理列表

var mainIndex = (function(c, $) {
	var canNext = false;
	var pageNo = 1;
	var pageSize = 10;
	var total = 0;
	var ajaxName = 'dailyManageList';
	var vmAnList = new Vue({
		el: '#listContentMain',
		data: {
			listData: [],
		},
		methods: {
			goDetail: function(start,end,type) { //详情
				window.WebviewUtil.show('dailyManageDetail', {
					startDate:start ,
					endDate:end,
					dailyType:type,
				});
			},
		},
		computed: {

		},
		filters: {

		}
	});

	function getParams() {
		return {
			pageNo: pageNo,
			pageSize: pageSize,
		}
	}

	function setParams(val) {
		pageNo = val;
	}

	function hasNext() {
		return pageNo < total;
	}

	function initList(isDown) {
		if (isDown) {
			setParams(1);
			console.log('===getParams===' + JSON.stringify(getParams()));
			c.DataUtil[ajaxName](getParams(), function(data) {
				console.log('===日报管理列表===' + JSON.stringify(data));
				data = data || {};
				data.page = data.page || {};
				total = data.page.total || 0;
				data.page.rows = data.page.rows || [];
				mui('#refreshContainer').pullRefresh().endPulldown();
				if (data.page.rows.length) {
					vmAnList.listData = data.page.rows;
					mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
					canNext = hasNext();
					if (!canNext) { //无下一页数据
						console.log("禁用上拉1");
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						console.log("禁用上拉2");
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
						setParams(pageNo + 1);
					}
				} else {
					console.log("禁用上拉3");
					mui.toast("没有记录");
					vmAnList.listData = [];
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
					canNext = false;
					$.toast(ERROR_CONFIG[data.SystemCode]);
					return;
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		} else {
			if (!canNext) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			c.DataUtil[ajaxName](getParams(), function(data) {
				console.log('==日报管理列表下一页==' + JSON.stringify(data));
				data = data || {};
				data.page = data.page || {};
				total = data.page.total || 0;
				data.page.rows = data.page.rows || [];
				if (data.page.rows.length) {
					vmAnList.listData = vmAnList.listData.concat(data.page.rows);
					canNext = hasNext();
					if (!canNext) {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					} else {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
						setParams(pageNo + 1);
					}
				} else {
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});

		}
	}
	
	return {
		init:function(){
			
		},
		initList: initList
	}
}(window, mui));


//日报管理详情
var dailyManageDetail = (function(c, $) {
	var self = null;
	var vmDetail = new Vue({
		el: '#detailContentMain',
		data: {
			detailData: {},
			workSingMap:{},//考勤数据
			startDate:'',
			endDate: '',
			dailyType:'',
		},
		methods: {
			goItem: function(item, startTime, endTime) {
				console.log(item + '=====' + startTime + '///////' + endTime);
				goEachItem(item, startTime, endTime);
			},
		},
		filters: {
			getDate: function(data) {
				return data ? data.slice(0,data.length-9) : '';
			}
		}
	});

	function goEachItem(dailyType, start, end) {
		window.WebviewUtil.show(dailyType, {
			dailyMask: dailyType,
			startTime: start,
			endTime: end,
		});
	}

	//日报管理详情数据
	function initPage() {
		plus.nativeUI.showWaiting();
		var obj = {
			startDate:vmDetail.startDate,
			endDate:vmDetail.endDate,
		}
		console.log("obj===" + JSON.stringify(obj));
		c.DataUtil.dailyManageDetail(obj, function(res) {
			plus.nativeUI.closeWaiting();
			console.log("日报管理详情数据===" + JSON.stringify(res));
			if (res.SystemCode==1) {
				vmDetail.detailData = res;
				vmDetail.workSingMap = res.workSingMap;
			} else {
				mui.toast(ERROR_CONFIG[res.SystemCode]);
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			mui.toast('服务器异常');
		});
	}

	return {
		init: function() {
			vmDetail.startDate = plus.webview.currentWebview().startDate || '';
			vmDetail.endDate = plus.webview.currentWebview().endDate || '';
			vmDetail.dailyType = plus.webview.currentWebview().dailyType || '';
			initPage();
		}
	}
})(window, mui);


//打卡统计领导
var Attendance = (function(c, $) {
	var canNext = false;
	var pageNo = 1;
	var pageSize = 10;
	var total = 0;

	var vm = new Vue({
		el: '#attendanceSituation',
		data: {
			listData: [], //迟到，异常，缺勤对应的列表
			itemData: {}, //迟到，异常，缺勤
			startDate: '',
			endDate: '',
			clockType:'1',//1迟到2异常3缺勤
		},
		methods: {
			changeItem: function(num) {
				vm.clockType = num;
				refreshList(true);
			},
		},
		filters: {
			subs: function(value) {
				return window.MethodUtil.subs(value);
			}
		}


	});

	function getParams() {
		return {
			pageNo: pageNo,
			pageSize: pageSize,
			startDate: vm.startDate,
			endDate: vm.endDate,
			exceptionType: vm.clockType,
		}
	}

	function setParams(val) {
		pageNo = val;
	}

	function hasNext() {
		var ret = Math.ceil(total / pageSize) > pageNo;
		console.log("hasNext:" + ret);
		return Math.ceil(total / pageSize) > pageNo;
	}
	//初始化页面
	function initPage() {
		var obj = {
			startDate: vm.startDate,
			endDate: vm.endDate,
		}
		c.DataUtil.getLeaderClockData(obj, function(res) {
			console.log("===日报管理考勤三个状态===" + JSON.stringify(res));
			res.workSign = res.data || {};
			plus.nativeUI.closeWaiting();
			if (res.SystemCode == 1) {
				vm.itemData = res.data||{};
			} else {
				if (res.SystemCode == 10001) {
					mui.toast(ERROR_CONFIG[res.SystemCode]);
				} else {
					mui.toast(ERROR_CONFIG[res.SystemCode]);
				}
				return;
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});

	}

	//上拉加载列表数据
	function refreshList(isRefresh) {
		if (isRefresh) {
			setParams(1);
			console.log('===getParams===' + JSON.stringify(getParams()));
			c.DataUtil.getLeaderClockDataList(getParams(), function(res) {
				console.log('===日报管理考勤列表===' + JSON.stringify(res));
				res = res || {};
				res.data=res.data||{};
				res.data.rows = res.data.rows || [];
				total = res.data.records || 0;
				mui('#refreshContainer').pullRefresh().endPulldown();
				if (res.data.rows.length) {
					vm.listData = res.data.rows;
					mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
					canNext = hasNext();
					if (!canNext) { //无下一页数据
						console.log("禁用上拉1");
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						console.log("禁用上拉2");
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
						setParams(pageNo + 1);
					}
				} else {
					console.log("禁用上拉3");
					mui.toast("没有记录");
					vm.listData = [];
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
					canNext = false;
					return;
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		} else {
			if (!canNext) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			c.DataUtil.getLeaderClockDataList(getParams(), function(res) {
				console.log('==日报管理考勤列表下一页==' + JSON.stringify(res));
				res = res || {};
				res.data = res.data||{};
				total = res.data.records || 0;
				res.data.rows = res.data.rows || [];
				if (res.data.rows.length) {
					vm.listData = vm.listData.concat(res.data.rows);
					canNext = hasNext();
					if (!canNext) {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					} else {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
						setParams(pageNo + 1);
					}
				} else {
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});

		}

	}

	return {
		init: function() {
			vm.startDate = plus.webview.currentWebview().startTime || '';
			vm.endDate = plus.webview.currentWebview().endTime || '';
			initPage();
		},
		refreshList: refreshList
	}
})(window, mui);



//功能室预约列表
var reservationIndexList = (function(c, $) {
	var userInfo;
	var vmIndexList = new Vue({
		el: '#functionContentMain',
		data: {
			list: [],
			ready: false,
			startDate: '',
			endDate: '',
		},
		methods: {
			

		},
		filters: {
			subStr: function(val) {
				return val.slice(11)
			},
			preStr: function(val) {
				var parts = val.replace(":", "-").replace(" ", "-").split("-");
				return parts[1] + "-" + parts[2];
			}
		}
	});

	function translateTime(ddStr) {
		var unit = 24 * 60 * 60 * 1000;
		var today = new Date(new Date().getFullYear(), new Date().getMonth() + 1, new Date().getDate());
		var ddStrArr = ddStr.split("-");
		var dd = new Date(ddStrArr[0], ddStrArr[1], ddStrArr[2]);
		return(today - dd) / unit;
	}

	function preStr(val, start, end) {
		var ret = '';
		var parts = val.replace(":", "-").replace(" ", "-").split("-");
		ret = parts.slice(start, end).join("-");
		return ret;
	}

	function viewText(str1, str2) {
		var ret = "";
		if(preStr(str1, 0, 3) == preStr(str2, 0, 3)) {
			if(preStr(str1, 0, 1) == new Date().getFullYear()) {
				var interval = translateTime(preStr(str1, 0, 3));
				ret = preStr(str1, 1, 3);
			} else {
				ret = preStr(str1, 0, 3);
			}
		} else {
			if(preStr(str1, 0, 1) == preStr(str2, 0, 1) && preStr(str1, 0, 1) == new Date().getFullYear()) {
				ret = preStr(str1, 1, 3) + "~" + preStr(str2, 1, 3);
			} else {
				ret = preStr(str1, 0, 3) + "~" + preStr(str2, 0, 3);
			}
		}
		
		console.log('ret===='+ret);
		return ret;
	}

	function dataHandler(data) {
		var obj = {};
		var ret = [];
		data = data || [];
		for(var i = 0; i < data.length; i++) {
			if(!obj[data[i].roomId]) {
				obj[data[i].roomId] = {
					roomId: data[i].roomId,
					roomName: data[i].roomName,
					reserveList: []
				};
			}
			if(obj[data[i].roomId] && data[i].startHm && data[i].endHm) {
				data[i].viewText = "";
				if(data[i].startDate && data[i].endDate) {
					data[i].viewText = viewText(data[i].startDate, data[i].endDate);
				}
				obj[data[i].roomId].reserveList.push(data[i]);
			}
		}

		for(var roomId in obj) {
			ret.push(obj[roomId])
		}
		return ret;

	}
	//功能室列表
	function orderFunctionList() {
		var obj = {
			startDate:vmIndexList.startDate,
			endDate:vmIndexList.endDate
		};
		c.DataUtil.getRoomListDetail(obj,function(res) {
			console.log('===日报管萝莉功能室列表===' + JSON.stringify(res));
			if(res.SystemCode == 1) {
				vmIndexList.list = dataHandler(res.functionRoomsList);
				console.log('===vmIndexList.list===' + JSON.stringify(vmIndexList.list));
				vmIndexList.ready = true;
			} else {
				mui.toast(c.ERROR_CONFIG[res.SystemCode]);
				return;
			}
		}, function() {
			plus.nativeUI.toast("请求出错");
		});
	}
	return {
		init: function() {
			vmIndexList.startDate = plus.webview.currentWebview().startTime || '';
			vmIndexList.endDate = plus.webview.currentWebview().endTime || '';
			orderFunctionList();
		}
	}
})(window, mui);




//请假列表
var leaveList = (function(c, $) {
	var vm = new Vue({
		el: '#leaveContentMain',
		data: {
			listData: [],
			// multipleAuditStatus: "1",
			startDate: '',//日报管理加进来的
			endDate: '',//日报管理加进来的
			dailyMask:'',//日报管理加进来的
			rangType:2,
		},
		methods: {},
		filters: {
			subs: function(value) {
				return window.MethodUtil.subs(value);
			},
			locale: function(value) {
				var ret = "";
				if(value && value.substring) {
					ret = parseInt(value.substring(11, 13));
					if(ret > 0 && ret < 12) {
						ret = "上午";
					} else {
						ret = "下午";
					}
				}
				return ret;
			}
		}
	});
	var pageSize = 10, //10 条一页
		maxPage, //最大页数
		pageNo = 1; //从第一页开始
	function getParams() {
		return {
			pageNo: pageNo,
			pageSize: pageSize,
			// multipleAuditStatus: vm.multipleAuditStatus,
			startDate: vm.startDate,
			endDate: vm.endDate,
			rangType:vm.rangType,
		}
	}

	//获取列表数据
	function teacherLeaveList(isRefresh) {
		if(isRefresh) { //下拉刷新
			pageNo = 1;
			if(mui('#refreshContainer') && mui('#refreshContainer').pullRefresh && mui('#refreshContainer').pullRefresh().disablePullupToRefresh) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
			}
			console.log('【getParams】===' + JSON.stringify(getParams()));
			c.DataUtil.teacherLeaveList(getParams(), function(data) {
				console.log('【日报请假数据列表】' + JSON.stringify(data));
				mui('#refreshContainer').pullRefresh().endPulldown(); //结束下拉刷新
				if(data.SystemCode == 1) {
					if(data.page.rows.length == 0) {
						vm.listData = [];
						mui.toast('没有数据');
						return;
					}
					maxPage = Math.ceil((data.page.records) / pageSize);
					vm.listData = data.page.rows;
					mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
					if(maxPage == 1) { //无下一页数据
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
					}
				} else if(data.SystemCode == 10001) {
					vm.listData = [];
				} else {
					mui.toast(ERROR_CONFIG[data.SystemCode]);
					return;
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});

		} else { //上拉加载
			pageNo++;
			if(maxPage == 1) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			c.DataUtil.teacherLeaveList(getParams(), function(data) {
				console.log('【日报请假下一页】===' + JSON.stringify(data));
				if(data.SystemCode == 1) {
					temp = data.page.rows;
					vm.listData = vm.listData.concat(temp);
					if(maxPage <= pageNo) {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					} else {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
					}
				} else {
					mui.toast(ERROR_CONFIG[data.SystemCode]);
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		}

	}

	//绑定事件
	function bindEventHandler() {
		//点击进入详情页
		mui('.leave_list').on('tap', '.item', function() {
			var itemId = this.dataset.id;
			window.WebviewUtil.show('leaveDetail', {
				itemId: itemId
			});
		});
	}

	return {
		init: function() {
			vm.startDate = plus.webview.currentWebview().startTime || '';
			vm.endDate = plus.webview.currentWebview().endTime || '';
			bindEventHandler();
		},
		teacherLeaveList: teacherLeaveList
	}
})(window, mui);