/*
 * 说明：忘记密码
 * 创建人：dwm
 * 创建时间：2018/4/28 10:14
 * 修改人：
 * 修改时间：
 */
var forgetPwd = (function(c, $) {
	var vmforgetPwd = new Vue({
		el: '#vmforgetPwd',
		data: {
			phoneNum: '',//手机账号
			password: '',//密码
			pwdConfirm: '',//确认密码
			verificationCode: '',//验证码
			smsId:'',//短信id
		},
		methods: {}
	});
	
	var remainTime = 60, //剩余时间 单位s => 用于设置按钮的是否禁用
		timer = null, //定时器
		regTel = /^0?1[2|3|4|5|6|7|8|9][0-9]\d{8}$/,//手机号验证
		regPwd = /^[a-zA-Z0-9]+$/,//密码验证
		encrypt = new JSEncrypt(); //初始化字符串加密对象
		
	encrypt.setPublicKey(c.GlOBAL_CONFIG.publicKey); //设置公钥


	//事件绑定
	function bindEvents() {
		//获取验证码
		document.getElementById("getVerification").addEventListener('tap',function(e) {
			e.stopPropagation();
			//判断手机号是否合法，合法则调取短信，不合法return
			var phoneNum = vmforgetPwd.phoneNum;
			console.log('phoneNum====='+phoneNum);
//			var regTel = /^0?1[2|3|4|5|6|7|8|9][0-9]\d{8}$/;
			if(phoneNum == '') {
				$.toast('请输入手机号')
				return;
			}
			if(!regTel.test(phoneNum)) {
				$.toast('请输入正确的手机号');
				return;
			}
			var companyId=window.GlOBAL_CONFIG.companyId;
			setTimer();
			//短信验证码
			c.DataUtil.sendCheckMsg(phoneNum,companyId, function(res) {
				console.log('===发送找回短信===' + JSON.stringify(res));
				if(res.SystemCode == 1) { //发送成功
					$.toast('发送成功');
					vmforgetPwd.smsId = res.smsId;
				}
			}, function(xhr, type, err) {
				$.toast('服务器异常，请稍后重试');
			})
		})

		document.getElementById("done").addEventListener('tap', function() {
			var phoneNum = vmforgetPwd.phoneNum,//手机号
				password = vmforgetPwd.password,//秘密
				pwdConfirm = vmforgetPwd.pwdConfirm,//确认秘密
				verificationCode = vmforgetPwd.verificationCode,//短信验证码
				smsId = vmforgetPwd.smsId;//短信id
			document.activeElement.blur();
			if(phoneNum == '') {
				$.toast('请输入手机号码');
				return;
			}
			if(!regTel.test(phoneNum)) {
				$.toast('请输入正确的手机号');
				return;
			}
			if(password == '') {
				$.toast('请输入密码');
				return;
			}
			if(!regPwd.test(password) || password.length < 6 || password.length > 18) {
				vmforgetPwd.password = '';
				$.toast('密码长度不符合要求');
				plus.nativeUI.closeWaiting();
				return false;
			}
			if(pwdConfirm == '') {
				$.toast('请输入确认密码');
				return;
			}
			if(password !== pwdConfirm) {
				$.toast('两次密码不一致');
				return;
			}
			if(verificationCode == '') {
				$.toast('请输入验证码');
				return;
			}
			var userPassword = encrypt.encrypt(password); //对密码进行加密操作
			var confirmPassword = encrypt.encrypt(pwdConfirm); //对确认密码进行加密操作
			plus.nativeUI.showWaiting('找回中...');
			var paramObj = {
				loginName: phoneNum,
				code: verificationCode,
				newPassword: userPassword,
				smsId: smsId,
				companyId:window.GlOBAL_CONFIG.companyId
			}
			c.DataUtil.forgetPassword(paramObj, function(res) {
				console.log('===找回密码===' + JSON.stringify(res));
				plus.nativeUI.closeWaiting();
				if(res.SystemCode == 1) {
					$.toast('修改成功，请登陆');
					plus.webview.currentWebview().close();
				} else if(res.SystemCode == 1008) {
					$.toast('验证码错误');
				} else if(res.SystemCode == 1003) {
					$.toast('用户不存在');
				}
//				else if(res.SystemCode == 10010) {
//					$.toast('验证码错误');
//				} else if(res.SystemCode == 10011) {
//					$.toast('两次密码不一致');
//				} 
				else {
					$.toast(c.ERROR_CONFIG[res.SystemCode]);
				}
			}, function() {
				$.toast('操作失败，稍后重试');
				plus.nativeUI.closeWaiting();
			})
		})

		//重写mui.back
		$.back = function() {
			$.confirm('是否放弃找回密码', '提示', ['确认', '取消'], function(e) {
				if(e.index == 1 || e.index == -1) {
					return;
				} else {
					plus.webview.currentWebview().close();
				}
			})
		}
	}
	//设置定时器
	function setTimer() {
		if(timer) {
			window.clearTimeout(timer);
		}
		document.getElementById("getVerification").disabled = true;
		document.getElementById("getVerification").innerText = remainTime + '秒';
		remainTime--;
		if(remainTime === -1) {
			document.getElementById("getVerification").disabled = false;
			document.getElementById("getVerification").innerText = '发送验证码'
			window.clearTimeout(timer);
			remainTime = 60;
			return;
		}
		timer = setTimeout(setTimer, 1000);
	}

	return {
		init: function() {
			bindEvents();
		}
	}
	
})(window, mui);