/*
 * 创建人：吕丹丹
 * 修改人：
 * 创建时间：2018/8/17 10:00
 */

//请假列表
var leaveList = (function(c, $) {
	var vm = new Vue({
		el: '#refreshContainer',
		data: {
			listData: [],
			multipleAuditStatus: "1"
		},
		methods: {},
		filters: {
			subs: function(value) {
				return window.MethodUtil.subs(value);
			},
			locale: function(value) {
				var ret = "";
				if(value && value.substring) {
					ret = parseInt(value.substring(11, 13));
					if(ret > 0 && ret < 12) {
						ret = "上午";
					} else {
						ret = "下午";
					}
				}
				return ret;
			}
		}
	});
	var pageSize = 10, //10 条一页
		maxPage, //最大页数
		pageNo = 1; //从第一页开始
	function getParams() {
		return {
			pageNo: pageNo,
			pageSize: pageSize,
			multipleAuditStatus: vm.multipleAuditStatus
		}
	}

	//自定义事件刷新列表
	function initPage() {
		window.addEventListener('refreshlistData', function() {
			teacherLeaveList(true);
		})
	}

	//获取列表数据
	function teacherLeaveList(isRefresh) {
		if(isRefresh) { //下拉刷新
			pageNo = 1;
			if(mui('#refreshContainer') && mui('#refreshContainer').pullRefresh && mui('#refreshContainer').pullRefresh().disablePullupToRefresh) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
			}
			c.DataUtil.teacherLeaveList(getParams(), function(data) {
				console.log('【请假数据列表】' + JSON.stringify(data));
				mui('#refreshContainer').pullRefresh().endPulldown(); //结束下拉刷新
				if(data.SystemCode == 1) {
					if(data.page.rows.length == 0) {
						vm.listData = [];
						mui.toast('没有数据');
						return;
					}
					maxPage = Math.ceil((data.page.records) / pageSize);
					vm.listData = data.page.rows;
					mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
					if(maxPage == 1) { //无下一页数据
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
					}
				} else if(data.SystemCode == 10001) {
					vm.listData = [];
				} else {
					mui.toast(ERROR_CONFIG[data.SystemCode]);
					return;
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});

		} else { //上拉加载
			pageNo++;
			if(maxPage == 1) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			c.DataUtil.teacherLeaveList(getParams(), function(data) {
				console.log('【请假下一页】===' + JSON.stringify(data));
				if(data.SystemCode == 1) {
					temp = data.page.rows;
					vm.listData = vm.listData.concat(temp);
					if(maxPage <= pageNo) {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					} else {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
					}
				} else {
					mui.toast(ERROR_CONFIG[data.SystemCode]);
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		}

	}

	//绑定事件
	function bindEventHandler() {
		//点击进入新增页面
		document.getElementById('new_add').addEventListener('tap', function() {
			window.WebviewUtil.show('leaveAdd');
		});
		//点击进入详情页
		mui('.leave_list').on('tap', '.item', function() {
			var itemId = this.dataset.id;
			window.WebviewUtil.show('leaveDetail', {
				itemId: itemId
			});
		});
		$("#topTabList").on('tap', '.tab-item', function() {
			var self = this;
			var tabList = self.parentNode.children;
			var tabItemTag = self.dataset.target;
			for(var i = 0; i < tabList.length; i++) {
				tabList[i].classList.remove('active');
			}
			self.classList.add('active');
			vm.multipleAuditStatus = tabItemTag || '';
			teacherLeaveList(true);
			$(c.GlOBAL_CONFIG.containerId).pullRefresh().scrollTo(0, 0, 1) //让滑动区域回到顶部
		});
	}

	return {
		init: function() {
			bindEventHandler();
			initPage();
		},
		teacherLeaveList: teacherLeaveList
	}
})(window, mui);

//请假新增
var leaveAdd = (function(c, $) {
	var leaveTypeId = '', //请假类型id
		leaveName, //请假类型名称
		leaveTallNum = 0, //总代课条数
		startflag = false,
		endflag = false,
		nodeName = '', //节点名
		taskId = [], //节点id
		taskUser = [], //审批人
		leavedays = 0, //请假天数
		leaveNum = '', //使用代课条数
		flag = 1, //选择照片限制1张
		photosCount = 0, //选择照片张数判断
		pictureId = [], //公告图片id
		typeArr = [],
		explain, //请假说明
		startTime = '', //开始时间
		endTime = ''; //结束时间
		var maxNum =1;

	var vm = new Vue({
		el: '#addLeave',
		data: {
			listData: [],
		},
		updated: function() {
			autoTextArea();
		},
		methods: {},
		filters: {}
	});
	
	function MaxOn(){
		if(document.getElementById("addPicBtn")){
		document.getElementById("addPicBtn").style.display= (photosCount>= maxNum)?'none':'';
		}
	}
	var approvepersonFristId = document.getElementById('approvepersonFristId'), //组长审批人的id
		approvepersonFrist = document.getElementById('approvepersonFrist'), //组长审批人的名字
		approvepersonid = document.getElementById('approvepersonid'), //领导审批人的id
		approveperson = document.getElementById('approveperson'), //领导审批人的名字
		imgArrow = document.getElementById('imgArrow'), //向下的箭头
		daysBlock = document.getElementById('days'); //第二个节点
	//初始化页面
	function initPage() { //审批人id
		//获取选择人员的数据
		window.addEventListener('selectPeople', function(e) {
			var nnodeNameType = e.detail.nodeName;
			if(nnodeNameType == 'gradeLeader') {
				approvepersonFristId.innerText = e.detail.selectId;
				approvepersonFrist.innerText = e.detail.selectName;
			} else {
				approvepersonid.innerText = e.detail.selectId;
				approveperson.innerText = e.detail.selectName;
			}
		});
		//ajax 获取请假类型
		window.DataUtil.getLeaveType(function(data) { //success
			console.log('【请假类型】' + JSON.stringify(data));
			if(data.SystemCode == 1) {
				for(var i = 0; i < data.data.length; i++) {
					typeArr.push({
						value: data.data[i].dictValue,
						text: data.data[i].dictName
					});
				}

			} else {
				mui.toast('请假类型获取失败');
			}
		}, function(xhr, type, err) { //error
			mui.toast('服务器异常')
		});
		//ajax 获取代价条和使用代价条数
		window.DataUtil.getLeaveNum(function(data) { //success
			console.log('【请假代课条可用数】' + JSON.stringify(data));
			if(data.SystemCode == 1) {
				leaveTallNum = (data.data.totals) - (data.data.usedTotals);
				document.getElementById('lastLeaveNum').innerText = leaveTallNum + '张可用';
				if(leaveTallNum == '0') {
					document.getElementById("num_leave").value = leaveTallNum;
				}
			} else {
				mui.toast('请前往后台输入代课条');
			}
		}, function(xhr, type, err) { //error
			mui.toast('服务器异常')
		});

	}

	function autoTextArea() {
		var elem = document.getElementById("explain");
		if(elem) {
			MethodUtil.autoTextarea(elem, 0, 125)
		}
	}
	//设置请假天数
	function setLeavedays(leaveNum, leaveTypeId, startflag, endflag, startTime, endTime) {
		if(startTime == endTime) {
			return;
		}
		leaveNum = document.getElementById("num_leave").value;
		//		console.log('leaveNum====' + leaveNum)
		if(startflag == true && endflag == true && leaveNum != '') {
			var obj = {
				leaveType: leaveTypeId,
				startDate: startTime,
				endDate: endTime,
				leaveCourseNum: leaveNum
			}
						console.log('obj请假时长计算====='+JSON.stringify(obj))
			window.DataUtil.getTeacherLeaveDays(obj, function(data) {
				console.log('===请假时长计算===' + JSON.stringify(data));
				if(data.SystemCode == 1) {
					leavedays = data.data;
					if(leavedays > 0) {
						getFlowTask(leavedays);
					} else if(leavedays == 0) {
						mui.toast('时长过短,请重新选择');
						return;
					} else {
						mui.toast('选择时间错误或为节假日，请重新选择');
						return;
					}
				} else {
					console.log('获取请假时长失败');
					//	mui.toast('获取请假时长失败');
				}
			}, function(xhr, type, error) {
				console.log(xhr.responseText);
			});
		}
	}
	//获取审批节点
	function getFlowTask(leavedays) {
		console.log("leavedays"+leavedays);
		taskId = [];
		taskUser = [];
		//教师请假节点
		imgArrow.style.display = 'none';
		daysBlock.style.display = 'none';
		window.DataUtil.getLeaveProcedure(leavedays, function(data) {
			console.log(" ===请假节点=== " + JSON.stringify(data));
			if(data.SystemCode == 1) {
				approvepersonFristId.innerText = '';
				approvepersonid.innerText = '';
				if(leavedays <= 0.5) {
					approvepersonFrist.innerText = data.data[0].taskName;
				} else {
					approvepersonFrist.innerText = data.data[0].taskName;
					approveperson.innerText = data.data[1].taskName;
					imgArrow.style.display = 'block';
					daysBlock.style.display = 'block';
				}
				document.getElementById("flow").style.display = 'block';
				for(var i = 0; i < data.data.length; i++) {
					taskId.push(data.data[i].id);
				}
			} else {
				mui.toast('获取请假节点失败');
			}
		}, function(xhr, type, error) {
			console.log(xhr.responseText);
		});
	}
	//调取相机拍照
	function getPhoto() {
		if(photosCount < 1) {
			window.MethodUtil.getCamera(function(path) {
				zipPicture(path); //压缩图片
			});
		} else {
			plus.nativeUI.toast("已经选取1张图片");
		}
	}

	//取相册图片
	function getPic() {
		flag = 1 - photosCount;
		if(photosCount < 1) {
			plus.gallery.pick(function(e) {
				for(var item in e.files) {
					var path = e.files[item];
					zipPicture(path); //压缩图片
				}
			}, function() {
				plus.nativeUI.toast('取消选择图片');
			}, {
				filter: 'image',
				multiple: true,
				maximum: flag,
				system: false,
				onmaxed: function() {
					plus.nativeUI.toast('最多只能选取1张图片');
					return;
				}
			});
		} else {
			plus.nativeUI.toast("已经选取1张图片");
			return;
		}
	}
	//压缩图片
	function zipPicture(path) {
		plus.zip.compressImage({
			src: path,
			dst: "_downloads/camera/" + path.split('/')[path.split('/').length - 1],
			overwrite: true,
			quality: 20
		}, function(event) {
			if(photosCount < 1) {
				var newNode = document.createElement("li");
				newNode.innerHTML = '<img class="circle-photo-item repair_photo_item" src="' +
					event.target +
					'" /><img class="icon-remove" src="../../assets/images/common/cancel.png" />';
				document.getElementById('publishPhotoList').insertBefore(newNode,document.getElementById("addPicBtn"));
				photosCount++;
				MaxOn();
			} else {
				plus.nativeUI.toast("最多选取1张图片");
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});
	}

	//绑定事件
	function bindEventHandler() {
		document.getElementById("num_leave").addEventListener("blur", function() {
			setLeavedays(leaveNum, leaveTypeId, startflag, endflag, startTime, endTime);
		});
		//点击请假类型（选择器）
		document.getElementById('type_leave').addEventListener('tap', function() {
			var _this = this;
			document.activeElement.blur();
			var picker = new $.PopPicker(); //初始化popPicker组件
			picker.setData(typeArr);
			picker.show(function(selectItems) {
				leaveTypeId = selectItems[0].value;
				console.log('leaveTypeId===' + leaveTypeId)
				leaveName = selectItems[0].text;
				_this.style.color = '#000';
				_this.innerText = selectItems[0].text;
				setLeavedays(leaveNum, leaveTypeId, startflag, endflag, startTime, endTime);
				picker.dispose();
			});
			picker.pickers[0].setSelectedIndex(leaveTypeId - 1); //设置默认文本

		});
		//点击进入选择人员页面
		mui('.add_leave_bottom').on('tap', '.flow_item', function() {
			var nodeNum = this.dataset.type;
			if(nodeNum == 1) {
				nodeName = 'gradeLeader';
			} else {
				nodeName = 'schoolLeader';
			}
			window.WebviewUtil.show('leaveSelect', {
				nodeName: nodeName
			});
		});

		//选择开始时间
		document.getElementById('start_time').addEventListener('tap', function() {
			var _this = this;
			var pickerTime = new mui.DtPicker({
				'type': 'datetime'
			}); //初始化DtPicker组件
			document.activeElement.blur();
			pickerTime.show(function(selectItems) {
				startTime = selectItems.value;
				_this.style.color = '#000';
				_this.innerText = startTime;
				startflag = true;
				setLeavedays(leaveNum, leaveTypeId, startflag, endflag, startTime, endTime);
				pickerTime.dispose();
			});
			pickerTime.setSelectedValue(startTime);

		});
		//选择结束时间
		document.getElementById('end_time').addEventListener('tap', function() {
			var _this = this;
			var pickerEndTime = new mui.DtPicker({
				'type': 'datetime'
			}); //初始化DtPicker组件
			document.activeElement.blur();
			pickerEndTime.show(function(selectItems) {
				endTime = selectItems.value;
				_this.style.color = '#000';
				_this.innerText = endTime;
				endflag = true;
				setLeavedays(leaveNum, leaveTypeId, startflag, endflag, startTime, endTime);
				pickerEndTime.dispose();
			});
			pickerEndTime.setSelectedValue(endTime);

		});

		//添加图片
		document.getElementById('addPicBtn').addEventListener('tap', function(e) {
			e.stopPropagation();
			if(photosCount == 1) {
				mui.toast('最多只能添加1张图片');
				return;
			} else {
				plus.nativeUI.actionSheet({
					title: "添加图片附件",
					cancel: "取消",
					buttons: [{
							title: '从手机选择'
						},
						{
							title: '拍照'
						},
					]
				}, function(e) {
					switch(e.index) {
						case 1:
							getPic(); //相册选择
							break;
						case 2:
							getPhoto(); //拍照
							break;
					}
				});
			}
		});
		//图片右上角红色删除图片
		mui("#publishPhotoList").on('tap', '.icon-remove', function(e) {
			e.stopPropagation();
			this.parentNode.remove();
			photosCount--;
			flag--;
			MaxOn();
		});

		function checkData(data1, data2) {
			if(data1 == '') {
				mui.toast(data2);
				return false;
			} else if(!window.MethodUtil.filterEmoji(data1)) {
				return false;
			}
			return true;
		}

		document.getElementById("submit_block").addEventListener('tap', function() {
			taskUser = [];
			pictureId = [];
			explain = document.getElementById("explain").value;
			leaveNum = document.getElementById("num_leave").value;
			//审批人id
			var handlePerson = approvepersonFristId.innerText;
			var handlePersonFrist = approvepersonid.innerText;
			taskUser.push(handlePerson);
			taskUser.push(handlePersonFrist);
			var taskUserALL = taskUser.length > 0 ? taskUser.toString() : "";
			if(!checkData(leaveTypeId, '请假类型不能为空')) {
				return;
			}
			if(!checkData(leaveNum, '请填写代假条使用数')) {
				return;
			}
			if(leaveNum > leaveTallNum) {
				mui.toast("代假条使用数不得大于拥有数");
				return;
			}
			if(leaveNum < 0) {
				mui.toast("代假条使用数不得小于0");
				return;
			}
			if(!checkData(startTime, '请选择开始时间')) {
				return;
			}
			if(!checkData(endTime, '请选择结束时间')) {
				return;
			}
			if(startTime == endTime) {
				mui.toast("结束日期不能和开始日期相同");
				return;
			}
			if(startTime >= endTime) {
				mui.toast("结束日期不能早于或等于开始日期");
				return;
			}
			if(!checkData(explain, '请填写请假说明')) {
				return;
			}
			if(explain.length > 250) {
				mui.toast('不能超过250个字');
				return;
			}
			if(leavedays <= 0.5) {
				if(handlePerson == '') {
					mui.toast('请选择审批人');
					return;
				}
			} else {
				if(handlePerson == '' || handlePersonFrist == '') {
					mui.toast('请选择审批人');
					return;
				}
			}
			var photos = [];
			mui('.repair_photo_item').each(function() {
				photos.push(this.getAttribute('src'));
			}); //返回图片地址
			var i = 0;
			var length = photos.length;
			//递归上传图片
			var loop = function(i, callBack) {
				if(i < length) {
					window.MethodUtil.uploadImage(photos[i], function(data) {
						console.log('uploadImage=======' + JSON.stringify(data))
						pictureId.push(data.pk);
						i++;
						loop(i, callBack);
					});

				} else {
					callBack();
				}
			};

			//获取表单数据
			mui.confirm('是否确认新增？', '提示', ['确认', '取消'], function(e) {
				if(e.index == 1 || e.index == -1) {
					taskUser = [];
					return;
				} else {
					plus.nativeUI.showWaiting('提交中...');
					loop(i, function() {
						//图片路径换成字符串
						var paths = pictureId.length > 0 ? pictureId.toString() : "";
						var taskIdALL = taskId.length > 0 ? taskId.toString() : "";
						var obj = {
							leaveName: leaveName,
							leaveType: leaveTypeId,
							startDate: startTime,
							endDate: endTime,
							leaveDays: leavedays,
							leaveContent: explain,
							pictureId: paths,
							leaveCourseNum: leaveNum,
							taskId: taskIdALL,
							handlePerson: taskUserALL
						}
						console.log('obj=======' + JSON.stringify(obj))
						//调联提交新增接口
						window.DataUtil.submitLeave(obj, function(data) {
							console.log('新增请假======' + JSON.stringify(data))
							plus.nativeUI.closeWaiting();
							if(data.SystemCode == 1) {
								mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
								mui.fire(plus.webview.getWebviewById('Leave'), 'refreshlistData', {});
								mui.toast("提交成功");
								photos = [];
								photosPath = [];
								mui.back();
							} else if(data.SystemCode == 10002) {
								mui.toast("当前请假已存在,请确认");
							} else {
								mui.toast('新增请假失败');
							}

						}, function() {
							plus.nativeUI.toast("请求出错");
						});
					});
				}
			});

		});

	}

	return {
		init: function() {
			bindEventHandler();
			autoTextArea();
			initPage();
		}
	}
})(window, mui);

//请假详情
var leaveDetail = (function(c, $) {
	var vm = new Vue({
		el: '#leaveDetail',
		data: {
			listData: [],
			pictureSrc: '',
			flow: []
		},
		methods: {},
		filters: {}
	});

	var itemId;
	//初始化页面
	function initPage(itemId) {
		//教师请假节点
		window.DataUtil.getInfoById(itemId, function(data) {
			console.log(" ===请假详情=== " + JSON.stringify(data));
			if(data.SystemCode == 1) {
				plus.nativeUI.closeWaiting();
				//	请假说明
				data.data.leaveContent = window.MethodUtil.replaceLB(data.data.leaveContent);
				vm.listData = data.data;
				vm.pictureSrc = IMAGE_GET_CONFIG + data.data.pictureId;
				vm.flow = data.instances;
			}
		}, function(xhr, type, error) {
			console.log(xhr.responseText);
		});
	}

	//绑定事件
	function bindEventHandler() {
		//如推送时就在本页则刷新数据
		c.addEventListener('refreshCurrentPage', function(e) {
			itemId = e.detail.push_detail_id;
			initPage(itemId);
		});
	}

	return {
		init: function() {
			plus.nativeUI.showWaiting();
			var self = plus.webview.currentWebview();
			itemId = self.itemId || self.push_detail_id;
			bindEventHandler();
			initPage(itemId);
		}
	}
})(window, mui);

//选人
var selectPeople = (function(c, $) {
	var vm = new Vue({
		el: '#selectBox',
		data: {
			listData: [],
		},
		methods: {},
		filters: {}
	});

	var nodeName; //节点名
	//初始化页面
	function initPage() {
		//教师请假节点
		window.DataUtil.getHandlePerson(nodeName, function(data) {
			console.log(" ===请假审批人=== " + JSON.stringify(data));
			if(data.SystemCode == 1) {
				plus.nativeUI.closeWaiting();
				vm.listData = data.data;
			}
		}, function(xhr, type, error) {
			console.log(xhr.responseText);
		});

	}

	//绑定事件
	function bindEventHandler() {
		//点击选择人员
		mui('.m-va-select').on('tap', '.studentlist', function() {
			var selectId = this.dataset.id;
			var selectName = this.dataset.name;
			if(nodeName == 'attendance') { //考勤异常
				mui.fire(plus.webview.getWebviewById('addAttendanceExpection'), 'selectPeople', {
					selectId: selectId,
					selectName: selectName
				});
			} else { //请假leaveAdd
				mui.fire(plus.webview.getWebviewById('leaveAdd'), 'selectPeople', {
					selectId: selectId,
					selectName: selectName,
					nodeName: nodeName
				});
			}
			mui.back();
		});

	}

	return {
		init: function() {
			plus.nativeUI.showWaiting();
			var self = plus.webview.currentWebview();
			nodeName = self.nodeName;
			bindEventHandler();
			initPage();
		}
	}
})(window, mui);