/*
 *新社团列表
 * 
 * 
 * */

//新社团申报新增
var addCommunity = (function(c, $) {
	var maxNum = 1;
	var baseUrl = "_downloads/camera/";
	var detailId = "";
	var picHostOSS = IMAGE_GET_CONFIG_OSS;
	var picHost = IMAGE_GET_CONFIG;
	var inputData = {}; //初始设置选择范围时数据格式，用于班级，该数据仅赋值一次

	function num2Lang(num) {
		var gradeNum = ['一', '二', '三', '四', '五', '六', '七', '八', '九', '十', '十一', '十二', '十三', '十四', '十五'];
		var ref = {};
		for(var i = 0; i < gradeNum.length; i++) {
			ref[i] = gradeNum[i];
		}
		return ref[num] || '';
	}

	function transfer(val) {
		var ret = "";
		var prefix = "";
		var suffix = "";
		var index = 0;
		var preUnit = "年级";
		var suffixUnit = "班";
		var num = 1;
		if(val) {
			prefix = val.substr(index, num);
			suffix = val.substr(index + 1);
			prefix = num2Lang((prefix * 1 - 1)) + preUnit;
			if(suffix == '0') {
				ret = prefix;
			} else {
				suffix = num2Lang((suffix * 1 - 1)) + suffixUnit;
				ret = prefix + suffix;
			}
		}
		return ret;
	}

	function getPickerText(mainId, arr) {
		console.log("mainId:" + mainId + "/arr:" + JSON.stringify(arr))
		var obj = arr.filter(function(item) {
			return item.value == mainId;
		});
		if(obj && obj.length) {
			return obj[0].text;
		} else {
			return '';
		}
	}

	function getCollapse(item) { //没用到
		var ret = false;
		// 	  ret = (vmAdd.limit=="1"&&item.checkedStatus);
		return ret;
	}

	function transferLimitInfo(data) {
		var rangeArr = data || [];
		vmAdd.gradeAddData = vmAdd.gradeAddData.map(function(item) {
			item.checkedStatus = getCheckedStatus((rangeArr || []), item.value)
			item.gradeKey = item.value + "0";
			item.collapse = false;
			return item;
		});
		console.log("transferLimitInfo" + JSON.stringify(vmAdd.gradeAddData));
	}

	function resetRangeInfo() {
		transferLimitInfo([])
	}

	function initRangeInfo() {
		var rangeInput = {};
		console.log("vmAdd.enrollRel" + JSON.stringify(vmAdd.enrollRel));
		vmAdd.enrollRange.map(function(item, index) {
			rangeInput[item] = vmAdd.enrollRel[index];
		});
		console.log("rangeInput" + JSON.stringify(rangeInput));
		if(rangeInput) {
			vmAdd.enrollNum = getPostData(rangeInput).enrollNum || [];
			inputData = rangeInput;
		}
	}

	function setData(data) {
		for(var i in data) {
			vmAdd[i] = data[i]||'';
		}
		vmAdd.periodsValue = data.mainId||'';
		console.log("vmAdd.periodsName" + vmAdd.periodsName);
		vmAdd.typeValue = data.type||'';
		vmAdd.enrollRange = data.enrollRange||[];
		vmAdd.enrollNum = data.enrollNum||[];
		vmAdd.schooltime = data.schoolTime||'';
		vmAdd.limit = data.isLimit||'';
		vmAdd.enrollRel = (data.enrollNum||[]).slice();
		transferLimitInfo(data.enrollRange);
		initRangeInfo();
		vmAdd.fileIds = data.pictureId ? data.pictureId.split(",") : [];
		vmAdd.teachersName = data.teacherUserNameApp||'';
		vmAdd.teachersId = data.teacherUserId ? data.teacherUserId.split(',') : [];
		vmAdd.periodsName = data.assnTitle||'';
		vmAdd.type = data.typeName||'';
	}

	function getDetail() {
		plus.nativeUI.showWaiting();
		window.DataUtil.assnInfoDetail(detailId, function(res) {
			res = res || {};
			res.assnInfo = res.assnInfo || {};
			plus.nativeUI.closeWaiting();
			console.log('可编辑情况下的详情' + JSON.stringify(res.assnInfo));
			if(res.SystemCode == '1') {
				setData(res.assnInfo);
				vmAdd.$forceUpdate();
				console.log("vmAdd.$data" + JSON.stringify(mui.extend({}, vmAdd.$data, res.assnInfo)));
			} else {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});
	}

	function getRangeText(type, rangeArr, numArr) {
		var ret = "";
		var temp = [];
		for(var i = 0; i < rangeArr.length; i++) {
			if(type == "0") {
				temp.push(transfer(rangeArr[i]))
			} else {
				temp.push(transfer(rangeArr[i]) + numArr[i] + '人');
			}
		}
		ret = temp.join(",");
		console.log('----' + JSON.stringify(ret));
		return ret;
	}

	function toggleRange() {
		vmAdd.enrollRange = [];
		vmAdd.enrollNum = [];
		vmAdd.enrollRel = [];
		inputData = {};
		resetRangeInfo();
	}
	var vmAdd = new Vue({
		el: '#addCommunity',
		data: {
			assnName: '', //社团报名
			type: '', //类别
			typeValue: '', //类别value
			placeName: '', //地点
			teachersName: '', //教师名字
			teachersNameList: [], //教师名字数组
			teachersId: [], //教师id
			schooltime: '', //上课时间
			periodsName: '', //社团期数名字
			periodsValue: '', //社团期数value
			totalEnrollNum: '', //报名总人数
			limit: '0', //限制
			enrollRange: [], //范围
			assnSynopsis: '', //简介
			pictureList: '', //图片
			fileIds: [], //图片文件
			typeArr: [], //类别
			timeArr: [], //时间期数
			status: '', //保留0、提交1
			grade: [], //年级
			enrollNum: [], //对应年级班级人数(提交)
			gradeAddData: [], //渲染班级数据
			maskLayerShow: '0', //遮罩层0不现实，1显示
			enrollRel: [], //对应年级班级人数(展示)
			isBtnShow: '2',
			picHost: picHost,
			picHostOSS: picHostOSS,
		},
		computed: {
			enrollRangeText: function() {
				return getRangeText(this.limit, this.enrollRange, this.enrollRel);
			},
			contentLen:function(){
				return this.assnSynopsis.length;
			}
		},
	
		methods: {
			submit: function(sta) { //提交
				vmAdd.status = sta;
				document.activeElement.blur();
				vmAdd.enrollNum = getPostData(inputData).enrollNum || [];
				var msg;
				if(vmAdd.status == '4') {
					rejected(detailId, vmAdd.status);
				}
				if(vmAdd.status == '0') {
					msg = '是否确认保存';
				} else if(vmAdd.status == '3') {
					if(!validate()) return;
					msg = '是否审核通过';
				} else if(vmAdd.status == '1') {
					if(!validate()) return;
					msg = '是否确认提交';
				}
				$.confirm(msg, '提示', ['确认', '取消'], function(e) {
					if(e.index == 0) {
						plus.nativeUI.showWaiting();
						loop(submitData)();
					}
				});
			},
			input: function(grade) { //填写数据
				console.log("input");
				checkstatus(grade);
			},
			SelectCategory: function(diff) { //选择类别与期数
				if(diff == 1) {
					select_picker(diff, vmAdd.typeArr);
				} else {
					select_picker(diff, vmAdd.timeArr);
				}
			},
			selectTeacher: function() { //选择教师
				window.WebviewUtil.show('select_teacher', {
					selectedPerson: vmAdd.teachersNameList,
					selectId: vmAdd.teachersId,
				});
			},
			toggleSwitch: function(event) {
				if(event.detail.isActive) {
					vmAdd.limit = '1'; //你启动了开关
				} else {
					vmAdd.limit = '0'; //你关闭了开关
				}
				toggleRange();
			},
			addPicture: function(e) { //添加图片
				document.activeElement.blur();
				if(vmAdd.fileIds.length >= maxNum) {
					$.toast("已选图片数量已达" + maxNum + "张");
					return;
				}
				var that = this;
				e.stopPropagation();
				plus.nativeUI.actionSheet({
					title: "添加图片附件",
					cancel: "取消",
					buttons: [{
							title: '从手机选择'
						},
						{
							title: '拍照'
						},
					]
				}, function(e) {
					switch(e.index) {
						case 1:
							getPic(that); //相册选择
							break;
						case 2:
							getPhoto(that); //拍照
							break;
					}
				});
			},
			showMask: function() {
				vmAdd.maskLayerShow = '1';
			},
			determine: function() { //确认
				var data = getPostData();
				if(vmAdd.totalEnrollNum<sum(data.enrollRel)){
					$.toast('班级填写人数之和超过报名总人数');
					return false;
				}
				vmAdd.enrollRange = data.enrollRange || [];
				vmAdd.enrollNum = data.enrollNum;
				vmAdd.enrollRel = data.enrollRel;
				vmAdd.grade = getGrade(vmAdd.gradeAddData);
				
				vmAdd.maskLayerShow = '0';
			},
			cancel: function() { //取消
				vmAdd.maskLayerShow = '0';
			},
			getClass: function(val) { //获取班级
				if(vmAdd.limit == 1) {
					getClassFn(val);
				}
			},
			imgFilter: function(val, type) {
				return imgFilter(val, type)
			}
		},
		filters: {
			imgFilter: function(val, type) {
				return imgFilter(val, type)
			}
		}
	});

	function submitData(temp) {
		var params = {
			id: detailId || '',
			assnName: vmAdd.assnName,
			teacherUserId: (vmAdd.teachersId instanceof Array) ? vmAdd.teachersId.join(',') : vmAdd.teachersId,
			teacherUserNameApp: vmAdd.teachersName,
			placeName: vmAdd.placeName,
			type: vmAdd.typeValue,
			schoolTime: vmAdd.schooltime,
			enrollRangRes: vmAdd.enrollRange.join(',') || '',
			enrollNumRes: vmAdd.enrollNum.join(','),
			assnSynopsis: vmAdd.assnSynopsis,
			submitStatus: vmAdd.status,
			totalEnrollNum: vmAdd.totalEnrollNum,
			isLimit: vmAdd.limit,
			mainId: vmAdd.periodsValue,
			gradeRes: vmAdd.grade.join(','),
			pictureId: temp.join(","),
		};
		console.log("c.DataUtil.declareAdd" + JSON.stringify(params));
		c.DataUtil.declareAdd(params, function(res) {
			console.log("declareAdd" + JSON.stringify(res));
			plus.nativeUI.closeWaiting();
			if(res.SystemCode == 1) {
				if(vmAdd.status == '0') {
					$.toast("保存成功");
				} else if(vmAdd.status == '3') {
					$.toast("审核成功");
					mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {}); //角标
				} else {
					$.toast("提交成功");
				}
				setTimeout(function(){
				    $.fire(plus.webview.currentWebview().opener(), 'reflush', {});
					plus.webview.currentWebview().close();
				},200); 
			} else if(res.SystemCode == 10019){
				$.toast("该记录已审批");
				setTimeout(function(){
				    $.fire(plus.webview.currentWebview().opener(), 'reflush', {});
					plus.webview.currentWebview().close();
				},200); 
			} else {
				if(vmAdd.status == '0') {
					$.toast("保存失败");
				} else if(vmAdd.status == '3') {
					$.toast("审核失败");
				} else {
					$.toast("提交失败");
				}
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			$.toast("接口失败");
		});
	};

	function imgFilter(item, type) {
		var preSuffixOSS = "&r.type=resize&r.h=100";
		var preSuffix = '?renditions=fill-130x130-c100';
		var suffix = preSuffix;
		var ret = "";
		if(item.match("//")) {
			ret = item;

		} else {
			if(isNaN(item) || item.length > 8) {
				ret = vmAdd.picHostOSS + item + '?format=jpeg';
				suffix = preSuffixOSS;
			} else {
				ret = vmAdd.picHost + item;
			}
		}
		ret = ret + (type == 1 ? suffix : '');
		console.log("imgFilter" + ret);
		return ret;
	}

	function getAssnTime() {
		c.DataUtil.findAssnTime(function(res) { //社团时间（期数）
			plus.nativeUI.closeWaiting();
			console.log("==findAssnTime==" + JSON.stringify(res));
			var data = res.data || [];
			for(var i = 0; i < data.length; i++) {
				vmAdd.timeArr.push({
					value: data[i].id,
					text: data[i].assnTitle
				});
			}
			vmAdd.periodsName = res.data[0].assnTitle;
			vmAdd.periodsValue = res.data[0].id;
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});
	}

	//获取类别，社团期数
	function initPage() {
		plus.nativeUI.showWaiting();
		c.DataUtil.findAssnType(function(res) { //社团类别
			plus.nativeUI.closeWaiting();
			console.log("==findAssnType==" + JSON.stringify(res));
			var data = res.assnInfoList || [];
			for(var i = 0; i < data.length; i++) {
				vmAdd.typeArr.push({
					value: data[i].type,
					text: data[i].typeName
				});
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});
		getAssnTime();
		vmAdd.gradeAddData = [{
			'gradeName': '一年级',
			'value': '1',
			'classList': []
		}, {
			'gradeName': '二年级',
			'value': '2',
			'classList': []
		}, {
			'gradeName': '三年级',
			'value': '3',
			'classList': []
		}, {
			'gradeName': '四年级',
			'value': '4',
			'classList': [],
		}, {
			'gradeName': '五年级',
			'value': '5',
			'classList': [],
		}, {
			'gradeName': '六年级',
			'value': '6',
			'classList': []
		}, ];
		if(detailId) {
//			alert('准备审核initPage+++++++detailId===='+detailId);
			getDetail();
		}else{
			toggleRange();
		}
	}
	//类别与期数的选择
	function select_picker(diff, data) {
		if(diff == 1) { //类别
			var picker = new mui.PopPicker();
			picker.setData(data);
			picker.show(function(selectItems) {
				console.log(JSON.stringify(selectItems));
				vmAdd.type = selectItems[0].text;
				vmAdd.typeValue = selectItems[0].value;
				picker.dispose();
			});
			picker.pickers[0].setSelectedValue(vmAdd.typeValue, 0);
		} else { //期数
			var picker = new mui.PopPicker();
			picker.setData(data);
			picker.show(function(selectItems) {
				console.log(JSON.stringify(selectItems));
				vmAdd.periodsName = selectItems[0].text;
				vmAdd.periodsValue = selectItems[0].value;
				picker.dispose();
			});
			picker.pickers[0].setSelectedValue(vmAdd.periodsValue, 0);
		}
	};
	//获取vmAdd.grade
	function getGrade(data) {
		var ret = [];
		for(var i = 0; i < data.length; i++) {
			if(data[i].checkedStatus) {
				ret.push(data[i].value + '0');
			}
		}
		return ret;
	};

	//驳回
	function rejected(id, status) {
		var postData = {
			id: id,
			auditStatus: status,
		}
		console.log("==驳回==" + JSON.stringify(postData));
		$.confirm("是否确认驳回", '提示', ['确认', '取消'], function(e) {
			if(e.index == 0) {
				plus.nativeUI.showWaiting();
				c.DataUtil.assnAuditExamine(postData, function(res) { //社团驳回
					plus.nativeUI.closeWaiting();
					console.log("==assnAuditExamine==" + JSON.stringify(res));
					if(res.SystemCode == 1){
						$.toast("驳回成功");
						mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});//角标
						setTimeout(function(){
						    $.fire(plus.webview.currentWebview().opener(), 'reflush', {});
							plus.webview.currentWebview().close();
						},200); 
					}else if(res.SystemCode == 10019){
						$.toast("该记录已审批");
						setTimeout(function(){
						    $.fire(plus.webview.currentWebview().opener(), 'reflush', {});
							plus.webview.currentWebview().close();
						},200); 
					} else{
						$.toast("驳回失败");
					}
					

				}, function() {
					plus.nativeUI.closeWaiting();
					plus.nativeUI.toast("驳回失败");
				});
			}
		});

	}
	//验证
	function validate() {
		if(!vmAdd.periodsValue) {
			$.toast('请选择社团期数');
			return false;
		}
		if(!vmAdd.assnName) {
			$.toast('请填写社团名称');
			return false;
		}
		if(!vmAdd.typeValue) {
			$.toast('请选择社团类别');
			return false;
		}
		if(!vmAdd.placeName) {
			$.toast('请填写上课地点');
			return false;
		}
		if(!(vmAdd.teachersName)) {
			$.toast('请选择任课老师');
			return false;
		}
		if(!vmAdd.schooltime) {
			$.toast('请填写上课时间');
			return false;
		}
		if(!(vmAdd.totalEnrollNum&&vmAdd.totalEnrollNum!=0)) {
			$.toast('请填写报名总人数');
			return false;
		}
		if(!(vmAdd.enrollRange&&vmAdd.enrollRange.length)) {
			$.toast('请选择报名范围');
			return false;
		}
		if(!vmAdd.assnSynopsis) {
			$.toast('请填写社团简介');
			return false;
		}
		if(!(vmAdd.fileIds && vmAdd.fileIds.length)) {
			$.toast('请添加图片');
			return false;
		}
		if(!window.MethodUtil.filterEmoji(vmAdd.assnName)) {
			return false;
		}
		if(!window.MethodUtil.filterEmoji(vmAdd.placeName)) {
			return false;
		}
		if(!window.MethodUtil.filterEmoji(vmAdd.schooltime)) {
			return false;
		}
		if(!window.MethodUtil.filterEmoji(vmAdd.assnSynopsis)) {
			return false;
		}
		if(vmAdd.limit==1&&vmAdd.totalEnrollNum<sum(vmAdd.enrollRel)){
			$.toast('班级填写人数之和超过报名总人数');
			return false;
		}
		return true;
	}
	//形成数据
	function getDefaultData(data) {
		var gradeStart = 1;
		var clazzStart = 1;
		var enrollRange = [];
		var enrollNum = [];
		var enrollRel = [];
		var temp = [];
		var key;
		for(var i = gradeStart; i <= 6; i++) {
			for(var j = clazzStart; j <= 15; j++) {
				if(data[i.toString() + j]) {
					enrollRange.push(i.toString() + j);
					enrollRel.push(data[i.toString() + j] || '');
				}
				enrollNum.push(data[i.toString() + j] || ' ');

			}
		}
		return {
			enrollRange: enrollRange,
			enrollNum: enrollNum,
			enrollRel: enrollRel
		}
	};
	//查找班级
	function findGrade(grade) {
		return vmAdd.gradeAddData.filter(function(item) {
			return item.value == grade;
		});
	};
	//键值对数据
	function getInputData() {
		var ret = {};
		vmAdd.gradeAddData.map(function(item) {

			if(item.clazzList && item.clazzList.length) {
				item.clazzList.map(function(it) {
					ret[it.postKey] = it.word;
				});
			}

		});
		inputData = mui.extend({}, inputData, ret);
		return mui.extend({}, inputData, ret);
	}

	function getInputDataArr() {
		return vmAdd.gradeAddData.filter(function(item) {
			return item.checkedStatus

		}).map(function(item) {
			return item.gradeKey
		});
	}
	//提交的数据
	function getPostData(inputData) {
		var ret = {};
		if(vmAdd.limit == "1") {
			inputData = inputData || getInputData();
			ret = getDefaultData(inputData);
			console.log("inputData" + JSON.stringify(inputData));
		} else {
			ret = {
				enrollRange: getInputDataArr(),
				enrollNum: getDefaultData({}).enrollNum,
				enrollRel: []
			}
		}

		console.log("inputDataRet" + JSON.stringify(ret));

		return ret;
	}

	function checkstatus(grade) {
		var tarArr = findGrade(grade);
		console.log("tar" + JSON.stringify(tar));
		var status = false;
		if(tarArr && tarArr.length) {
			var tar = tarArr[0];
			if(tar.clazzList) {
				for(var i = 0; i < tar.clazzList.length; i++) {
					if(tar.clazzList[i].word != '') {
						status = true;
						break;
					}
				}
				tar.checkedStatus = status;
				vmAdd.$forceUpdate();
			}
		}
	}

	function getClazzWord(item) {
		var ret = "";
		var arr = vmAdd.enrollRange || [];
		var enrollNumArr = vmAdd.enrollRel || [];
		var idx = arr.indexOf(item.postKey);
		if(idx != -1 && enrollNumArr.length) {
			ret = enrollNumArr[idx];
		}
		return ret;
	}

	function getCheckedStatus(arr, val) {
		return arr.filter(function(item) {
			return item.substring(0, 1) == val;
		}).length
	}

	function dataHandler(grade, data) {
		var tar = findGrade(grade);
		console.log("tar" + JSON.stringify(tar));
		if(tar && tar.length) {

			tar[0].clazzList = data.map(function(item, index) {
				item.postKey = grade + (index * 1 + 1);
				item.word = getClazzWord(item);
				return item;
			});
			tar[0].collapse = true;
		}

	}

	function getClassFn(grade) {
		var tarGradeArr = findGrade(grade);
		if(tarGradeArr && tarGradeArr.length) {
			var tar = tarGradeArr[0];
			if(!tar.collapse) {
				if(!tar.clazzList) {
					c.DataUtil.findClassInfo(grade, function(res) { //社团时间（期数）
						plus.nativeUI.closeWaiting();
						console.log("==findClassInfo==" + JSON.stringify(res));
						var data = res.data || [];
						dataHandler(grade, data);
						console.log("getClassFn" + JSON.stringify(vmAdd.gradeAddData));
						vmAdd.$forceUpdate();
					}, function() {
						plus.nativeUI.closeWaiting();
						plus.nativeUI.toast("请求出错");
					});
				} else {
					tar.collapse = true;
					vmAdd.$forceUpdate();
				}
			} else {
				tar.collapse = false;
				vmAdd.$forceUpdate();
			}
		}
	}

	//图片
	function loop(callBack) {
		var i = 0;
		var temp = [];
		return function() {
			var me = arguments.callee;
			var photos = vmAdd.fileIds || [];
			if(photos.length) {
				if(i < photos.length) {
					if(photos[i].match("file:")) {
						window.MethodUtil.uploadImage(photos[i], function(data) {
							temp.push(data.pk);//data.data[0]
							i++;
							me(i, callBack);
						});
					} else {
						temp.push(photos[i]);
						i++;
						me(i, callBack);
					}

				} else {
					callBack(temp);
				}
			} else {
				callBack(temp);
			}
		}
	};

	function getCamera(callback) {
		c.MethodUtil.getCamera(function(path) {
			zipPhoto(path, callback);
		});
	};

	function zipPhoto(path, callback) {
		c.MethodUtil.compressImage(path, baseUrl + _getpath(path),
			function(zipEvent) {
				callback(path, zipEvent);
			});
	};

	function getPhoto(that) {
		getCamera(function(path, zipEvent) {
			vmAdd.fileIds.push(zipEvent.target);
		});
	};

	function _getpath(path) {
		return path.substring(path.lastIndexOf('/'));
	};

	function getPic(that) {
		var max = maxNum || 3;
		var photosCount = vmAdd.fileIds.length;
		flag = max - photosCount;
		if(photosCount < max) {
			plus.gallery.pick(function(e) {
					for(var item in e.files) {
						var path = e.files[item];
						zipPhoto(path, function(path, zipEvent) {
							vmAdd.fileIds.push(zipEvent.target);
						});
					}
				},
				function() {
					plus.nativeUI.toast('取消选择图片');
				}, {
					filter: 'image',
					multiple: true,
					maximum: flag,
					system: false,
					onmaxed: function() {
						plus.nativeUI.toast("最多只能选取" + max + "张图片");
						return;
					}
				});
		} else {
			plus.nativeUI.toast("已经选取" + max + "张图片");
			return;
		}
	}
	
	function sum(arr) {
	  	return eval(arr.join("+"));
	};

	function bindEvent() {
		//选择任课教师
		window.addEventListener('afterSeleted', function(e) {
			console.log("e.detail=====" + JSON.stringify(e.detail));
			vmAdd.teachersId = e.detail.selectedIds;
			vmAdd.teachersNameList = e.detail.selectedName;
			vmAdd.teachersName = e.detail.selectedName.join(',');
		});
		//删除图片
		mui(document).on('tap', '.img_cancel', function(e) {
			e.stopPropagation();
			var liElem = this.parentNode;
			var idx = liElem.dataset.idx;
			vmAdd.fileIds.splice(idx, 1);
		});
		//待办推送
		window.addEventListener('refreshCurrentPage', function(e) {
			detailId = e.detail.push_detail_id;
			vmAdd.isBtnShow = e.detail.isBtnShow;
			initPage()
		});
	}

	return {
		init: function() {
			detailId = plus.webview.currentWebview().detail||plus.webview.currentWebview().push_detail_id;
			vmAdd.isBtnShow = plus.webview.currentWebview().isBtnShow;
			initPage();
			bindEvent();
		},
	}
}(window, mui));