/*
 * 页面：功能室预约
 * 说明：功能室预约
 * 创建人：dwm
 * 创建时间：2018/3/17 13：00
 * 修改人：
 * 修改时间：
 */

//新增功能室预约
var reservationAdd = (function(c, $) {
	var roomId = '';
	var sendTime = '',
		timeSelectEnd, //结束时间选择器的默认值
		timeSelect, 
		startTimeValue,//开始时间选择器的默认值
		pickerStart; //开始时间选择器
	var vmReservationAdd = new Vue({
		el: '#vmReservationAdd',
		data: {
			applyName: null,
			selectedIds: [], //备选人的id集合
			selectedName: [], //被选人的姓名集合
			selectedPersonList: [],
			selectIdOrgs: [] //被选人的部门以及id集合
		},
		methods: {}
	});
	//获取功能室
	var typeArr = [];

	function getRooms() {
		c.DataUtil.getAllRoom(function(res) {
			console.log("==获取功能室==" + JSON.stringify(res));

			var data = res.data || [];
			for(var i = 0; i < data.length; i++) {
				typeArr.push({
					value: data[i].roomId,
					text: data[i].roomName
				});
			}

		});

	}
	//

	//绑定事件
	function bindEventHandler() {
		var startTime = '';
		var endTime = '';
		//选择开始时间
		document.getElementById("startReservation").addEventListener('tap', function() {
			document.activeElement.blur();
			pickerStart = new $.DtPicker({
				"type": "datetime",
				beginDate: new Date()

			}); //初始化DtPicker组件
			pickerStart.show(function(selectItem) {
				timeSelectNew = selectItem.value
				console.log("时间:" + selectItem.value + "：" + selectItem.text);
				document.getElementById('startReservation').style.color = '#000';
				document.getElementById('startReservation').innerText = selectItem.text;
				timeSelect = sendTime + ' ' + selectItem.value;
				startTimeValue = selectItem.value;
				startTime = selectItem.text;
				pickerStart.dispose();
			});
			console.log("startTimeValue:" + startTimeValue);
			pickerStart.setSelectedValue(startTimeValue); //设置默认选中
		});

		//自定义事件 => 选择人员后
		window.addEventListener('afterSeleted', function(e) {
			//			console.log(JSON.stringify(e.detail))
			vmReservationAdd.selectedIds = e.detail.selectedIds;
			//			console.log(JSON.stringify(e.detail.selectedIds));
			vmReservationAdd.selectedPersonList = e.detail.selectedPersonList;
			vmReservationAdd.selectIdOrgs = e.detail.selectIdOrgs;
			document.getElementById("meetPersonText").value = e.detail.selectedName.join(',')
		})

		//是否开始会议签到
		document.getElementById("switch").addEventListener("toggle", function(event) {
			if(event.detail.isActive) {
				//				console.log("你启动了开关");
				document.getElementById("meetPersonText").value = '';
				vmReservationAdd.selectedIds = [];
				document.getElementById("meetPerson").style.display = 'block';
			} else {
				//				console.log("你关闭了开关");
				document.getElementById("meetPerson").style.display = 'none';
			}
		})

		//跳转选人页面
		document.getElementById("meetPersonText").addEventListener('tap', function() {
			window.WebviewUtil.show('selectPeople', {
				selectedPerson: vmReservationAdd.selectedPersonList,
				selectId: vmReservationAdd.selectedIds,
				selectIdOrgs: vmReservationAdd.selectIdOrgs
			});
		})

		document.getElementById("endReservation").addEventListener('tap', function() {
			document.activeElement.blur();

			var pickerEnd = new $.DtPicker({
				"type": "datetime",
				beginDate: new Date(startTime)

			}); //初始化DtPicker组件
			pickerEnd.show(function(selectItem) {
				//				console.log("时间:" + selectItem.value);
				document.getElementById('endReservation').style.color = '#000';
				document.getElementById('endReservation').innerText = selectItem.text;
				timeSelectEnd = selectItem.value;
				endTime = selectItem.text;
				pickerEnd.dispose();
			});
			//			console.log("timeSelectEnd:" + timeSelectEnd);
			pickerEnd.setSelectedValue(timeSelectEnd); //设置默认选中
		});
		document.getElementById("roomSelect").addEventListener('tap', function(e) {
			var that = this;
			e.preventDefault();
			var roomPicker = new mui.PopPicker();
			roomPicker.setData(typeArr);
			document.activeElement.blur();
			roomPicker.show(function(selectItems) {
				roomId = selectItems[0].value;
				that.innerText = selectItems[0].text;
				that.style.color = '#000';
				roomPicker.dispose();
			});
			console.log("roomId=====:" + roomId);
			roomPicker.pickers[0].setSelectedValue(roomId); 
		});
		document.getElementById('submit').addEventListener('tap', function() {
			document.activeElement.blur();
			var reson = document.getElementById('explain').value; //预约原因
			var meetPersonText = document.getElementById("meetPersonText").value;
			if(document.getElementById("startReservation").innerText == '选择开始时间') {
				$.toast('请选择开始时间');
				return;
			}
			if(document.getElementById("endReservation").innerText == '选择结束时间') {
				$.toast('请选择结束时间');
				return;
			}

			var now = new Date();
			var dd = now.getFullYear() + '-' + (now.getMonth() > 8 ? (now.getMonth() + 1) : '0' + (now.getMonth() + 1)) + '-' + (now.getDate() > 9 ? now.getDate() : '0' + now.getDate())
			var hh = now.getHours(); //时  
			var mm = now.getMinutes(); //分  
			var clock = "";
			if(hh < 10) {
				clock += "0";
			}
			clock += hh + ":";
			if(mm < 10) {
				clock += '0';
			}
			clock += mm;
			if(startTime > endTime) {
				$.toast('结束时间不能早于开始时间');
				return;
			}
			if(startTime == endTime) {
				$.toast('开始时间与结束时间不能相同');
				return;
			}
			if((dd == sendTime) && (startTime < clock)) {
				$.toast('请选择当前时间之后的时间');
				return;
			}
			if(roomId.trim() == '') {
				$.toast('请选择功能室');
				return;
			}
			var isActive = document.getElementById("switch").classList.contains("mui-active");
			if(isActive && (meetPersonText == '' || vmReservationAdd.selectedIds.length == 0)) {
				$.toast('请选择参会人员');
				return;
			}
			if(reson.trim() == '') {
				$.toast('请填写申请理由');
				return;
			}
			if(!isActive) {
				var obj = {
					roomId: roomId,
					startTime: startTime + ":00",
					endTime: endTime + ":59",
					theme: reson,
					isSign: '0',
					joinPeople: '',
				}
			} else {
				var obj = {
					roomId: roomId,
					startTime: startTime + ":00",
					endTime: endTime + ":59",
					theme: reson,
					isSign: '1',
					joinPeople: vmReservationAdd.selectedIds.join(',')
				}
			}

			console.log('==saveRoom提交的数据==' + JSON.stringify(obj));
			console.log('==saveRoom提交的数据==' + sendTime);
			mui.confirm('是否确认提交？', '提示', ['确认', '取消'], function(e) {

				if(e.index == 1 || e.index == -1) {
					return;
				} else {
					plus.nativeUI.showWaiting('预约中...');
					window.DataUtil.saveRoom(obj, function(res) {
						plus.nativeUI.closeWaiting();
						console.log('数据提交成功，后台反馈数据res' + JSON.stringify(res));
						if(res.SystemCode == 1) {
							$.toast('预约成功');
							$.fire(plus.webview.currentWebview().opener(), 'success', {});
							plus.webview.currentWebview().close();
						} else if(res.SystemCode == 10009) {
							$.toast('所选时间与他人冲突');
						}else{
							$.toast("预约失败");
						}
					}, function(xhr, type, err) {
						plus.nativeUI.closeWaiting();
						$.toast('预约失败');
					})
				}
			});

		})

	}
	return {
		init: function() {
			vmReservationAdd.applyName = window.MethodUtil.getUserInfo().userName;
			roomId = plus.webview.currentWebview().roomId || '';
			if(!roomId) {
				getRooms();
			}
			//sendTime = plus.webview.currentWebview().sendTime||'';
			//console.log("sendTime" + sendTime);
			bindEventHandler();
		}
	}
})(window, mui)

//功能室预约列表
var reservationIndexList = (function(c, $) {
	var userInfo;
	var vmIndexList = new Vue({
		el: '#listContentMain',
		data: {
			list: [],
			ready: false
		},
		methods: {
			reservation_enter: function() {
				window.WebviewUtil.show('addReservation')
			}
			/*btn_add_order: function() {
				window.WebviewUtil.show('addReservation')
			}*/
		},
		filters: {
			subStr: function(val) {
				return val.slice(11)
			},
			preStr: function(val) {
				var parts = val.replace(":", "-").replace(" ", "-").split("-");
				return parts[1] + "-" + parts[2];
			}
		}
	});

	function translateTime(ddStr) {
		var unit = 24 * 60 * 60 * 1000;
		var today = new Date(new Date().getFullYear(), new Date().getMonth() + 1, new Date().getDate());
		console.log('today===='+today);
		var ddStrArr = ddStr.split("-");
		console.log('ddStrArr===='+ddStrArr);
		var dd = new Date(ddStrArr[0], ddStrArr[1], ddStrArr[2]);
		console.log('(today - dd) / unit===='+(today - dd) / unit);
		return(today - dd) / unit;
	}

	function preStr(val, start, end) {
		var ret = '';
		var parts = val.replace(":", "-").replace(" ", "-").split("-");
		console.log('parts===='+parts);
		ret = parts.slice(start, end).join("-");
		console.log('ret===='+ret);
		return ret;
	}

	function viewText(str1, str2) {
		var ret = "";
		if(preStr(str1, 0, 3) == preStr(str2, 0, 3)) {
			if(preStr(str1, 0, 1) == new Date().getFullYear()) {
				var interval = translateTime(preStr(str1, 0, 3));
				console.log('interval===='+interval);
//				if(interval == 0) {
//					ret = "今天";
//				} else {
//					ret = preStr(str1, 1, 3);
//				}
				ret = preStr(str1, 1, 3);
			} else {
				ret = preStr(str1, 0, 3);
			}
		} else {
			if(preStr(str1, 0, 1) == preStr(str2, 0, 1) && preStr(str1, 0, 1) == new Date().getFullYear()) {
				ret = preStr(str1, 1, 3) + "~" + preStr(str2, 1, 3);
			} else {
				ret = preStr(str1, 0, 3) + "~" + preStr(str2, 0, 3);
			}
		}
		
		console.log('ret===='+ret);
		return ret;
	}

	function dataHandler(data) {
		var obj = {};
		var ret = [];
		data = data || [];

		for(var i = 0; i < data.length; i++) {
			if(!obj[data[i].roomId]) {
				obj[data[i].roomId] = {
					roomId: data[i].roomId,
					roomName: data[i].roomName,
					reserveList: []
				};
			}
			if(obj[data[i].roomId] && data[i].startHm && data[i].endHm) {
				data[i].viewText = "";
				if(data[i].startDate && data[i].endDate) {
					data[i].viewText = viewText(data[i].startDate, data[i].endDate);
				}
				obj[data[i].roomId].reserveList.push(data[i]);
			}
		}

		for(var roomId in obj) {
			ret.push(obj[roomId])
		}
		return ret;

	}
	//功能室列表
	function orderFunctionList() {
		c.DataUtil.orderFunctionList(function(res) {
			console.log('===功能室列表===' + JSON.stringify(res));
			if(res.SystemCode == 1) {
				vmIndexList.list = dataHandler(res.FunctionRoomsList);
				vmIndexList.ready = true;
			} else {
				mui.toast(c.ERROR_CONFIG[res.SystemCode]);
				return;
			}
		}, function() {
			//			console.log('数据失败')
			plus.nativeUI.toast("请求出错");
		});
	}
	//绑定事件
	function bindEventHandler() {
		document.getElementById('reservation').addEventListener('tap', function() {
			window.WebviewUtil.show('addReservation');
		});
		document.getElementById('btn_my_orders').addEventListener('tap', function() {
			window.WebviewUtil.show('mineReservation');
		});
		window.addEventListener("success", function(e) {
			orderFunctionList();
		});
		//跳转详情
		/*$('#listContentMain').on('tap', '.m-room', function() {
			c.WebviewUtil.show('roomDetail', {
				roomId: this.dataset.roomId
			});
		});*/
	}
	return {
		init: function() {
			orderFunctionList();
			bindEventHandler();
		}
	}
})(window, mui);

//我的功能室预约列表
var mineReservationList = (function(c, $) {
	var userId;
	var canNext = false;
	var pageNo = 1;
	var pageSize = 10;
	var total = 0;
	var vmMineIndexList = new Vue({
		el: '#mineListContentMain',
		data: {
			list: [],
		},
		methods: {

		},
		filters: {
			subStr: function(val) {
				return val.slice(11)
			}
		}
	});

	function getParams() {
		return {
			pageNo: pageNo,
			pageSize: pageSize
		}
	}

	function setParams(val) {
		pageNo = val;
	}

	function hasNext() {
		var ret = Math.ceil(total / pageSize) > pageNo;
		console.log("hasNext:" + ret);
		return Math.ceil(total / pageSize) > pageNo;
	}

	function bindEvents() {
		$('#mineListContentMain').on('tap', '.del', function() {
			var id = this.dataset.id;
			var index = this.dataset.index;
			var self = this;
			$.confirm('确认取消预约该功能室吗？', '提示', ['确认', '取消'], function(e) {
				if(e.index == 1 || e.index == -1) {
					return;
				} else {
					//删除
					c.DataUtil.deleteRoom(id, function(res) {
						//						console.log('===删除预约==' + JSON.stringify(res));
						if(res.SystemCode == 1) {
							setTimeout(function() {
								vmMineIndexList.list.splice(index, 1);
								$.fire(plus.webview.currentWebview().opener(), 'success', {});
								mui.toast("成功取消预约");
							}, 300);
							//							document.getElementById("mineListContentMain").removeChild(self.parentNode);
						} else {
							$.toast('取消预约失败');
						}

					}, function(xhr, type, err) {
						$.toast('取消预约失败');
					})
				}
			})
		})
	}

	function mineIneFunctionList(isDown) {
		var refreshBlock = mui('#refreshContainer').pullRefresh();
		if(isDown) { //下拉
			setParams(1);
			c.DataUtil.mineFunctionList(getParams(), function(res) {
				res = res || {};
				res.page = res.page || {};
				res.page.rows = res.page.rows || [];
				
				mui('#refreshContainer').pullRefresh().endPulldown(); //结束下拉
				console.log('【我的功能室预约列表】===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					//					console.log(JSON.stringify(res.varList))
					total=res.page.records;
					canNext = hasNext();
					if(!canNext) { //无下一页数据
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
						setParams(pageNo + 1);
					}
					if(!res.page.rows.length){
						mui.toast("没有记录");
					}
					vmMineIndexList.list = res.page.rows;
					
				} else {
					mui.toast(ERROR_CONFIG[res.SystemCode]);
					return;
				}
			}, function() {
				//				console.log('数据失败')
				plus.nativeUI.toast("请求出错");
			});
		} else { //上拉
			if(!canNext) {
				mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
				return;
			} else {
				mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
				mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
			}
			c.DataUtil.mineFunctionList(getParams(), function(res) {
				//				console.log('【我的功能室预约列表】===' + JSON.stringify(res));
				res = res || {};
				res.page = res.page || {};
				res.page.rows = res.page.rows || [];
				if(res.SystemCode == 1) {
					//					console.log(JSON.stringify(res.varList))
					total=res.page.records||0;
					canNext = hasNext();
					vmMineIndexList.list = vmMineIndexList.list.concat(res.page.rows);
					if(!canNext) {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					} else {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
						setParams(pageNo + 1);
					}
				} else {
					mui.toast(ERROR_CONFIG[res.SystemCode]);
					return;
				}
			}, function() {
				//				console.log('数据失败')
				plus.nativeUI.toast("请求出错");
			});
		}

	}
	return {
		init: function() {
			userId = window.MethodUtil.getUserInfo().userId;
			//			mineIneFunctionList(true);
			bindEvents()
		},
		mineIneFunctionList: mineIneFunctionList
	}

})(window, mui);

var roomDetail = (function(c, $) {
	var vm = new Vue({
		el: '#room',
		data: {
			dateList: [],
			detailList: [],
		},
		methods: {

		},
		filters: {
			subStr: function(val) {
				return val.slice(11)
			}
		}
	});
	var roomId = ''; //功能室id
	var sendTime = ''; //传给新增的页面的日期
	//事件绑定
	function bindEvents() {
		//点击日期事件
		$('.m-top-date').on('tap', '.u-date-num', function() {
			for(var i = 0; i < document.querySelectorAll('.u-date-num').length; i++) {
				if(document.querySelectorAll('.u-date-num')[i].classList.contains('u-date-num-active')) {
					document.querySelectorAll('.u-date-num')[i].classList.remove('u-date-num-active');
				}
			}
			this.classList.add('u-date-num-active');
			sendTime = this.dataset.sendTime;
			getRoom(this.dataset.time);

		});
		//跳转添加
		document.getElementById("add").addEventListener('tap', function() {
			c.WebviewUtil.show('addReservation', {
				sendTime: sendTime,
				roomId: roomId
			})
		})

		//刷新页面
		window.addEventListener('success', function() {
			getRoom(sendTime);
		})
	}

	function formatDate(val) {
		switch(val) {
			case 0:
				return '日';
				break;
			case 1:
				return '一';
				break;
			case 2:
				return '二';
				break;
			case 3:
				return '三';
				break;
			case 4:
				return '四';
				break;
			case 5:
				return '五';
				break;
			case 6:
				return '六';
				break;
			default:
				break;
		}
	}

	//获取当前的时间和未来六天的日期
	function getDayTime() {
		var dates = [];
		var datestr;
		var myDate = new Date();
		for(var i = 0; i < 7; i++) {
			dates.push({
				monthTitle: myDate.getMonth() + 1,
				day: myDate.getDate(),
				week: formatDate(myDate.getDay()),
				date: myDate.getFullYear() + '-' + (myDate.getMonth() > 8 ? (myDate.getMonth() + 1) : '0' + (myDate.getMonth() + 1)) + '-' + (myDate.getDate() > 9 ? myDate.getDate() : '0' + myDate.getDate())
			});
			myDate.setTime(myDate.getTime() + 1000 * 60 * 60 * 24);
		}
		return dates;
	}
	//查询详情
	function getRoom(date) {
		c.DataUtil.getRoom(date, roomId, function(res) {
			console.log('===功能室详情===' + JSON.stringify(res));
			if(res.SystemCode == 1) {
				vm.detailList = res.roomsDataList;
			}
		}, function(xhr, type, err) {
			$.toast('请求出错');
		})
	}

	return {
		init: function() {
			roomId = plus.webview.currentWebview().roomId;
			vm.dateList = getDayTime();
			bindEvents();
			var time = new Date();
			var curTime = time.getFullYear() + '-' + (time.getMonth() > 8 ? (time.getMonth() + 1) : '0' + (time.getMonth() + 1)) + '-' + (time.getDate() > 9 ? time.getDate() : '0' + time.getDate());
			sendTime = curTime;
			getRoom(curTime);
		}
	}
}(window, mui));