//列表
var orderIndex = (function(c, $) {
	var pageNo = 1, //默认第一页
		pageSize = 10, //默认一页10条数据
		maxPage; //最大页数

	var vmOrderList = new Vue({
		el: '#orderList',
		data: {
			listData: [],
			curType: '2', //2与我有关，3我要听课，5我要上课，4班级视导
			startDate: '',//日报管理加进来的
			endDate: '',//日报管理加进来的
			dailyMask:true,//日报管理加进来的
		},
		created: function() {

		},
		methods: {
			changeType: function(type, e) {
				fnChangeType(type, e)
			},
			goListenAdd: function() {
				window.WebviewUtil.show('listenAdd');
			},
			goToAdd: function() {
				window.WebviewUtil.show('goToAdd');
			},
			goSuperviseAdd: function() {
				window.WebviewUtil.show('superviseAdd');
			},
			goDetail: function(id, index) {
				WebviewUtil.show('orderCourseDetail', {
					'detailid': id,
					'itemIndex': index
				});
			},
		},
		filters: {

		}
	});

	//tab切换
	function fnChangeType(type, e) {
		var active = document.getElementsByClassName('active');
		for(var i = 0; i < active.length; i++) {
			active[i].classList.remove('item-active');
		}
		e.target.classList.add('item-active');
		pageNo = 1;
		vmOrderList.curType = type;
		console.log('vmOrderList.curType===' + vmOrderList.curType);
		orderListData(true);
	}

	//获取约课列表
	function orderListData(isRefresh) {
		if(isRefresh) { //下拉刷新
			pageNo = 1;
			var obj = {
				pageNo: pageNo,
				pageSize: pageSize,
				queryType: vmOrderList.curType,
				startDate: vmOrderList.startDate,
				endDate: vmOrderList.endDate,
			}
			console.log('obj111111=====' + JSON.stringify(obj))
			c.DataUtil.orderListData(obj, function(res) {
				plus.nativeUI.closeWaiting();
				console.log('【约课列表列表====】' + JSON.stringify(res));
				mui('#refreshContainer').pullRefresh().endPulldown(); //结束下拉刷新
				if(res.SystemCode == 1) {
					if(res.data.rows.length == 0) {
						vmOrderList.listData = [];
						mui.toast('没有数据');
						return;
					}
					maxPage = Math.ceil((res.data.records) / pageSize);
					console.log('maxPage======' + maxPage);
					vmOrderList.listData = res.data.rows;
					mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
					if(maxPage == 1) { //无下一页数据
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
					}
				} else {
					mui.toast(ERROR_CONFIG[res.SystemCode]);
					return;
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		} else { //上拉加载
			pageNo++;
			var obj = {
				pageNo: pageNo,
				pageSize: pageSize,
				queryType: vmOrderList.curType,
				startDate: vmOrderList.startDate,
				endDate: vmOrderList.endDate,
			}
			if(maxPage == 1) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			console.log('约课下一页obj=====' + JSON.stringify(obj))
			c.DataUtil.orderListData(obj, function(res) {
				plus.nativeUI.closeWaiting();
				console.log('【约课下一页】===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					temp = res.data.rows;
					vmOrderList.listData = vmOrderList.listData.concat(temp);
					if(maxPage <= pageNo) {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					} else {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
					}
				} else {
					mui.toast(ERROR_CONFIG[res.SystemCode]);
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		}

	}

	return {
		init: function() {
			vmOrderList.startDate = plus.webview.currentWebview().startTime || '';
			vmOrderList.endDate = plus.webview.currentWebview().endTime || '';
			vmOrderList.dailyMask = plus.webview.currentWebview().dailyMask || '';
			if(vmOrderList.dailyMask){
				vmOrderList.curType = '5';
			}
		},
		orderListData: orderListData
	}
})(window, mui);

//约课各种详情
var orderCourseDetail = (function(c, $) {
	var vmOrderCourseDetail = new Vue({
		el: '#orderDetail',
		data: {
			listData: {},
			commentsData: [],//评论
			files:[],//附件课案
		},
		created: function() {

		},
		methods: {
			submitComment: function(id) {
				commentSubmit(id);
				console.log("orderDetailsubmitComment");
			},
			attachment: function(id) {
				goAttachment(id)
			},

		},
		filters: {

		}
	});
	//设置title
	function isSupervise(title){
		document.getElementById('changeTitle').innerHTML = title;
	}
	
	
	//处理换行
	function dealData(data) {
		for(var i = 0; i < data.length; i++) {
			if(data[i].commentText.indexOf("\n") != -1) {
				data[i].commentText = c.MethodUtil.replaceLB(data[i].commentText);
			}
		}
		return data;
	}
	
    //评论权限
	function commentAuth(auth) {
		document.querySelector("#comment").style.display = (auth == '1' ? "block" : "none");
		document.querySelector("#holder").style.display = (auth == '1' ? "block" : "none");
	}
    //获取评论内容
	function getCommentCnt() {
		var ret = "";
		var el = document.querySelector("#commentCnt");
		el && (ret = el.value);
		return ret;
	}
    //评论校验
	function commentCheck() {
		var ret = "";
		var maxLen =500;
		var cnt = getCommentCnt();
		if(cnt == "") {
			ret = "请填写评论";
		} else if(!c.MethodUtil.filterEmoji(cnt)) {
			ret = "不能输入emoji表情";
		} else if(cnt.length > maxLen) {
			ret = "请输入500字以内评论";
		}

		return ret;
	}

	function commentSubmit(id) {
		var msg = commentCheck();
		if(msg){
			$.toast(msg);
			return;
		}
		//获取表单数据
		$.confirm('是否确认提交？', '提示', ['确认', '取消'], function(e) {
			if(e.index == 1 || e.index == -1) {
				return;
			} else {
				var obj ={
					classId:id,
					commentText:getCommentCnt()
				};
				plus.nativeUI.showWaiting('提交中...');
				console.log('提交之前-----obj===' + JSON.stringify(obj));
				c.DataUtil.reservationComment(obj, function(data) {
					console.log('提交之后-----data===' + JSON.stringify(data));
					plus.nativeUI.closeWaiting();
					 mui('#commentPanel').popover('toggle');
					if(data.SystemCode == 1) {
						$.toast("评论成功");
						commentAuth("0");
						initPage();
					} else {
						$.toast(ERROR_CONFIG[data.SystemCode]);
					}
				}, function(xhr) {
					console.log("error" + xhr.status);
					plus.nativeUI.closeWaiting();
					plus.nativeUI.toast("请求出错" + xhr.status);
				});

			}
		});

	}

	function getDetail() {
		plus.nativeUI.showWaiting();
		var classId = plus.webview.currentWebview().detailid;
		console.log('classId约课详情详情----------------' + classId);
		window.DataUtil.getClassDetail(classId, function(res) {
			res = res || {};
			res.data = res.data || {};
			plus.nativeUI.closeWaiting();
			console.log('约课详情详情' + JSON.stringify(res));
			if(res.SystemCode == '1') {
				vmOrderCourseDetail.listData = res.data;
				vmOrderCourseDetail.files = res.data.files;
				if(res.data.type != 3){
					if(res.data.comments.length == 0){
						$.toast("评论无记录");
					} else {
						vmOrderCourseDetail.commentsData = dealData(res.data.comments);
					}
				}
				if(res.data.type == 3){
					isSupervise('班级视导详情');
				}
				commentAuth(res.data.isComment);
			} else {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});
	}

	function initPage() {
		getDetail();
	}
	//点击查看附件教案
	function goAttachment(fileId) {
//		console.log('fileId==fileIdfileIdfileIdfileId===='+fileId)
//		var isIphoneX = /iphone/gi.test(navigator.userAgent) && (screen.height == 812 && screen.width == 375);
//		console.log('附件地址==='+window.FILE_TRANSFORM_SERVER + window.FILE_HOST_CONFIG_VIEW + fileId);
//		var subView = plus.webview.create(window.FILE_TRANSFORM_SERVER + window.FILE_HOST_CONFIG_VIEW + fileId, null, {
//			top: isIphoneX ? '85px' : '60px',
//			bottom: '0',
//			scalable: true
//		});
//		plus.webview.currentWebview().append(subView);
//		subView.show();
		WebviewUtil.show('orderCourseFile', {
			'fileId': fileId
		});
		
		
		
	}

	return {
		init: function() {
			initPage()
		},
	}
})(window, mui);

//约课拒绝原因
var refuseReason = (function(c, $) {
	var pageNo = 1, //默认第一页
		pageSize = 10, //默认一页10条数据
		id, //拒绝id
		maxPage; //最大页数

	var vmRefuseReason = new Vue({
		el: '#refuseReason',
		data: {
			listData: [],
		},
		created: function() {

		},
		methods: {

		},
		filters: {

		}
	});

	//获取约课拒绝原因列表
	function refuseReasonListData(isRefresh) {
		if(isRefresh) { //下拉刷新
			pageNo = 1;
			var obj = {
				pageNo: pageNo,
				pageSize: pageSize,
				id: id,
			}
			console.log('obj约课拒绝原因=====' + JSON.stringify(obj));
			plus.nativeUI.showWaiting();
			c.DataUtil.getReasonList(obj, function(res) {
				plus.nativeUI.closeWaiting();
				console.log('【约课拒绝原因====】' + JSON.stringify(res));
				mui('#refreshContainer').pullRefresh().endPulldown(); //结束下拉刷新
				if(res.SystemCode == 1) {
					maxPage = Math.ceil((res.data.records) / pageSize);
					console.log('maxPage======' + maxPage);
					vmRefuseReason.listData = res.data.rows;
					mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
					if(maxPage == 1) { //无下一页数据
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
					}
				} else if(res.SystemCode == 1 && res.data.rows.length == 0) {
//					document.getElementById('anList').innerHTML = ' ';
					mui.toast('没有记录');
				} else {
					plus.nativeUI.toast("请求出错");
					return;
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		} else { //上拉加载
			pageNo++;
			var obj = {
				pageNo: pageNo,
				pageSize: pageSize,
				id: id,
			}
			if(maxPage == 1) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			console.log('约课拒绝原因obj=====' + JSON.stringify(obj))
			c.DataUtil.getReasonList(obj, function(res) {
				plus.nativeUI.closeWaiting();
				console.log('【约课拒绝原因下一页】===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					temp = res.data.rows;
					vmRefuseReason.listData = vmRefuseReason.listData.concat(temp);
					if(maxPage <= pageNo) {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					} else {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
					}
				} else {
					plus.nativeUI.toast("请求出错");
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		}

	}

	return {
		init: function() {
			id = plus.webview.currentWebview().detailid;
		},
		refuseReasonListData: refuseReasonListData
	}

})(window, mui);

//约课附件详情
var orderCourseFile = (function (c, $) {

    //初始化页面
    function initPage () {
        var fileId = plus.webview.currentWebview().fileId;
		console.log('fileId==fileIdfileIdfileIdfileId===='+fileId)
		var isIphoneX = /iphone/gi.test(navigator.userAgent) && (screen.height == 812 && screen.width == 375);
		console.log('附件地址==='+window.FILE_TRANSFORM_SERVER + window.FILE_HOST_CONFIG_VIEW + fileId);
		var subView = plus.webview.create(window.FILE_TRANSFORM_SERVER + window.FILE_HOST_CONFIG_VIEW + fileId, null, {
			top: isIphoneX ? '85px' : '60px',
			bottom: '0',
			scalable: true
		});
		plus.webview.currentWebview().append(subView);
		subView.show();
    }

    //绑定事件
    function bindEventHandler () {
    
    }
	
    return {
    	init: function () {
    		bindEventHandler();
    		initPage();
    	}
    }
})(window, mui);