/*
社团报名*/

var gradeProxy = {
    1: '一年级',
    2: '二年级',
    3: '三年级',
    4: '四年级',
    5: '五年级',
    6: '六年级'
};
var codeProxy = {
    "1": {msg: '报名成功'},
    '10002': {msg: '已报名'},
    '10013': {msg: '人数已满'},
    '10007': {msg: '不在报名范围内'},
    '10017': {msg: '您已报过其他社团'},
};
//列表
var OrganizationActivity = (function (c, $) {
    var scrollWrap = '#refreshContainer';
    var startTime = '', //开始时间
        endTime = '', //结束时间
        pageNo = 1,//默认第一页
        pageSize = 3,//默认一页10条数据
        maxPage = -1;//最大页数

    var vmRecipients = new Vue({
        el: '#culb',
        data: {
            listData: [],
            typeList: [],
            curType: '',
            typeWith: 100,
            imageUrl: window.IMAGE_GET_CONFIG
        },
        created: function () {
            fnGetActTypeList();
        },
        methods: {
            changeType: function (type, e) {
                fnChangeType(type, e)
            },
            goDetail: function (id, index) {
                WebviewUtil.show('MyClubDetail', {'detailid': id, 'itemIndex': index});
            },
        },
        filters: {
            formatDateStart: function (data) {
                return MethodUtil.getDate(data.replace(/-/g, '/'));

            },
            formatDateEnd: function (data) {
                return MethodUtil.getMonthDay(data.replace(/-/g, '/'));
            },
            checkTime: function (data, item) {
                var now = Date.now();
                var start = Date(item.enrollStartDate.replace(/-/g, '/'));
                return (now - start > 0 ) ? data : 0
            },
            getGrade: function (data) {
                switch (data) {
                    case '1':
                        return '报名范围： 一年级';
                        break;
                    case '2':
                        return '报名范围： 二年级';
                        break;
                    case '3':
                        return '报名范围： 三年级';
                        break;
                    case '4':
                        return '报名范围： 四年级';
                        break;
                    case '5':
                        return '报名范围： 五年级';
                        break;
                    case '6':
                        return '报名范围： 六年级';
                        break;
                    default :
                        return '';
                        break;
                }
            }
        }
    });

    function fnGetActTypeList() {
        DataUtil.getActType({}, function (res) {
            if (res.SystemCode === '1') {
                console.log(JSON.stringify(res.assnType));
                vmRecipients.typeList = res.assnType;
                vmRecipients.curType = vmRecipients.typeList[0].dictValue;
                if (vmRecipients.typeList.length <= 4) {
                    return
                }
                vmRecipients.typeWith += (vmRecipients.typeList.length - 4) * 25;
                return;
            }
            mui.toast(ERROR_CONFIG[res.SystemCode]);
        }, function (err) {
            plus.nativeUI.toast("请求出错");
        })
    }

    function fnChangeType(type, e) {
        //todo
        console.log(this);
        console.log(e.target);
        for (var i = 0; i < e.target.parentNode.children.length; i++) {
            e.target.parentNode.children[i].classList.remove('item-active');
        }
        e.target.classList.add('item-active');
        pageNo = 1;
        maxPage = -1;
        vmRecipients.curType = type;
        fnGetActivityList(true)
    }

    //处理数据
    function formatItem(itemList, rangeList, annexList) {
        if (!itemList || !rangeList) {
            this.setState({
                itemList: []
            });
            return;
        }
        var greardObj = {};
        var annexObj = {};
        rangeList.map(function (item) {
            var singleArr = [];
            var tempArr = item.enrollCode.split(',').map(function (grade) {
                var temp = grade.substr(0, 1);
                if (singleArr.indexOf(temp) === -1) {
                    singleArr.push(temp);
                }
            });
            singleArr.sort();
            console.log(singleArr);
            var tempSingleArr = singleArr.map(function (item) {
                return gradeProxy[item];
            });
            greardObj[item.assnInfoId] = tempSingleArr.join(',')
        });
        annexList.map(function (item) {
                annexObj[item.assnInfoId] = item.fileId
            }
        );
        return itemList.map(function (item) {
            item.rangeList = greardObj[item.id] || '';
            item.fileId = annexObj[item.id] || '';
            return item
        });
    }

    //获取活动列表
    function fnGetActivityList(isRefresh) {

        isRefresh ? pageNo = 1 : pageNo++;
        var param = {
            pageNo: pageNo,
            pageSize: pageSize,
            type: vmRecipients.curType || '1'
        };
        if (!isHasMore()) {
            return;
        }
        console.log('获取活动列表参数:' + JSON.stringify(param));

        window.DataUtil.findPageList(param,
            function (res) {
                console.log('活动列表返回:' + JSON.stringify(res));
                if (!res.success) {
                    mui.toast(ERROR_CONFIG[res.SystemCode]);
                    mui(scrollWrap).pullRefresh().endPulldown();
                    mui(scrollWrap).pullRefresh().endPullupToRefresh(true);
                    return;
                }

                if (res.page.rows.length === 0) {
                    vmRecipients.listData = [];
                    mui.toast('没有记录');
                    return;
                }
                maxPage = Math.ceil((res.page.records) / pageSize);
                var formatList = formatItem(res.page.rows, res.rangeList, res.annexList);
                if (isRefresh) {
                    vmRecipients.listData = formatList;
                } else {
                    var tempArr = vmRecipients.listData;
                    vmRecipients.listData = tempArr.concat(formatList);
                }
                stopLoadingFlag(isRefresh);
                console.log(JSON.stringify(vmRecipients.listData));

            }, function () {
                plus.nativeUI.closeWaiting();
                plus.nativeUI.toast("请求出错");
            });
    }

    function stopLoadingFlag(isRefresh) {
        isHasMore();
        if (isRefresh) {
            mui(scrollWrap).pullRefresh().refresh(true);
            mui(scrollWrap).pullRefresh().endPulldown();
        } else {
            mui(scrollWrap).pullRefresh().endPullupToRefresh(false);
        }

    }

    function isHasMore() {
        if (maxPage !== -1 && maxPage < pageNo) { //无下一页数据
            mui(scrollWrap).pullRefresh().endPullupToRefresh(true);
            return false;
        }
        return true
    }


    return {
        init: function () {
            addEventListener('SubmitEmit', function (event) {
                var tempList = vmRecipients.listData;
                var index = event.detail.index;
                tempList[index].enrollType = true;
                vmRecipients.listData = tempList;
            });
            addEventListener('loveChange', function (event) {
                var tempList = vmRecipients.listData;
                var index = event.detail.index;
                tempList[index].attention = event.detail.attention;
                vmRecipients.listData = tempList;
            })
        },
        getActivityList: fnGetActivityList
    }
})(window, mui);
//详情
var OrganizationActivityDetail = (function (c, $) {
    function uniq(array) {
        var temp = []; //一个新的临时数组
        for (var i = 0; i < array.length; i++) {
            if (temp.indexOf(array[i]) === -1) {
                temp.push(array[i]);
            }
        }
        temp.sort();
        return temp;
    }

    var vm = new Vue({
        el: '#orgDetail',
        data: {
            assnInfo: {
                enrollRange: []
            },
            assnAnnex: {},
            imageUrl: window.IMAGE_GET_CONFIG,
            btnMsg: '',
            isBtnFlag: false
        },
        methods: {
            attention: function () {
                this.assnInfo.praiseType = !this.assnInfo.praiseType;
                var params = {
                    assnInfoId: this.assnInfo.id,
                    status: this.assnInfo.praiseType
                };
                var _this = this;
                console.log(JSON.stringify({param: params, assnInfo: this.assnInfo}));
                window.DataUtil.dbclicklove(params, function (res) {
                    console.log('点赞' + JSON.stringify(res));
                    if (res.success) {
                        params.status ? _this.assnInfo.attention++ : _this.assnInfo.attention--;
                        loveChange(_this.assnInfo.attention);
                        return;
                    }
                    _this.assnInfo.praiseType = !_this.assnInfo.praiseType; //如果请求失败,点在状态还原
                }, function () {
                    plus.nativeUI.toast("请求出错");
                });
            },
            commit: function () {
                //报名
                submitAct();
            },
            back: function () {
                mui.back();
            },
            checkIsShowBtn: function () {
                console.log(this.assnInfo);
                var isInDate = ((new Date().getTime() - new Date(this.assnInfo.enrollEndDate.replace(/-/g, "/")).getTime()) < 0 && (new Date().getTime() - new Date(this.assnInfo.enrollStartDate.replace(/-/g, "/")).getTime()) > 0);
                console.log(isInDate);
                if (!this.assnInfo.enrollType && isInDate) {
                    this.btnMsg = '报名';
                    this.isBtnFlag = true;
                    return true
                }
                if (!isInDate) {
                    this.btnMsg = '不在报名时间内';
                }
                if (this.assnInfo.enrollType) {
                    this.btnMsg = '已报名';
                }
                this.isBtnFlag = false;
                return false
            }
        },
        filters: {
            formatDateStart: function (data) {
                return MethodUtil.getDate(data.replace(/-/g, '/'));
            },
            formatDateEnd: function (data) {
                return MethodUtil.getMonthDay(data.replace(/-/g, '/'));
            },
            getRange: function (data) {
                var arr = [];
                for (var i = 0; i < data.length; i++) {
                    arr.push(data[i].substring(0, 1));
                }
                arr = uniq(arr);
                var newArr = '';
                for (var j = 0; j < arr.length; j++) {
                    switch (arr[j]) {
                        case '1':
                            newArr = newArr + '一年级    ';
                            break;
                        case '2':
                            newArr = newArr + '二年级    ';
                            break;
                        case '3':
                            newArr = newArr + '三年级    ';
                            break;
                        case '4':
                            newArr = newArr + '四年级    ';
                            break;
                        case '5':
                            newArr = newArr + '五年级    ';
                            break;
                        case '6':
                            newArr = newArr + '六年级    ';
                            break;
                        default :
                            newArr = newArr + '    ';
                            break;
                    }
                }
                return newArr
            }
        }
    });

    function submitAct() {
        plus.nativeUI.showWaiting('正在报名...');
        var id = plus.webview.currentWebview().detailid;
        window.DataUtil.getRoleList(function (res) {
                if (res.success) {
                    if (!res.userRoleList || res.userRoleList.length === 0) {
                        plus.nativeUI.toast('没有学生信息');
                        return
                    }
                    for (var i = 0; i < res.userRoleList.length; i++) {
                        if (res.userRoleList[i].type == '2' && res.userRoleList[i].isDefault == '1') {
                            var stuId = res.userRoleList[i].studentId;
                        }
                    }
                    var param = {assnInfoId: id, studentId: stuId};
                    console.log('params报名=====' + JSON.stringify(param));
                    window.DataUtil.organizeCommit(param, function (resd) {
                        console.log('organizeCommit成功=====' + JSON.stringify(resd))
                        plus.nativeUI.closeWaiting();
                        if (resd.success) {
                            plus.nativeUI.toast(codeProxy[resd.SystemCode].msg);
                            if (resd.SystemCode === '1') {
                                orgDetail.isBtnFlag = false;
                                orgDetail.btnMsg = '已报名';
                                SubmitEmit();
                            }
                        } else {
                            plus.nativeUI.toast('请求出错')
                        }
                    }, function () {
                        plus.nativeUI.closeWaiting();
                        plus.nativeUI.toast("请求出错");
                    });
                } else {
                    plus.nativeUI.toast('获取孩子信息失败')
                }
            },
            function () {
                plus.nativeUI.toast("获取孩子信息失败");
            });
    }

    function getDetail() {
        plus.nativeUI.showWaiting('正在获取详情...');
        var actId = plus.webview.currentWebview().detailid;
        console.log('获取活动详情:'+JSON.stringify({id: actId}));
        window.DataUtil.organizeDetail({id: actId}, function (res) {
            plus.nativeUI.closeWaiting();
            console.log('社团活动详情' + JSON.stringify(res));
            if (res.SystemCode === '1') {
                vm.assnInfo = res.assnInfo;
                vm.assnAnnex = res.assnAnnex;
                vm.assnInfo.intro = MethodUtil.replaceLB(vm.assnInfo.assnSynopsis);
                vm.checkIsShowBtn();
            }
        }, function () {
            plus.nativeUI.closeWaiting();
            plus.nativeUI.toast("请求出错");
        });
    }

    function pageInit() {
        getDetail();
    }

    function SubmitEmit() {
        var itemIndex = plus.webview.currentWebview().itemIndex;
        if (typeof(itemIndex) === 'number') {
            var list = plus.webview.getWebviewById('Association');
            //触发列表界面的自定义事件（refresh）,从而进行数据刷新
            mui.fire(list, 'SubmitEmit', {index: itemIndex});
            //返回true，继续页面关闭逻辑
        }
    }

    function loveChange(attentionNum) {
        var itemIndex = plus.webview.currentWebview().itemIndex;
        if (typeof(itemIndex) === 'number') {
            var list = plus.webview.getWebviewById('Association');
            //触发列表界面的自定义事件（refresh）,从而进行数据刷新
            mui.fire(list, 'loveChange', {attention: attentionNum, index: itemIndex});
            //返回true，继续页面关闭逻辑
        }
    }

    return {
        init: function () {
            var deceleration = mui.os.ios ? 0.003 : 0.0009;
            $('.mui-scroll-wrapper').scroll({
                bounce: false,
                indicators: true, //是否显示滚动条
                deceleration: deceleration
            });
            pageInit();
        }

    }
})(window, mui);


