/*
 * 说明：计划管理页面逻辑
 * 创建人：lv
 * 创建时间：2018/03/13 11:30
 * 修改人：
 * 修改时间：
 */
//计划管理列表
var planList = (function(c, $) {
	var nextUrl = "", //下一页地址
		vm, //Vue
		obj = {
			isTot: 0 //1汇总列表0个人列表
		};
	var canNext = false;
	var pageNo = 1;
	var pageSize = 10;
	var total = 0;

	function getParams() {
		return {
			pageNo: pageNo,
			pageSize: pageSize
		}
	}

	function setParams(val) {
		pageNo = val;
	}

	function hasNext() {
		var ret = Math.ceil(total / pageSize) > pageNo;
		console.log("hasNext:" + ret);
		return Math.ceil(total / pageSize) > pageNo;
	}
	//获取列表数据
	function getPlanListMine(isRefresh) {
		if(isRefresh) { //下拉刷新
			setParams(1);
			c.DataUtil.getPlanListMine(getParams(), function(data) {
				console.log('【计划管理列表数据】' + JSON.stringify(data));
				data = data || {};
				data.page = data.page || {};
				data.page.rows = data.page.rows || [];
				total = data.page.records||0;
				mui('#refreshContainer').pullRefresh().endPulldown(); //结束下拉刷新
				if(data.SystemCode && data.page.rows.length) {
					vm.listData = data.page.rows;
					mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
					canNext = hasNext();
					if(!canNext) { //无下一页数据
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
						setParams(pageNo + 1);
					}
				} else {
					vm.listData = [];
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
					mui.toast("没有记录");
					return;
				}
			}, function() {
				plus.nativeUI.closeWaiting(); //结束加载框
				plus.nativeUI.toast("请求出错");
			});

		} else { //上拉加载
			if(!canNext) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			c.DataUtil.getPlanListMine(getParams(), function(data) {
				console.log('【计划管理下一页】===' + JSON.stringify(data));
				data = data || {};
				data.page = data.page || {};
				data.page.rows = data.page.rows || [];
				if(data.SystemCode) {
					vm.listData = vm.listData.concat(data.page.rows);
					canNext = hasNext();
					if(!canNext) {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true); //禁用上拉
					} else {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false); //启用上拉
						setParams(pageNo + 1);
					}
				} else {
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		}

	}

	//初始化页面
	function initPage() {
		window.addEventListener('refreshlist', function() {
			obj.isTot = 0;
			getPlanListMine(true);
		})
	}

	//绑定事件
	function bindEventHandler() {
		mui("#plan_list").on('tap', '.mui-slider-handle', function(e) {
			var itemId = this.dataset.item;
			window.WebviewUtil.show('PlanEditor', { //点击进入详情或编辑页面
				itemId: itemId
			});
		});
		//点击蓝按钮提交
		mui("#plan_list").on('tap', '.mui-btn-blue', function(e) {
			var Id = this.dataset.id;
			var submitStatus = this.dataset.num;
			var _self = this;
			var li = _self.parentNode.parentNode;
			if(submitStatus != 1) {
				mui.toast("请先编辑在提交");
				return;
			}
			mui.confirm('是否确认提交？', '提示', ['确 认', '取 消'], function(e) {
				console.log("===Id===" + JSON.stringify(Id));
				if(e.index == 1 || e.index == -1) {
					setTimeout(function() {
						$.swipeoutClose(li);
					}, 0);
					return;
				} else {
					plus.nativeUI.showWaiting("提交中...");
					window.DataUtil.postSubmitPlanDetail(Id, function(data) {
						plus.nativeUI.closeWaiting();
						//console.log("===保存===" + JSON.stringify(data));
						if(data.SystemCode == 1) {
							mui.toast("提交成功");
							_self.innerText = '已提交'; //提交后按钮提示字变已提交
							_self.style.backgroundColor = "red"; //提交按钮变红色
							_self.parentNode.parentNode.querySelector('.plan_buttom').querySelector('span.m-tag-status-rect').innerText = '已提交';
							_self.parentNode.parentNode.querySelector('.plan_buttom').querySelector('span.m-tag-status-rect').classList.remove("m-tag-status-alert");
							_self.parentNode.parentNode.querySelector('.plan_buttom').querySelector('span.m-tag-status-rect').classList.add("m-tag-status-green");
							_self.classList.remove("mui-btn-blue");
							_self.classList.add("mui-btn-red");
							setTimeout(function() {
								$.swipeoutClose(li);
							}, 600);

						} else {
							mui.toast(ERROR_CONFIG[data.SystemCode]);
						}
					}, function() {
						plus.nativeUI.toast("请求出错");
					});
				}
			});

		});

		//点击红按钮提示
		mui("#plan_list").on('tap', '.mui-btn-red', function(e) {
			mui.toast('已提交无需再次提交');
			var _self = this;
			var li = _self.parentNode.parentNode;
			setTimeout(function() {
				$.swipeoutClose(li);
			}, 0);
		});

		//点击灰色按钮提示
		mui("#plan_list").on('tap', '.mui-btn-gray', function(e) {
			mui.toast('请编辑');
			var _self = this;
			var li = _self.parentNode.parentNode;
			setTimeout(function() {
				$.swipeoutClose(li);
			}, 0);
		});

	}

	return {
		init: function() {
			vm = new Vue({
				el: '#plan_list',
				data: {
					listData: [],
					all: true
				},
				methods: {},
				filters: {
					moment: function(data) {
						return window.MethodUtil.getDate(data);
					}
				}
			});
			//plus.nativeUI.showWaiting();
			bindEventHandler();
			initPage();
		},
		getPlanListMine: getPlanListMine
	}
})(window, mui);

//计划管理编辑页面
var planEditor = (function(c, $) {
	var vm,
		picker, //选择器
		id, //详情id
		actmagTitle, //标题
		orgId, //机构id
		week, //周次
		weekPoint, //本周总结
		nextPlan, //下周安排
		itemId, //id
		departmentListName, //部门名
		typeArr, //部门数组
		totType,
		source,
		noticeId = "";

	function getParams() {
		if(noticeId) {
			return {
				id: itemId,
				noticeId: noticeId
			}
		} else {
			return {
				id: itemId
			}
		}
	}

	function getUrl() {
		var ret = "";
		if(noticeId) {
			ret = API_CONFIG.planDetailNotice;
		}
		return ret;
	}
	//初始化页面
	function initPage() {
		var url = getUrl();
		var params = getParams();
		c.DataUtil.getPlanListDetail(getUrl(), getParams(), function(data) {
			//更新角标
			mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
			mui.fire(plus.webview.getWebviewById('Notice'),'redDot', {redId:getParams().noticeId||""});
			plus.nativeUI.closeWaiting();
			console.log('【计划与总结列表详情数据】' + JSON.stringify(data));
			if(data.SystemCode) {
				document.getElementById('planEditor').style.display = 'block'; //请求到数据全部显示;
				id = data.data.id;
				if(noticeId) {
					data.data.status = "2";
				}
				if(data.data.status == '2') { //详情页面
					document.getElementById('title').innerText = '详情';
					document.getElementById('week').style.pointerEvents = 'none';
					document.getElementById('departmentList').style.pointerEvents = 'none';
					if(data.data.weekSummary) {
						//	本周小结分段
						data.data.weekSummary = window.MethodUtil.replaceLB(data.data.weekSummary);
					}

					if(data.data.nextPlan) {
						//	下周计划分段
						data.data.nextPlan = window.MethodUtil.replaceLB(data.data.nextPlan);

					}
					document.getElementById('submit_block').style.display = 'none';
				} else { //编辑页面状态值为0、1 为可编辑
					document.getElementById('title').innerText = '编辑';
					document.getElementById('submit_block').style.display = 'block';
				}

				if(data.data.status == "2") { //编辑时渲染选择器
					if(data.data.orgName){
					document.getElementById('departmentList').innerText = data.data.orgName; //选择部门设置部门类型
					document.getElementById('departmentList').classList.remove("prompt_color"); //移除灰色类名
					document.getElementById('departmentList').classList.add("prompt_color_active");//添加黑色类名
					document.getElementById('departmentList').classList.remove("m-placeholder");
					}
				} else {
					
					if(data.data.orgId) {
						orgId = data.data.orgId;
						for(var i = 0; i < typeArr.length; i++) {
							if(data.data.orgId == typeArr[i].value) {
								data.data.orgIdName = typeArr[i].text;
								data.data.orgIdNameNum = typeArr[i].index;
							}
						}
						if(data.data.orgIdName){
							document.getElementById('departmentList').innerText = data.data.orgIdName; //选择部门设置部门类型
							document.getElementById('departmentList').classList.remove("prompt_color"); //移除灰色类名
							document.getElementById('departmentList').classList.add("prompt_color_active"); //添加黑色类名
							document.getElementById('departmentList').classList.remove("m-placeholder");
	                    }
						if(noticeId) { //汇总标题
							document.getElementById('titleDetail').innerText = data.data.orgIdName + '第' + data.data.week + '周工作计划表';
						} else { //个人的标题
							document.getElementById('titleDetail').innerText = '天正小学' + data.data.orgIdName + '第' + data.data.week + '周工作计划表';
						}
						picker.pickers[0].setSelectedIndex(data.data.orgIdNameNum);
					}
					
				}

				if(data.data.week) { //设置周次
					document.getElementById('week').value = data.data.week;
				}
                 
				if(data.tzxxWeekPlans) { //表格数据是否存在
					data.data.actMags = data.tzxxWeekPlans;
					for(i = 0; i < data.data.actMags.length; i++) {
						//		上午说明分段
						data.data.actMags[i].morning = window.MethodUtil.replaceLB(data.data.actMags[i].morning);
						//		下午说明分段
						data.data.actMags[i].afternoon = window.MethodUtil.replaceLB(data.data.actMags[i].afternoon);

					}
					for(var i = 0; i < data.data.actMags.length; i++) {
						data.data.actMags[i].weekly = data.data.actMags[i].day;
						switch(data.data.actMags[i].weekly) { //周一到周日把数字变成星期几
							case '1':
								data.data.actMags[i].weekly = '星期一';
								break;
							case '2':
								data.data.actMags[i].weekly = '星期二';
								break;
							case '3':
								data.data.actMags[i].weekly = '星期三';
								break;
							case '4':
								data.data.actMags[i].weekly = '星期四';
								break;
							case '5':
								data.data.actMags[i].weekly = '星期五';
								break;
							case '6':
								data.data.actMags[i].weekly = '星期六';
								break;
							case '7':
								data.data.actMags[i].weekly = '星期日';
								break;
						}
					}

					data.data.nextPlans = data.data.actMags;
				}

				if(data.data.remarks) {
					//		备注说明分段
					data.data.remarks = window.MethodUtil.replaceLB(data.data.remarks);
				}

				vm.listData = data.data;
				
								console.log('【vm.listData】' + JSON.stringify(vm.listData));
			} else {

				vm.listData = {};
				
			}
			if(source == "2") {
				vm.listData.totType = "1";
			} else if(source == "3") {
				vm.listData.totType = "2";
			} else {
				vm.listData.totType = "3";
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});

	}

	//绑定事件
	function bindEventHandler() {
		//推送刷新
		window.addEventListener('refreshCurrentPage', function(e) {
			itemId = e.detail.push_detail_id;
			source = e.detail.source;
			noticeId = e.detail.noticeId;
			initPage();
		});

		//部门选择器
		document.getElementById('departmentList').addEventListener('tap', function() {
			var departmentListIndex;
			document.activeElement.blur();
			picker.show(function(selectItems) {
				orgId = selectItems[0].value;
				departmentListIndex = selectItems[0].index;
				departmentListName = selectItems[0].text;
				document.getElementById('departmentList').innerText = selectItems[0].text;
				document.getElementById('titleDetail').innerText = '天正小学' + selectItems[0].text + '周工作计划表';
				document.getElementById('departmentList').classList.remove("prompt_color");
				document.getElementById('departmentList').classList.add("prompt_color_active");
				document.getElementById('departmentList').classList.remove("m-placeholder");
			});

		})
		//点击提交按钮
		document.getElementById('submit_block').addEventListener('tap', function() {
			week = document.getElementById('week').value; //获取周次
			actmagTitle = '天正小学' + departmentListName + '第' + week + '周工作计划表'; //获取标题
			weekPoint = document.getElementById('weekPoint').value; //获取本周小结
			nextPlan = document.getElementById('nextPlan').value; //获取下周计划
			//console.log('标题 actmagTitle===' + actmagTitle);
			//console.log('周次 week===' + week);
			//console.log('部门类型 orgName===' + orgName);
			//console.log('本周总结 weekPoint===' + weekPoint);
			//console.log('下周计划 nextPlan===' + nextPlan);
			//console.log('本条id ===' + id);

			if(!orgId || orgId == '') { //类型
				$.toast('请选择部门类型');
				return false;
			}

			if(!window.MethodUtil.stringText(week, '周次')) { //校验参数
				return;
			}

//			if(!window.MethodUtil.stringText(weekPoint, '本周小结')) { //校验参数
//				return;
//			}
//
//			if(!window.MethodUtil.stringText(nextPlan, '下周计划')) { //校验参数
//				return;
//			}

			var obj = {
				actmagTitle: actmagTitle,
				week: week,
				orgName: orgId,
				weekSummary: weekPoint,
				nextPlan: nextPlan,
				id: id
			}
			//获取表单数据
			mui.confirm('是否确认保存？', '提示', ['确认', '取消'], function(e) {
				console.log("postSavePlanDetail提交的数据" + JSON.stringify(obj));
				if(e.index == 1 || e.index == -1) {
					return;
				} else {
					plus.nativeUI.showWaiting("保存中...");
					window.DataUtil.postSavePlanDetail(obj, function(data) {
						plus.nativeUI.closeWaiting();
						console.log("===保存===" + JSON.stringify(data));
						if(data.SystemCode == 1) {
							mui.toast("保存成功");
							var self = plus.webview.currentWebview();
							var opener = self.opener();
							mui.fire(opener, "refreshlist");
							mui.back();

						} else {
							mui.toast(ERROR_CONFIG[data.SystemCode]);
						}
					}, function() {
						plus.nativeUI.toast("请求出错");
					});
				}
			});

		})

	}

	return {
		init: function() {
			noticeId = plus.webview.currentWebview().noticeId || '';
			console.log('noticeId===='+noticeId);
			source = plus.webview.currentWebview().source || '';
			vm = new Vue({
				el: '#planEditor',
				data: {
					listData: []
				},
				methods: {},
				filters: {
					moment: function(data) {
						return window.MethodUtil.getDate(data);
					}
				}
			});

			document.getElementById('planEditor').style.display = 'none'; //进来全部隐藏
			//ajax 获取部门类型
			window.DataUtil.getDepartmentList(function(data) { //success
				console.log('部门类型' + JSON.stringify(data));
				if(data.SystemCode) {
					typeArr = [];
					for(var i = 0; i < data.data.length; i++) {
						typeArr.push({
							value: data.data[i].orgId,
							text: data.data[i].orgName,
							index: i
						});
					}
					picker = new mui.PopPicker(); //初始化popPicker组件
					picker.setData(typeArr);
					initPage();
				} else {
					//console.log('计划管理部门类型获取失败');
				}
			}, function(xhr, type, err) { //error
				//console.log('服务器异常')
			});

			plus.nativeUI.showWaiting();
			self = plus.webview.currentWebview();
			itemId = self.itemId || self.push_detail_id;
			bindEventHandler();

		}
	}
})(window, mui);