/*
 * 说明：护导巡视记录
 * 创建人：qk
 */

var clockRecord = (function(c, $) {
	var listDataAll = [];
	var initDefault = false;

	if(window.NodeList && !NodeList.prototype.forEach) {
		NodeList.prototype.forEach = function(callback, thisArg) {
			thisArg = thisArg || window;
			for(var i = 0; i < this.length; i++) {
				callback.call(thisArg, this[i], i, this);
			}
		};
	}

	function getCurrentDay() {
		var newDate = new Date();
		var month = newDate.getMonth() + 1;
		var day = newDate.getDate();
		if(month < 10) {
			month = '0' + month;
		} else {
			month = month;
		}
		if(day < 10) {
			day = '0' + day;
		} else {
			day = day;
		}
		return newDate.getFullYear() + '-' + month + '-' + day;
	}
	var date = getCurrentDay();
	var vmClockList = new Vue({
		el: '#mineListContentMain',
		data: {
			listData: [],
			dateList: [],
			status: ''
		},
		filters: {
			//processTime: function(value) {
			//	return moment(new Date(value)).utc().utcOffset(8).format("YYYY-MM-DD HH:mm");
			//},
			subStr: function(val) {
				return val.slice(0, 5);
			},
			preStr: function(val) {
				if(val) {
					return val.slice(10, 16);
				} else {
					return val;
				}
			},
			formatDate: function(timestamp) {
				var time = moment(new Date(timestamp)).format("YYYY-MM-DD HH:mm");
				return time.substr(10, 16);
			}

		}
	});

	function translate(val, num) {
		num = num || 2;
		var day = new Date(val);
		var hh = day.getHours() < 10 ? ("0" + day.getHours()) : day.getHours();
		var mm = day.getMinutes() < 10 ? ("0" + day.getMinutes()) : day.getMinutes();
		var ss = day.getSeconds() < 10 ? ("0" + day.getSeconds()) : day.getSeconds();
		if(num == 2) {
			return hh + ":" + mm;
		} else {
			return hh + ":" + mm + ":" + ss;
		}
	}

	function _getViewText(time, needDay, dayhandle) {
		var ret = "";
		ret = translate(time);
		if(needDay) {
			ret = date + " " + ret;
		} else {
			if(dayhandle) {

				if(date != getCurrentDay()) {
					ret = date + " " + ret;
				}
			}
		}
		return ret;
	}

	function getViewText(start, end) {
		return _getViewText(start, false, true) + _getViewText(end, false, false);
	}

	function dataHandler1(ref, infoList) {
		var ret = [];

		for(var i = 0; i < ref.length; i++) {
			var obj = $.extend({}, ref[i], {
				address: ref[i].addressName,
				addressId: ref[i].ID
			});
			obj.scan = [];
			for(var j = 0; j < infoList.length; j++) {
				if(ref[i].ID == infoList[j].addressId) {
					//alert("b");
					ret.push(infoList[j]);
					break;
				}
			}
			if(j == infoList.length) {
				ret.push(obj);
			}
		}
		return ret;
	}
//	var getSignInfo = function(placeId, infoObj) {
//		var ret = [];
//		if(infoObj) {
//			for(var i in infoObj) {
//				console.log("infoObj[i].placeId："+infoObj[i].placeId +);
//				if(infoObj[i].placeId == placeId) {
//					ret = infoObj[i];
//					break;
//				}
//			}
//		}
//    console.log('getSignInfo'+JSON.stringify(ret));
//		return ret;
//	};
	var dataHandler = function(placeMap, infoObj) {
		infoObj=infoObj||{};
		var ret = [];
		if(placeMap && placeMap.length) {
			ret = placeMap.map(function(placeInfo, index) {
				console.log();
				placeInfo.signInfo = infoObj[placeInfo["id"]];
				return placeInfo;
			});
		}
		return ret;
	};

	function _getList(time) {
		//time = "14:45-15:00";
		var params = {
			createDate: date,
			startTime: date + " " + time.split("-")[0],
			endTime: date + " " + time.split("-")[1],
			status: vmClockList.status
		};
		plus.nativeUI.showWaiting('加载中...');
		console.log("c.DataUtil.findScanInfo入参" + JSON.stringify(params));
		c.DataUtil.findScanInfo("", params, function(res) {
			plus.nativeUI.closeWaiting();
			console.log('【打卡列表2】' + JSON.stringify(res));
			if(res.success) {
				res.protectPlaceList = res.protectPlaceList || [];
				if(vmClockList.status == "0") {
					vmClockList.listData = dataHandler(res.protectPlaceList, res.placeIdLinkSignInfoList || {});
					if(!initDefault) {
						var defaultDate = getDefaultDate();
						setTimeout(function() {
							initDefault = true;
							if(document.querySelectorAll(".p-time-item").length) {
								console.log("p-time-item:" + defaultDate['index']);
								document.querySelectorAll(".p-time-item")[defaultDate['index']].classList.add("active-time");
								var el = document.querySelectorAll(".p-time-item")[defaultDate['index']];
								var elem = document.querySelectorAll(".p-time-item")[0];
								//alert(elem.getBoundingClientRect().width);
								var wh = elem.getBoundingClientRect().width || 120;

								/*var wh = elem.style.width+el.style.paddingRight;
								console.log("wh"+elem.style.width);*/
								document.querySelector(".cnt-time-list").scrollLeft = el.offsetLeft - wh / 2;
								console.log('offsetLeft');
							}
							if(document.querySelector(".cnt-time")) {
								document.querySelector(".cnt-time").style.width = wh * (vmClockList.dateList.length + 2) + "px";
							}
						}, 255);
					}
					//alert(JSON.stringify(vmClockList.listData));
				} else {
					vmClockList.listData = dataHandlerSubmit(res.protectPlaceList, res.signCountMap);

				}

			} else {
				$.toast("暂无数据");
			}
			// vmClockList.listData = res.infoList;
		}, function(xhr) {
			plus.nativeUI.closeWaiting();
			$.toast('加载失败，请稍后重试');
			console.log('error=' + xhr.status);
		});
	}

	function getSignInfoSubmit(id, signArr) {
		var ret = [];
		if(signArr && signArr.length) {
			signArr.forEach(function(item, i) {
				if(item.placeId == id) {
					ret.push(item);
				}
			});
		}
		return ret;
	}

	function dataHandlerSubmit(placeMap, signInfo) {
		var ret = [];
		if(placeMap && placeMap.length) {
			ret = placeMap.map(function(placeItem, index) {
				placeItem.signInfo = getSignInfoSubmit(placeItem.id, signInfo);
				return placeItem;
			});
		}
		console.log("dataHandlerSubmit" + JSON.stringify(ret));
		return ret;

	};

	function getCurrentStr() {
		var today = new Date();
		var current = date + " " + translate(today, 3);
		console.log("current"+current);
		var todayStamp = new Date(current.replace(/-/g, "/")).getTime();
		console.log(todayStamp);
		return todayStamp;
	}

	function getDefaultDate() {
		var ret = "";
		var dataList = vmClockList.dateList;
		var today = getCurrentStr();
		var startDate;
		var endDate;
		var nextDate;
		var j = 0;
		var length = dataList.length;
		if(length > 0) {
			for(var i = 0; i < length; i++) {
				dataList[i].startDate = dataList[i].beginTime;
				dataList[i].endDate = dataList[i].endTime;
				startDate = date + " " + dataList[i].startDate;
				console.log(startDate);
				endDate = date + " " + dataList[i].endDate;
				console.log(endDate);
				startDate = new Date(startDate.replace(/-/g, "/")).getTime();
				endDate = new Date(endDate.replace(/-/g, "/")).getTime();
				console.log("startDateStamp"+startDate);
				console.log("sendDateStamp"+endDate);
				console.log("today" + today);
				if((startDate <= today) && (today <= endDate)) {
					console.log("today1" + today);
					ret = dataList[i].startDate + "-" + dataList[i].endDate;
					j = i;
					break;
				} else {
					if((i + 1) < dataList.length) {
						
						nextDate = date + " " + dataList[i + 1].beginTime;
						console.log("nextDate"+nextDate);
						nextDate = new Date(nextDate.replace(/-/g, "/")).getTime();
						console.log("today2" + today);
						console.log("today2EndDate"+endDate);
						console.log("today2EndDate"+nextDate);
						if((endDate < today) && (today < nextDate)) {
							console.log("today3" + today);
							ret = dataList[i].startDate + "-" + dataList[i].endDate;
							j = i;
							break;
						}
					}
				}
			}
			console.log("retBefore"+ret);
			if(ret == "") {
				j = length - 1;
				ret = dataList[length - 1].startDate + "-" + dataList[length - 1].endDate;
			}
		}
		var c = {
			date: ret,
			index: j
		};
		console.log("getDefaultData"+JSON.stringify(c));
		return {
			date: ret,
			index: j
		};
	}

	function getList() {
		var params = {
			date: date
		};
		//alert("b");
		plus.nativeUI.showWaiting('加载中...');
		c.DataUtil.findScanTime("", params, function(res) {
			console.log('【打卡列表1】' + JSON.stringify(res));

			if(res.SystemCode == 1) {
				vmClockList.dateList = res.timeList;
                
				_getList(getDefaultDate().date);
			} else {

				$.toast("暂无数据");
			}
		}, function(xhr) {
			plus.nativeUI.closeWaiting();
			$.toast('加载失败，请稍后重试');
			console.log('error=' + xhr.status);
		});
	}

	function getDateData(arr, current) {
		var ret = [];
		var startTime;
		var endTime;
		var str = "";

		for(var i = 0; i < arr.length; i++) {
			str = translate(arr[i].startTime) + "-" + translate(arr[i].endTime);
			if(current == str) {
				ret = arr[i];
				break;
			}
		}
		return ret;
	};

	function bindevent() {
		mui(document).on("tap", ".p-time-item", function(e) {
			document.querySelectorAll(".p-time-item").forEach(function(item) {
				item.classList.remove("active-time");
			});

			this.classList.add("active-time");
			_getList(this.dataset.date);

		});
	}

	return {
		init: function(cfg) {
			var time = plus.webview.currentWebview().date;
			vmClockList.status = plus.webview.currentWebview().status || "0";
			if(time) {
				date = time;
			}
			bindevent();
			getList();
			//_getList();
			//document.querySelector(".clock-line").style.height = document.body.clientHeight ;
		},
		//getClockList: getClockList,
	}
})(window, mui);