/**
 * 二维码扫描模块逻辑
 */

var qrCodeScan = {
	scanObj: null, // 扫描控件
	locale: '', // 本地地址信息
	getLocalPosition: function() {
		var _this = this;
		plus.geolocation.getCurrentPosition(function(res) {
			console.log("===高德定位====" + JSON.stringify(res));
//			if(mui.os.ios) {
//				AMap.convertFrom([res.coords.longitude, res.coords.latitude], 'gps', function(status, result) {
//					console.log('===转换地址===' + JSON.stringify(result));
//					qrCodeScan.locale = result.locations[0].lng + ',' + result.locations[0].lat;
//					qrCodeScan.initScan(); //页面
//				})
//			} else {
				qrCodeScan.locale = res.coords.longitude + ',' + res.coords.latitude;
				qrCodeScan.initScan(); //页面
//			}

		}, function(err) {
			mui.toast('获取地址失败');
			console.log('定位失败' +  JSON.stringify(err))
			plus.nativeUI.closeWaiting();
		}, {
			provider: 'amap'
		});
	},
	// 会议签到
	meetingSignIn: function(resObj) {
		var _this = this;
		var paramObj = {
			id: resObj.id,
			locale: qrCodeScan.locale   
		};    
		console.log('paramObj.locale========' + paramObj.locale);
		window.DataUtil.postMeetingSignInData(paramObj, function(res) {
			console.log('【会议签到扫描后台返回】' + JSON.stringify(res));
			var now = new Date();	//当前时间
			var meetTime = now.getFullYear() + '-' + (now.getMonth() > 8 ? (now.getMonth() + 1) : '0' + (now.getMonth() + 1)) + '-' + (now.getDate() > 9 ? now.getDate() : '0' + now.getDate()) + " " + (now.getHours() > 9 ? now.getHours() : '0' + now.getHours()) + ":" + (now.getMinutes() > 9 ? now.getMinutes() : '0' + now.getMinutes()) + ":" + (now.getSeconds() > 9 ? now.getSeconds() : '0' + now.getSeconds());
			if(res.success){
				var msgRef = {
					"1":"签到成功",
					"20001":"二维码有误",
					"10006":"会议已结束",
					"10002":"您已经签过到了",
					"10007":"您不在参会人员中",
				};
				console.log('res.SystemCode==='+typeof(res.SystemCode));
				if(res.SystemCode == 1){
					plus.webview.currentWebview().close();
					setTimeout(function() {
						mui.toast('签到成功\r\n主题：' + res.functionRooms.theme + '\r\n地点：' + res.functionRooms.roomName + '\r\n时间：' + meetTime, {
							duration: 'long'
						})
					})
				} else {
					plus.webview.currentWebview().close();
					var msg =msgRef[res.SystemCode]||"签到失败";
					setTimeout(function() {
						mui.toast(msg);
					})
				}
			} else {
				plus.webview.currentWebview().close();
				setTimeout(function() {
					mui.toast('签到失败')
				})
			}
		}, function(xhr, type, err) {
			mui.confirm('服务器异常，请重试！', '提示', ['返回', '重新扫描'], function(e) {
				if(e.index == 0) {
					mui.back();
					_this.scanObj.close();
				} else {
					_this.scanObj.start();
				}
			});
			console.log(xhr.status + ',' + type + ',' + err)
		})
	},
	//扫码二维码登陆
	saveQuickLoginRecord: function(result){
		var _this = this;
		var code = result.id;
		document.getElementById('confirm').addEventListener('tap',function(){
			console.log('=====confirm======');
			var now = new Date();
			var nowTime = now.getTime();//当前时间 与到期时间对比；result.time二维码到期时间
			if(nowTime <= result.time){
				window.DataUtil.saveQuickLoginRecord(code, function(res) {
					console.log('扫码二维码登陆======'+JSON.stringify(res))
					if(res.success && res.SystemCode == 1){
						mui.back();
						mui.toast('登录成功');
					}
				},function(xhr, type, err){
					mui.confirm('服务器异常，请重试！', '提示', ['返回', '重新扫描'], function(e) {
						if(e.index == 0) {
							mui.back();
							_this.scanObj.close();
						} else {
							_this.scanObj.start();
						}
					});
					console.log(xhr.status + ',' + type + ',' + err)
				})
			} else {
				mui.toast('二维码已过期');
				mui.back();
			}
		})
		//点击取消登录
		document.getElementById('cancel').addEventListener('tap',function(){
			mui.back();
		})
	},
	//物品领用二维码
	scavengingUse: function(result){
		var _this = this;
		var id = result.id;
		console.log('======id======='+id)
		window.DataUtil.scavengingUse(id, function(res) {
			console.log('物品领用二维码======'+JSON.stringify(res));
			if(res.success){
//				res.SystemCode = Number(res.SystemCode);
				console.log('res.SystemCode==='+typeof(res.SystemCode))
				switch(res.SystemCode) {
					case 10013:
						plus.webview.currentWebview().close();
						setTimeout(function() {
							mui.toast('物品领用成功');
						})
						break;
					case 10014:
						plus.webview.currentWebview().close();
						setTimeout(function() {
							mui.toast('物品已被领用');
						})
						break;
					case 10015:
						plus.webview.currentWebview().close();
						setTimeout(function() {
							mui.toast('归还成功');
						})
						mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
						break;
					case 10016:
						plus.webview.currentWebview().close();
						setTimeout(function() {
							mui.toast('物品归还审核中');
						})
						break;
					case 2001:
						plus.webview.currentWebview().close();
						setTimeout(function() {
							mui.toast('未到扫码时间');
						})
						break;
					case 10001:
						plus.webview.currentWebview().close();
						setTimeout(function() {
							mui.toast('此物品不存在');
						})
						break;
				}
			}
			
		},function(xhr, type, err){
			mui.confirm('服务器异常，请重试！', '提示', ['返回', '重新扫描'], function(e) {
				if(e.index == 0) {
					mui.back();
					_this.scanObj.close();
				} else {
					_this.scanObj.start();
				}
			});
			console.log(JSON.stringify(xhr.status) + ',' + type + ',' + err)
		})
	},
	
	
	
	
	// 加载扫描界面
	initScan: function() {
		var _this = this;
		//扫描控件构造
		var filter = [plus.barcode.QR];
		var styles = {
			frameColor: "#3498DB",
			scanbarColor: "#3498DB",
			background: ""
		};
		setTimeout(function(){
			plus.nativeUI.closeWaiting();
		},1000);
		_this.scanObj = new plus.barcode.Barcode('qrCode', filter, styles);
		_this.scanObj.onmarked = function(type, result) { // 扫描成功的回调
			var resObj = null;
			console.log('result=========='+JSON.stringify(result));
			if(result.indexOf("id") > -1) { // 是我们系统生成的会议考勤二维码
				resObj = JSON.parse(result);
				if(!resObj.id) {
					mui.confirm('生成的二维码有误，请联系管理员！', '提示', ['返回', '重新扫描'], function(e) {
						if(e.index == 0) {
							mui.back();
							_this.scanObj.close();
						} else {
							_this.scanObj.start();
						}
					});
					return;
				} else {
					console.log('resObj.type==='+resObj.type);
					switch(resObj.type) {
						case '0'://登录
							document.getElementById('main').style.display = 'none';
							document.getElementById('isLogin').style.display = 'block';
							_this.scanObj.close();
							_this.saveQuickLoginRecord(resObj);
							break;
						case '1'://护导
							var msgRef = {
								"10001":"二维码不可使用",
								"2001":"无效的扫描时间",
								"10002":"签到失败:该时间段已签到成功",
								"1":"签到成功",
							};
							DataUtil.scanQRCode(resObj.id,function(res){
								console.log('护导二维码======'+JSON.stringify(res))
								_this.scanObj.close();
								if(res.success){
									var msg =msgRef[res.SystemCode]||"签到失败";
									mui.toast(msg);
								} else {
									mui.toast('签到失败');
								}
								mui.back();
							},function(xhr, type, err){
								mui.confirm('服务器异常，请重试！', '提示', ['返回', '重新扫描'], function(e) {
									if(e.index == 0) {
										mui.back();
										_this.scanObj.close();
									} else {
										_this.scanObj.start();
									}
								});
								console.log(xhr.status + ',' + type + ',' + err)
							});
							break;
						case '2'://物品领用
							_this.scavengingUse(resObj);
							break;
						case '3'://会议考勤
							_this.meetingSignIn(resObj);
							break;
					}
				}
			} else {
				plus.webview.currentWebview().close();
				// 首先判断是不是网址
				var RegUrl = new RegExp();
				RegUrl.compile("^[A-Za-z]+://[A-Za-z0-9-_]+\\.[A-Za-z0-9-_%&\?\/.=]+$");
				if(!RegUrl.test(result)) { // 不是网址
					WebviewUtil.show('thirdPartyPage', {
						str: result
					});
				} else { // 是网址
					plus.runtime.openURL(result); // 调用浏览器打开第三方网址
					_this.scanObj.start();
				}
			}
		};
		//开启扫描
		_this.scanObj.start();
	},

	init: function() {
		var _this = this;
		plus.nativeUI.showWaiting();
		var functionArr = _this.getLocalPosition;
		var arr = [functionArr];
		window.MethodUtil.openSetting(arr);//判断是否开启定位服务，开启了继续执行，否则开启定位服务
	}
}