/*
 * 说明：待办页面逻辑
 * 创建人：ls
 * 创建时间：2018/03/31 11:30
 * 修改人：ls
 * 修改时间：
 */

var scheduleList = (function(c, $) {
	//列表的点击事件
	var vmSchList = new Vue({
		el: '#schList',
		data: {
			listData: [],
			picHost: IMAGE_GET_CONFIG
		},
		methods: {},
		filters: {
			subs: function(value) {
				return window.MethodUtil.subs(value);
			}
		}
	});
	var pageSize = 10, //10 条一页
		maxPage, //最大页数
		pageNo = 1; //从第一页开始
	function getParams() {
		return {
			pageNo: pageNo,
			pageSize: pageSize
		}
	}
	//获取列表数据
	function getScheduleList(isRefresh) {
		if(isRefresh) { //下拉刷新
			pageNo = 1;
			c.DataUtil.getToDoListData(getParams(), function(data) {
				console.log('【待办数据列表】' + JSON.stringify(data));
				$(c.GlOBAL_CONFIG.containerId).pullRefresh().endPulldown(); //结束下拉刷新
				if(data.SystemCode == 1) {
					if(data.page.rows.length == 0) {
						document.getElementById('schList').innerHTML = ' ';
						mui.toast('没有数据');
						return;
					}
					maxPage = Math.ceil((data.page.records) / pageSize);
					vmSchList.listData = data.page.rows;
					$(c.GlOBAL_CONFIG.containerId).pullRefresh().refresh(true); //重置上拉加载
					if(maxPage == 1) { //无下一页数据
						$(c.GlOBAL_CONFIG.containerId).pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						$(c.GlOBAL_CONFIG.containerId).pullRefresh().enablePullupToRefresh(); //启用上拉
						$(c.GlOBAL_CONFIG.containerId).pullRefresh().refresh(true); //重置上拉
					}
				} else {
					plus.nativeUI.toast(c.ERROR_CONFIG[data.SystemCode]);
					return;
				}
			}, function(xhr, type, err) {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast(c.ERROR_CONFIG['0']);
			});

		} else { //上拉加载
			pageNo++;
			if(maxPage == 1) {
				$(c.GlOBAL_CONFIG.containerId).pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			c.DataUtil.getToDoListData(getParams(), function(data) {
				// console.log('【待办下一页】===' + JSON.stringify(data));
				if(data.SystemCode == 1) {
					temp = data.page.rows;
					vmSchList.listData = vmSchList.listData.concat(temp);
					if(maxPage <= pageNo) {
						$(c.GlOBAL_CONFIG.containerId).pullRefresh().endPullupToRefresh(true);
					} else {
						$(c.GlOBAL_CONFIG.containerId).pullRefresh().endPullupToRefresh(false);
					}
				} else {
					$.toast(ERROR_CONFIG[data.SystemCode]);
					$(c.GlOBAL_CONFIG.containerId).pullRefresh().disablePullupToRefresh();
				}
			}, function(xhr, type, err) {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast(c.ERROR_CONFIG['0']);
			});
		}

	}

	//绑定事件
	function bindEventHandler() {
		$('.m-sch-list').on('tap', '.item', function() {
			var itemId = this.dataset.item;
			var type = this.dataset.type;
			var instanceId = this.dataset.id;
			if(type == "T_FLOW_REPAIR") {
				var taskCode =this.dataset.code;
				console.log('taskCode==='+taskCode)
				c.WebviewUtil.show('scheduleDetail', {
					itemId: itemId,
					type: type,
					instanceId: instanceId,
					taskCode:taskCode,
				});
			} else if(type == "t_work_abnormal") {
				c.WebviewUtil.show('scheduleAttendanceExceptionDetail', {
					itemId: itemId,
					type: type,
					instanceId: instanceId
				});
			} else if(type == "T_EMP_LEAVE") {
				c.WebviewUtil.show('handleLeave', {
					itemId: itemId,
					type: type
				});
			} else if(type == "t_goods_received") { //物品归还
				c.WebviewUtil.show('handleRecipients', {
					itemId: itemId,
					type: type
				});
			} else if(type == "T_CLASS_LISTENER") { //听课上课待办
				c.WebviewUtil.show('handleOrderCourse', {
					itemId: itemId,
					type: type,
					instanceId: instanceId
				});
			} else if(type == "T_CLASS_ASSN") { //社团审核
				c.WebviewUtil.show('declareAdd', {
					detail: instanceId,
					type: type,
					isBtnShow:3,
				});
			};
		});
	}
	return {
		init: function() {
			bindEventHandler();
		},
		getScheduleList: getScheduleList
	}
})(window, mui)

// //待办详情
var scheduleDetail = (function(c, $) {
	var self = null,
		itemId, //获取详情的id
		createById, //申请人id
		taskId, //报修类型taskId
		taskCodes,//节点编码
		instanceId; //当前节点id
	var vmSchDetail = new Vue({
		el: '#schDetail',
		data: {
			detail: "",
			taskList: [],
			imgid: "",
			sort: "",
			flowInstance: '',
			assign: "",
			listPerson: [],
			proposer: "",
			disposeOpinions: ''

		},
		methods: {},
		filters: {
			repairType: function(value) {
				return window.MethodUtil.repairType(value);
			},
			getDate: function(value) {
				return window.MethodUtil.getDate(value);
			}
		}
	});

	function bindEventHandler() {
		c.addEventListener('refreshCurrentPage', function(e) {
			itemId = e.detail.push_detail_id;
			var act = e.detail.act;
			if(act == "repair") {
				taskCode = e.detail.taskCode;
				initRepairPage(itemId);
			} else if(act == "attendance") {
				initAttendanceExceptionPage(itemId)
			}
		});
		//同意
		document.getElementById("agree_button").addEventListener("tap", function() {
			var type = this.getAttribute('data-type');
			var act, obj = null;
			if(type == "repair") {
				obj = {
					id: itemId,
					instanceId: instanceId,
					flowCode: 'FLOW_REPAIR',
					instanceState: 2,
					disposeOpinion: '',
					taskUser: '',
					createBy: createById,
					taskId: taskId
				}
				//              console.log('obj========'+JSON.stringify(obj));
				//关闭软键盘
				document.activeElement.blur();
				$.confirm(c.TITLE_CONFIG['cfmTip'], c.TITLE_CONFIG['cfmTtitle'], c.TITLE_CONFIG['cfmButton'], function(e) {
					if(e.index == 1 || e.index == -1) {
						return;
					} else {
						plus.nativeUI.showWaiting(c.TITLE_CONFIG['submit']);
						c.DataUtil.handleToRepair(obj, function(data) {
							console.log("【待办审核】:" + JSON.stringify(data));
							if(data.SystemCode == 1) {
								plus.nativeUI.closeWaiting();
								plus.nativeUI.toast(c.TITLE_CONFIG['success']);
								var list = plus.webview.getWebviewById("Schedule");
								$.fire(list, 'reflush');
								$.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
								$.back();
							} else {
								plus.nativeUI.closeWaiting();
								if(data.SystemCode == 5001) { //已处理的状态码
									mui.toast('该数据已处理,无需再次处理!');
									var ws = plus.webview.currentWebview();
									plus.webview.close(ws); //关闭本页面
								} else {
									plus.nativeUI.toast(ERROR_CONFIG[data.SystemCode]);
								}
								return;
							}

						}, function(xhr, type, err) {
							plus.nativeUI.closeWaiting();
							plus.nativeUI.toast(c.ERROR_CONFIG['0']);

						});
					}

				})

			} else if(type == "attendance") {
				obj = {
					flowCode: 'Attendance_Exception',
					instanceState: 2,
					disposeOpinion: '',
					instanceId: instanceId,
					createBy: createById,
					id: itemId
				}
				console.log('obj========' + JSON.stringify(obj));
				//关闭软键盘
				document.activeElement.blur();
				$.confirm(c.TITLE_CONFIG['cfmTip'], c.TITLE_CONFIG['cfmTtitle'], c.TITLE_CONFIG['cfmButton'], function(e) {
					if(e.index == 1 || e.index == -1) {
						return;
					} else {
						plus.nativeUI.showWaiting(c.TITLE_CONFIG['submit']);
						c.DataUtil.handleAttendanceException(obj, function(data) {
							console.log("【待办考勤处理审核】:" + JSON.stringify(data));
							if(data.SystemCode == 1) {
								plus.nativeUI.closeWaiting();
								plus.nativeUI.toast(c.TITLE_CONFIG['success']);
								var list = plus.webview.getWebviewById("Schedule");
								$.fire(list, 'reflush');
								$.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
								$.back();
							} else {
								plus.nativeUI.closeWaiting();
								if(data.SystemCode == 5001) { //已处理的状态码
									mui.toast('该数据已处理,无需再次处理!');
									var ws = plus.webview.currentWebview();
									plus.webview.close(ws); //关闭本页面
								} else {
									plus.nativeUI.toast(ERROR_CONFIG[data.SystemCode]);
								}
								return;
							}

						}, function(xhr, type, err) {
							plus.nativeUI.closeWaiting();
							plus.nativeUI.toast(c.ERROR_CONFIG['0']);

						});
					}

				})
			}

		});
	}
	//驳回
	function disagreeSchedule(disposeOpinion, act) {
		if(act == "repair") {
			obj = {
				id: itemId,
				instanceId: instanceId,
				flowCode: 'FLOW_REPAIR',
				instanceState: 3,
				disposeOpinion: disposeOpinion,
				taskUser: '',
				createBy: createById,
				taskId: taskId
			}
			console.log('obj========' + JSON.stringify(obj));
			c.DataUtil.handleToRepair(obj, function(data) {
				console.log('报修处理====' + JSON.stringify(data));
				plus.nativeUI.showWaiting(c.TITLE_CONFIG['submit']);
				if(data.SystemCode == 1) {
					plus.nativeUI.closeWaiting();
					plus.nativeUI.toast(c.TITLE_CONFIG['success']);
					var list = plus.webview.getWebviewById("Schedule");
					$.fire(list, 'reflush');
					$.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
					$.back();
				} else {
					plus.nativeUI.closeWaiting();
					$.toast(ERROR_CONFIG[data.SystemCode]);
				}

			}, function(xhr, type, err) {
				plus.nativeUI.toast(c.ERROR_CONFIG['0']);
			})
		} else if(act == "attendance") {
			obj = {
				flowCode: 'Attendance_Exception',
				instanceState: 3,
				disposeOpinion: disposeOpinion,
				instanceId: instanceId,
				createBy: createById,
				id: itemId
			}
			console.log('obj========' + JSON.stringify(obj));
			c.DataUtil.handleAttendanceException(obj, function(data) {
				console.log('考勤处理====' + JSON.stringify(data));
				plus.nativeUI.showWaiting(c.TITLE_CONFIG['submit']);
				if(data.SystemCode == 1) {
					plus.nativeUI.closeWaiting();
					plus.nativeUI.toast(c.TITLE_CONFIG['success']);
					var list = plus.webview.getWebviewById("Schedule");
					$.fire(list, 'reflush');
					$.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
					$.back();
				} else {
					plus.nativeUI.closeWaiting();
					$.toast(ERROR_CONFIG[data.SystemCode]);
				}

			}, function(xhr, type, err) {
				plus.nativeUI.toast(c.ERROR_CONFIG['0']);
			})
		}
	}
	//获取指派的人列表
	function getToDoAssignData() {
		c.DataUtil.getToDoAssignData(function(data) {
			console.log("【指派的人列表】:" + JSON.stringify(data));
			if(data.SystemCode == 1) {
				plus.nativeUI.closeWaiting();
				var typeArr = [];
				for(var i = 0; i < data.users.length; i++) {
					typeArr.push({
						value: data.users[i].userId,
						text: data.users[i].userName
					});
				}
				document.getElementById('showUserPicker').addEventListener('tap', function(event) {
					var userPicker = new $.PopPicker();
					var option = "";
					var optionName = '';
					userPicker.setData(typeArr);
					userPicker.show(function(selectItems) {
						option = selectItems[0].value;
						optionName = selectItems[0].text;
						assignSchedule(option, optionName);
					});
					if(option != "") {
						userPicker.pickers[0].setSelectedIndex(option);
					}

				}, false);
			} else {
				plus.nativeUI.toast(ERROR_CONFIG[data.SystemCode]);
			}

		}, function(xhr, type, err) {
			plus.nativeUI.toast(c.ERROR_CONFIG['0']);
		})

	}
	//指派给某人
	function assignSchedule(id, optionName) {
		plus.nativeUI.showWaiting(c.TITLE_CONFIG['submit']);
		c.DataUtil.handleToRepair({
			id: itemId,
			instanceId: instanceId,
			flowCode: 'FLOW_REPAIR',
			instanceState: 4,
			disposeOpinion: '',
			taskUser: id,
			createBy: createById,
			taskUserName: optionName,
			taskId: taskId
		}, function(data) {
			console.log('报修出理指派人按钮=====' + JSON.stringify(data));
			if(data.SystemCode == 1) {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast(c.TITLE_CONFIG['success']);
				var list = plus.webview.getWebviewById("Schedule");
				$.fire(list, 'reflush');
				$.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
				$.back();

			} else {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast(ERROR_CONFIG[data.SystemCode]);
			}

		}, function(xhr, type, err) {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast(c.ERROR_CONFIG['0']);
		})
	}
	//初始化报修详情
	function initRepairPage(itemId,taskCodes) {
		if(itemId) {
			c.DataUtil.findRepairDetail(itemId,taskCodes, function(data) {
				console.log("【保修详情】:" + JSON.stringify(data));
				if(data.SystemCode == 1) {
					plus.nativeUI.closeWaiting();
					if(data.repair.auditStatus != 4) {
						instanceId = data.instance.id;
						taskId = data.instance.taskId;
					}
					createById = data.repair.createById;
					vmSchDetail.detail = data.repair; //详情数据
					vmSchDetail.disposeOpinions = data.repair;
					if(vmSchDetail.detail.annexIds != "") {
						vmSchDetail.imgid = vmSchDetail.detail.annexIds.split(',');
						for(var i = 0; i < vmSchDetail.imgid.length; i++) {
							vmSchDetail.imgid[i] = c.IMAGE_GET_CONFIG + vmSchDetail.imgid[i];
						}
					}
					//处理换行
					if(vmSchDetail.detail.repairContent.indexOf("\n") != -1) {
						vmSchDetail.detail.repairContent = c.MethodUtil.replaceLB(vmSchDetail.detail.repairContent);
					}
					//处理换行
					if(vmSchDetail.disposeOpinions.disposeOpinion) {
						if(vmSchDetail.disposeOpinions.disposeOpinion.indexOf("\n") != -1) {
							vmSchDetail.disposeOpinions.disposeOpinion = c.MethodUtil.replaceLB(vmSchDetail.disposeOpinions.disposeOpinion);
						}
					}
					document.getElementById("agree_button_box").style.display = 'block';
					getToDoAssignData();

				} else {
					if(data.SystemCode == 10002) {
						mui.toast("该记录已处理");
						mui.back();
					} else {
						plus.nativeUI.closeWaiting();
						plus.nativeUI.toast(c.ERROR_CONFIG[data.SystemCode]);
					}

				}
			}, function(xhr, type, err) {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast(c.ERROR_CONFIG['0']);
			});
		}

	}
	//初始化考勤异常详情
	function initAttendanceExceptionPage(itemId) {
		if(itemId) {
			c.DataUtil.getAttendanceException({
				id: itemId
			}, function(data) {
				console.log('【待办事项考勤详情数据】' + JSON.stringify(data));
				if(data.SystemCode == 1) {
					plus.nativeUI.closeWaiting();
					instanceId = data.data.instanceId;
					createById = data.data.createById;
					if(data.data.instanceState == 2 && data.data.createById != JSON.parse(plus.storage.getItem('userInfo')).id) {
						mui.toast("该记录已处理");
						mui.back();
					}
					vmSchDetail.detail = data.data; //详情数据
					if(vmSchDetail.detail.disposeOpinion.indexOf("\n") != -1) {
						vmSchDetail.detail.disposeOpinion = c.MethodUtil.replaceLB(vmSchDetail.detail.disposeOpinion);
					}
				} else {
					plus.nativeUI.closeWaiting();
					plus.nativeUI.toast(ERROR_CONFIG[data.SystemCode]);
				}
			}, function(xhr, type, err) {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast(c.ERROR_CONFIG['0']);
			});
		}

	}
	return {
		init: function() {
			plus.nativeUI.showWaiting();
			self = plus.webview.currentWebview();
			itemId = self.itemId || self.push_detail_id;
			if(self.type == "T_FLOW_REPAIR") {
				taskCodes = self.taskCode;
				console.log('taskCodes==='+taskCodes)
				initRepairPage(itemId,taskCodes);
			} else if(self.type == "t_work_abnormal") {
				initAttendanceExceptionPage(itemId);
			}

			var msgs = plus.push.getAllMessage();
			if(msgs) {
				msgs.forEach(function(item, idx, arr) {
					if(typeof item.payload != 'object') { //安卓的payload的是字符串转换成json
						item.payload = JSON.parse(item.payload);
					}
					/*以下是删除系统消息中心推送的代码*/
					switch(item.payload.pushType) {
						case "6": //保修
							if(item.payload.id == self.itemId) {
								plus.push.remove(item);
							}
							break;
						case "7": //考勤
							if(item.payload.id == self.itemId) {
								plus.push.remove(item);
							}
							break;
						default:
							break;
					}

				})
			}
			setTimeout(function() {
				bindEventHandler();
			}, 1000)
		},
		disagreeSchedule: function(disposeOpinion, act) {
			disagreeSchedule(disposeOpinion, act);
		}

	}
})(window, mui)
//请假审批
var leaveHandle = (function(c, $) {
	var vm = new Vue({
		el: '#leaveDetail',
		data: {
			listData: [],
			pictureSrc: '',
			flow: [],
			flow1: {},
		},
		methods: {},
		filters: {}
	});
	var itemId, //id
		instanceId, //代办当前节点id
		flowCode = 'FLOW_LEAVE', //流程编码
		instanceState, //处理状态（2：通过 3：驳回 ）
		disposeOpinion = '', //处理意见
		type; //
	//初始化页面
	function initPage(itemId) {
		//教师请假节点
		window.DataUtil.getInfoById(itemId, function(data) {
			console.log(" ===待办请假详情=== " + JSON.stringify(data));
			if(data.SystemCode == 1) {
				if(data.isHandle == 1) {
					mui.toast("该记录已处理");
					mui.back();
				}
				plus.nativeUI.closeWaiting();
				//	请假说明
				data.data.leaveContent = window.MethodUtil.replaceLB(data.data.leaveContent);
				vm.listData = data.data;
				vm.pictureSrc = IMAGE_GET_CONFIG + data.data.pictureId;
				vm.flow = data.instances;
				vm.flow1 = data.instances[0];
				instanceId = data.nowInstance.id;
			}
		}, function(xhr, type, error) {
			console.log(xhr.responseText);
		});
	}
	//如推送时就在本页则刷新数据
	function initPageRefresh() {
		c.addEventListener('refreshCurrentPage', function(e) {
			itemId = e.detail.push_detail_id;
			initPage(itemId);
		});
	}
	//绑定事件
	function bindEventHandler() {
		//同意
		document.getElementById('handleOk').addEventListener('tap', function() {
			subDataLast(2)
		});
		//驳回
		document.getElementById('handleNo').addEventListener('tap', function() {
			subDataLast(3)
		});
	}

	function subDataLast(numSign) {
		var infoData = {
			id: itemId,
			instanceId: instanceId,
			flowCode: flowCode,
			instanceState: numSign,
			disposeOpinion: disposeOpinion,
		}
		console.log('infoData======' + JSON.stringify(infoData))
		handleVacation(infoData);
	}

	function handleVacation(infoData) {
		if(infoData.instanceState == 3) {
			mui.prompt('请输入不通过的理由', '请输入理由', ' ', ['取消', '确认'], function(e) {
				infoData.disposeOpinion = document.querySelector('.mui-popup-input input').value.trim();
				if(e.index == 1) {
					if(!window.MethodUtil.filterEmoji(infoData.disposeOpinion)) {
						return;
					}
					if(infoData.disposeOpinion == '') {
						mui.toast('请输入拒绝通过的理由');
						return;
					} else {
						plus.nativeUI.showWaiting('处理中...');
						window.DataUtil.handleToLeave(infoData, function(data) {
							console.log('【请假审批】' + JSON.stringify(data));
							if(data.SystemCode == 1) {
								plus.nativeUI.closeWaiting();
								mui.toast("审批不通过");
								var self = plus.webview.currentWebview();
								var opener = self.opener();
								mui.fire(opener, 'reflush');
								setTimeout(function() {
									mui.back();
								}, 300)
								//更新角标
								mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
							} else {
								mui.toast(ERROR_CONFIG[data.SystemCode]);
							}
						}, function() {
							plus.nativeUI.closeWaiting();
							mui.toast('服务器异常，请稍后重试！');
							return;
						});
					}
				} else {
					return;
				}
			}, 'div');

		} else {
			mui.confirm('是否确认通过', '提示', ['确认', '取消'], function(e) {
				if(e.index == 1 || e.index == -1) {
					return
				} else {
					plus.nativeUI.showWaiting('处理中...');
					window.DataUtil.handleToLeave(infoData, function(data) {
						console.log('【请假审批】' + JSON.stringify(data));
						plus.nativeUI.closeWaiting();
						if(data.SystemCode == 1) {
							mui.toast('审批通过');
							var opener = plus.webview.currentWebview().opener();
							mui.fire(opener, 'reflush');
							setTimeout(function() {
								mui.back();
							}, 300)
							//更新角标
							mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
						} else {
							mui.toast(ERROR_CONFIG[data.SystemCode]);
						}
					}, function() {
						plus.nativeUI.closeWaiting();
						mui.toast('服务器异常，请稍后重试！');
						return;
					});

				}
			})

		}
	}

	return {
		init: function() {
			plus.nativeUI.showWaiting();
			var self = plus.webview.currentWebview();
			itemId = self.itemId || self.push_detail_id;
			type = self.type;
			initPage(itemId);
			initPageRefresh();
			bindEventHandler();
			var msgs = plus.push.getAllMessage();
			if(msgs) {
				msgs.forEach(function(item, idx, arr) {
					if(typeof item.payload != 'object') { //安卓的payload的是字符串转换成json
						item.payload = JSON.parse(item.payload);
					};
					if(item.payload.id == self.itemId) {
						plus.push.remove(item);
					};
				});
			};
		}
	}
})(window, mui);

//物品归还
var ItemsReturnedHandle = (function(c, $) {
	var vm = new Vue({
		el: '#ItemsReturnedHandle',
		data: {
			listData: [],
		},
		methods: {},
		filters: {
			getReturnDatedDate: function(data) {
				return window.MethodUtil.getReturnDatedDate(data);
			}
		}
	});
	var itemId, //id
		instanceId, //代办当前节点id
		flowCode = 'Goods_Return', //流程编码
		createById,
		instanceState; //处理状态（2：通过 ）
	//初始化页面
	function initPage(itemId) {
		window.DataUtil.mobileGetGoodsUse(itemId, function(res) { //待办物品归还详情
			console.log(" ===待办物品归还详情=== " + JSON.stringify(res));
			if(res.success) {
//				if(res.isHandle == 1) {
//					mui.toast("该记录已处理");
//					mui.back();
//				}
				plus.nativeUI.closeWaiting();
				vm.listData = res.goodsUse;
				createById = res.goodsUse.createById; //创建人的id
				instanceId = res.goodsUse.instanceId; //代办当前节点id
			} else {
				mui.toast("请求失败");
			}
		}, function(xhr, type, error) {
			console.log(xhr.responseText);
		});
	}
	//如推送时就在本页则刷新数据
	function initPageRefresh() {
		c.addEventListener('refreshCurrentPage', function(e) {
			itemId = e.detail.push_detail_id;
			initPage(itemId);
		});
	}
	//绑定事件
	function bindEventHandler() {
		//同意
		document.getElementById('handleOk').addEventListener('tap', function() {
			subDataLast(2)
		});
	}

	function subDataLast(numSign) {
		infoData = {
			flowCode: flowCode,
			instanceState: numSign,
			disposeOpinion: '',
			instanceId: instanceId,
			createBy: createById,
			id: itemId
		}
		console.log('infoData======' + JSON.stringify(infoData))
		handleVacation(infoData);
	}

	function handleVacation(infoData) {
		mui.confirm('是否确认通过', '提示', ['确认', '取消'], function(e) {
			if(e.index == 1 || e.index == -1) {
				return
			} else {
				plus.nativeUI.showWaiting('处理中...');
				window.DataUtil.goodsUseHandle(infoData, function(data) {
					console.log('【物品领用审批】' + JSON.stringify(data));
					plus.nativeUI.closeWaiting();
					if(data.success) {
						mui.toast('确认归还');
						var opener = plus.webview.currentWebview().opener();
						mui.fire(opener, 'reflush');
						setTimeout(function() {
							mui.back();
						}, 300)
						//更新角标
						mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
					} else {
						mui.toast(ERROR_CONFIG[data.SystemCode]);
					}
				}, function() {
					plus.nativeUI.closeWaiting();
					mui.toast('服务器异常，请稍后重试！');
					return;
				});
			}
		})
	}

	return {
		init: function() {
			plus.nativeUI.showWaiting();
			var self = plus.webview.currentWebview();
			itemId = self.itemId || self.push_detail_id;
			type = self.type;
			console.log("itemIdDWM===" + itemId);
			initPage(itemId);
			initPageRefresh();
			bindEventHandler();
			var msgs = plus.push.getAllMessage();
			if(msgs) {
				msgs.forEach(function(item, idx, arr) {
					if(typeof item.payload != 'object') { //安卓的payload的是字符串转换成json
						item.payload = JSON.parse(item.payload);
					};
					if(item.payload.id == self.itemId) {
						plus.push.remove(item);
					};
				});
			};
		}
	}
})(window, mui);

//约课审批
var orderCourseHandle = (function(c, $) {
	var vm = new Vue({
		el: '#orderCourseDetail',
		data: {
			listData: '',
			instId: '',
//			taskLocation:'',//待办地点
		},
		methods: {
			handleOk: function() {
				subDataLast(2)
			},
			handleNo: function() {
				subDataLast(0)
			},
		},
		filters: {}
	});
	var itemId, //获取详情的id
		instanceId, //列表带过来的id
		flowCode, //流程编码
		instanceState, //处理状态（2：通过 0：驳回 ）
		reservationClassId, //待办详情id
		state, //存储状态
		type; //类型
	//初始化页面
	function initPage(itemId) {
		//待办约课详情
		window.DataUtil.reservationFlowDetail(itemId, function(data) {
			console.log(" ===待办约课详情=== " + JSON.stringify(data));
			if(data.SystemCode == 1) {
				if(data.isHandle == 1) {
					mui.toast("该记录已处理");
					mui.back();
				}
				plus.nativeUI.closeWaiting();
				vm.listData = data.data;
				reservationClassId = data.data.id; //待办详情的id
				type = data.data.type; //待办详情的type
				state = data.data.instanceState; //状态
				vm.instId = instanceId;
				if(type == 1) {
					flowCode = 'Listen_Class';
				} else {
					flowCode = 'Having_Class';
				}
				if(type == 2 && data.data.instanceState == 2) { //申请我要听课，待办同意之后，再给组发推送
					flowCode = 'Having_Class';
				}
				if(type == 3){
					isSupervise('班级视导通知');
				}
			}
		}, function(xhr, type, error) {
			console.log(xhr.responseText);
		});
	}
	//如推送时就在本页则刷新数据约课
	function initPageRefresh() {
		c.addEventListener('refreshCurrentPage', function(e) {
			itemId = e.detail.push_detail_id;
			instanceId = e.detail.instanceId;
			initPage(itemId);
		});
	}
	//验证地点必填问题
//	function validate(con1){
//	    var ret="";
//	    var locationRequired = (state == 1 && con1);
//	    if(locationRequired&&(!vm.taskLocation || vm.taskLocation == '')) { //地点
//	        ret = '请输入地点';
//	   	}
//	    if(locationRequired&&vm.taskLocation.length > 30) { //地点
//	        ret = '地点字数不得超过30';
//	   	}
//	    return ret;
//	}
	//设置title
	function isSupervise(title){
		document.getElementById('changeTitle').innerHTML = title;
	}
	//约课审批
	function subDataLast(numSign) {
//		vm.taskLocation = c.MethodUtil.delAllTrim(document.getElementById('location').value); //地点
		var infoData = {
			flowCode: flowCode,
			instanceState: numSign,
			disposeOpinion: '',
			instanceId: instanceId, //列表带过来的id
			reservationClassId: reservationClassId, //待办详情id
		}
		console.log('infoData======' + JSON.stringify(infoData))
		handleVacation(infoData);
	}

	function handleVacation(infoData) {
		var tipSuccess = "同意参加";
		var confirmMsg = "是否确认参加";
		if(infoData.instanceState == 0) { //上课通知，我要听课
			if((state == 1||state == 3) && infoData.flowCode == 'Having_Class') {
				mui.prompt('请输入拒绝的理由', '请输入理由', ' ', ['取消', '确认'], function(e) {
					infoData.disposeOpinion = document.querySelector('.mui-popup-input input').value.trim();
					if(e.index == 1) {
						if(!window.MethodUtil.filterEmoji(infoData.disposeOpinion)) {
							return;
						}
						if(infoData.disposeOpinion == '') {
							mui.toast('请输入拒绝通过的理由');
							return;
						} else {
							plus.nativeUI.showWaiting('处理中...');
							window.DataUtil.orderCourseHandle(infoData, function(data) {
								console.log('【约课待办】' + JSON.stringify(data));
								plus.nativeUI.closeWaiting();
								if(data.SystemCode == 1) {
									mui.toast("审批不通过");
									var self = plus.webview.currentWebview();
									var opener = self.opener();
									mui.fire(opener, 'reflush');
									setTimeout(function() {
										mui.back();
									}, 300)
									//更新角标
									mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
								} else {
									mui.toast(ERROR_CONFIG[data.SystemCode]);
								}
							}, function() {
								plus.nativeUI.closeWaiting();
								mui.toast('服务器异常，请稍后重试！');
								return;
							});
						}
					} else {
						return;
					}
				}, 'div');
			} else {
				mui.confirm('是否确认不参加', '提示', ['确认', '取消'], function(e) {
					if(e.index == 1 || e.index == -1) {
						return
					} else {
						plus.nativeUI.showWaiting('处理中...');
						window.DataUtil.orderCourseHandle(infoData, function(data) {
							console.log('【约课待办】' + JSON.stringify(data));
							plus.nativeUI.closeWaiting();
							if(data.SystemCode == 1) {
								mui.toast('确认不参加');
								var opener = plus.webview.currentWebview().opener();
								mui.fire(opener, 'reflush');
								setTimeout(function() {
									mui.back();
								}, 300)
								//更新角标
								mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
							} else {
								mui.toast(ERROR_CONFIG[data.SystemCode]);
							}
						}, function() {
							plus.nativeUI.closeWaiting();
							mui.toast('服务器异常，请稍后重试！');
							return;
						});

					}
				})
			}
		} else {
			//验证提交信息
//			var errorMsg = validate((infoData.flowCode == 'Having_Class'));
//			if(errorMsg){
//				$.toast(errorMsg);
//				return;
//			}
			if(state == 1 && infoData.flowCode == 'Having_Class') {
				tipSuccess = "审批通过";
				confirmMsg = "是否确认通过";
			}
			if(vm.listData.isSame==1 && state==2 && infoData.flowCode=='Listen_Class') {
				tipSuccess = "";
				confirmMsg = "请及时上传教案等附件";
			}
			mui.confirm(confirmMsg, '提示', ['确认', '取消'], function(e) {
				if(e.index == 1 || e.index == -1) {
					return
				} else {
					plus.nativeUI.showWaiting('处理中...');
					window.DataUtil.orderCourseHandle(infoData, function(data) {
						console.log('【约课待办】' + JSON.stringify(data));
						plus.nativeUI.closeWaiting();
						if(data.SystemCode == 1) {
							console.log("state：" + state + "==：" + (state == 1) + "===:" + (infoData.flowCode == 'Having_Class'));
							if(state == 1 && infoData.flowCode == 'Having_Class') { //上课通知
								mui.alert('请至电脑端及时补充教案等材料');
							} else {
								mui.toast(tipSuccess);
							}
							var opener = plus.webview.currentWebview().opener();
							mui.fire(opener, 'reflush');
							setTimeout(function() {
								mui.back();
							}, 300)
							//更新角标
							mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
						} else {
							mui.toast(ERROR_CONFIG[data.SystemCode]);
						}
					}, function() {
						plus.nativeUI.closeWaiting();
						mui.toast('服务器异常，请稍后重试！');
						return;
					});

				}
			})

		}
	}

	return {
		init: function() {
			plus.nativeUI.showWaiting();
			var self = plus.webview.currentWebview();
			itemId = self.itemId || self.push_detail_id;
			instanceId = self.instanceId;
			type = self.type;
			initPage(itemId);
			initPageRefresh();
			var msgs = plus.push.getAllMessage();
			if(msgs) {
				msgs.forEach(function(item, idx, arr) {
					if(typeof item.payload != 'object') { //安卓的payload的是字符串转换成json
						item.payload = JSON.parse(item.payload);
					};
					if(item.payload.id == self.itemId) {
						plus.push.remove(item);
					};
				});
			};
		}
	}
})(window, mui);