var classPhotoList = (function(c, $) {
	var classPhotoListVue = new Vue({
		el: '#refreshContainer',
		data: {
			listData: [],
		},
		methods: {
			openDetail: function(id) {
				window.WebviewUtil.show('schoolActiveDetail', {
					itemId: id
				});
			},
		},
		filters: {
			getReturnDatedDate: function(data) {
				return window.MethodUtil.getReturnDatedDate(data);
			}
		}
	});
	var pageSize = 10, //10 条一页
		maxPage, //最大页数
		pageNo = 1; //从第一页开始
	var total = 0;

	function getParams() {
		return {
			pageNo: pageNo,
			pageSize: pageSize,
		}
	}
	//初始化页面
	function initPage() {
		window.addEventListener('refreshlistData', function() {
			getAlbumList(true);
		})
		//校园活动是否新增的权限
		window.DataUtil.campusActivitiesIsLeader(function(res) {
			console.log('【校园活动是否新增的权限】' + JSON.stringify(res));
			if(res.SystemCode == 1) {
				if(res.flag == 1) {
					document.getElementById('schoolActive_add').style.display = 'block';
				}
			} else {
				mui.toast(ERROR_CONFIG[res.SystemCode]);
			}
		}, function(res) {
			plus.nativeUI.toast("请求出错");
		})

	}
	//获取列表数据
	function getAlbumList(isRefresh) {
		if(isRefresh) { //下拉刷新
			pageNo = 1;
			if(mui('#refreshContainer') && mui('#refreshContainer').pullRefresh && mui('#refreshContainer').pullRefresh().disablePullupToRefresh) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
			}
			console.log('getParams()====' + JSON.stringify(getParams()));
			c.DataUtil.activitiesList(getParams(), function(data) {
				console.log('【校园活动列表】' + JSON.stringify(data));
				mui('#refreshContainer').pullRefresh().endPulldown(); //结束下拉刷新
				data = data || {};
				data.rows = data.rows || [];
				total = data.records || 0;
				var items = data.rows;
				if(items.length) {
					if(items.length == 0) {
						classPhotoListVue.listData = [];
						mui.toast('没有数据');
						return;
					}
					maxPage = Math.ceil(total / pageSize);
					classPhotoListVue.listData = items;
					mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
					if(maxPage == 1) { //无下一页数据
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
					}
				} else {
					$.toast("没有记录");
					return;
				}
			}, function(xhr, type, error) {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
				console.log('xhr===' + xhr.status);
				console.log('type===' + type);
				console.log('error===' + error);

			});

		} else { //上拉加载
			pageNo++;
			if(maxPage == 1) {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			c.DataUtil.activitiesList(getParams(), function(data) {
				console.log('【校园活动列表下一页】===' + JSON.stringify(data));
				data = data || {};
				data.rows = data.rows || [];
				total = data.records || 0;
				var items = data.rows;

				if(items.length) {
					temp = items;
					classPhotoListVue.listData = classPhotoListVue.listData.concat(temp);
					if(maxPage <= pageNo) {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					} else {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
					}
				} else {
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		}

	}
	//绑定事件
	function bindEventHandler() {
		//点击进入新增页面
		document.getElementById('schoolActive_add').addEventListener('tap', function() {
			window.WebviewUtil.show('schoolActiveAdd', {});
		});
		//点击删除按钮
		mui('#refreshContainer').on('tap', '.mui-btn-red', function() {
			var _that = this;
			var deleteId = _that.dataset.id;
			var index = _that.dataset.index;
			var li = _that.parentNode.parentNode;
			var obj = {
				activitiesId: deleteId
			};
			console.log('obj====' + JSON.stringify(obj));
			mui.confirm('确认删除该条校园活动？', '提示', ['确认', '取消'], function(e) {
				if(e.index == 1 || e.index == -1) {
					return;
				} else {
					$.swipeoutClose(li);
					window.DataUtil.activitiesDelete(obj, function(res) {
						console.log('【班级相册列表删除】' + JSON.stringify(res));
						if(res.SystemCode) {
							setTimeout(function() {
								classPhotoListVue.listData.splice(index, 1);
								mui.toast("删除成功");
								if(classPhotoListVue.listData.length == 0) {
									mui.toast("暂无数据");
								}
							}, 300); //使删除归位
						} else {
							mui.toast(ERROR_CONFIG[res.SystemCode]);
						}
					}, function(res) {
						plus.nativeUI.toast("请求出错");
					})
				}
			});
		});
	}

	return {
		init: function() {
			bindEventHandler();
			initPage();
		},
		getAlbumList: getAlbumList
	}
})(window, mui);

//新增页面
var addSchoolActive = (function(c, $) {
	var isSet = false;
	var capLock = true;
	var addSchoolActiveVue = new Vue({
		el: '#addSchoolActive',
		data: {
			listData: {},
			photoNum: '0',
			videoIds: [], //视频展示
			videoIdsUp: [], //视频上传
			confirmTextSuccess: '',
			confirmText: '',
			activitiesGetData: [], //新增钱查询
			progressNUm: 1,
			addVideoFirstFrame: '', //视频第一帧
		},
		methods: {
			addVideo: function(e) { //添加视频
				document.activeElement.blur();
				console.log('addSchoolActiveVue.videoIds.length===' + addSchoolActiveVue.videoIds.length);
				if(addSchoolActiveVue.videoIds.length >= 1) {
					$.toast("已选视频数量已达1个");
					return;
				}
				//				e.stopPropagation();
				plus.nativeUI.actionSheet({
					title: "添加视频附件",
					cancel: "取消",
					buttons: [{
							title: '从手机选择'
						},
						{
							title: '摄像'
						},
					]
				}, function(e) {
					switch(e.index) {
						case 1:
							getPic(1); //相册选择
							break;
						case 2:
							getVideoIng(); //摄像
							break;
					}
				});
			},
			cancelvideo: function() {
				addSchoolActiveVue.videoIds = [];
				addSchoolActiveVue.videoIdsUp = [];
				addSchoolActiveVue.addVideoFirstFrame = '';
			},
		},
		filters: {

		}
	});
	var type;
	var photosCount = 0, //已选图片
		flag = 9, //图片选择不得超过9张
		videoCount = 0, //已选视频
		annexIds = []; //图片id
	//初始化页面
	function initPage() {
		c.DataUtil.activitiesGet(function(data) {
			console.log("===新增校园查询===" + JSON.stringify(data));
			if(data.SystemCode) {
				var picArr;
				var photo = [];
				if(data.data.pictureId) {
					picArr = data.data.pictureId.split(',');
					picArr.forEach(function(item) {
						photo.push(c.IMAGE_GET_CONFIG_OSS + item + '?format=jpeg');
					});
				}
				data.data.pictureId = photo;
				photosCount = data.data.pictureId.length;
				addSchoolActiveVue.photoNum = data.data.pictureId.length;
				addSchoolActiveVue.listData.id = data.data.id;
				addSchoolActiveVue.activitiesGetData = data.data;

				if(data.data.activiesTitle) {
					document.getElementById('title').value = data.data.activiesTitle;
				}
				if(data.data.activiesContent) {
					document.getElementById('addDesc').value = data.data.activiesContent;
				}

				console.log('addSchoolActiveVue.activitiesGetData====' + JSON.stringify(addSchoolActiveVue.activitiesGetData));
			} else {
				addSchoolActiveVue.listData.id = '';
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});

	}

	//调取相机拍照
	function getPhoto() {
		if(photosCount < 9) {
			window.MethodUtil.getCamera(function(path) {
				zipPicture(path); //压缩图片
			});
		} else {
			addSchoolActiveVue.photoNum = 9;
			plus.nativeUI.toast('已经选取9张图片');
		}
	}

	function getPic(type) {
		if(type == 1) { //视频
			var max = 1;
			var videoCount = addSchoolActiveVue.videoIds.length;
			var videoFlag = max - videoCount;
			if(videoCount < max) {
				plus.gallery.pick(function(e) {
						addSchoolActiveVue.videoIdsUp.push(e);
						addSchoolActiveVue.videoIds.push(e);
						isSet = false;
						capLock = true;
						setTimeout(function() {
							bindVideoEvent();

						}, 255);
					},
					function() {
						plus.nativeUI.toast('取消选择视频');
					}, {
						filter: 'video',
						multiple: false,
						maximum: videoFlag,
						system: false,
						onmaxed: function() {
							plus.nativeUI.toast("最多只能选取" + max + "个视频");
							return;
						}
					});
			} else {
				plus.nativeUI.toast("已经选取" + max + "个视频");
				return;
			}
		} else { //图片
			flag = flag - photosCount;
			if(photosCount < 9) {
				plus.gallery.pick(function(e) {
					for(var item in e.files) {
						var path = e.files[item];
						zipPicture(path); //压缩图片
					}
				}, function() {
					plus.nativeUI.toast('取消选择图片');
				}, {
					filter: 'image',
					multiple: true,
					maximum: flag,
					system: false,
					onmaxed: function() {
						addSchoolActiveVue.photoNum = 9;
						plus.nativeUI.toast('最多只能选取9张图片');
						return;
					}
				});
			} else {
				addSchoolActiveVue.photoNum = 9;
				plus.nativeUI.toast("已经选取9张图片");
				return;
			}
		}

	}
	//视频上传
	function loopVideo(callBack) {
		var i = 0;
		var tempVideo = [];
		return function() {
			var me = arguments.callee;
			var photos = addSchoolActiveVue.videoIdsUp || [];
			console.log("photos" + JSON.stringify(photos));
			if(photos.length) {
				if(i < photos.length) {
					window.MethodUtil.uploadImages(photos[i], function(data) {
						addSchoolActiveVue.progressNUm = 2,
							tempVideo.push(data.data[0]);
						i++;
						me(i, callBack);
					}, 2, function(res, status) {
						//						console.log('-----res---' + JSON.stringify(res));
						var progress = res.uploadedSize / res.totalSize * 100;

						//						console.log('progress1==='+progress);
						var progressbar1 = mui('#demo1');

						if(res.state < 4) {
							if(res.state == 3) {
								if(progress < 85) {
									mui(progressbar1).progressbar().setProgress(progress);
								} else {
									mui(progressbar1).progressbar().setProgress(85);
								}
							} else {
								if(progress < 50) {
									mui(progressbar1).progressbar().setProgress(progress);
								} else {
									mui(progressbar1).progressbar().setProgress(50);
								}
							}

						} else {
							mui(progressbar1).progressbar().setProgress(100);
						}

					}); //2为音频
				} else {
					callBack && callBack(tempVideo);
				}
			} else {
				callBack && callBack(tempVideo);
			}
		}
	};
	//视频
	var isFn = function(val) {
		return typeof val == 'function';
	};

	function getVideo(callback) {
		c.MethodUtil.getVideo(callback);
	};

	function fileRead(e, callback) {
		plus.io.resolveLocalFileSystemURL(e, function(entry) {
			console.log("entry" + entry);
			isFn(callback) && callback(e, entry);
		});
	}

	function getVideoIng() {
		getVideo(function(e) {
			fileRead(e, function(path, entry) {
				addSchoolActiveVue.videoIdsUp.push(path);
				addSchoolActiveVue.videoIds.push(entry.toLocalURL());
				isSet = false;
				capLock = true;
				setTimeout(function() {
					bindVideoEvent();
				}, 255);
			});
		});
	}

	//压缩图片
	function zipPicture(path) {
		plus.zip.compressImage({
			src: path,
			dst: "_downloads/camera/" + path.split('/')[path.split('/').length - 1],
			overwrite: true,
			quality: 20
		}, function(event) {
			if(photosCount < 9) {
				var currentNode = document.getElementById("addPicBtn");
				var newNode = document.createElement("li");
				newNode.className = 'add_pic';
				newNode.innerHTML = '<img class="repair_photo_item" src="' +
					event.target +
					'" /><img class="icon_remove" src="../../assets/images/annoucement/cancel.png" />';
				document.getElementById('publishPhotoList').insertBefore(newNode, currentNode);
				photosCount++;
				addSchoolActiveVue.photoNum = photosCount;
			} else {
				addSchoolActiveVue.photoNum = 9;
				plus.nativeUI.toast("最多选取9张图片");
			}
		}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		});
	}

	function ajaxSubMit(i, length, photos, type) {

		//递归上传图片
		var loop = function(i, callBack) {
			var text = type==0?'保存中...':'提交中...';
			plus.nativeUI.showWaiting(text);
			if(i < length) {
				if(photos[i].match("file:")) {
					console.log('photos[i]===='+photos[i]);
					window.MethodUtil.uploadImages(photos[i], function(res) {
						console.log("window.MethodUtil.uploadImages" + JSON.stringify(res));
						if(res.pk) {
							annexIds.push(res.pk);
						} else {
							if(res && res.data && res.data.length) {
								annexIds.push(res.data[0]);
							}
						}
						i++;
						loop(i, callBack);
					});
				} else {
//					console.log(photos[i].substring(0,photos[i].lastIndexOf("?")).substring(photos[i].substring(0,photos[i].lastIndexOf("?")).lastIndexOf("/")+1));
					annexIds.push(photos[i].substring(0,photos[i].lastIndexOf("?")).substring(photos[i].substring(0,photos[i].lastIndexOf("?")).lastIndexOf("/")+1));
					i++;
					loop(i, callBack);
				}

			} else {
				callBack();
			}
		};

		loop(i, function() {

			loopVideo(function(tempVideo) {
				//图片路径
				addSchoolActiveVue.listData.pictureId = annexIds.length > 0 ? annexIds.toString() : "";
				addSchoolActiveVue.listData.videoId = tempVideo.length > 0 ? tempVideo.toString() : "";
				plus.nativeUI.closeWaiting();
				console.log('提交之前-----addSchoolActiveVue.listData===' + JSON.stringify(addSchoolActiveVue.listData));
				c.DataUtil.activitiesAdd(addSchoolActiveVue.listData, function(data) {
					plus.nativeUI.closeWaiting();
					console.log("===校园活动===" + JSON.stringify(data));
					if(data.SystemCode == 1) {

						mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
						mui.toast(addSchoolActiveVue.confirmTextSuccess);
						photos = [];
						var self = plus.webview.currentWebview();
						var opener = self.opener();
						mui.fire(opener, "refreshlistData", {});
						self.close();

					} else {
						mui.toast(ERROR_CONFIG[data.SystemCode]);
					}
				}, function() {
					plus.nativeUI.closeWaiting();
					plus.nativeUI.toast("请求出错");
				});
			})();

		});

	}

	function subMit(type) {
		//type  0  保存     1保存并提交
		addSchoolActiveVue.listData.status = type;

		addSchoolActiveVue.confirmText = type == 1 ? '是否确认提交？' : '是否确认保存？';
		addSchoolActiveVue.confirmTextSuccess = type == 1 ? '提交成功' : '保存成功';

		//获取表单数据
		console.log('ajaxSubMit===type===' + type);
		addSchoolActiveVue.listData.pictureId = '';
		addSchoolActiveVue.listData.videoId = '';
		var photos = []; //图片路径
		//返回图片地址
		mui('.repair_photo_item').each(function() {
			photos.push(this.getAttribute('src'));
		});
		var i = 0;
		var length = photos.length;
		if(length == 0 && addSchoolActiveVue.videoIds.length == 0 && type == 1) {
			mui.toast('图片和视频至少选其一');
			return false;
		}
		//		console.log('photos===' + JSON.stringify(photos))
		//		console.log('length===' + length);

		if(type == 1) {
			mui.confirm(addSchoolActiveVue.confirmText, '提示', ['确认', '取消'], function(e) {
				if(e.index == 1 || e.index == -1) {
					return;
				} else {
					ajaxSubMit(i, length, photos, type);
				}
			});
		} else {
			ajaxSubMit(i, length, photos, type);
		}

	}
	//绑定事件
	function bindEventHandler() {
		//重定义返回键
		mui.back = function() {
			mui.confirm("是否保存数据?", '提示', ['确认', '取消'], function(e) {
				if(e.index == 0) {
					console.log('保存中')
					addSchoolActiveVue.listData.activiesContent = document.getElementById('addDesc').value;
					addSchoolActiveVue.listData.activiesTitle = document.getElementById('title').value
					subMit(0)
				} else {
					var _self = plus.webview.currentWebview();
					var opener = _self.opener();
					//					mui.fire(opener, 'refreshVIew');
					_self.close();
				}
			});
		}

		document.getElementById('addPicBtn').addEventListener('tap', function(e) {
			e.stopPropagation();
			if(photosCount == 9) {
				addSchoolActiveVue.photoNum = 9;
				mui.toast('最多只能添加9张图片');
				return;
			} else {
				plus.nativeUI.actionSheet({
					title: "添加图片附件",
					cancel: "取消",
					buttons: [{
							title: '从手机选择'
						},
						{
							title: '拍照'
						},
					]
				}, function(e) {
					switch(e.index) {
						case 1:
							getPic(2); //相册选择
							break;
						case 2:
							getPhoto(); //拍照
							break;
					}
				});
			}
		});
		//图片右上角红色删除图片
		mui("#publishPhotoList").on('tap', '.icon_remove', function(e) {
			e.stopPropagation();
			this.parentNode.remove();
			photosCount--;
			addSchoolActiveVue.photoNum = photosCount;
		});
		document.getElementById('submit').addEventListener('tap', function() {

			addSchoolActiveVue.listData.activiesContent = document.getElementById('addDesc').value;
			addSchoolActiveVue.listData.activiesTitle = document.getElementById('title').value
			if(!window.MethodUtil.filterEmoji(addSchoolActiveVue.listData.activiesTitle)) {
				photos = [];
				return false;
			}
			if(!addSchoolActiveVue.listData.activiesTitle || addSchoolActiveVue.listData.activiesTitle == '') { //公告说明
				photos = [];
				mui.toast('请填写标题');
				return false;
			}
			if(!window.MethodUtil.filterEmoji(addSchoolActiveVue.listData.activiesContent)) {
				photos = [];
				return false;
			}

			if(!addSchoolActiveVue.listData.activiesContent || addSchoolActiveVue.listData.activiesContent == '') { //公告说明
				photos = [];
				mui.toast('请填写描述内容');
				return false;
			}

			subMit(1);

		})
	}

	function bindVideoEvent() {
		var videos = document.querySelectorAll("video");
		if(videos) {
			videos.forEach(function(item, idx) {
				item.autoplay = false;
				item.load();
				item.addEventListener("loadeddata", function() {
					console.log("loadeddata");
					console.log("loadeddata" + item.currentTime);
					captureImage(item, idx);
				}, false);
				if(mui.os.android) {
					item.addEventListener("timeupdate", function() {
						console.log("-----showvideo--------" + isSet);
						if(!isSet && capLock) {
							capLock = false;
							console.log("videoCapture");
							captureImage(item, idx);
							isSet = true;
						}
					}, false);
				}
			});

		}
	};
	var captureImage = function(video, idx) {
		console.log("captureImage");
		var scale = 0.8;
		var canvas = document.createElement("canvas"); // 创建一个画布
		canvas.width = video.videoWidth * scale;
		canvas.height = video.videoHeight * scale;
		canvas.getContext('2d').drawImage(video, 0, 0, canvas.width, canvas.height); // getContext:设置画布环境；drawImage:画画 
		var img = document.createElement("img");
		try {
			var src = canvas.toDataURL("image/png");
			console.log("captureImage3" + src);
			img.src = src; // 获取图片的url
			console.log("captureImage4");
			if(src && src != "data:,") {
				video.poster = src;
				addSchoolActiveVue.addVideoFirstFrame = src;
				console.log("picSrc" + src);
			}
			capLock = true;
		} catch(e) {
			console.log("problem" + JSON.stringify(e));
			capLock = true;
		}
	};

	return {
		init: function() {
			initPage();
			bindEventHandler();

		}
	}
})(window, mui);

//详情页
var schoolActiveDetail = (function(c, $) {
	var classPhotoDetailVue = new Vue({
		el: '#schoolActiveDetail',
		data: {
			listData: [],
		},
		methods: {

		},
		filters: {

		}
	});
	var itemId;
	//处理视频
	function loopGetVideo(arr, callback) {
		var i = 0;
		var temp = [];
		return function() {
			var me = arguments.callee;
			if(i < arr.length) {
				window.DataUtil.getOSSFile(arr[i], function(res) {
					console.log("loopGetVideo======" + JSON.stringify(res));
					temp.push({
						src: "http://" + res.data.filePath,
						postSrc: arr[i]
					});
					i++;
					me();
				});
			} else {
				if(typeof callback == "function") {
					callback(temp);
				}
			}
		}

	};

	function fillForm(item, videoInfo) {
		console.log('videoInfo====' + JSON.stringify(videoInfo));
		item.newVideo = videoInfo[0].src;
		item.videoIdImg = window.FILE_GET_CONFIG_OSS_IMG + videoInfo[0].postSrc + '?t=0&w=0&h=0&m=fast&f=png';
		classPhotoDetailVue.listData = item;
		console.log('classPhotoDetailVue.listData====' + JSON.stringify(classPhotoDetailVue.listData));
	}

	//如推送时就在本页则刷新数据
	function initPageRefresh() {
		window.addEventListener('refreshCurrentPage', function(e) {
			itemId = e.detail.activitiesId;
			initPage(itemId);
		});
	}

	//初始化页面
	function initPage(itemId) {
		var obj = {
			activitiesId: itemId
		}
		console.log('obj====' + JSON.stringify(obj))
		window.DataUtil.activitiesDetail(obj, function(data) {
				console.log(" ===校园活动详情=== " + JSON.stringify(data));
				if(data.SystemCode == 1) {
					plus.nativeUI.closeWaiting();
					var picArr;
					var photo = [];
					data.data.activiesContent = window.MethodUtil.replaceLB(data.data.activiesContent);
					if(data.data.pictureId && data.data.channel == 2) {
						picArr = data.data.pictureId.split(',');

						picArr.forEach(function(item) {
							photo.push(c.IMAGE_GET_CONFIG_OSS + item + '?format=jpeg');
						});
						data.data.pictureId = photo;
					}

					var arr = [];
					console.log('data.data.channel====' + data.data.channel);
					console.log('data.data.pictureId===' + data.data.pictureId);
					console.log('data.data.channel====' + data.data.channel);
					var videoId = data.data.videoId;
					//					var videoId = data.data.channel == 1 ? data.data.pictureId : data.data.videoId;
					console.log('videoId====' + videoId);
					if(videoId) {
						arr.push(videoId);
					}

					console.log('arr===' + JSON.stringify(arr));

					if(arr.length != 0) {
						var item = data.data;
						var getVideo = loopGetVideo(arr, function(videoInfo) {
							fillForm(item, videoInfo);

						});
						getVideo();
					} else {
						classPhotoDetailVue.listData = data.data;
					}

				}
			},
			function(xhr, type, error) {
				console.log(xhr.responseText);
			});

	}

	//绑定事件
	function bindEventHandler() {

	}

	return {
		init: function() {
			var self = plus.webview.currentWebview();
			itemId = self.itemId || self.activitiesId;
			bindEventHandler();
			initPageRefresh();
			initPage(itemId);
		}
	}
})(window, mui);