/*
 * 说明：护导添加页、编辑页、查看页
 * 创建人：qk
 */

var scrutiny = (function(c, $) {

	var picHostOSS = IMAGE_GET_CONFIG_OSS;
	var picHost = IMAGE_GET_CONFIG;
	var picHostUpdate=true;
	var updateTimeStamp = new Date(c.GlOBAL_CONFIG.picHostUpdateDay).getTime();

	var vm = new Vue({
		el: '#scrutinycnt',
		data: {
			username: "",
			canEdit: true,
			time: "",
			inspection: [],
			picHost: picHost,
			picHostOSS: picHostOSS,
			isAct: false,
			pictureIds: []
		},
		updated: function() {
			c.MethodUtil.initPhotoSwipeFromDOM('.my-gallery');
		},
		filters: {
			substr: function(val) {
				return val.substr(0, 10);
			},
			prefix: function(val) {
				return val.substr(10, 16);
			}
			
		},
		methods:{
			photoPreview:function(pic){
				var ret="";
				if(pic){
					if(pic.match(picHostOSS)){
						ret = pic+"&r.type=resize&r.h=100";
					}else{
						ret =pic+'?renditions=fill-130x130-c100';
					}
				}
				return ret;
			}
		}
	});

	//拍照模块
	var camera = function() {
		var baseUrl = "_downloads/camera/";
		var _data = {};

		var _getpath = function(path) {
			return path.substring(path.lastIndexOf('/'));
		};
		var zipPhoto = function(path, callback) {
			c.MethodUtil.compressImage(path, baseUrl + _getpath(path),
				function(zipEvent) {
					callback(path, zipEvent);
				});
		};

		var getData = function(key) {
			return _data[key];
		};
		var setData = function(obj) {
			_data = mui.extend({}, data, obj);
		};

		var getCamera = function(callback) {
			c.MethodUtil.getCamera(function(path) {
				zipPhoto(path, callback);
			});
		};
		return {
			getCamera: getCamera,
			zipPhoto: zipPhoto
		}
	};

	// 页面模块
	var page = function() {
		//id
		var pageId = "";
		//创建时间
		var time = "";
		//护导标题 舍去
		/*var title = "";*/
		//提交还是保存状态
		var status = "0";
		//接口 数据type需要
		var source = "1";
		//调用相机
		var cameraTool = camera();
		//用户信息
		var userInfo;
		//判断是否是今天
		var isToday = function() {
			return(getCurrentDay() == vm.time);
		};
		//从公告点进详情需要传入此值
		var noticeId = "";
		//一个一个图片上传
		var uploader = function(callback) {
			var data = vm.inspection.slice();
			var startIndex = 0;
			var columnsLen = data.length;
			var photosPath = [];
			var i = 0;
			var j = 0;

			var loop = function(i, fn) {
				var length;
				var arr;
				var photo;
				var pictureId;
				if(i < columnsLen) {
					arr = data[i];
					pictureId = data[i].pictureId.slice();
					length = pictureId.length;

					if(j < length) {
						if(pictureId[j].match("download")) {
							c.MethodUtil.uploadImages(pictureId[j], function(res) {
								photosPath.push(picHostOSS + res.data[0] + '?format=jpeg');
								j++;
								loop(i, fn);

							});
						} else {
							photosPath.push(pictureId[j]);
							j++;
							loop(i, fn);
						}
					} else {
						data[i].pictureId = photosPath.slice();
						photosPath = [];
						i++;
						j = 0;
						loop(i, fn);
					}

				} else {
					fn(data);
				}

			};

			loop(startIndex, function() {
				callback(data);
			});

		};
		//校验
		var checkForm = function(type) {
			var msg = "";
			var data = vm.inspection;

			for(var i = 0; i < data.length; i++) {
				/*if(type == "1") {
					if(data[i].guideContent == "") {
						msg = "请填写完所有内容";
						break;
					}
				}*/
				if(!c.MethodUtil.filterEmoji(data[i].guideContent)) {
					msg = "不能输入emoji表情";
					break;
				}

			}
			return msg;
		};

		var _ch_save = function(sendData) {
			//alert("senddata");
			var str = "提交";
			if(status == "0") {
				str = "保存";
			}
			c.DataUtil.saveProtectContent(sendData, function(res) {
				console.log('保存护导' + JSON.stringify(res));
				plus.nativeUI.closeWaiting();
				if(res.SystemCode == 1) {
					$.toast(str + '成功');
					$.fire(plus.webview.currentWebview().opener(), 'refresh', {});
					plus.webview.currentWebview().close();

				} else {
					if(res.SystemCode == "10002") {
						if(pageId) {
							$.toast("当日护导记录已提交,不能再次保存或提交");
						} else {
							$.toast("今日护导记录已存在,请编辑该记录");
						}
						$.fire(plus.webview.currentWebview().opener(), 'refresh', {});
						plus.webview.currentWebview().close();
					} else {
						$.toast(str + '失败');
					}
				}
			}, function(xhr) {
				plus.nativeUI.closeWaiting();
				console.log(xhr.status);
				$.toast(str + '失败');
			});
		}

		function resetPostData(data, type) {
			var ret = {};
			var content = [];
			ret.status = status;
			ret.summaryId = "";
			if(pageId) {
				ret.summaryId = pageId;
			}
			//ret.title = title;
			ret.username = vm.username;

			var orign = data;
			for(var i = 0; i < orign.length; i++) {
				var obj = {
					protectItem: orign[i].id,
					protectContent: orign[i].guideContent,
					protectAnnex: orign[i].pictureId.map(function(item) {
						var index = item.lastIndexOf("/");
						var suffixIndex = item.lastIndexOf("?");
						var startIndex = 0;
						var endIndex = item.length;
						if(index != -1) {
							startIndex = index + 1;
						}
						if(suffixIndex != -1) {
							endIndex = suffixIndex;
						}
						return item.substring(startIndex, endIndex);
					})
				};
				content.push(obj);
			}
			ret.content = content;
			return ret;
		};

		var formSubmit = function(type) {
			var url = "";
			var str = "提交";
			if(type == "0") {
				str = "保存";
			}
			var cfgStr = "是否确认" + str + "?";
			var tip = "今天";
			if(!isToday()) {
				tip = "当天" + (vm.time);
			}

			if(type == "1") {
				cfgStr = "提交后 ," + tip + "的记录将无法再提交或保存 ," + cfgStr;
			}
			//var formData = getFormData();
			console.log(vm.inspection);
			console.log("表单数据" + JSON.stringify(vm.inspection));
			//var validateResult = checkForm(type, rules, formData)

			//var submitData = {};
			var msg = checkForm(type);
			if(msg) {
				plus.nativeUI.closeWaiting();
				$.toast(msg);
				return;
			} else {
				$.confirm(cfgStr, '提示', ['确认', '取消'], function(e) {
					//					var tlt = title ? title : '请输入 标题';
					if(e.index == 0) {

						plus.nativeUI.showWaiting('提交中...');

						uploader(function(uploadData, type) {
							var postData = resetPostData(uploadData, type);
							console.log("提交的数据" + JSON.stringify(postData));
							_ch_save(postData, str);

						});
					}

				});
			}
		};

		var _submit = function(type) {

			//var formData = getFormData();
			//console.log("表单数据"+JSON.stringify(formData)));
			status = type;
			formSubmit(type);
		};
		var removeData = function(columId, id) {
			var inspection = vm.inspection;
			//alert(columId + "：" + id);
			var temp = [];
			for(var i = 0; i < inspection.length; i++) {
				inspection[i].pictureId = inspection[i].pictureId || [];
				if(i == columId) {
					//alert(i);
					temp = inspection[i].pictureId;
					temp.splice(id, 1);
					break;
				}
			}

		};
		var setRemark = function(val, columnId) {
			var inspection = vm.inspection;
			var temp = [];
			for(var i = 0; i < inspection.length; i++) {
				inspection[i].guideContent = inspection[i].guideContent || '';
				if(i == columnId) {

					vm.$set(inspection, i, mui.extend({}, inspection[i], {
						guideContent: val
					}));
					break;
				}
			}
		};
		var setPictureData = function(columId, pictureData) {

			var inspection = vm.inspection;
			var temp = [];
			for(var i = 0; i < inspection.length; i++) {
				inspection[i].pictureId = inspection[i].pictureId || [];
				if(i == columId) {
					temp = inspection[i].pictureId.slice();
					temp.push(pictureData);

					inspection[i].pictureId = temp;
					vm.$set(inspection, i, mui.extend({}, inspection[i], {
						pictureId: temp
					}));
					break;
				}
			}

		};
		var getPhoto = function(that) {
			cameraTool.getCamera(function(path, zipEvent) {
				var colomnId = that.dataset.columnIdx;
				setPictureData(colomnId, zipEvent.target);
				//var wrap = document.getElementById("publishPhotoList"+colomnId);
				//photoList.createPreview(zipEvent,wrap,that);
			});
		};

		function getPic(that) {
			var max = 9;
			var colomnId = that.dataset.columnIdx;
			var photosCount = vm.inspection[colomnId].pictureId.length;
			flag = max - photosCount;
			if(photosCount < max) {
				plus.gallery.pick(function(e) {
						for(var item in e.files) {
							var path = e.files[item];
							var colomnId = that.dataset.columnIdx;
							cameraTool.zipPhoto(path, function(path, zipEvent) {
								setPictureData(colomnId, zipEvent.target);
								//var wrap = document.getElementById("publishPhotoList"+colomnId);
								//photoList.createPreview(zipEvent,wrap,that);
							}); //压缩图片
						}
					},
					function() {
						plus.nativeUI.toast('取消选择图片');
					}, {
						filter: 'image',
						multiple: true,
						maximum: flag,
						system: false,
						onmaxed: function() {
							plus.nativeUI.toast("最多只能选取" + max + "张图片");
							return;
						}
					});
			} else {
				plus.nativeUI.toast("已经选取" + max + "张图片");
				return;
			}
		}
		var bindEvent = function() {
			console.log("护导页面====bindEvent");
			mui(document).on("tap", "#save", function(e) {
				//document.activeElement.blur();
				console.log("护导页面====保存");
				_submit("0");

			});
			mui(document).on("tap", "#submit", function(e) {
				console.log("护导页面====提交")
				_submit("1");
			});

			mui(document).on("tap", ".J-camera", function(e) {
				var that = this;
				e.stopPropagation();
				var index = this.dataset.index;

				plus.nativeUI.actionSheet({
					title: "添加图片附件",
					cancel: "取消",
					buttons: [{
							title: '从手机选择'
						},
						{
							title: '拍照'
						},
					]
				}, function(e) {
					switch(e.index) {
						case 1:
							getPic(that); //相册选择
							break;
						case 2:
							getPhoto(that); //拍照
							break;
					}
				});

			});
			mui(document).on("change", ".J-remark", function(e) {
				var that = this;
				var columnIdx = that.dataset.columnIdx;
				//alert(that.value);
				setRemark(that.value, columnIdx);
			});
			mui(document).on("tap", ".btn-search", function(e) {
				window.WebviewUtil.show('protectionClockRecord', {
					date: vm.time,
					status: status
				});
			});
			mui(document).on('tap', '.icon-remove', function(e) {
				e.stopPropagation();
				var liElem = this.parentNode;
				//alert(liElem.innerHTML);
				var columnIdx = liElem.dataset.columnIdx;
				var idx = liElem.dataset.idx;
				//this.parentNode.remove();
				removeData(columnIdx, idx);

			});

			//推送刷新
			window.addEventListener('refreshCurrentPage', function(e) {
				pageId = e.detail.push_detail_id;
				time = e.detail.time;
				time = moment(new Date(time * 1)).utc().zone(-8).format("YYYY-MM-DD HH:mm:ss");
				vm.canEdit = false;
				vm.time = time.slice(0, 10);
				source = '3';
				noticeId = e.detail.noticeId;
				getDetail();
			});
		};
		var getContent = function(itemId, cntArr) {
			var ret = "";
			var temp;
			for(var i = 0; i < cntArr.length; i++) {
				temp = cntArr[i];
				if(temp.itemId == itemId) {
					ret = temp["content"];
					break;
				}
			}
			return ret;
		}
		var _dataHandler = function(data) {
			var ret = {};
			ret.content = [];
			data.annexMap = data.annexMap || {};
			data.protectContentList = data.protectContentList || [];
			if(data && data.protectItemList && data.protectItemList.length) {
				ret.content = data.protectItemList.map(function(item, i) {
					var annexMap = data.annexMap[item.id] || [];
					return mui.extend({}, item, {
						guideContent: getContent(item.id, data.protectContentList),
						pictureId: annexMap.map(function(pic, index) {
							return pic;
						})
					});
				});
			}
			ret.createUserName = data.createUserName;
			ret.createDate = data.createDate;
			console.log("protectionDetail:ret:" + JSON.stringify(ret));
			return ret;
		};
		var dataHandler = function() {
			for(var i = 0; i < vm.inspection.length; i++) {
				if(pageId) {
					vm.inspection[i].pictureId = vm.inspection[i].pictureId || [];
					vm.inspection[i].id = vm.inspection[i].id || '';
					vm.inspection[i].guideContent = vm.inspection[i].guideContent || '';

					vm.inspection[i].guideContentLB = c.MethodUtil.replaceLB(vm.inspection[i].guideContent);
					vm.inspection[i].pictureId = (vm.inspection[i].pictureId || []).slice();
				} else {
					vm.inspection[i].guideContent = '';
					vm.inspection[i].pictureId = [];
				}

				vm.inspection[i].pictureId = vm.inspection[i].pictureId.map(function(item) {
					//console.log(item);
					if(item.match("download")) {
						return item;
					} else {
						if(item.match("/")) {
							item = item.substr(item.lastIndexOf("/") + 1);
						}
						//console.log("picHost"+picHost + item);
						if(isNaN(item)||item.length>8) {
							return picHostOSS + item + '?format=jpeg';
						} else {
							return picHost + item;
						}
					}
				});
				
				console.log("dataHandler" + JSON.stringify(vm.inspection));
			}
		};

		function getDetail() {
			var url = "";
			plus.nativeUI.showWaiting('加载中...');
			var params = {};
			if(!pageId) {
				url = API_CONFIG.findAllProtectItem;
				params = {
					url: url
				};
			} else {
				params = {
					url: url,
					summaryId: pageId,
					date: time,
					noticeId: noticeId

				};
			}
			console.log("getDetail" + JSON.stringify(params));
			c.DataUtil.getScrutiny(params, function(res) {
				plus.nativeUI.closeWaiting();
				mui.fire(plus.webview.getWebviewById('Notice'), 'redDot', {
					redId: noticeId || ""
				});
				//res =JSON.parse(res);
				console.log('===护导点详情===' + JSON.stringify(res));
				console.log('===护导点详情===' + JSON.stringify(res.updateDate));

				if(res.success && res.SystemCode == 1) {
					if(pageId) {
						var inspection = _dataHandler(res);
						console.log("_dataHandlerInspection" + JSON.stringify(inspection));
						vm.inspection = inspection.content;
						title = res.title || '';
						vm.username = res.createUserName;
						if(res.createDate) {
							vm.time = moment(new Date(res.createDate)).format("YYYY-MM-DD");
						}
						if(res.updateDate&&res.updateTimeStamp>=updateTimeStamp){
							picHostUpdate = true;
						}else{
							picHostUpdate =false;
						}
						//alert(res.userId==userInfo.userId);
						//控制保存状态下非本人不可以编辑
						/*if(res.userId && vm.canEdit && res.userId != userInfo.userId) {
							vm.canEdit = false;
						}*/

						//更新角标
						if(!vm.canEdit) {
							setTimeout(function() {}, 255);
							mui.fire(plus.webview.getWebviewById('index-subpage-app.html'), 'updateBadgeNum', {});
						}
					} else {
						vm.inspection = res.protectItemList || [];
					}

					dataHandler();
					console.log('===护导点详情1===' + JSON.stringify(vm.inspection));

					if(vm.inspection.length == 0) {
						if(!pageId) {
							$.toast('没有检查项，请联系管理员');

							plus.webview.currentWebview().close();
						} else {
							$.toast('数据异常，没有检查项');
						}
					} else {
						if(vm.canEdit) {
							vm.isAct = true;
						}
					}
				} else {

					$.toast("服务器异常");
					vm.canEdit = false;
					vm.inspection = [];
					$.toast('数据异常，没有检查项');

				}
			}, function(xhr) {
				plus.nativeUI.closeWaiting();
				$.toast('加载失败，请稍后重试')
				console.log('error=' + xhr.status)
			})
		}

		function getCurrentDay() {
			var newDate = new Date();
			var month = newDate.getMonth() + 1;
			var day = newDate.getDate();
			if(month < 10) {
				month = '0' + month;
			} else {
				month = month;
			}
			if(day < 10) {
				day = '0' + day;
			} else {
				day = day;
			}
			return newDate.getFullYear() + '-' + month + '-' + day;
		}

		function _init() {
			var id = plus.webview.currentWebview().pageId || plus.webview.currentWebview().push_detail_id;
			var pushTime = plus.webview.currentWebview().time;
			var dqtime = plus.webview.currentWebview().dqtime;
			status = plus.webview.currentWebview().status;
			var username = plus.webview.currentWebview().username;
			var type = plus.webview.currentWebview().type;
			var dailyMask = plus.webview.currentWebview().dailyMask||'';
			noticeId = plus.webview.currentWebview().noticeId;
			userInfo = JSON.parse(plus.storage.getItem('userInfo'));

			if(type) {
				source = type;
			}
			if(id) {
				pageId = id;
			}
			if(dailyMask){
				vm.canEdit = false;
			}else{
				if(status) {
					// alert("status=="+plus.webview.currentWebview().status);
					vm.canEdit = (status == "0");
					// alert(vm.canEdit);
				}
			}

			if(dqtime) {
				time = dqtime;
				vm.time = time.slice(0, 10);
			} else if(pushTime) {
				time = moment(new Date(pushTime * 1)).utc().zone(-8).format("YYYY-MM-DD HH:mm:ss");
				vm.time = time.slice(0, 10);
			} else {
				vm.time = getCurrentDay();
			}
			if(username) {
				vm.username = username;
			} else {
				if(!pageId) {
					vm.username = userInfo.userName;
				}
			}
			dataHandler();

		}
		var init = function() {
			_init();
			getDetail();
			bindEvent();
		}

		return {
			init: init
		}

	};

	return page();

})(window, mui);