/*
 * 说明：统计看板js
 * 创建人：lv
 * 创建时间：2018/3/7 16:55
 * 修改人：
 * 修改时间：
 */

/*Vue 过滤器*/
Vue.filter('formatStr', function(value, maxLength) {
	if(!value) return ''
	if(!maxLength) {
		maxLength = value.length - 1;
	}
	return value = value.toString().slice(0, maxLength)
});

//统计看板/统计汇总
var statisticsList = (function(c, $) {
	//绑定事件
	function bindEventHandler() {
		mui('.clock').on('tap', '.statistics_item', function() {
			var href = this.dataset.href;
			window.WebviewUtil.show(href);

		});
	}

	return {
		init: function() {
			bindEventHandler();
		}
	}
})(window, mui);

//打卡统计
var clockLeader = (function(c, $) {
	//  设置时间控件 start
	function getParams() {
		return {
			pageNo: pageNo,
			pageSize: pageSize
		}
	}

	function setParams(val) {
		pageNo = val;
	}

	function hasNext() {
		var ret = Math.ceil(total / pageSize) > pageNo;
		console.log("hasNext:" + ret);
		return Math.ceil(total / pageSize) > pageNo;
	}
	//   设置时间控件 end
	var vm = new Vue({
		el: '#queryDataVue',
		data: {
			listData: [], //迟到，异常，缺勤的数量
			listDataList: [], //迟到，异常，缺勤对应的列表
		},
		methods: {
			startTimePicker: function() { //开始时间选择器
				var picker = new $.DtPicker({
					"type": "date",
					endDate: new Date()
				});

				//初始化DtPicker组件
				document.activeElement.blur();
				picker.show(function(selectItems) {
					startTime = selectItems.value;
					startTime = startTime + ' 00:00:00';
					var selectTimeStart = selectItems.text.replace(/\-/g, '.')
					document.getElementById('startTimeSpan').innerText = selectTimeStart;
					picker.dispose();
				});
				picker.setSelectedValue(startTime); //设置默认选中
			},
			endTimePicker: function() { //结束时间选择器
				var picker = new $.DtPicker({
					"type": "date",
					endDate: new Date()
				}); //初始化DtPicker组件
				document.activeElement.blur();
				picker.show(function(selectItems) {
					endTime = selectItems.value;
					endTime = endTime + ' 23:59:59';
					var selectTimeStart = selectItems.text.replace(/\-/g, '.')
					document.getElementById('endTimeSpan').innerText = selectTimeStart;
					picker.dispose();
				});
				picker.setSelectedValue(endTime); //设置默认选中
			},
		},
		filters: {
			subs: function(value) {
				return window.MethodUtil.subs(value);
			}
		}
	});
	var startTime, //开始时间
		clockType = 0, //数据类型，1、迟到 2、异常 3、缺勤
		keepStartTime, //存开始时间
		keepEndTime, //存结束时间
		nextUrl = '', //下一页地址
		nextUrlFrist, //记录上一页地址
		endTime, //结束时间
		isLoading = false, //是否请求数据的标志
		typeIndex = 0; //类型index 

	var pageSize = 10, //10 条一页
		maxPage, //最大页数
		pageNo = 0; //从第一页开始

	//获取当天的时间设置默认周、月的是时间
	var newDate = new Date();
	var month = newDate.getMonth() + 1;
	var day = newDate.getDate();
	if(month < 10) {
		month = '0' + month;
	} else {
		month = month;
	}
	if(day < 10) {
		day = '0' + day;
	} else {
		day = day;
	}
	var currentDay = newDate.getFullYear() + '-' + month + '-' + day + ' 23:59:59';
	//初始化页面
	function pieFunction() {
		var obj = {
			startDate: startTime,
			endDate: endTime
		}
		console.log('startTime====' + startTime);
		console.log('endTime====' + endTime);
		c.DataUtil.getMyClockData(obj, function(data) { //饼图接口
			console.log("===个人打卡统计===" + JSON.stringify(data));
			if(data.SystemCode == 1) {
				document.getElementById('queryData').style.display = 'block';
				data.workSign = data.data;
				document.getElementById('clockStatus').style.display = 'block';
				keepStartTime = startTime;
				keepEndTime = endTime;
				//tab切换设置默认第一个高亮
				var typeTab = document.getElementById('queryDataVue');
				var typeTabs = typeTab.querySelectorAll('.item');
				for(var i = 0; i < typeTabs.length; i++) {
					typeTabs[i].classList.remove("active");
				}
				typeTabs[0].classList.add("active");
				clockType = 1; //tab栏对应的值设为第一个
				var unit = "次";
				//饼图数据
				//				var arr = [{
				//					value: data.workSign.late,
				//					name: '迟到'+data.workSign.late+unit
				//				}, {
				//					value: data.workSign.isException,
				//					name: '异常'+data.workSign.isException+unit
				//				}, {
				//					value: data.workSign.absence,
				//					name: '缺勤'+data.workSign.absence+unit
				//				}, {
				//					value: data.workSign.normal,
				//					name: '正常'+data.workSign.normal+unit
				//				}];
				//				c.MethodUtil.echartsPie('', arr); //调饼图方法
				var arr = [{
					value: data.workSign.normal,
					name: '正常' + data.workSign.normal + '次'
				}, {
					value: data.workSign.isException,
					name: '异常' + data.workSign.isException + '次'
				}, {
					value: data.workSign.late,
					name: '迟到' + data.workSign.late + '次'
				}, {
					value: data.workSign.absence,
					name: '缺勤' + data.workSign.absence + '次'
				}];
				var title = ['正常' + data.workSign.normal + '次', '异常' + data.workSign.isException + '次', '迟到' + data.workSign.late + '次', '缺勤' + data.workSign.absence + '次'];
				var color = ['#378aff', '#7739ff', '#ffd24a', '#ff4a4a'];
				c.MethodUtil.echartsDoublePie(title, true, color, arr); //调饼图方法
				vm.listDataList = []; //清空迟到，异常，缺勤的数组
				vm.listData = data.workSign;
				nextUrlFrist = '';
				refreshList(nextUrlFrist); //底部列表接口
			} else {
				if(data.SystemCode == 10001) {
					document.getElementById('queryData').style.display = 'none';
					document.getElementById('datas_lv').style.display = 'block';
				}
				mui.toast(ERROR_CONFIG[data.SystemCode]);
			}
		}, function() {
			plus.nativeUI.toast("请求出错");
		});

	}

	function refreshData(id) {
		$.fire(plus.webview.getWebviewById('Clock'), "refreshlistSpecial", {});
		var activeElem = document.querySelector(".btnActive");
		var index = activeElem.dataset.idx;
		console.log("index:" + index);
		var oldObj;
		if(index != undefined && index != null) {
			if(vm.listDataList[index]) {
				oldObj = vm.listDataList[index];
				vm.listDataList.splice(index, 1, $.extend({}, oldObj, {
					abnormalId: id,
					exceptionType: 2
				}))
			}
			console.log(vm.listDataList[index].flagException);
		}
		activeElem.classList.remove("btnActive");

	}

	function bindEvent() {

		mui("#refreshContainer").on("tap", ".J-act", function(e) {
			var that = this;
			that.classList.add("btnActive");
			e.preventDefault();
			var pageId = that.dataset.pageId;
			var type = that.dataset.type;
			var time = that.dataset.time || '';
			var page = "addAttendanceExpection";
			if(type == "1") {
				page = "clockException";
				that.classList.remove("btnActive");
			}
			WebviewUtil.show(page, {
				pageId: pageId,
				attendanceExceptionTime: time
			});
		});
		window.addEventListener("refreshlist", function(e) {
			var id = e.detail.id;
			refreshData(id);

		});

	}

	function initPage() {
		//设置打开页面渲染当天时间往前推6天(一星期)的数据
		var today = newDate.getFullYear() + '-' + month + '-' + day;
		var dateweek = new Date(today);
		var timeweek = dateweek.getTime() - 6 * 24 * 60 * 60 * 1000;
		startTime = moment(new Date(timeweek)).utc().zone(-8).format("YYYY-MM-DD");
		startTime = startTime + ' 00:00:00';
		timeweek = moment(new Date(timeweek)).utc().zone(-8).format("YYYY.MM.DD");
		document.getElementById('startTimeSpan').innerText = timeweek;
		document.getElementById('endTimeSpan').innerText = moment(new Date(today)).utc().zone(-8).format("YYYY.MM.DD");

		endTime = newDate.getFullYear() + '-' + month + '-' + day + ' 23:59:59';
		bindEvent();
		pieFunction(); //调后台数据
	}

	//上拉加载列表数据,底部列表接口
	function refreshList(nextUrlFrist) {
		plus.nativeUI.showWaiting("加载中..."); //加载框
		//传参
		if(!isLoading) {
			isLoading = true;
			pageNo++;
			var obj = {
				startDate: keepStartTime,
				endDate: keepEndTime,
				exceptionType: clockType,
				pageNo: pageNo,
				pageSize: pageSize
			};
			console.log('obj=====' + JSON.stringify(obj))
			c.DataUtil.getMyClockDataList(obj, function(data) { //底部列表接口
				isLoading = false;
				console.log('【===打卡统计列表 下一页===】' + JSON.stringify(data));
				if(data.SystemCode == 1) {
					if(data.data.rows.length == 0) {
						plus.nativeUI.closeWaiting();
						document.getElementById('noDatas').style.display = 'block';
						return;
					}
					maxPage = Math.ceil((data.data.records) / pageSize);
					console.log('maxPage======' + maxPage);
					if(clockType == 3) { //缺勤(整理数据保持格式和迟到,异常一致，缺勤现实缺勤字段)
						for(var i = 0; i < data.data.rows.length; i++) {
							data.data.rows[i].clockTypeName = '缺勤';
							data.data.rows[i].clockTime = data.data.rows[i].clockTime;
						}
						vm.listDataList = vm.listDataList.concat(data.data.rows);
						for(var i = 0; i < vm.listDataList.length; i++) {
							vm.listDataList[i].clockType = clockType;
						}
						//						console.log('【===打卡统计列表缺勤2===】' + JSON.stringify(vm.listDataList));
						if(maxPage == 1) {
							document.getElementById('upDatas').style.display = 'none'; //隐藏上拉显示等多
							document.getElementById('noData').style.display = 'none';
							var fristNexturl = nextUrlFrist; //存储第一次的数据
							if(fristNexturl != 1) {
								document.getElementById('noDatas').style.display = 'block';
							}
							mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
							mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
						} else {
							if(maxPage <= pageNo) {
								mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
								document.getElementById('upDatas').style.display = 'block'; //显示上拉加载更多
							} else {
								document.getElementById('upDatas').style.display = 'none'; //隐藏上拉显示等多
								mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
								mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
							}

							//							mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
							//							document.getElementById('upDatas').style.display = 'block';//显示上拉加载更多
						}
						plus.nativeUI.closeWaiting();
					} else { //迟到和异常
						//整理数据,迟到和异常现实校内打开和校外打卡
						for(var i = 0; i < data.data.rows.length; i++) {
							if(data.data.rows[i].isSchool == 0) {
								data.data.rows[i].clockTypeName = '校内打卡';
							} else {
								data.data.rows[i].clockTypeName = '校外打卡';
							}
						}
						vm.listDataList = vm.listDataList.concat(data.data.rows);
						if(maxPage == 1) {
							var fristNexturls = nextUrlFrist; //存储第一次的数据
							document.getElementById('upDatas').style.display = 'none'; //隐藏上拉显示等多
							document.getElementById('noData').style.display = 'none';
							if(fristNexturls != 1) {
								document.getElementById('noDatas').style.display = 'block';
							}
							mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
							mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
						} else {

							if(maxPage <= pageNo) {
								mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
								document.getElementById('upDatas').style.display = 'block'; //显示上拉加载更多
							} else {
								document.getElementById('upDatas').style.display = 'none'; //隐藏上拉显示等多
								mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
								mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
							}

							//							mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
							//						    document.getElementById('upDatas').style.display = 'block';//显示上拉加载更多
						}
						plus.nativeUI.closeWaiting();
					}
					//					nextUrl = data.nextUrl; //下一页地址
					nextUrlFrist = maxPage;
					mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
				} else {
					vm.listDataList = [];
					plus.nativeUI.closeWaiting();
					document.getElementById('noData').style.display = 'block';
					document.getElementById('upDatas').style.display = 'none'; //隐藏上拉显示等多
					document.getElementById('noDatas').style.display = 'none';
					mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					if(data.SystemCode != 10001) {
						mui.toast(ERROR_CONFIG[data.SystemCode]);
					}
				}
			}, function() {
				isLoading = false;
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		}

	}

	//绑定事件
	function bindEventHandler() {

		//点击切换迟到，异常的tab栏
		mui('.data').on('tap', '.item', function() {
			clockType = this.dataset.href;
			pageNo = 0;
			this.classList.add("active");
			var childrens = this.parentNode.children;
			for(var i = 0; i < childrens.length; i++) {
				childrens[i].classList.remove("active");
			}
			this.classList.add("active");
			//console.log('开始时间1startTime====' + startTime);
			//console.log('结束时间1endTime====' + endTime);
			//console.log('开始时间1keepStartTime====' + keepStartTime);
			//console.log('结束时间1keepEndTime====' + keepEndTime);
			//console.log('clockType====' + clockType);
			if(keepStartTime != startTime) {
				$.toast('当前所选时间与所求列表时间不一致,请修改');
				return;
			}
			if(keepEndTime != endTime) {
				$.toast('当前所选时间与所求列表时间不一致,请修改');
				return;
			}
			mui('#refreshContainer').pullRefresh().scrollTo(0, 0, 1) //让滑动区域回到顶部
			vm.listDataList = [];
			nextUrl = '';
			document.getElementById('upDatas').style.display = 'none'; //隐藏上拉显示等多
			document.getElementById('noData').style.display = 'none';
			document.getElementById('noDatas').style.display = 'none';
			nextUrlFrist = '';
			refreshList(nextUrlFrist); //点击切换列表
		});

		//类型周，月，学期 去除
		//document.getElementById('clockTypeSpan').innerText = typeArr[0].text; //默认周统计

		//点击查询
		document.getElementById('query').addEventListener('tap', function() {
			//下一次查询前把原列表数据清掉
			document.getElementById('noData').style.display = 'none';
			document.getElementById('noDatas').style.display = 'none';
			document.getElementById('upDatas').style.display = 'none'; //隐藏上拉显示等多
			vm.listDataList = [];
			if(startTime == undefined || startTime == '') {
				$.toast('请选择时间');
				return;
			}
			if(endTime == undefined || endTime == '') {
				$.toast('请选择时间');
				return;
			}
			if(startTime > endTime) {
				$.toast('开始时间不得大于结束时间');
				return;
			}

			if(endTime > currentDay) {
				$.toast('结束时间不得大于当前时间');
				return;
			}
			pieFunction();

		})

	}

	return {
		init: function() {
			bindEventHandler();
			initPage();
		},
		refreshList: refreshList
	}
})(window, mui);