//功能室统计
var orderRoom = (function(c, $) {
	var startTime, //开始时间
		keepStartTime, //存开始时间
		isLoading = false, //是否请求数据的标志
		keepEndTime, //存结束时间
		roomId = 1, //功能室ID
		endTime; //结束时间
	var vmAnDetail = new Vue({
		el: '#roomList',
		data: {
			detailList: [],
			detailListName: []
		},
		methods: {
			startTimePicker: function() { //开始时间选择器
				var picker = new $.DtPicker({
					"type": "date"
				});

				//初始化DtPicker组件
				document.activeElement.blur();
				picker.show(function(selectItems) {
					startTime = selectItems.value;
					startTime = startTime + ' 00:00:00';
					var selectTimeStart = selectItems.text.replace(/\-/g, '.')
					document.getElementById('startTimeSpan').innerText = selectTimeStart;
					picker.dispose();
				});
				picker.setSelectedValue(startTime); //设置默认选中
			},
			endTimePicker: function() { //结束时间选择器
				var picker = new $.DtPicker({
					"type": "date"

				}); //初始化DtPicker组件
				document.activeElement.blur();
				picker.show(function(selectItems) {
					endTime = selectItems.value;
					endTime = endTime + ' 23:59:59';
					var selectTimeStart = selectItems.text.replace(/\-/g, '.')
					document.getElementById('endTimeSpan').innerText = selectTimeStart;
					picker.dispose();
				});
				picker.setSelectedValue(endTime); //设置默认选中
			}
		}
	});

	function getPieData(arr) {
		var ret = [];
		if(arr && arr.length) {
			ret = arr.map(function(item) {
				if(item.roomName.length>5){
					item.roomName = item.roomName.slice(0,5)+'\n'+item.roomName.slice(5);
				}
				return {
					name: item.roomName + '\n' + item.useNum + "次",
					value: item.useNum
				}
			});
		}
		return ret;
	}

	//初始化页面
	function initPage() {
		getList();

		function add_zero(temp) {
			if(temp < 10) return "0" + temp;
			else return temp;
		}
		var d = new Date();
		var years = d.getFullYear();
		var month = add_zero(d.getMonth() + 1);
		var days = add_zero(d.getDate());
		var ndate = years + "-" + month + "-" + days;
	}
	//获取当前时间,设置打开页面 现实当天的数据
	var newDate = new Date();
	var month = newDate.getMonth() + 1;
	var day = newDate.getDate();
	if(month < 10) {
		month = '0' + month;
	} else {
		month = month;
	}
	if(day < 10) {
		day = '0' + day;
	} else {
		day = day;
	}
	var today = newDate.getFullYear() + '-' + month + '-' + day;
	var date = new Date(today);
	var time = date.getTime() - 6 * 24 * 60 * 60 * 1000;
	startTime = moment(startTime).format("YYYY-MM-DD");
	document.getElementById('startTimeSpan').innerText = moment(new Date(startTime)).utc().zone(-8).format("YYYY.MM.DD");
	document.getElementById('endTimeSpan').innerText = moment(new Date(today)).utc().zone(-8).format("YYYY.MM.DD")
	var currentDay = newDate.getFullYear() + '-' + month + '-' + day + ' 23:59:59';
	startTime = startTime + ' 00:00:00';
	endTime = newDate.getFullYear() + '-' + month + '-' + day + ' 23:59:59';

	function getList() {

		//传参
		var obj = {
			startDay: new Date(startTime.replace(/\-/g, '/')),
			endDay: new Date(endTime.replace(/\-/g, '/'))
		};
		console.log("startTime:" + (startTime));
		console.log("传参" + JSON.stringify(obj));
		c.DataUtil.getRoomUsedList(obj, function(data) {
			console.log('【===功能室统计===】' + JSON.stringify(data));

			var allNum = 0;
			for(var i = 0; i < data.data.length; i++) {
				allNum += Number(data.data[i].useNum);

			}
			if(data.SystemCode != 1 || allNum == 0) {

				if(data.SystemCode == 10001 || allNum == 0) {
					if(allNum == 0) {
						mui.toast('没有数据');
					} else {
						mui.toast(ERROR_CONFIG[data.SystemCode]);
					}
					document.getElementById('clockStatus').style.display = 'none';
					document.getElementById('pieChart').style.display = 'none';
				} else {

					mui.toast(ERROR_CONFIG[data.SystemCode]);
				}
				return;
			}

			//			if(data.SystemCode != 1) {
			//
			//				if(data.SystemCode == 10001) {
			//					mui.toast(ERROR_CONFIG[data.SystemCode]);
			//					document.getElementById('clockStatus').style.display = 'none';
			//					document.getElementById('pieChart').style.display = 'none';
			//				} else {
			//					mui.toast(ERROR_CONFIG[data.SystemCode]);
			//				}
			//				return;
			//			}
			document.getElementById('pieChart').style.display = 'block';
			document.getElementById('clockStatus').style.display = 'block';
			keepStartTime = startTime;
			keepEndTime = endTime;
			vmAnDetail.detailList = data.data;

			//饼图数据
			var arr = getPieData(data.data);
			//			var arr = [{
			//				value: data.data[0].useNum,
			//				name: data.data[0].roomName + '\n' + data.data[0].useNum + '次'
			//			}, {
			//				value: data.data[1].useNum,
			//				name: data.data[1].roomName + '\n' + data.data[1].useNum + '次'
			//			}, {
			//				value: data.data[2].useNum,
			//				name: data.data[2].roomName + '\n' + data.data[2].useNum + '次'
			//			}, {
			//				value: data.data[3].useNum,
			//				name: data.data[3].roomName + '\n' + data.data[3].useNum + '次'
			//			}, {
			//				value: data.data[4].useNum,
			//				name: data.data[4].roomName + '\n' + data.data[4].useNum + '次'
			//			}];
			//			c.MethodUtil.echartsPie(' ', arr); //调饼图方法
			var chartOption = {
				
				series: [{
//					name: '访问来源',
					type: 'pie',
					radius: ['30%', '45%'],
					center: ['50%', '53%'], // 左右距离
					avoidLabelOverlap: false,
					label: {
						normal: {
							show: false,
							position: 'center'
						},
						emphasis: {
							show: true,
							textStyle: {
								fontSize: '30',
								fontWeight: 'bold'
							}
						}
					},
					labelLine: {
						normal: {
							show: false
						}
					},
					data: arr
				}]
			};
			var pieChart = echarts.init(document.getElementById('pieChart'));
			pieChart.setOption(chartOption);

		}, function() {
			mui.toast('服务器异常');
		});
	}

	function getListName() {
		vmAnDetail.detailListName = [];
		//传参
		var obj = {
			roomId: roomId,
			startDate: new Date(startTime.replace(/\-/g, '/')),
			endDate: new Date(endTime.replace(/\-/g, '/'))
		};
		console.log("startTime:" + startTime);
		console.log("c.DataUtil.getRoomListName" + JSON.stringify(obj));
		c.DataUtil.getRoomListName(obj, function(data) {
			console.log('【===功能室统计会议名===】' + JSON.stringify(data));
			isLoading = false;
			if(data.SystemCode != 1) {
				mui.toast(ERROR_CONFIG[data.SystemCode]);
				return;
			}
			document.getElementById('meetting_name').style.display = 'block';
			data.data = data.roomsDataList;
			for(var i = 0; i < data.data.length; i++) {
				if(data.data[i].theme.length > 17) {
					data.data[i].theme = (data.data[i].theme).substring(0, 17) + '...';
				}
			}

			vmAnDetail.detailListName = data.data;

		}, function() {
			isLoading = false;
			mui.toast('服务器异常');
		});
	}
	//绑定事件
	function bindEventHandler() {
		//点击nav
		mui('.nav').on('tap', '.item', function() {
			if(this.dataset.target !=1){
				var href = this.dataset.href;
			   window.WebviewUtil.show(href,null,'none',0);
			}
			
		});
		
		mui('body').on('tap', '.data', function() { //点击切换迟到，异常的tab栏
			roomId = this.dataset.href;
			var numName = this.dataset.num;
			if(!isLoading) {
				isLoading = true;
				if(keepStartTime != startTime) {
					$.toast('当前所选时间与所求列表时间不一致,请修改');
					return;
				}
				if(keepEndTime != endTime) {
					$.toast('当前所选时间与所求列表时间不一致,请修改');
					return;
				}
				console.log('roomId====' + roomId);
				if(numName > 0) {
					//					getListName();

				} else {
					$.toast('所选功能室该时段没有会议!');
					isLoading = false;
					return;
				}
			}

		});
		//关闭弹框
		document.getElementById('closeIcon').addEventListener('tap', function() {
			document.getElementById('meetting_name').style.display = 'none';
			vmAnDetail.detailListName = [];
		})
		//点击查询
		document.getElementById('query').addEventListener('tap', function() {
			vmAnDetail.detailList = [];
			if(startTime == undefined || startTime == '') {
				$.toast('请选择开始时间');
				return;
			}
			if(endTime == undefined || endTime == '') {
				$.toast('请选择结束时间');
				return;
			}
			if(startTime > endTime) {
				$.toast('开始时间不得大于结束时间');
				return;
			}
			if(endTime > currentDay) {
				$.toast('结束时间不得大于当前时间');
				return;
			}

			initPage();

		})
	}

	return {
		init: function() {
			initPage();
			bindEventHandler();
		}
	}
})(window, mui);