/*
 * 说明：系统考勤js
 * 创建人：dwm
 * 创建时间：2018/3/22 10:00
 * 修改人：
 * 修改时间：
 */
var systemClock = (function(c, $) {
	var vmIndexList = new Vue({
		el: '#systemClock',
		data: {
			position: null,
			picker: null,
			username: '',
			nowTime: '',
			nowTimeList: [],
			isSetGPS: false, //是否打开GPS
			clockType: null
		},
		methods: {
			//蓝色按钮打卡事件
			checking_in: function() {
				var _this = this;
				if(!_this.picker) {
					_this.picker = new mui.PopPicker(); //初始化popPicker组件
					_this.picker.setData([{
						value: '0',
						text: '上班打卡'
					}]);
				}
				if(!_this.position) {
					plus.nativeUI.toast('没有获取到您的定位，不能打卡');
					return;
				}

				document.activeElement.blur();
				_this.picker.show(function(selectItems) {

					_this.clockType = selectItems[0].value;
					console.log(document.querySelector(".inschool").classList)
					if(document.querySelector(".inschool").classList.contains('mui-active')) {
						console.log('校内打卡');
						//打卡类型是校内打卡
						//判断是否无线网
						var netType = plus.networkinfo.getCurrentType();
						switch(netType) {
							case plus.networkinfo.CONNECTION_ETHERNET: //无线网
							case plus.networkinfo.CONNECTION_WIFI:
								var curDate = (new Date()).valueOf(); //当前时间的时间戳
								var xhr = new plus.net.XMLHttpRequest();
								xhr.timeout = 3000;
								xhr.onreadystatechange = function() {
									console.log('xhr.ready' + xhr.readyState);
									switch(xhr.readyState) {
										case 4:
											if(xhr.status == 200) {
												console.log("===串码校内===" + xhr.responseText);
												var IMEI = JSON.parse(xhr.responseText).IMEI
												subClock(IMEI);
											} else {
												console.log("请求出错：" + xhr.readyState);
												subClock('');
											}
											break;
										default:
											//其他
											break;
									}
								}
								xhr.open("GET", 'http://10.143.192.10:8080/fileserver/getCardNumber/get');
//								xhr.open("GET", "http://192.168.241.48:8180/hhpt/client/user/getCode");
								xhr.send();

								break;
								//2G,3G,4G
							case plus.networkinfo.CONNECTION_CELL2G:
							case plus.networkinfo.CONNECTION_CELL3G:
							case plus.networkinfo.CONNECTION_CELL4G:
								mui.toast("请切换WIFI网络打卡");
								return;
								break;
							default:
								mui.toast("请切换WIFI网络打卡");
								return;
								break;
						}
					} else {
						console.log('校外打卡')
						//打卡类型是校外打卡
						//判断是否无线网
						var netType = plus.networkinfo.getCurrentType();
						//						alert(netType);
						switch(netType) {
							case plus.networkinfo.CONNECTION_ETHERNET: //无线网
							case plus.networkinfo.CONNECTION_WIFI:
								subClock();
								break;
								//2G,3G,4G
							case plus.networkinfo.CONNECTION_CELL2G:
							case plus.networkinfo.CONNECTION_CELL3G:
							case plus.networkinfo.CONNECTION_CELL4G:
								mui.confirm('您没有在WIFI环境下，是否切换', '提示', ['去设置', '不用了'], function(e) {
									if(e.index == 0) { //去设置
										if(mui.os.android) {
											var main = plus.android.runtimeMainActivity();
											var Intent = plus.android.importClass("android.content.Intent");
											var mIntent = new Intent('android.settings.WIFI_SETTINGS');
											main.startActivity(mIntent);
										} else {
											plus.runtime.openURL("app-settings:");
										}
									} else { //点击的是不用了
										subClock();
									}
								})
								return;
								break;
							default:
								mui.toast("请检查网络环境");
								return;
								break;
						}

					}

				});
			},
			abnormal: function(id,type) {
				var nextPage = (type=="1"?"clockException":"addAttendanceExpection");
				WebviewUtil.show(nextPage,{pageId:id});
			},
			goBack:function(){
				 console.log("goBack");
				mui.back();
			}
		}
	})

	//初始化数据
	function initPage() {
		window.DataUtil.getByUserAndDay(function(res) {
			console.log('【当前打卡记录】===' + JSON.stringify(res));
			if(res.SystemCode == 1) {
				vmIndexList.nowTimeList = res.data;
			}
		}, function(xhr, type, error) {
			plus.nativeUI.toast("请求出错");
		})
	}
	//提交打卡
	function subClock(imei) {
		var paramObj = {
			longitude: vmIndexList.position.lng,
			latitude: vmIndexList.position.lat,
			clockType: vmIndexList.clockType,
			IMEI: imei || '',
			cid:plus.push.getClientInfo().clientid
		};
		console.log(JSON.stringify(paramObj));
		plus.nativeUI.showWaiting('打卡中...');
		window.DataUtil.systemClock(paramObj, function(res) {
			plus.nativeUI.closeWaiting();
			console.log('【上下班打卡】===' + JSON.stringify(res));
			if(res.SystemCode == 1) {
				initPage();
				plus.nativeUI.toast("打卡成功");
			} else if(res.SystemCode == 202) {
				initPage();
				plus.nativeUI.toast("打卡成功");
			} else if(res.SystemCode == 10002) {
				plus.nativeUI.toast("不可重复打卡");
			} else if(res.SystemCode == 10004) {
				plus.nativeUI.toast("无权限打卡");
			} else {
				mui.toast(ERROR_CONFIG[res.SystemCode]);
				return;
			};
		}, function(xhr, type, error) {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.toast("请求出错");
		})
	}

	//绘画地图
	var initMap = function(){
		var mapObj = new AMap.Map('container', {
			zoom: 17, // 默认缩放比例
			zoomEnable: false, // 禁止缩放
			touchZoom: false, //关闭手势缩放地图
			dragEnable: false, //禁止鼠标拖拽平移
		});
		mapObj.plugin('AMap.Geolocation', function() {
			var geolocation = new AMap.Geolocation({
				enableHighAccuracy: true, //是否使用高精度定位，默认:true
				timeout: 10000, //超过10秒后停止定位，默认：无穷大
				maximumAge: 0, //定位结果缓存0毫秒，默认：0
				convert: true, //自动偏移坐标，偏移后的坐标为高德坐标，默认：true
				showButton: true, //显示定位按钮，默认：true
				buttonPosition: 'LB', //定位按钮停靠位置，默认：'LB'，左下角
				buttonOffset: new AMap.Pixel(10, 30), //定位按钮与设置的停靠位置的偏移量，默认：Pixel(10, 20)
				showMarker: true, //定位成功后在定位到的位置显示点标记，默认：true
				showCircle: true, //定位成功后用圆圈表示定位精度范围，默认：true
				panToLocation: true, //定位成功后将定位到的位置作为地图中心点，默认：true
				zoomToAccuracy: true //定位成功后调整地图视野范围使定位位置及精度范围视野内可见，默认：false
			});
			mapObj.addControl(geolocation);
			geolocation.getCurrentPosition();
			AMap.event.addListener(geolocation, 'complete', function(posi) {
				console.log('==高德定位==' + JSON.stringify(posi));
//				vmIndexList.isSetGPS = true;
				vmIndexList.position = posi.position;
			}); //返回定位信息
			AMap.event.addListener(geolocation, 'error', function(err) {
//				console.log('==定位失败==' + JSON.stringify(err));
				var str = '定位失败,';
				str += '错误信息：'
				switch(err.info) {
					case 'PERMISSION_DENIED':
						str += '您阻止了定位操作';
						break;
					case 'POSITION_UNAVAILBLE':
						str += '无法获得当前位置';
						break;
					case 'TIMEOUT':
						str += '定位超时';
						break;
					default:
						str += '未知错误';
						break;
				}
				mui.toast(str);
				
			}); //返回定位出错信息
		});

	}

	//index跳转打卡记录
	function bindEventHandler() {
		
		document.getElementById('clock_record').addEventListener('tap', function() {
			window.WebviewUtil.show('clockLeaderMy');
		});
		
		window.addEventListener("refreshlist",function(e){
    		initPage();
    		
    	});
    	window.addEventListener("refreshlistSpecial",function(e){
    		initPage();
    		
    	});
	}

	return {
		init: function() {
			var phoneCID = plus.push.getClientInfo().clientid;
			console.log('phoneCID=======' + phoneCID);
			//判断开启定位服务
			var gpsArr = [initMap];
			window.MethodUtil.openSetting(gpsArr);
			vmIndexList.username = window.MethodUtil.getUserInfo().userName;
			//获取当前时间
			var date = new Date();
			vmIndexList.nowTime = date.getFullYear() + '.' + (date.getMonth() > 8 ? (date.getMonth() + 1) : '0' + (date.getMonth() + 1)) + '.' + (date.getDate() > 9 ? date.getDate() : '0' + date.getDate())

			initPage();
			bindEventHandler();

			//30秒更新一下地理位置
			if(vmIndexList.isSetGPS) {
				setInterval(function() {
					window.MethodUtil.openSetting(gpsArr);
				}, 30000);
			}
		}
	}
})(window, mui)

//打卡列表
var clockRecord = (function(c, $) {
	var vmClockList = new Vue({
		el: '#clockRecord',
		data: {
			listData: ''
		},
		filters: {
			//processTime: function(value) {
			//	return moment(new Date(value)).utc().utcOffset(8).format("YYYY-MM-DD HH:mm");
			//},
			subStr: function(val) {
				return val.slice(5)
			}
		},
	});

	function getClockList(isRefresh) {
		if(isRefresh) { //下拉刷新
			c.DataUtil.clockList(c.API_CONFIG.clockList, function(res) {
				//console.log('【打卡列表】' + JSON.stringify(res));
				mui('#refreshContainer').pullRefresh().endPulldown(); //结束下拉刷新
				if(res.SystemCode == 1) {
					vmClockList.listData = res.data.varList;
					mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉加载
					nextUrl = res.data.nextUrl;
					if(nextUrl == '') { //无下一页数据
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						mui('#refreshContainer').pullRefresh().enablePullupToRefresh(); //启用上拉
						mui('#refreshContainer').pullRefresh().refresh(true); //重置上拉
					}
				} else {
					if(res.SystemCode == 10001) {
						mui.toast(ERROR_CONFIG[res.SystemCode]);
						vmClockList.listData = [];
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						mui.toast(ERROR_CONFIG[res.SystemCode]);
					}
					return;
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});

		} else { //上拉加载
			if(nextUrl == "") {
				mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
				return;
			}
			//console.log('打卡列表nextUrl====' + nextUrl);
			c.DataUtil.clockList(c.HOST_CONFIG + nextUrl, function(res) {
				//console.log('【打卡下一页】===' + JSON.stringify(res));
				if(res.SystemCode == 1) {
					temp = res.data.varList;
					vmClockList.listData = vmClockList.listData.concat(temp);
					//vmClockList.listData = window.MethodUtil.getCombineObj(vmClockList.listData, temp);
					nextUrl = res.data.nextUrl;
					if(nextUrl == "") {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
					} else {
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(false);
					}
				} else {
					if(res.SystemCode == 10001) {
						mui.toast(ERROR_CONFIG[res.SystemCode]);
						vmClockList.listData = [];
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh(); //禁用上拉
					} else {
						mui.toast(ERROR_CONFIG[res.SystemCode]);
						mui('#refreshContainer').pullRefresh().disablePullupToRefresh();
					}
					return;
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		}

	}

	return {
		init: function() {},
		getClockList: getClockList,
	}
})(window, mui)