var teacherAddCircle = (function (c, $) {
    var title = '', //报修类型
        assnInfoId,//社团id
        flag = 6, //选择照片限制九张
        photosCount = 0, //选择照片张数判断
        circleContent, //内容
        annexIds = []; //图片id

    //初始化界面
    function initPage() {

    }


    //拍照
    function getPhoto() {
        if (photosCount < 6) {
            c.MethodUtil.getCamera(function (path) {
                zipPicture(path); //压缩图片
            });
        } else {
            plus.nativeUI.toast("已经选取6张图片");
        }
    }

    //取相册图片
    function getPic() {
        flag = 6 - photosCount;
        if (photosCount < 6) {
            plus.gallery.pick(function (e) {
                for (var item in e.files) {
                    var path = e.files[item];
                    zipPicture(path); //压缩图片
                }
            }, function () {
                plus.nativeUI.toast('取消选择图片');
            }, {
                filter: 'image',
                multiple: true,
                maximum: flag,
                system: false,
                onmaxed: function () {
                    plus.nativeUI.toast('最多只能选取6张图片');
                    return;
                }
            });
        } else {
            plus.nativeUI.toast("已经选取6张图片");
            return;
        }
    }

    //压缩图片
    function zipPicture(path) {
        plus.zip.compressImage({
            src: path,
            dst: "_downloads/camera/" + path.split('/')[path.split('/').length - 1],
            overwrite: true,
            quality: 20
        }, function (event) {
            if (photosCount < 6) {
                var newNode = document.createElement("li"); //克隆li标签
                newNode.className = 'add_pic'; //添加类名
                newNode.innerHTML = '<img class="repair_photo_item" src="' +
                    event.target +
                    '" /><img class="icon_remove" src="../../assets/images/repair/cancel.png" />';
                document.getElementById('publishPhotoList').appendChild(newNode); //放到ul里
                photosCount++;

            } else {
                plus.nativeUI.toast("最多选取6张图片");
            }
        }, function () {
            plus.nativeUI.closeWaiting();
            plus.nativeUI.toast(c.ERROR_CONFIG['0']);
        });
    }

    //绑定事件
    function bindEventHandler() {
        //点击选择图片
        document.getElementById('addPicBtn').addEventListener('tap', function (e) {
            e.stopPropagation();
            if (photosCount == 6) {
                $.toast('最多只能添加6张图片');
                return;
            } else {
                plus.nativeUI.actionSheet({
                    title: "添加图片附件",
                    cancel: "取消",
                    buttons: [{
                        title: '从手机选择'
                    },
                        {
                            title: '拍照'
                        },
                    ]
                }, function (e) {
                    switch (e.index) {
                        case 1:
                            getPic(); //相册选择
                            break;
                        case 2:
                            getPhoto(); //拍照
                            break;
                    }
                });
            }
        });

        //删除图片
        $("#publishPhotoList").on('tap', '.icon_remove', function (e) {
            e.stopPropagation();
            this.parentNode.remove();
            photosCount--;
            flag--;
        });

        //点击提交按钮
        document.getElementById('submit').addEventListener('tap', function () {
            title = document.getElementById('title').value; //新增圈子标题
            circleContent = document.getElementById('explain').value; //新增圈子说明
            if (!window.MethodUtil.stringText(title, '标题')) { //校验参数
                photos = [];
                annexIds = [];
                return;
            }
            if (!window.MethodUtil.stringText(circleContent, '内容')) { //校验参数
                photos = [];
                annexIds = [];
                return;
            }
            if (circleContent.length > 200) { //报修说明字数不得超过100
                photos = [];
                annexIds = [];
                $.toast('内容字数不得超过200');
                return;
            }

            var photos = []; //图片路径

            //返回图片地址
            $('.repair_photo_item').each(function () {
                photos.push(this.getAttribute('src'));
            });
            var i = 0;
            var length = photos.length;
            //递归上传图片
            var loop = function (i, callBack) {
                if (i < length) {
                    plus.nativeUI.showWaiting('提交中...');
                    c.MethodUtil.uploadImage(photos[i], function (data) {
                        annexIds.push(data.pk);
                        i++;
                        loop(i, callBack);
                    });
                } else {
                    callBack();
                }
            };

            //获取表单数据
            $.confirm('是否确认提交？', '提示', ['确认', '取消'], function (e) {
                if (e.index == 1 || e.index == -1) {
                    return;
                } else {
                    loop(i, function () {
                        //图片路径
                        var paths = annexIds.length > 0 ? annexIds.toString() : "";
                        var obj = {
                            assnInfoId: assnInfoId,
                            title: title,
                            achievementsContent: circleContent,
                            fileIds: paths
                        }
                        console.log('提交之前-----obj===' + JSON.stringify(obj));
                        c.DataUtil.saveAssnAchievement(obj, function (data) {
                            plus.nativeUI.closeWaiting();
                            console.log("===新增圈子===" + JSON.stringify(data));
                            if (data.SystemCode == 1) {
                                $.toast("提交成功");
                                photos = [];
                                annexIds = [];
                                var self = plus.webview.currentWebview();
                                var opener = self.opener();
                                $.fire(opener, "refreshlist", {});
                                $.back();

                            } else {
                                $.toast(ERROR_CONFIG[data.SystemCode]);
                            }
                        }, function () {
                            plus.nativeUI.closeWaiting();
                            plus.nativeUI.toast("请求出错");
                        });
                    });
                }
            });

        })

    }

    return {
        init: function () {
            var self = plus.webview.currentWebview();
            assnInfoId = self.assnInfoId;
            initPage();
            bindEventHandler();

        }
    }

})(window, mui);

var ClubCircle = (function (c, $) {
    var pageNo = 1,//默认第一页
        pageSize = 10,//默认一页10条数据
        maxPage;//最大页数
    var _this;
    var PROPID = '';
    var vm = new Vue({
        el: '#culbCircle',
        data: {
            cardList: [],
            imageUrl: window.IMAGE_GET_CONFIG
        },
        methods: {
            clicklove: function (item, e) {
                var param = {
                    achievementsId: item.id
                };

                c.DataUtil.changeAssnAchievementPraise(param, function (res) {
                    var tempCount = parseInt(item.praiseCount);
                    switch (item.isPraised) {
                        case '1':
                            item.isPraised = '0';
                            tempCount--;
                            item.praiseCount = tempCount + '';

                            break;
                        case '0':
                            item.isPraised = '1';
                            tempCount++;
                            item.praiseCount = tempCount + '';
                            break;
                        default:
                            break;
                    }

                }, function (err) {

                })
            }
        },
        filters: {
            subString: function (data, paramStart, paramEnd) {
                var start = paramStart || 0;
                var end = paramEnd || 40;
                return data.substr(start, end) + '...';
            },
        }
    });


    //获取朋友圈
    function GetCardList(isRefresh) {
        if (isRefresh) { //下拉刷新
            pageNo = 1;
            var obj = {
                pageNo: pageNo,
                pageSize: pageSize,
                assnInfoId: PROPID
            };
            console.log('obj111111=====' + JSON.stringify(obj));
            window.DataUtil.fnGetClubCircleList(obj, function (res) {
                console.log('【朋友圈列表====】' + JSON.stringify(res));
                mui('#culbCircle').pullRefresh().endPulldown(); //结束下拉刷新
                pageNo++;
                if (res.SystemCode == 1 && res.page.rows.length !== 0) {
                    maxPage = Math.ceil((res.page.records) / pageSize);
                    mui('#culbCircle').pullRefresh().refresh(true); //重置上拉加载
                    if (maxPage == 1) { //无下一页数据
                        mui('#culbCircle').pullRefresh().disablePullupToRefresh(); //禁用上拉
                    } else {
                        mui('#culbCircle').pullRefresh().enablePullupToRefresh(); //启用上拉
                        mui('#culbCircle').pullRefresh().refresh(true); //重置上拉
                    }
                    var tempList = res.page.rows;
                    tempList.map(function (item) {
                        item.fileIds !== '' ? item.fileIdList = item.fileIds.split(',') : item.fileIdList = [];
                    });
                    vm.cardList = tempList;
                    console.log(vm.cardList)

                } else if (res.SystemCode == 1 && res.page.rows.length == 0) {
                    document.getElementById('mineListContentMain').innerHTML = ' ';
                    mui.toast('没有记录');
                } else {
                    mui.toast(ERROR_CONFIG[res.SystemCode]);
                    return;
                }
            }, function () {
                plus.nativeUI.closeWaiting();
                plus.nativeUI.toast("请求出错");
            });
            return;
        }

        var obj = {
            pageNo: pageNo,
            pageSize: pageSize,
            assnInfoId: PROPID
        };
        if (maxPage === 1) {
            mui('#culbCircle').pullRefresh().disablePullupToRefresh(); //禁用上拉
            return;
        }
        console.log('obj=====' + JSON.stringify(obj))
        window.DataUtil.fnGetClubCircleList(obj, function (res) {
            console.log('【朋友圈列表下一页】===' + JSON.stringify(res));
            if (res.SystemCode == '1') {
                temp = res.page.rows;
                console.log(JSON.stringify(temp));
                vm.cardList = vm.cardList.concat(temp);
                if (maxPage <= pageNo) {
                    mui('#culbCircle').pullRefresh().endPullupToRefresh(true);
                } else {
                    mui('#culbCircle').pullRefresh().endPullupToRefresh(false);
                }
            } else {
                mui.toast(ERROR_CONFIG[res.SystemCode]);
                mui('#culbCircle').pullRefresh().disablePullupToRefresh();
            }
        }, function () {
            plus.nativeUI.closeWaiting();
            plus.nativeUI.toast("请求出错");
        });
    }

    function checkRole() {
        var userInfo = JSON.parse(plus.storage.getItem('userInfo'));
        var showAdd = true;
        if (userInfo.userType === '2' || (userInfo.userType === "3" && userInfo.userTypeLast !== "1")) {
            showAdd = false;
        }
        showAdd ? document.getElementById("new_add").style.display = "block" : document.getElementById("new_add").style.display = "none"
    }


    function initPage() {
        checkRole();
        window.addEventListener('refreshlist', function () {
            GetCardList(true);
        })
    }

    function bindEventHandler() {
        //点击新增
        document.getElementById('new_add').addEventListener('tap', function () {
            document.activeElement.blur();
            window.WebviewUtil.show('teacherAddCircle', {assnInfoId: PROPID});
        })
    }


    return {
        init: function () {
            var self = plus.webview.currentWebview();
            PROPID = self.itemId;
            initPage();
            bindEventHandler();
        },
        GetCardList: GetCardList
    }
})(window, mui);
