var RYUploader = (function(g, $) {
	var PANNEL_CONFIG_TITLE = "添加图片附件";
	var PANNEL_CONFIG_CANCEL = "取消";
	var PANNEL_CONFIG_BUTTON_GALLERY = "从手机选择";
	var PANNEL_CONFIG_BUTTON_CAMERA = "拍照";
	var CANCEL_GALLERY_PICK = "取消选择图片";
	var CAMERA_BATH_URL = "_downloads/camera/";
	var PANNEL_CONFIG_TITLE_AUDIO = "添加视频附件";
	var PANNEL_CONFIG_BUTTON_GALLERY = "从手机选择";
	var PANNEL_CONFIG_BUTTON_CAMERA_AUDIO = "摄像";
	var CANCEL_GALLERY_PICK_AUDIO = "取消摄像";
	var CAMERA_BATH_URL = "_downloads/camera/";
	var PICHOST = g.IMAGE_GET_CONFIG;
	var PICHOSTOSS = g.IMAGE_GET_CONFIG_OSS;
	var PICSUFFIX = "?renditions=fill-130x130-c100";
	var PICOSSSUFFIX = "&r.type=resize&r.h=100";
	var posterPrefix = g.FILE_POSTER_GET;

	function getCompleteSrc(src) {
		var ret = src || '';
		if(src && (isNaN(src) || src.length > 10)) {
			ret = PICHOSTOSS + src + "?format='png'"
		} else {
			if(src && (!isNaN(src) && src.length <= 10)) {
				ret = PICHOST + src;
			}
		}
		return ret;
	}

	var captureImage = function(video, idx) {
		var scale = 0.8;
		var canvas = document.createElement("canvas"); // 创建一个画布

		console.log("video.Width" + video.width);
		console.log("video.Height" + video.height);

		console.log("videoWidth" + video.videoWidth);
		console.log("videoHeight" + video.videoHeight);
		canvas.width = video.videoWidth * scale;
		canvas.height = video.videoHeight * scale;
		video.width = canvas.width;
		video.height = canvas.height;
		canvas.getContext('2d').drawImage(video, 0, 0, canvas.width, canvas.height); // getContext:设置画布环境；drawImage:画画 

		var img = document.createElement("img");
		var src = canvas.toDataURL("image/png");
		img.src = src; // 获取图片的url
		video.poster = src;
	};

	function UPLOADER(cfg) {

		var data = {
			min: 0,
			max: 6,
			type: "0",
			openType: 3, //默认相机和相册两种模式
			files: [],
			extras: {},
			oriFiles: [],
			uploadFiles: [],
			tmplId: "J-photo-tmpl",
			pannelConfig: {
				title: PANNEL_CONFIG_TITLE,
				cancel: PANNEL_CONFIG_CANCEL,
				buttons: [{
						title: PANNEL_CONFIG_BUTTON_GALLERY
					},
					{
						title: PANNEL_CONFIG_BUTTON_CAMERA
					},
				]
			},
			cfg: {}
		};
		var elems = {
			addBtn: '.J-photo-add',
			delBtn: '.J-del',
			wrap: '.J-photo-wrap',
			previews: ".J-previews"
		};

		function onMax() {
			console.log("onMax" + (data.files.length >= data.max));
			document.querySelector(elems.wrap).querySelector(elems.addBtn).style.display = (data.files.length >= data.max ? "none" : "");

		}
		var isFn = function(val) {
			return typeof val == 'function';
		};
		var uploaderTool = function(path, callback) {
			window.MethodUtil.uploadImage.call(this, path, callback);
		}; //上传工具
		var pannelSheet = function(pannelConfig, callback) {
			plus.nativeUI.actionSheet(pannelConfig, callback);
		}; //打开面板工具
		var getCamera = function(callback) {
			window.MethodUtil.getCamera(callback);
		};
		var getVideo = function(callback) {
			window.MethodUtil.getVideo(callback);
		};
		var compressImageTool = function(src, dst, sCallBack, fCallBack, quality) {
			window.MethodUtil.compressImage(src, dst, sCallBack, fCallBack, quality);
		};
		var galleryPick = function(successCB, errorCB, options) {
			plus.gallery.pick(successCB, errorCB, options);
		};
		var toastTool = function(message, options) {
			plus.nativeUI.toast(message, options);
		};
		var cameraTool = (function() {

			return function(callback) {
				getCamera(function(path) {
					isFn(callback) && callback(path)
				});
			}
		})();

		var compressTool = (function() {
			var baseUrl = CAMERA_BATH_URL;
			var _getpath = function(path) {
				return path.substring(path.lastIndexOf('/'));
			};
			return function(path, afterCompress) {
				compressImageTool(path, baseUrl + _getpath(path), function(zipEvent) {
					isFn(afterCompress) && afterCompress(path, zipEvent);
				});
			}

		})();

		function getMaxTip() {
			if(data.type = "0") {
				return "最多只能选取" + data.max + "张图片";
			} else {
				return "最多只能选取" + data.max + "个视频";
			}
		};

		function fileRead(e, callback) {
			plus.io.resolveLocalFileSystemURL(e, function(entry) {
				isFn(callback) && callback(e, entry);
			});
		}

		function _openCamera(afterCamera) {
			if(data.type == "0") {
				cameraTool(function(origpath) {
					compressTool(origpath, function(path, zipEvent) {
						isFn(afterCamera) && afterCamera(zipEvent);
					});
				});
			} else {
				getVideo(function(e) {
					fileRead(e, function(path, entry) {
						isFn(afterCamera) && afterCamera(path, entry);
						//                  g.methodUtil.uploadImages(e);
					});
				});
			}
		}

		function _openGallery(afterSelected) {
			var filterStr = (data.type == "0" ? "image" : "video");
			var left = data.max - data.files.length;
			var muitipleCfg = (data.type == "0" ? (data.max > 1 ? true : false) : false);
			if(data.files.length < data.max) {
				galleryPick(function(e) {
						isFn(afterSelected) && afterSelected(e);
					},
					function() {
						var msg = (data.type == "0" ? CANCEL_GALLERY_PICK : CANCEL_GALLERY_PICK_AUDIO);
						toastTool(msg);
					}, {
						filter: filterStr,
						multiple: muitipleCfg,
						maximum: left,
						system: false,
						onmaxed: function() {
							toastTool(getMaxTip());
							return;
						}
					});
			} else {
				toastTool(getMaxTip());
				return;
			}
		}

		function getMSrc(src) {
			var ret = src || '';
			if(src) {
				if(src.match(PICHOSTOSS)) {
					ret = src + PICOSSSUFFIX;
				} else {
					ret = src + PICSUFFIX;
				}
			}
			return ret;
		}

		function renderItem(renderObj) {
			var tmpl = data.tmplId;
			var arr = [];
			if(typeof renderObj == 'object') {
				if(renderObj instanceof Array) {
					arr = renderObj;
				} else {
					arr.push(renderObj);
				}
			}
			console.log("renderItem" + JSON.stringify(arr));
			var newHtml = "";
			newHtml += template(tmpl, {
				listData: arr
			});
			document.querySelector(elems.wrap).querySelector(elems.previews).innerHTML += newHtml;
			if(data.type == "1") {
				bindVideoEvent();
			}

		}

		function bindVideoEvent() {
			var videos = document.querySelectorAll("video");
			if(videos) {
				videos.forEach(function(item, idx) {
					item.load();
					item.addEventListener("loadeddata", function() {
						captureImage(item, idx);
					});
					item.addEventListener("error", window.MethodUtil.videoError);
				});
			}
		}

		function render(zipEvent) {
			data.oriFiles.push(zipEvent.target);
			data.files.push(zipEvent.target);
			var renderObj = {
				postSrc: zipEvent.target,
				src: zipEvent.target,
				mSrc: getMSrc(zipEvent.target)
			};

			if(isFn(data.cfg.renderItem)) {
				data.cfg.renderItem(renderObj);
			} else {
				renderItem(renderObj);
			}
			onMax();

		}

		function renderVideo(path) {
			data.oriFiles.push(path);
			data.files.push(path);
//			if(isFn(data.cfg.renderItem)) {
//				data.cfg.renderItem({
//					src: path
//				});
//
//			} else {
//				renderItem({
//					src: path
//				});
//			}
			var currentNode = document.getElementById("videoBg");
			var newNode = document.createElement("div");
			    newNode.className = 'add_video';
				newNode.innerHTML = '<video class="J-video-play" controls="controls" width="345" height="150" preload="load" webkit-playsinline="true" playsinline x5-video-player-type="h5" x-webkit-airplay="true" x5-video-player-fullscreen="true" poster="../../assets/images/circle/video-poster.png" class="J-video-play" src="' +
					path +
					'" /></video><img class="icon_remove J-del" src="../../assets/images/annoucement/cancel.png" />';
//				document.getElementById('videoBox').insertBefore(newNode,currentNode);
			document.getElementById('videoBox').appendChild(newNode);
			
			if(data.type == "1") {
				bindVideoEvent();
			}
			onMax();

		}

		function openCamera() {
			if(data.type == "0") {
				_openCamera(function(zipEvent) {
					render(zipEvent);
				});
			} else {
				_openCamera(function(e, entry) {
					renderVideo(entry.toLocalURL())
				});
			}
		};

		function batchSetFile(e) {
			var path;
			console.log("batchSetFile" + JSON.stringify(e));
			if(data.type == "0") {
				for(var i in e.files) {
					path = e.files[i];
					console.log("batchSetFile" + path);
					compressTool(path, function(src, zipEvent) {
						render(zipEvent);
					});
				}
			} else {
				renderVideo(e);
			}
		}

		function openGallery() {
			_openGallery(function(e) {
				batchSetFile(e);
			});
		}

		function openPanel() {
			pannelSheet(data.pannelConfig, function(e) {
				switch(e.index) {
					case 1:
						openGallery(); //相册选择
						break;
					case 2:
						openCamera(); //拍照
						break;
				}
			});

		}

		function open() {
			switch(data.openType) {
				case '1':
					openGallery(); //相册选择
					break;
				case '2':
					openCamera(); //拍照
					break;
				case '3':
					openPanel(); //相册和拍照
					break;
				default:
					openPanel();
			}
		}

		function _stopEvent(e) {
			//阻止默认事件，阻止冒泡
			e.preventDefault();
			e.stopPropagation();
		}

		function _del(target) {
			target.parentNode.remove();
		}

		function _delItem(idx, tar) {
			data.files.splice(idx, 1);
			data.oriFiles.splice(idx, 1);
			console.log("_delItem" + JSON.stringify(data.oriFiles));
			_del(tar);
			onMax();

		}

		function bindEvent() {
			$(document).on("tap", elems.wrap + " " + elems.addBtn, function(e) {
				_stopEvent(e);
				document.activeElement.blur();
				open();

			});
			$(document).on("tap", elems.wrap + " " + elems.delBtn, function(e) {
				_stopEvent(e);
				var idx = this.dataset.id;
				_delItem(idx, e.target);
			});
			window.addEventListener("upload", function() {
				upload(function() {
					isFn(data.cfg.uploaded) && data.cfg.uploaded();
				});

			});
		}

		function _init() {
			if(cfg) {
				elems = $.extend({}, elems, cfg.elems);
				data.pannelConfig = $.extend({}, data.pannelConfig, cfg.data.pannelConfig);
				data.cfg = $.extend({}, data.cfg, cfg.data.cfg);
				data = $.extend({}, data, cfg.data);
			}
			bindEvent();
		}

		function init(cfg) {
			//					g.methodUtil = g.MethodUtil;
			//					uploaderTool = g.methodUtil.uploadImages; //上传工具
			//					pannelSheet = plus.nativeUI.actionSheet; //打开面板工具
			//					getCamera = g.methodUtil.getCamera;
			//					compressImageTool = g.methodUtil.compressImage;
			//					galleryPick = plus.gallery.pick;
			//					toastTool = plus.nativeUI.toast;
			//					if(cfg) {
			//						data = $.extend({}, data, cfg);
			//					}

		}

		function singleUpload(arr, fn) {
			console.log("uploadArr" + JSON.stringify(arr));
			uploadFn = uploaderTool;
			console.log("data.type" + data.type);
			if(data.type == "1") {
				uploadFn = window.MethodUtil.uploadImages;
			}
			console.log("uploadFn" + JSON.stringify(arr));
			var i = 0;
			var temp = [];

			return function() {
				console.log("i:" + i + "arr.length" + arr.length);
				var me = arguments.callee;
				if(i < arr.length) {
					console.log('酷酷酷酷酷0000');
					if(arr[i].match('camera') || arr[i].match('file://')) {
						console.log('进入了1');
						uploadFn(arr[i],function(res) {
							console.log('酷酷酷酷酷11111');
							//temp.push(res.data[0]);
							if(res.pk) {
								temp.push(res.pk);
							} else {
								if(res && res.data && res.data.length) {
									temp.push(res.data[0]);
								}
							}
							i++;
							me();
						}, 2);
					} else {
						console.log('进入了1')
						temp.push(arr[i]);
						i++;
						me();
					}
				} else {
					isFn(fn) && fn(temp);
				}

			}
		};

		function upload(afterUpload) {
			singleUpload(data.oriFiles, function(files) {
				console.log("视频上传----" + JSON.stringify(files));
				isFn(afterUpload) && afterUpload(files, data);
			})();
		}

		function getUploadFile() {
			return data.uploadFiles;
		}

		function getOriginalFile() {
			return data.oriFiles;
		}

		function setItem(arr) {
			if(arr && arr.length) {

				var dataObj = [];
				if(data.type == "0") {
					data.oriFiles = arr;
					data.files = data.oriFiles.slice();
					dataObj = arr.map(function(item) {
						var src = getCompleteSrc(item);
						return {
							postSrc: item,
							src: src,
							mSrc: getMSrc(src)
						}
					});
					if(isFn(data.cfg.renderItem)) {
						data.cfg.renderItem(dataObj);
					} else {
						renderItem(dataObj);
					}
					onMax();
				} else {
					data.oriFiles = arr.map(function(item) {
						return item.postSrc;
					});
					data.files = data.oriFiles.slice();
					dataObj = arr;
					if(isFn(data.cfg.renderItem)) {
						data.cfg.renderItem(dataObj);
					} else {
						renderItem(dataObj);
					}
					onMax();
				}

			}
		}
		_init();
		return {
			init: init,
			getUploadFile: getUploadFile,
			getOriginalFile: getOriginalFile,
			upload: upload,
			setItem: setItem
		}
	}

	function AUDIOUPLOADER(cfg) {
		var uploader = new UPLOADER({

			data: {
				type: "1",
				tmplId: "J-video-tmpl",
				max: 1,
				pannelConfig: {
					title: PANNEL_CONFIG_TITLE_AUDIO,
					cancel: PANNEL_CONFIG_CANCEL,
					buttons: [{
							title: PANNEL_CONFIG_BUTTON_GALLERY
						},
						{
							title: PANNEL_CONFIG_BUTTON_CAMERA_AUDIO
						},
					]
				},

			},
			elems: {
				addBtn: '.J-audio-add',
				delBtn: '.J-del',
				wrap: '.J-audio-list'

			}
		});
		return uploader;
		
	}
	return {
		AUDIOUPLOADER: AUDIOUPLOADER,
		UPLOADER: UPLOADER
	};
	
})(window, mui);