/*
 * 说明：投票
 * 创建人：qk
 */

var vote = (function(c, $) {
	var picHost = IMAGE_GET_CONFIG;

	var vm = new Vue({
		el: '#detailCnt',
		data: {
			picHost: IMAGE_GET_CONFIG,
			voteData: {},
			voteList: [],
			isVoted: false,
			status: false,
			edit: false
		},
		filters: {
			substr: function(val) {
				return val.substr(0, 10);
			},
			prefix: function(val) {
				return val.substr(10, 16);
			}
		},
		watch: {
			'inspection': {
				handler: function(newValue, oldValue) {},
				deep: true,
			}
		},
	});

	// 页面模块
	var page = function() {
		//id
		var pageId = "";
		//创建时间
		var time = "";
		//护导标题 舍去
		/*var title = "";*/
		//提交还是保存状态
		var status = false;
		//接口 数据type需要
		var source = "1";

		//用户信息
		var userInfo;
		//判断是否是今天
		var isToday = function() {
			return(getCurrentDay() == vm.time);
		};
		//从公告点进详情需要传入此值
		var noticeId = "";

		//校验
		var checkForm = function(data) {
			var msg = "";
			var type = vm.voteData.isChoice;
			var selectedNum =0;
			if(data.detailId!=""){
			selectedNum = data.detailId.split(",").length;
			}
			
			console.log("type:"+type);
			if(type == 0) {
				
				if(selectedNum == 0) {
					msg = "请选择一个选项";
				} else if(selectedNum > 1) {
					msg = "只能选择一个选项";
				}
			} else {
				var min = vm.voteData.choiceNum || 1;
				if(selectedNum < min) {
					msg = "请至少选择" + min + "个选项";
				
				}
			}
			mui.toast(msg);
			return msg;
		};

		function getDetailId() {
			var ret = [];
			var data = vm.voteList;
			for(var i = 0; i < data.length; i++) {
				if(data[i].checked == "1") {
					ret.push(data[i].id);
				}
			}
			return ret;
		}

		function getPostDatas() {
			var ret = {};
			ret.voteId = pageId;
			ret.detailId = getDetailId().join(",");
			return ret;
		}
		var formSubmit = function(type) {

			var params = getPostDatas();

			console.log("表单数据" + JSON.stringify(params));
			var msg = checkForm(params);
			if(msg) {
				plus.nativeUI.closeWaiting();
				return;
			} else {
				$.confirm("确认投票？", '提示', ['确认', '取消'], function(e) {
					if(e.index == 0) {
						c.DataUtil.voteSubmit(params, function(res) {
							console.log("投票" + JSON.stringify(res));
							if(res.SystemCode == 1) {
								mui.toast("投票成功");
								vm.isVoted = true;
								vm.edit = false;
								getDetail();
								$.fire(plus.webview.currentWebview().opener(), 'refresh', {
									
								});
							} else if(res.SystemCode == 10019) {
								mui.toast("不可重复投票");
							} else {
								mui.toast("投票失败");
							}
						}, function() {
							getDetail();
							plus.nativeUI.closeWaiting();
							mui.toast("服务器异常");
						});

					}

				});
			}
		};

		var _submit = function(type) {

			//var formData = getFormData();
			//console.log("表单数据"+JSON.stringify(formData)));
			status = type;
			formSubmit(type);
		};
		var bindEvent = function() {
			mui(document).on("tap", "#submit", function(e) {
				_submit("0");
			});
			mui(document).on("tap", ".list-checkbox", function(e) {
				console.log("投票页面====切换");
				if(vm.edit) {
					var index = this.dataset.index;
					vm.voteList[index].checked = vm.voteList[index].checked == "1" ? "0" : "1";
				}
			});

		};

		function getDetail() {
			var params = {
				id: pageId
			};
			console.log("voteDetail" + JSON.stringify(params));
			c.DataUtil.voteDetail(params, function(res) {
				plus.nativeUI.closeWaiting();

				//res =JSON.parse(res);
				console.log('===投票详情===' + JSON.stringify(res));

				if(res.SystemCode == 1) {
					vm.voteData = res.data || {};
					vm.voteData = dealData(vm.voteData);
					vm.voteList = res.data.voteList || [];
				} else {

					$.toast("服务器异常");
					vm.voteData = {};
					vm.voteList = [];

				}
			}, function(xhr) {
				plus.nativeUI.closeWaiting();
				$.toast('加载失败，请稍后重试')
				console.log('error=' + xhr.status)
			})
		}
		
		//换行数据
		function dealData(data) {
			//报修说明换行
			if(data.voteDesc&&data.voteDesc.indexOf("\n") != -1) {
				data.voteDesc = c.MethodUtil.replaceLB(data.voteDesc);
			}
			return data;
		}
		
		function getCurrentDay() {
			var newDate = new Date();
			var month = newDate.getMonth() + 1;
			var day = newDate.getDate();
			if(month < 10) {
				month = '0' + month;
			} else {
				month = month;
			}
			if(day < 10) {
				day = '0' + day;
			} else {
				day = day;
			}
			return newDate.getFullYear() + '-' + month + '-' + day;
		}

		function _init() {
			var id = plus.webview.currentWebview().pageId || plus.webview.currentWebview().push_detail_id;
			vm.isVoted = (plus.webview.currentWebview().isVoted == "1" ? true : false);
			vm.status = (plus.webview.currentWebview().status == "1" ? true : false);
			vm.edit = (vm.status && !vm.isVoted) ? true : false;
			if(id) {
				pageId = id;
			}

		}
		var init = function() {
			_init();
			bindEvent();
			getDetail();

		}

		return {
			init: init
		}

	};

	return page();

})(window, mui);
