/*
 *投票列表
 * qk
 * 
 * */

var voteList = (function(c, $) {
	var canNext = false;
	var isSubmit;
	var pageNo = 1;
	var pageSize = 10;
	var total = 0;
	var isVoted = '';//调接口给后台
	var vmAnList = new Vue({
		el: '#refreshContainer',
		data: {
			listData: [],
			picHost: IMAGE_GET_CONFIG
		},
		methods: {
			handleClick: function(id,isVoted,status) {
				window.WebviewUtil.show('voteDetail', {
					pageId: id,
					isVoted:isVoted,
					status:status
				});
			},
		},
		filters: {
			moment: function(val) {
				return val.substr(0, 10);
			},
			substr: function(val) {
				return val.substr(0, 10)
			},
			formatTitle:function(val){
				val =val||'';
				if(val.length>15){
					val=val.substr(0,15)+"...";
				}
				return val;
			},
			formatCnt:function(val){
				val =val||'';
				if(val.length>40){
					val=val.substr(0,40)+"...";
				}
				return val;
			}
		}
	});

	function getParams() {
		return {
			pageNo: pageNo,
			pageSize: pageSize,
			isVoted:isVoted
		}
	}

	function setParams(val) {
		pageNo = val;
	}

	function hasNext() {
		return pageNo<total;
	}

	function initList(isDown,noDataHidden) {
		var refreshEl = mui('#refreshContainer').pullRefresh();
		var maxNum;
		if(isDown) {
            setParams(1);
            console.log('===getParams===' + JSON.stringify(getParams()));
			c.DataUtil.voteList(getParams(), function(data) {
				console.log('===投票列表===' + JSON.stringify(data));
				data = data || {};
				total = data.total || 0;
				data.rows = data.rows || [];
				
				refreshEl.endPulldown();
				if(data.rows.length) {
					vmAnList.listData = data.rows;
					refreshEl.refresh(true); //重置上拉加载

					canNext = hasNext();
					if(!canNext) { //无下一页数据
						console.log("禁用上拉1");
						refreshEl.disablePullupToRefresh(); //禁用上拉
						
					} else {
						console.log("禁用上拉2");
						refreshEl.enablePullupToRefresh(); //启用上拉
						refreshEl.refresh(true); //重置上拉
						setParams(pageNo + 1);
					}
				} else {
					console.log("禁用上拉3");
					if(!noDataHidden){
					mui.toast("没有记录");
					}
					vmAnList.listData = [];
					refreshEl.disablePullupToRefresh();
					canNext = false;
					$.toast(ERROR_CONFIG[data.SystemCode]);
					return;
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});
		} else {
			if(!canNext) {
				refreshEl.disablePullupToRefresh(); //禁用上拉
				return;
			}

			c.DataUtil.voteList(getParams(), function(data) {
				console.log('==投票下一页==' + JSON.stringify(data));
				data = data || {};
				total = data.total || 0;
				data.rows = data.rows || [];
				if(data.rows.length) {
					vmAnList.listData = vmAnList.listData.concat(data.rows);
					canNext = hasNext();
					if(!canNext) {
						refreshEl.endPullupToRefresh(true);
					} else {
						refreshEl.endPullupToRefresh(false);
						setParams(pageNo + 1);
					}
				} else {
					//$.toast(ERROR_CONFIG[data.SystemCode]);
					refreshEl.disablePullupToRefresh();
				}
			}, function() {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.toast("请求出错");
			});

		}
	}

	function bindEvent() {
		window.addEventListener('refresh', function() {
			initList(true,true);
		});
		
		//tab点击
		$("#topTabList").on('tap', '.tab-item', function() {
			var self = this;
			var tabList = self.parentNode.children;
			var tabItemTag = self.dataset.target;
			for(var i = 0; i < tabList.length; i++) {
				tabList[i].classList.remove('active');
			}
			self.classList.add('active');
			if(tabItemTag == '0') { //未投票
				isVoted = '';
				initList(true);
				mui('#refreshContainer').pullRefresh().scrollTo(0, 0, 1) //让滑动区域回到顶部
			} else { //
				isVoted = '1';
				initList(true);
				mui('#refreshContainer').pullRefresh().scrollTo(0, 0, 1); //让滑动区域回到顶部
			}
		});
	}

	function init() {
		bindEvent();
	}
	return {
		init: init,
		initList: initList
	}
}(window, mui));