/*
 * Ajax获取数据方法封装
 */

window.DataUtil = {
	//登陆
	login: function(paramObj, sCallBack, fCallBack) {
		paramObj.companyId=window.GlOBAL_CONFIG.companyId;
		console.log("login"+window.API_CONFIG.login);
		mui.ajax({
			url: window.API_CONFIG.login,
			type: "POST",
			dataType: "json",
			timeout: window.GlOBAL_CONFIG.timeOut,
			data: paramObj,
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, fCallBack);
			},
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				sCallBack && sCallBack(data);
			}
		})
	},
	//获取角色列表
	getRoleList: function( sCallBack, fCallBack) {
		console.log("getRoleList"+window.API_CONFIG.getRoleList);
		mui.ajax({
			url: window.API_CONFIG.getRoleList,
			type: "POST",
			dataType: "json",
			timeout: window.GlOBAL_CONFIG.timeOut,
//			data: paramObj,
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, fCallBack);
			},
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				sCallBack && sCallBack(data);
			}
		})
	},
	//切换角色列表
	changeRoleType: function(paramObj, sCallBack, fCallBack) {
		console.log("getRoleList"+window.API_CONFIG.changeRoleType);
		mui.ajax({
			url: window.API_CONFIG.changeRoleType,
			type: "POST",
			dataType: "json",
			timeout: window.GlOBAL_CONFIG.timeOut,
			data: paramObj,
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, fCallBack);
			},
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				sCallBack && sCallBack(data);
			}
		})
	},
	//获取菜单
	getMenu:function(sCallBack, fCallBack,preventTip) {
		console.log("getMenu"+window.API_CONFIG.login);
		mui.ajax({
			url: window.API_CONFIG.getMenu,
			type: "GET",
			dataType: "json",
			timeout: window.GlOBAL_CONFIG.timeOut,
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, fCallBack,preventTip);
			},
			success: function(data) {
				sCallBack && sCallBack(data);
			}
		})
	},

	//修改密码
	modifyPassword: function(paramObj, sCallBack, fCallBack) {
		mui.ajax({
			url: window.API_CONFIG.modifyPassword,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			type: "POST",
			dataType: "json",
			timeout: window.GlOBAL_CONFIG.timeOut,
			data: paramObj,
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, fCallBack);
			},
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				sCallBack && sCallBack(data);
			}
		})
	},

	//获取公告列表
	getAnnoucementList: function(params, sCallBack, fCallBack) {
		mui.ajax(window.API_CONFIG.getAnnoucementList, {
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				sCallBack && sCallBack(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, fCallBack);
			}
		});
	},
	// 获取公告详情
	getAnnoucementDetail: function(obj, successCB, errorCB) {
		mui.ajax(window.API_CONFIG.getAnnoucementDetail, {
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			data: obj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//关闭手势密码
	//	resetGesture: function (token, sCallBack, fCallBack) {
	//		mui.ajax({
	//			url: window.API_CONFIG.resetGesture,
	//			headers: {
	//				token: token
	//			},
	//			type: "POST",
	//			dataType: "json",
	//			timeout: window.GlOBAL_CONFIG.timeOut,
	//			error: function(xhr, type, error) {
	//				MethodUtil.checkToken(xhr,type,error,fCallBack);
	//			},
	//			success: function(data) {
	//					plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
	//				sCallBack && sCallBack(data);
	//			}
	//		})
	//	},
	// 新增报修
	saveRepair: function(obj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.saveRepair,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			data: obj,
			dataType: 'json',
			type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//	//报修详情
	//	getRepair: function (token,obj, successCB, errorCB) {
	//		mui.ajax({
	//			url: window.API_CONFIG.getRepair,
	//			headers: {
	//				token: token
	//			},
	//			data: obj,
	//			dataType: 'json',
	//			type: 'GET',
	//			timeout: window.GlOBAL_CONFIG.timeOut,
	//			success: function(data) {
	//				successCB && successCB(data);
	//			},
	//			error: function(xhr, type, error) {
	//				MethodUtil.checkToken(xhr, type, error, errorCB);
	//			}
	//		});
	//	},
	//报修类型
	getRepairType: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.repairType,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//报修列表
	getRepairList: function(obj, successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.getRepairList,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			data: obj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//待办审批
	getToDoHandle: function(act, obj, successCB, errorCB) {
		// console.log(JSON.stringify(obj));
		var api = "";
		if(act == "repair") {
			api = window.API_CONFIG.toDoHandle;
		} else if(act == "attendance") {
			api = window.API_CONFIG.attendanceExpectionHandle;
		}
		mui.ajax({
			url: api,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			data: obj,
			dataType: 'json',
			type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//待办列表
	getToDoListData: function(obj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.toDoListData,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
 			data: obj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//待办详情
	getToDoDetailData: function(obj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.toDoDetailData,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			data: obj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//待办指派人
	getToDoAssignData: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.toDoAssignData,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//提交用户的菜单信息
	modifyMenuInfo: function(menuInfo, successCB, errorCB) {
		mui.ajax(window.API_CONFIG.modifyMenuInfo, {
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			data: {
				menuInfo: menuInfo
			},
			dataType: 'json',
			type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//旧token换新token
	tokenExchange: function(successCB, errorCB) {
		mui.ajax(window.API_CONFIG.tokenExchange, {
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'POST',
			timeout: 3000,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//天气获取
	getWeather: function(cityName, successCB, errorCB) {
		console.log("getWeather:"+cityName[cityName.length-1]);
		if(cityName&&cityName[cityName.length-1]=="市"){
			cityName = cityName.substr(0,cityName.length-1);
		}
		console.log("getWeatherAfter:"+cityName);
		mui.ajax(window.API_CONFIG.getWeather, {
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			data: {
				cityName: cityName,
				theUserID:''
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	// 提交会议考勤数据二维码
	postMeetingSignInData: function(params, successCB, errorCB) {
		mui.ajax(window.API_CONFIG.postMeetingSignInData, {
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			data: params,
			dataType: 'json',
			type: 'post',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//功能室预约列表
	orderFunctionList: function(successCB, errorCB) {
		mui.ajax(window.API_CONFIG.orderFunctionList, {
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//我的功能室预约列表
	mineFunctionList: function(params, successCB, errorCB) {
		mui.ajax(window.API_CONFIG.mineFunctionList, {
			data:params,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//新增保存功能室预约
	saveRoom: function(obj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.saveRoom,
			data: obj,
			dataType: 'json',
			type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//上下班打卡
	systemClock: function(paramObj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.systemClock,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			data: paramObj,
			dataType: 'json',
			type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//打卡记录
	clockList: function(nextUrl, successCB, errorCB) {
		mui.ajax(nextUrl, {
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//功能室详情
	getRoom: function(appDate, roomId, successCB, errorCB) {
		mui.ajax(window.API_CONFIG.getRoom, {
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			data: {
				appDate: appDate,
				roomId: roomId
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//删除预约的功能室
	deleteRoom: function(id, successCB, errorCB) {
		mui.ajax(window.API_CONFIG.deleteRoom, {
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			data: {
				id: id
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//通讯录
	getListTeacher: function(paramObj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.listTeacher,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			data: paramObj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//设置内修改密码
	updatePassword: function(paramObj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.updatePassword,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			dataType: 'json',
			type: 'GET',
			data: paramObj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//公告类型
	getAnnoucementListType: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getAnnoucementListType,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//公告机构
	getAnnoucementListGroup: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getAnnoucementListGroup,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//新增公告
	saveAnnoucement: function(paramObj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.saveAnnoucement,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			data: paramObj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//计划管理列表个人
	getPlanListMine: function(obj, successCB, errorCB) {
		mui.ajax(window.API_CONFIG.planListMine, {
			data: obj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//计划管理列表编辑详情 已改qk
	getPlanListDetail: function(url, params,successCB, errorCB) {
		mui.ajax({
			url: url||window.API_CONFIG.planListDetail,
			data: params,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//计划管理列表编辑部门数据
	getDepartmentList: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getDepartmentList,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//计划管理列表编辑保存
	postSavePlanDetail: function(obj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.savePlanDetail,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			data: obj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//计划管理列表提交
	postSubmitPlanDetail: function(id, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.submitPlanDetail,
			data: {
				id: id
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//角标
	getSubscriptNum: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getSubscriptNum,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//考勤异常列表
	getAttendanceExceptionListData: function(nextUrl, successCB, errorCB) {
		nextUrl = nextUrl || window.API_CONFIG.attendanceExpectionList
		mui.ajax({
			url: nextUrl,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//新增考勤异常
	saveAttendanceExpection: function(paramObj, successCB, errorCB) {
		console.log("saveAttendanceExpectionparamObj"+JSON.stringify(paramObj));
		mui.ajax({
			url: window.API_CONFIG.saveAttendanceExpection,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'POST',
			data: paramObj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		})

	},
	//考勤异常打卡类型
	getAttendanceExceptionType: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.attendanceExpectionType,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//选人
	recursiveFindTeacher: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.recursiveFindTeacher,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//公告列表删除
	AnnoucementListDelete: function(id, successCB, errorCB) {
		mui.ajax(window.API_CONFIG.AnnoucementListDelete, {
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			data: {
				id: id
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//查询老师
	findTreeTeacher: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.findTreeTeacher,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//打卡当天数据
	getByUserAndDay: function(successCB, errorCB) {
		mui.ajax(window.API_CONFIG.getByUserAndDay, {
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//个人打卡统计饼图
	getMyClockData: function(obj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.myClockData,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			data: obj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//个人打卡统计饼图列表
	getMyClockDataList: function(obj, successCB, errorCB) {
		mui.ajax( {
			url:window.API_CONFIG.myClockDataList,
			data: obj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//领导打卡统计饼图
	getLeaderClockData: function(obj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.leaderClockData,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			data: obj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//领导打卡统计饼图列表
	getLeaderClockDataList: function(obj, successCB, errorCB) {
		mui.ajax(window.API_CONFIG.leaderClockDataList, {
			data: obj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//短信验证码
	sendCheckMsg: function(phone,companyId, successCB, errorCB) {
		mui.ajax(window.API_CONFIG.sendCheckMsg, {
			dataType: 'json',
			data: {
				phone: phone,
				companyId:companyId
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//忘记密码
	forgetPassword: function(paramObj, successCB, errorCB) {
		mui.ajax(window.API_CONFIG.forgetPassword, {
			dataType: 'json',
			data: paramObj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//会议考勤统计饼图数据
	meetingStatistical: function(paramObj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.meetingStatistical,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			data: paramObj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//会议考勤统计人员
	findPeopleList: function(url,paramObj, successCB, errorCB) {
		mui.ajax({
			url: url,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			data: paramObj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//扫码二维码登陆
	saveQuickLoginRecord: function(code, successCB, errorCB) {
		console.log(window.API_CONFIG.saveQuickLoginRecord);
		mui.ajax({
			url: window.API_CONFIG.saveQuickLoginRecord,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			dataType: 'json',
			data: {
				codeId: code
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//功能室预约统计
	getRoomUsedList: function(obj, successCB, errorCB) {
		var url = window.API_CONFIG.roomUsedList;
		mui.ajax(url, {
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			data: obj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//功能室预约统计会议名
	getRoomListName: function(obj, successCB, errorCB) {
		var url = window.API_CONFIG.getRoomListName;
		mui.ajax(url, {
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			data: obj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//获取互导详情
	getProtectionDetail: function(paramObj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getProtectionDetail,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			data: paramObj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//互导提交、保存
	uploadScrutiny: function(paramObj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.uploadScrutiny,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			data: paramObj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//获取护导详情 
	getScrutiny: function(params,successCB, errorCB) {
		console.log("getScrutiny"+(params.url||window.API_CONFIG.findProtectContent));
		mui.ajax({
			url: params.url||window.API_CONFIG.findProtectContent,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//保存
	saveProtectContent: function(obj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.saveProtectContent,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			data:  {
            "content":JSON.stringify(obj)
			},
            type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//由面板进入的当天护岛
	getProtectionDay: function(userId, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getProtectionDay,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			data: {
				userId: userId
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
//护导列表
	protectList: function(nextUrl, params,successCB, errorCB) {
	
		nextUrl = nextUrl || window.API_CONFIG.protectList;
		mui.ajax({
			url: nextUrl,
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	getProtectionAll: function(dqtime, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getProtectionAll,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			data: {
				dqtime: dqtime,
				noticeFlag:'1',
				userId: window.MethodUtil.getUserInfo().userId
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	// 根据id获取某个异常处理详情
	getAttendanceException: function(params, successCB, errorCB) {
		console.log("getAttendanceException"+window.API_CONFIG.getAttendanceException+JSON.stringify(params));
		mui.ajax({
			url: window.API_CONFIG.getAttendanceException,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	getAllRoom: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getAllRoom,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	annoucementSelect:function(successCB,errorCB) {
		mui.ajax({
			url: window.API_CONFIG.annoucementSelect,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	// 护导二维码签到
	scanQRCode: function(params, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.scanQRCode,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			dataType: 'json',
			data: {
				placeId: params
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//护导签到查询
	findScanInfo:function(url,params,successCB, errorCB) {
		mui.ajax({
			url: url||window.API_CONFIG.findScanInfo,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//列表提交护导
	submitProtection:function(params,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.submitProtection,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	findScanTime:function(url,params,successCB, errorCB) {
		console.log("window.API_CONFIG.findScanTime"+(window.API_CONFIG.findScanTime));
		mui.ajax({
			url: url||window.API_CONFIG.findScanTime,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			data:{
			  date:params.date,
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//获取请假类型
	getLeaveType:function(successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.getLeaveType,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//获取代价条和使用代价条数
	getLeaveNum:function(successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.getLeaveNum,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//获取请假时长计算
	getTeacherLeaveDays:function(params,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getTeacherLeaveDays,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//获取请假流程节点
	getLeaveProcedure:function(leaveDays,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getLeaveProcedure,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			dataType: 'json',
			data:{
				leaveDays:leaveDays
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//获取节点审批人
	getHandlePerson:function(nodeName,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getHandlePerson,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			dataType: 'json',
			data:{
				nodeName:nodeName
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	holidayList:function(params,successCB, errorCB){
		console.log("window.API_CONFIG.holidayList"+window.API_CONFIG.holidayList+JSON.stringify(params));
		mui.ajax({
			url: window.API_CONFIG.holidayList,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				console.log("holidayList"+JSON.stringify(data));
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				console.log("holidayListError");
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	holidayAdd:function(params,successCB, errorCB){
		mui.ajax({
			url: window.API_CONFIG.holidayAdd,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	holidayMouthList:function(params,successCB, errorCB){
		mui.ajax({
			url: window.API_CONFIG.holidayMouthList,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	holidayDelete:function(params,successCB, errorCB){
		mui.ajax({
			url: window.API_CONFIG.holidayDelete,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	holidayDetail:function(params,successCB, errorCB){
		mui.ajax({
			url: window.API_CONFIG.holidayDetail,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//物品领用扫码二维码
	scavengingUse: function(id, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.scavengingUse,
			dataType: 'json',
			data: {
				goodsTypeId: id
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//物品归还按钮
	mobileUpdate: function(id, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.mobileUpdate,
			dataType: 'json',
			data: {
				id: id
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//物品待办
	goodsUseHandle: function(obj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.goodsUseHandle,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//物品待办详情
	mobileGetGoodsUse: function(id, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.mobileGetGoodsUse,
			dataType: 'json',
			data: {
				id: id
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	// 物品领用列表
	goodsUseByUserId: function(obj, successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.goodsUseByUserId,
			data: obj,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				plus.storage.setItem('tokenNewestTime', Date.parse(new Date()));
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//新增请假
	submitLeave:function(params,successCB, errorCB){
		console.log("新增请假"+window.API_CONFIG.submitLeave);
		mui.ajax({
			url: window.API_CONFIG.submitLeave,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//请假列表
	teacherLeaveList:function(params,successCB, errorCB) {
		console.log("teacherLeaveListparams"+JSON.stringify(params));
		
		mui.ajax({
			url:window.API_CONFIG.teacherLeaveList,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//请假详情
	getInfoById:function(itemId,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.getInfoById,
//			headers: {
//				token: window.MethodUtil.getUserInfo().token
//			},
			dataType: 'json',
			data:{
				id:itemId
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//请假详情
	handleToLeave:function(itemId,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.handleToLeave,
			dataType: 'json',
			data:itemId,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//修改cid
	modifyUserRegistrationId:function(itemId,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.modifyUserRegistrationId,
			dataType: 'json',
			data:{
				registrationId:itemId
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//根据id获取打卡详情
	getClockDetail:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.getClockDetail,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//查看报修详情
	findRepairDetail:function(params,taskCode,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.findRepairDetail,
			dataType: 'json',
			data:{
				repairId:params,
				taskCode:taskCode
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//处理报修
	handleToRepair:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.handleToRepair,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//打卡异常处理
	handleAttendanceException:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.handleAttendanceException,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//获取所有活动类型
	findAllAssnType:function(params,successCB, errorCB) {
		console.log("window.API_CONFIG.findAllAssnType"+window.API_CONFIG.findAllAssnType);
		mui.ajax({
			url:window.API_CONFIG.findAllAssnType,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//社团列表
	findPageList:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.findPageList,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
    getAchievementList:function(params,successCB, errorCB) {
        mui.ajax({
            url:window.API_CONFIG.getAchievementList,
            dataType: 'json',
            data:params,
            type: 'GET',
            timeout: window.GlOBAL_CONFIG.timeOut,
            success: function(data) {
                window.MethodUtil.refreshTokenTimer();
                successCB && successCB(data);
            },
            error: function(xhr, type, error) {
                MethodUtil.checkToken(xhr, type, error, errorCB);
            }
        });
    },
    getGradeList:function(params,successCB, errorCB) {
        mui.ajax({
            url:window.API_CONFIG.getGradeList,
            dataType: 'json',
            data:params,
            type: 'GET',
            timeout: window.GlOBAL_CONFIG.timeOut,
            success: function(data) {
                window.MethodUtil.refreshTokenTimer();
                successCB && successCB(data);
            },
            error: function(xhr, type, error) {
                MethodUtil.checkToken(xhr, type, error, errorCB);
            }
        });
    },
	//新闻列表
	newListData:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.newListData,
			dataType: 'json',
			type: 'GET',
			data:params,
            timeout: window.GlOBAL_CONFIG.timeOut,
            success: function(data) {
                window.MethodUtil.refreshTokenTimer();
                successCB && successCB(data);
            },
            error: function(xhr, type, error) {
                MethodUtil.checkToken(xhr, type, error, errorCB);
            }
		});
   },
	//点赞状态
	dbclicklove:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.dbclicklove,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//投票提交
	voteSubmit:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.voteSubmit,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//新闻详情
	newDetail:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.newDetail,
			dataType: 'json',
			type: 'GET',
			data:{
				url:params
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	voteList:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.voteList,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				//window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	voteDetail:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.voteDetail,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//社团活动详情
	organizeDetail:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.organizeDetail,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//社团活动报名
	organizeCommit:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.organizeCommit,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},


	//保存推送
	saveAndPush:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.saveAndPush,
			dataType: 'json',
			type: 'POST',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},


	//我的社团列表（家长）
	getMyAssnList:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.getMyAssnList,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

//获取活动分类
    getActType:function(params,successCB, errorCB) {
        console.log("window.API_CONFIG.findAllAssnType" + window.API_CONFIG.findAllAssnType);
        mui.ajax({
            url: window.API_CONFIG.findAllAssnType,
            dataType: 'json',
            type: 'GET',
            data:params,
            timeout: window.GlOBAL_CONFIG.timeOut,
            success: function (data) {
                successCB && successCB(data);
                window.MethodUtil.refreshTokenTimer();
            },
            error: function (xhr, type, error) {
                MethodUtil.checkToken(xhr, type, error, errorCB);
            }
        });
    },


	//获取推送模板
	getPushTemplate:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.getPushTemplate,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {

				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//获取当前用户默认学生
	getDefaultStudent:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.getDefaultStudent,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//短信推送获取机构树
	treeJson:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.treeJson,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {

				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},



	//新增社团成果（老师）
	saveAssnAchievement:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.saveAssnAchievement,

			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//社团分享列表（老师）
	getAssnShareList:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.getAssnShareList,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

    //朋友圈列表
    fnGetClubCircleList:function(params,successCB, errorCB) {
        mui.ajax({
            url: window.API_CONFIG.getAssnAchievementList,
            type: "POST",
            dataType: "json",
            timeout: window.GlOBAL_CONFIG.timeOut,
            data: params,
            success: function(data) {
                window.MethodUtil.refreshTokenTimer();
                successCB && successCB(data);
            },
            error: function(xhr, type, error) {
                MethodUtil.checkToken(xhr, type, error, errorCB);
            }
        });
    },
	//朋友圈列表
    changeAssnAchievementPraise: function(params, successCB, errorCB) {
        mui.ajax({
            url: window.API_CONFIG.changeAssnAchievementPraise,
            type: "POST",
            dataType: "json",
            timeout: window.GlOBAL_CONFIG.timeOut,
            data: params,
            success: function(data) {
                window.MethodUtil.refreshTokenTimer();
                successCB && successCB(data);
            },
			error: function(xhr, type, error) {
                MethodUtil.checkToken(xhr, type, error, errorCB);
            }
        });
    },
    
    //约课首页查询列表dwm
	orderListData:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.orderListData,
			dataType: 'json',
			type: 'GET',
			data:params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//约课初始化节次dwm
	initClassNum:function(successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.initClassNum,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
    //约课详情dwm
    getClassDetail:function(id,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.getClassDetail,
			dataType: 'json',
			type: 'GET',
			data: {
				classId: id
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//约课各种申请dwm
    saveOrderClass:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.saveOrderClass,
			dataType: 'json',
			type: 'GET',
			data: params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//约课申请列表dwm
    saveOrderClassList:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.saveOrderClassList,
			dataType: 'json',
			type: 'GET',
			data: params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//约课拒绝原因列表dwm
    getReasonList:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.getReasonList,
			dataType: 'json',
			type: 'GET',
			data: params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
     //初始化年级班级树
	initClassTree:function(successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.initClassTree,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//约课评价
	reservationComment:function(params,successCB, errorCB) {
		console.log("window.API_CONFIG.reservationComment"+window.API_CONFIG.reservationComment);
		mui.ajax({
			url:window.API_CONFIG.reservationComment,
			dataType: 'json',
			type: 'POST',
			data: params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//约课待办详情
	reservationFlowDetail:function(itemId,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.reservationFlowDetail,
			dataType: 'json',
			type: 'POST',
			data:{
				lid:itemId
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//约课待办处理
	orderCourseHandle:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.orderCourseHandle,
			dataType: 'json',
			type: 'POST',
			data: params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//约课上课老师
	orderTreeTeacher: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.orderTreeTeacher,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//约课选择听课人到组
	orderTreeGroup: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.orderTreeGroup,
			headers: {
				token: window.MethodUtil.getUserInfo().token
			},
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//工资单列表
	financeList:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.financeList,
			dataType: 'json',
			type: 'GET',
			data:params,
            timeout: window.GlOBAL_CONFIG.timeOut,
            success: function(data) {
                window.MethodUtil.refreshTokenTimer();
                successCB && successCB(data);
            },
            error: function(xhr, type, error) {
                MethodUtil.checkToken(xhr, type, error, errorCB);
            }
		});
   },
   //工资单详情
	financeDetail:function(itemId,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.financeDetail,
			dataType: 'json',
			type: 'POST',
			data:{
				id:itemId
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//公告一键已读
	batchReaded:function(successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.batchReaded,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	findDefaultAssnAndOtherAssn:function(successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.findDefaultAssnAndOtherAssn,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	saveAssnAchievement:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.saveAssnAchievement,
			dataType: 'json',
			type: 'POST',
			data:params,
            timeout: window.GlOBAL_CONFIG.timeOut,
            success: function(data) {
                successCB && successCB(data);
            },
            error: function(xhr, type, error) {
                MethodUtil.checkToken(xhr, type, error, errorCB);
            }
		});
   },
   findAllTeacher:function(successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.findAllTeacher,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//获取社团所有学生
	getAllStudent:function(params,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getAllStudent,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	getAssnAchievementList:function(params,successCB, errorCB) {
		console.log("getAssnAchievementListUrl:"+window.API_CONFIG.getAssnAchievementList);
		console.log("getAssnAchievementListParams"+JSON.stringify(params));
		mui.ajax({
			url:window.API_CONFIG.getAssnAchievementList,
			dataType: 'json',
			type: 'GET',
			data: params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//保存点名
	callSave:function(params,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.callSave,
			dataType: 'json',
			data:params,
			type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
		        successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},		
				
				
	changeAssnAchievementPraise:function(params,successCB, errorCB) {
		console.log("changeAssnAchievementPraiseUrl:"+window.API_CONFIG.changeAssnAchievementPraise);
		console.log("changeAssnAchievementPraiseParams"+JSON.stringify(params));
		mui.ajax({
			url:window.API_CONFIG.changeAssnAchievementPraise,
			dataType: 'json',
			type: 'GET',
			data: params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	removeAssnAchievements:function(params,successCB, errorCB) {
		console.log("removeAssnAchievementsUrl:"+window.API_CONFIG.removeAssnAchievements);
		console.log("removeAssnAchievementsParams"+JSON.stringify(params));
		mui.ajax({
			url:window.API_CONFIG.removeAssnAchievements,
			dataType: 'json',
			type: 'GET',
			data: params,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	findInfo:function(params,successCB, errorCB) {
		console.log("findInfo:"+window.API_CONFIG.removeAssnAchievements);
		console.log("findInfoParams"+JSON.stringify(params));
		mui.ajax({
			url: window.API_CONFIG.findInfo,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	publish:function(params,successCB, errorCB) {
		console.log("publish:"+window.API_CONFIG.publish);
		console.log("publish"+JSON.stringify(params));
		mui.ajax({
			url: window.API_CONFIG.publish,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	findPageInfo:function(params,successCB, errorCB) {
		console.log("findPageInfo:"+window.API_CONFIG.findPageInfo);
		console.log("findPageInfo"+JSON.stringify(params));
		mui.ajax({
			url: window.API_CONFIG.findPageInfo,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	lostAndFoundModify:function(params,successCB, errorCB) {
		console.log("lostAndFoundModify:"+window.API_CONFIG.lostAndFoundModify);
		console.log("lostAndFoundModify"+JSON.stringify(params));
		mui.ajax({
			url: window.API_CONFIG.lostAndFoundModify,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	findTeacherIntroductionList:function(successCB, errorCB) {
		console.log("findTeacherIntroductionList:"+window.API_CONFIG.findTeacherIntroductionList);
		mui.ajax({
			url: window.API_CONFIG.findTeacherIntroductionList,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//食谱展示一周数据
	showDetailTzxxWeek:function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.showDetailTzxxWeek,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//教师版成绩分析类型
	getTeaAchieveType:function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getTeaAchieveType,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//老师版学生之前成绩分析列表
	getListTestTeacher:function(obj, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getListTestTeacher,
			dataType: 'json',
			type: 'GET',
			data:obj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//教师班级学生列表
	getClassLists:function(gradeId, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.classLists(gradeId),
			dataType: 'json',
			type: 'GET',
			data: {
				gradeId:gradeId
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//老师版成绩分析详情雷达图
	achievementRadar:function(studentId, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.achievementRadar(studentId),
			dataType: 'json',
			type: 'GET',
			data: {
				id:studentId
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//老师版成绩分析统计
	statisticsScore:function(detailId,grade,subjectId,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.statisticsScore,
			dataType: 'json',
			type: 'GET',
			data: {
				detailId:detailId,
				grade:grade,
				subjectId:subjectId
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//获取学校科目(家长版科目)
	listSubject: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.listSubject,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//家长版成绩分析列表
	listExamDetailByStudent:function(obj, studentId, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.listExamDetailByStudent(studentId),
			dataType: 'json',
			type: 'GET',
			data: obj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//家长成绩分析统计
	listExamAchievementByStudent:function(studentId,subjectId, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.listExamAchievementByStudent(studentId),
			dataType: 'json',
			type: 'GET',
			data: {
				studentId:studentId,
				subjectId:subjectId
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	getLossDetail:function(id,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.lossDetail,
			dataType: 'json',
			type: 'GET',
			data: {
				id:id
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//社团0809
	findAssnType:function(successCB, errorCB) {//社团列别
		mui.ajax({
			url: window.API_CONFIG.findAssnType,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	findAssnTime:function(successCB, errorCB) {//社团时间（期数）
		mui.ajax({
			url: window.API_CONFIG.findAssnTime,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	assnInfoList:function(obj, successCB, errorCB) {//社团申请列表
		mui.ajax({
			url: window.API_CONFIG.assnInfoList,
			dataType: 'json',
			type: 'GET',
			data:obj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	assnInfoDetail:function(id,successCB, errorCB) {//社团详情（最外面+申请
		mui.ajax({
			url: window.API_CONFIG.assnInfoDetail,
			dataType: 'json',
			type: 'GET',
			data: {
				id:id
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	declareAdd:function(obj, successCB, errorCB) {//社团申请新增
		mui.ajax({
			url: window.API_CONFIG.declareAdd,
			dataType: 'json',
			type: 'POST',
			data:obj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	assnInfoDelete:function(id,successCB, errorCB) {//社团删除（最外面+申请）
		mui.ajax({
			url: window.API_CONFIG.assnInfoDelete,
			dataType: 'json',
			type: 'GET',
			data: {
				id:id
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	findClassInfo:function(grade,successCB, errorCB) {//社团申报新增班级
		mui.ajax({
			url: window.API_CONFIG.findClassInfo,
			dataType: 'json',
			type: 'GET',
			data: {
				grade:grade
			},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	declareFindAllTeacher:function(successCB, errorCB) {//社团申报新增选择教师
		mui.ajax({
			url: window.API_CONFIG.declareFindAllTeacher,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	praiseAssn:function(obj,successCB, errorCB) {//点赞+关注
		mui.ajax({
			url: window.API_CONFIG.praiseAssn,
			dataType: 'json',
			type: 'GET',
			data: obj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	assnAuditUser: function(successCB, errorCB) {//判断教务人员是否有审批权限
		mui.ajax({
			url: window.API_CONFIG.assnAuditUser,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	assnAuditExamine: function(obj, successCB, errorCB) {//教务审核社团+驳回
		mui.ajax({
			url: window.API_CONFIG.assnAuditExamine,
			dataType: 'json',
			type: 'GET',
			data:obj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	assnAuditList: function(obj, successCB, errorCB) {//教务社团列表
		mui.ajax({
			url: window.API_CONFIG.assnAuditList,
			dataType: 'json',
			type: 'GET',
			data:obj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	saveAssnStudent:function(obj,successCB, errorCB) {//家长端报名
		mui.ajax({
			url: window.API_CONFIG.saveAssnStudent,
			dataType: 'json',
			type: 'GET',
			data: obj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//社团统计数据
	assnInfoStatList:function(obj,successCB, errorCB){
		mui.ajax({
			url: window.API_CONFIG.assnInfoStatList,
			dataType: 'json',
			type: 'GET',
			data: obj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	assnHeadmaster: function(successCB, errorCB) {//判断是否是班主任
		mui.ajax({
			url: window.API_CONFIG.assnHeadmaster,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//班主任社团统计数据
	assnListByType:function(obj,successCB, errorCB){
		mui.ajax({
			url: window.API_CONFIG.assnListByType,
			dataType: 'json',
			type: 'GET',
			data: obj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//课外练习提交
	ivitySubmit:function(obj,successCB, errorCB){
		mui.ajax({
			url: window.API_CONFIG.ivitySubmit,
			dataType: 'json',
			type: 'GET',
			data: obj,
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//课外练习列表
	ivityList:function(params,successCB, errorCB) {
		mui.ajax({
			url:window.API_CONFIG.ivityList,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				window.MethodUtil.refreshTokenTimer();
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//标题
	findIvityType:function(successCB, errorCB) {
		console.log("findIvityType==="+window.API_CONFIG.findIvityType);
		mui.ajax({
			url:window.API_CONFIG.findIvityType,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				
			}
		});
	},
	//科目
	findClassType:function(successCB, errorCB) {
		console.log("findClassType==="+window.API_CONFIG.findClassType);
		mui.ajax({
			url:window.API_CONFIG.findClassType,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				
			}
		});
	},
	//删除
	deleteIvity:function(id,successCB, errorCB) {
		console.log("deleteIvity==="+window.API_CONFIG.deleteIvity);
		mui.ajax({
			url:window.API_CONFIG.deleteIvity,
			dataType: 'json',
			data:{
				id:id
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				
			}
		});
	},
	//详情
	findDetailById:function(id,successCB, errorCB) {
		console.log("findDetailById==="+window.API_CONFIG.findDetailById);
		mui.ajax({
			url:window.API_CONFIG.findDetailById,
			dataType: 'json',
			data:{
				id:id
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				
			}
		});
	},
	
	
	//汇总一id为空是家长，有值是教师端
	findIvityByUserId:function(id,subjectId,successCB, errorCB) {
		console.log("findIvityByUserId==="+window.API_CONFIG.findIvityByUserId);
		mui.ajax({
			url:window.API_CONFIG.findIvityByUserId,
			dataType: 'json',
			data:{
				studentId:id,
				subjectId:subjectId
			},
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				
			}
		});
	},
	//汇总二
	findIvityByFlag:function(params,successCB, errorCB) {
		console.log("findIvityByFlag==="+window.API_CONFIG.findIvityByFlag);
		mui.ajax({
			url:window.API_CONFIG.findIvityByFlag,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				
			}
		});
	},
	//班级列表
	getUserLeaderClass:function(successCB, errorCB) {
		console.log("getUserLeaderClass==="+window.API_CONFIG.getUserLeaderClass);
		mui.ajax({
			url:window.API_CONFIG.getUserLeaderClass,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				
			}
		});
	},
	
	//教师端列表
	findListByClassId:function(params,successCB, errorCB) {
		console.log("findListByClassId==="+window.API_CONFIG.findListByClassId);
		mui.ajax({
			url:window.API_CONFIG.findListByClassId,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				
			}
		});
	},
	getOSSFile:function(id, successCB, errorCB) {
//		console.log("getOSSFile" + (window.FILE_GET_CONFIG_OSS + id));
//		console.log("getOSSFileId" + id);
		mui.ajax(window.FILE_GET_CONFIG_OSS + id, {
			dataType: 'json',
			type: 'GET',
			data: {},
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				console.log("getOSSFile" + JSON.stringify(data));
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				console.log("getOSSFile" + xhr.status);
				
			}
		});
	},
	//记录菜单使用
	recordMenu:function(params,successCB, errorCB) {
		console.log("recordMenu"+JSON.stringify(params));
		mui.ajax({
			url:window.API_CONFIG.recordMenu,
			dataType: 'json',
			data:params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				
			}
		});
	},
	//人脸采集
	updatePicture: function(params, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.updatePicture,
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//新增校园风采
	saveCampus: function(params, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.saveCampus,
			dataType: 'json',
			data: params,
			type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//校园风采列表
	getCampusList: function(params, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getCampusList,
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//校园风采详情
	getCampus: function(params, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getCampus,
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//删除校园风采
	deleteCampus: function(params, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.deleteCampus,
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//获取年级班级
	getGrade: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getGrade,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//新增班级相册
	saveClassPhoto: function(params,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.saveClassPhoto,
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//班级相册列表
	getAlbumList: function(params, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getAlbumList,
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//班级相册详情
	classPhotoDetail: function(params, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.classPhotoDetail,
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//删除班级相册接口
	deleteAlbum: function(params, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.deleteAlbum,
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//新增校园查询
	activitiesGet: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.activitiesGet,
			dataType: 'json',
			type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//新增校园活动
	activitiesAdd: function(params, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.activitiesAdd,
			dataType: 'json',
			data: params,
			type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//校园活动列表
	activitiesList: function(params, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.activitiesList,
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//校园活动详情
	activitiesDetail: function(params, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.activitiesDetail,
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//校园活动删除
	activitiesDelete: function(params, successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.activitiesDelete,
			dataType: 'json',
			data: params,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//校园活动是否新增的权限
	campusActivitiesIsLeader: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.campusActivitiesIsLeader,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比首页班级列表
	eduScoreGetGrade: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduScoreGetGrade,
			dataType: 'json',
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比班级学生（小组）列表
	eduScoreGetStudent: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduScoreGetStudent,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比点评项列表
	eduScoreGetCommentLsit: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduScoreGetCommentLsit,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比添加（修改）点评项
	eduScoreSave: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduScoreSave,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比删除点评项
	eduCommentDelete: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduCommentDelete,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比点评项点评(单人、多人、小组点评)
	eduSaveComment: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduSaveComment,
			dataType: 'json',
			data: obj,
			type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比添加（修改）小组
	eduSaveGroupName: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduSaveGroupName,
			dataType: 'json',
			data: obj,
			type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比小组人员详情
	eduGetStuList: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduGetStuList,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比文字点评内容
	eduGetWordComment: function(successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduGetWordComment,
			dataType: 'json',
			type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比获取单个小组信息
	eduGetGroupInfo: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduGetGroupInfo,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比保存（修改）小组成员
	eduSaveGroupStu: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduSaveGroupStu,
			dataType: 'json',
			data: obj,
			type: 'POST',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比解散小组
	eduGroupDetele: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduGroupDetele,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比班级表现
	eduClassComment: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduClassComment,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比模糊搜索
	eduSearch: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduSearch,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比家长端个人表现
	eduStuComment: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduStuComment,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//获取人脸采集上传的图片
	updatePictureDetail: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.updatePictureDetail,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//获取周报月报列表
	dailyManageList: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.dailyManageList,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	
	//获取日报管理详情
	dailyManageDetail: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.dailyManageDetail,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	
	//获取日报管理功能室详情
	getRoomListDetail: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.getRoomListDetail,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},

	//获取日报管理功能室详情
	reportNotice: function(obj,successCB, errorCB) {
		console.log('【reportNotice】' + window.API_CONFIG.reportNotice);
		mui.ajax({
			url: window.API_CONFIG.reportNotice,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
	//德育评比首页模糊搜索（学生姓名+小组）
	eduClassInfo: function(obj,successCB, errorCB) {
		mui.ajax({
			url: window.API_CONFIG.eduClassInfo,
			dataType: 'json',
			data: obj,
			type: 'GET',
			timeout: window.GlOBAL_CONFIG.timeOut,
			success: function(data) {
				successCB && successCB(data);
			},
			error: function(xhr, type, error) {
				MethodUtil.checkToken(xhr, type, error, errorCB);
			}
		});
	},
};
