/*
 * 常用方法封装
 * 王有锴
 */

window.MethodUtil = {
	// 去除字符串所有空格(主用于校验)
	delAllTrim: function(str) {
		return str.replace(/\s+/g, "");
	},
	// 判断表单字段是否空
	trimTitle: function(objArr) {
		var flag = false;
		for(var i = 0; i < objArr.length; i++) {
			if(!objArr[i].value || objArr[i].value == '') {
				plus.nativeUI.toast(objArr[i].title);
				flag = true;
				break;
			}
		}
		if(flag) {
			return false;
		} else {
			return true;
		}
	},
	stringText: function(string, Chinese) { //校验参数函数
		if(!window.MethodUtil.filterEmoji(string)) { //校验表情
			return false;
		} else if(!string || string == '') {
			mui.toast('请填写' + Chinese);
			return false;
		} else if(string.replace(/\s+/g, "") == '') {
			mui.toast(Chinese + '不能为空格');
			return false;
		}
		return true;
	},
	//处理多文本换行符
	replaceLB: function(val) {
		var descArr = val.split('\n');
		descArr.forEach(function(item, idx, arr) {
			arr[idx] = '<p>' + item + '</p>';
		});
		return descArr.join('');
	},
	replaceLBClamp: function(vals, per, line) {
		var ret = [];
		var total = 0;
		var descArr = vals.split('\n');
		var val;
		var item;
		var finished = false;
		per = per || 20;
		line = line || 6;

		if(descArr && descArr.length) {
			var minLine = line < descArr.length ? line : descArr.length;
			for(var i = 0; i < minLine; i++) {
				item = descArr[i];
				val = item || '';
				if(total < per * line) {
					if(total + val.length >= per * line) {
						if(val) {
							val = val.substr(0, per * line - total);
						}
						val = val.substr(0, per * line - total);
						ret[i] = '<p>' + val + '</p>';
						total += item.length;
						break;
					} else {
						ret[i] = '<p>' + val + '</p>';
						total += item.length;
					}

				} else {
					break;
				}
			}
			if(i == descArr.length) {
				finished = true;
			}
		}

		return {
			cnt: ret.join(''),
			finished: finished
		}
	},
	//去掉所有html标记的函数
	delHtmlTag: function delHtmlTag(str) {
		return str.replace(/<[^>]+>/g, ""); //去掉所有的html标记
	},
	//上拉下拉加载列表数据
	getListData: function getListData(module, isRefresh) {
		switch(module) {
			case "attendanceExpection": //考勤异常
				attendanceExpectionList.getattendanceExpectionList(isRefresh);
				break;
			case "repair": //报修
				repairList.getRepairList(isRefresh);
				break;
			case "schedule": //待办
				scheduleList.getScheduleList(isRefresh);
				break;
			case "plan": //计划管理
				planList.getPlanListMine(isRefresh);
				break;
		}
	},
	//列表下拉、上拉刷新
	pullRefreshList: function pullRefreshList(obj, style) {
		mui.init({
			pullRefresh: {
				container: obj.containerId,
				down: {
					style: style.shape,
					offset: style.position,
					color: style.color,
					auto: true,
					callback: function() {
						window.MethodUtil.getListData(obj.module, true);
					}
				},
				up: {
					contentrefresh: "正在加载...",
					contentnomore: '没有更多数据了',
					callback: function() {
						window.MethodUtil.getListData(obj.module, false);
					}
				}

			}
		});

	},
	// 字符串时间转时间戳
	getTimeStamp: function(stringTime) {
		var timestamp = Date.parse(new Date(stringTime));
		return timestamp;
	},

	//日期截取
	subs: function(value) {
		return value.substring(0, 11);
	},
	//工资整数截取
	getMoneyInt: function(value) {
		var arr = value.split('.');
		return arr[0];
	},
	//工资小数截取
	getMoneyFloat: function(value) {
		var arr = value.split('.');
		if(arr.length == 1) {
			return '00';
		}
		return arr[1];
	},
	//金额为空则添为0
	getMoneyHandleNull: function(value) {
		if(value == '') {
			return 0;
		}
		return value;
	},
	//报修类型
	repairType: function(value) {
		if(value == 1) {
			return "总务报修";
		} else {
			return '电教报修';
		}
	},
	//日期格式化
	getMonthDay: function(value) {
		return moment(new Date(value)).utc().zone(-8).format("MM/DD");
	},
	//日期格式化
	getDate: function(value) {
		return moment(new Date(value)).utc().zone(-8).format("YYYY/MM/DD");
	},
	//日期格式化
	getReceivedDate: function(value) {
		return moment(new Date(value)).utc().zone(-8).format("YYYY.MM.DD HH:mm:ss");
	},
	//日期格式化
	getReturnDatedDate: function(value) {
		return moment(new Date(value)).utc().zone(-8).format("YYYY-MM-DD HH:mm:ss");
	},
	//日期格式化
	getReturnOnlyDate: function(value) {
		return moment(new Date(value)).utc().zone(-8).format("YYYY-MM-DD");
	},
	//验证token是否过期
	checkToken: function(xhr, type, err, callBack, preventTip) {
		console.log("验证token是否过期====" + xhr.status)
		if(xhr.status == 599) { //599 token过期
			// 销毁token定时器
			//			var IndexPage = plus.webview.getWebviewById('index.html');
			//			mui.fire(IndexPage, 'destroyTokenTimer')
			window.WebviewUtil.show('login', null, "fade-in");
			if(window.plus) {
				plus.nativeUI.closeWaiting();
				plus.storage.setItem('tipTime', '');
				plus.storage.setItem('updateConfirm', '');
			}
			if(!preventTip) {
				mui.toast("会话超时或在另外登陆点登陆");
			}
		} else {
			console.log('12344566')
			callBack && callBack(xhr, type, err);
		}
	},
	// 重置token换新定时器
	refreshTokenTimer: function() {
		// 重置token换新定时器
		//		var IndexPage = plus.webview.getWebviewById('index.html');
		//		mui.fire(IndexPage, 'resetTokenTimer')
	},
	// 过滤emogi符号

	filterEmoji: function(content) {
		var emojiFilter = /[\uD83C|\uD83D|\uD83E][\uDC00-\uDFFF][\u200D|\uFE0F]|[\uD83C|\uD83D|\uD83E][\uDC00-\uDFFF]|[0-9|*|#]\uFE0F\u20E3|[0-9|#]\u20E3|[\u203C-\u3299]\uFE0F\u200D|[\u203C-\u3299]\uFE0F|[\u2122-\u2B55]|\u303D|[\A9|\AE]\u3030|\uA9|\uAE|\u3030/ig
		if(emojiFilter.test(content)) {
			plus.nativeUI.toast("不能输入emoji表情!");
			return false;
		}
		return true;
	},
	//json对象合并
	getCombineObj: function(jsonbject1, jsonbject2) {
		var resultJsonObject = {};
		for(var attr in jsonbject1) {
			resultJsonObject[attr] = jsonbject1[attr];
		}
		for(var attr in jsonbject2) {
			resultJsonObject[jsonbject1.length + attr] = jsonbject2[attr];
		}
		return resultJsonObject;
	},
	// 获取用户数据
	getUserInfo: function() {
		if(plus.storage.getItem('userInfo')) {
			return JSON.parse(plus.storage.getItem('userInfo'))
		}
		return ''
	},

	// 存储用户数据到本地
	setUserInfo: function(userInfo) {
		plus.storage.setItem('userInfo', JSON.stringify(userInfo));
	},
	//调用相机
	getCamera: function(callBack) {
		var camera = plus.camera.getCamera();
		camera.captureImage(function(path) {
			callBack(path);
		}, function(error) {
			console.log(error.message);
		}, {
			filename: "_doc/camera/",
			index: 1
		})
	},
	//调用相机
	getCamera2: function(callBack) {
		var camera = plus.camera.getCamera();
		camera.captureImage(function(path) {
			callBack(path);
		}, function(error) {
			console.log(error.message);
		}, {
			filename: "_doc/camera/",
			index: 2
		})
	},

	getVideo: function(callback) {         
		var cmr = plus.camera.getCamera();         
		var res = cmr.supportedVideoResolutions[0]; //获取支持的分辨率，拿默认的第一个
		var fmt = cmr.supportedVideoFormats[0]; //获取支持的录像文件格式，拿默认的第一个
		cmr.startVideoCapture(function(e) { //录像成功后会返回一个路径到e这里
			callback(e);
		}, function(error) {               
			mui.toast("取消录制");            
		}, {
			resolution: res,
			format: fmt,
			filename: '_doc/camera/',
			index: 1
		});      
	},

	//上传图片
	uploadImage: function(path, callBack) {
		var task = plus.uploader.createUpload(IMAGE_UPLOAD_CONFIG, {
				method: "POST"
			},
			function(t, status) {
				if(status == 200) {
					var result = JSON.parse(t.responseText);
					console.log("path，" + path)
					console.log("success: " + JSON.stringify(result))
					callBack(result);
				} else {
					plus.nativeUI.toast('图片上传失败');
					console.log("Upload failed: " + status)
				}
			}
		);
		task.addFile(path, {
			key: "file"
		});
		task.addData("title", "1");
		task.addData("collection", "1");
		task.start();
	},
	uploadImages: function(path, callBack, type,progressFn) {
		var task = plus.uploader.createUpload(IMAGE_UPLOAD_CONFIG_OSS, {
				method: "POST",
				timeout: 0
			},
			function(t, status) {
				if(status == 200) {
					var result = JSON.parse(t.responseText);
					console.log("path，" + path)
					console.log("success: " + JSON.stringify(result))
					callBack && callBack(result);
					console.log("afterCallback");
				} else {
					if(type == '1') { //1是音频2是视频默认是图片不传也可以
						plus.nativeUI.toast('音频上传失败');
					} else if(type == '2') {
						plus.nativeUI.toast('视频上传失败');
					} else {
						plus.nativeUI.toast('图片上传失败');
					}
					console.log("Upload failed: " + status)
				}
			}
		);
		task.addFile(path, {
			key: "files"
		});
		task.addData("projectId", window.GlOBAL_CONFIG.companyId);
		task.addData("title", "1");
		task.addData("collection", "1");
		var isFn = function(val) {
			return typeof val == 'function';
		};

		task.addEventListener("statechanged",function(upload, status){
			if(progressFn&&isFn(progressFn)){
				progressFn(upload,status);
			}
			
			
		} , false);
		
		
		task.start();
	},
	imageHandler: function(event, callback) {
		var p = event.target;
		plus.io.resolveLocalFileSystemURL(p, function(entry) {
			entry.file(function(file) {
				var fileReader = new plus.io.FileReader();
				fileReader.onloadend = function(evt) {
					console.log("fileReader" + evt.target.result);
					callback && callback({
						target: evt.target.result
					}, event);
				}
				fileReader.readAsDataURL(file);
			});
		});
	},
	/*
	 * 压缩图片
	 * @param src 文件路径
	 * @param 压缩后路径
	 * @quality 图片质量
	 */
	compressImage: function(src, dst, sCallBack, fCallBack, quality) {
		quality = quality || 40;
		plus.zip.compressImage({
			src: src,
			dst: dst,
			overwrite: true,
			quality: quality
		}, function(event) {
			//window.MethodUtil.imageHandler(event,sCallBack);
			sCallBack && sCallBack(event);
		}, function() {
			fCallBack && fCallBack();
			console.log("压缩失败");
			plus.nativeUI.toast("压缩失败");
		});
	},
	//打开定位服务
	openSetting: function(arr) {
		if(plus.os.name == "Android") {
			var context = plus.android.importClass("android.content.Context");
			var locationManager = plus.android.importClass("android.location.LocationManager");
			var main = plus.android.runtimeMainActivity();
			var mainSvr = main.getSystemService(context.LOCATION_SERVICE);
			androidIsOpen = mainSvr.isProviderEnabled(locationManager.GPS_PROVIDER);
			if(androidIsOpen) { //定位服务开启
				for(i = 0; i < arr.length; i++) {
					arr[i]();
				}

			} else { //没有开启定位服务
				mui.confirm('检测到您关闭了定位功能，是否打开？', '提示', ['确 认', '取 消'], function(e) {
					if(e.index == 1 || e.index == -1) {
						plus.nativeUI.closeWaiting();
						setTimeout(function() {
							//不打开设置页面就关闭当前页面不继续执行
							var ws = plus.webview.currentWebview();
							plus.webview.close(ws);
						}, 2000);
						return;
					} else {
						plus.nativeUI.closeWaiting();
						var main = plus.android.runtimeMainActivity(); //获取activity
						var Intent = plus.android.importClass('android.content.Intent');
						var Settings = plus.android.importClass('android.provider.Settings');
						var intent = new Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS); //可设置表中所有Action字段
						main.startActivity(intent);
						setTimeout(function() {
							//如果没有打开定位服务，默认关掉当前页面
							var ws = plus.webview.currentWebview();
							plus.webview.close(ws);
						}, 2000);

					}
				})

			}
		} else {
			var ios = plus.navigator.checkPermission('LOCATION');
			switch(ios) {
				case 'authorized': //定位服务开启
					for(i = 0; i < arr.length; i++) {
						arr[i]();
					}
					break;
				default: //没有开启定位服务
					mui.confirm('是否打开定位服务页面？', '提示', ['确 认', '取 消'], function(e) {
						if(e.index == 1 || e.index == -1) {
							plus.nativeUI.closeWaiting();
							setTimeout(function() {
								//不打开设置页面就关闭当前页面不继续执行
								var ws = plus.webview.currentWebview();
								plus.webview.close(ws);
							}, 2000);
							return;
						} else {
							plus.nativeUI.closeWaiting();
							plus.runtime.openURL("app-settings:")
							setTimeout(function() {
								//如果没有打开定位服务，默认关掉当前页面
								var ws = plus.webview.currentWebview();
								plus.webview.close(ws);
							}, 2000);
						}
					})

					break;
			}
		}

	},
	//封装饼图
	echartsPie: function(title, arr) {
		var chartOption = {
			title: {
				text: title,
				left: 'left',
				textStyle: {
					fontWeight: 'normal',
					fontSize: 14,
				}
			},
			series: [{
				name: '访问来源',
				type: 'pie',
				radius: '35%',
				center: ['50%', '50%'],
				data: arr
			}]
		}
		var pieChart = echarts.init(document.getElementById('pieChart'));
		pieChart.setOption(chartOption);
	},
	//环形饼图
	echartsDoublePie: function(title, show, color, arr) {
		var chartOption = {
			legend: {
				show: show,
				orient: 'horizontal',
				x: 'left',
				textStyle: {
					fontSize: 10
				},
				data: title
			},
			color: color,
			series: [{
				name: '访问来源',
				type: 'pie',
				radius: ['30%', '45%'],
				avoidLabelOverlap: false,
				label: {
					normal: {
						show: false,
						position: 'center'
					},
					emphasis: {
						show: true,
						textStyle: {
							fontSize: '30',
							fontWeight: 'bold'
						}
					}
				},
				labelLine: {
					normal: {
						show: false
					}
				},
				data: arr
			}]
		};
		var pieChart = echarts.init(document.getElementById('pieChart'));
		pieChart.setOption(chartOption);
	},
	//柱状图
	echartsBar: function(params) {
		var option = {
			title: {
				text: params.title,

			},
			tooltip: {
				trigger: 'axis'
			},
			legend: {
				data: params.legend,
				orient: 'horizontal',
				x: 'left',
				y: 'top'
			},
			toolbox: {
				show: false,
				feature: {
					mark: {
						show: true
					},
					dataView: {
						show: true,
						readOnly: false
					},
					magicType: {
						show: true,
						type: ['line', 'bar']
					},
					restore: {
						show: true
					},
					saveAsImage: {
						show: true
					}
				}
			},
			calculable: true,
			xAxis: [{

				data: params.xAxis
			}],
			yAxis: [

			],
			series: [{
					name: params.seriesName || '人数',
					type: 'bar',
					data: params.data,

				},

			]
		};
		var pieChart = echarts.init(document.getElementById('chartBlock'));
		pieChart.setOption(option);
	},
	//仅仅是格式校验，必填校验不归于此类
	isPhone: function(phone) {
		var reg = /^[1][3,4,5,7,8,9][0-9]{9}$/;
		if(phone && (!reg.test(phone))) {
			return false;
		} else {
			return true;
		}
	},
	//仅仅是格式校验，必填校验不归于此类
	isMob: function(phone) {
		var reg = /^0?1[3|4|5|8][0-9]\d{8}$/;
		if(phone && (!reg.test(phone))) {
			return false;
		} else {
			return true;
		}
	},
	validContactNo: function(val) {
		var msg = "";
		if(val) {
			if(!this.isPhone(val) && !this.isMob(val)) {
				msg = "请输入有效的联系电话";
			}
		}
		return msg;
	},
	textCopy: function(key) {
		var elem = document.getElementById(key);
		if(elem) {
			var text = document.getElementById(key).innerText;
			if(text) {
				text = text.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
				var input = document.getElementById("copy-text");
				if(!input) {
					input = document.createElement("textarea");
					input.id = "copy-text";
					input.classList.add("textarea-copy");
					document.body.appendChild(input);
				}

				input.value = text; // 修改文本框的内容
				input.select(); // 选中文本
				document.execCommand("copy"); // 执行浏览器复制命令
				alert("复制成功");
			}
		}
	},
	initPhotoSwipeFromDOM: function(gallerySelector, openFn, closeFn) {

		// parse slide data (url, title, size ...) from DOM elements 
		// (children of gallerySelector)
		var parseThumbnailElements = function(el) {
			var thumbElements = el.childNodes,
				numNodes = thumbElements.length,
				items = [],
				figureEl,
				linkEl,
				size,
				item;
			var img;

			for(var i = 0; i < numNodes; i++) {

				figureEl = thumbElements[i]; // <figure> element
				console.log("figureEl" + figureEl.className);
				// include only element nodes 
				if(figureEl.nodeType !== 1) {
					continue;
				}
				figureEl = figureEl.querySelector(".J-inner") || figureEl;
				linkEl = figureEl.children[0]; // <a> element
				//              var img = new Image();
				//                  img.src = linkEl.getAttribute('href');
				//                  
				//                  linkEl.setAttribute('data-size', img.naturalWidth + 'x' + img.naturalHeight);
				img = linkEl.children[0];
				linkEl.setAttribute('data-size', img.naturalWidth * 6 + 'x' + img.naturalHeight * 5.5);
				size = linkEl.getAttribute('data-size').split('x');
				console.log("size" + size)
				// create slide object
				item = {
					src: linkEl.getAttribute('href'),
					w: parseInt(size[0], 10),
					h: parseInt(size[1], 10)
				};

				if(figureEl.children.length > 1) {
					// <figcaption> content
					item.title = figureEl.children[1].innerHTML;
				}

				if(linkEl.children.length > 0) {
					// <img> thumbnail element, retrieving thumbnail url
					item.msrc = linkEl.children[0].getAttribute('src');
				}

				item.el = figureEl; // save link to element for getThumbBoundsFn
				items.push(item);
			}

			return items;
		};

		// find nearest parent element
		var closest = function closest(el, fn) {
			return el && (fn(el) ? el : closest(el.parentNode, fn));
		};

		// triggers when user clicks on thumbnail
		var onThumbnailsClick = function(e) {

			e = e || window.event;
			e.preventDefault ? e.preventDefault() : e.returnValue = false;

			var eTarget = e.target || e.srcElement;

			// find root element of slide
			var clickedListItem = closest(eTarget, function(el) {
				return(el.tagName && el.tagName.toUpperCase() === 'LI') || (el.className && el.className.match('J-figure'));
			});

			if(!clickedListItem) {
				return;
			}

			// find index of clicked item by looping through all child nodes
			// alternatively, you may define index via data- attribute
			var clickedGallery = clickedListItem.parentNode,
				childNodes = clickedListItem.parentNode.childNodes,
				numChildNodes = childNodes.length,
				nodeIndex = 0,
				index;

			for(var i = 0; i < numChildNodes; i++) {
				if(childNodes[i].nodeType !== 1) {
					continue;
				}

				if(childNodes[i] === clickedListItem) {
					index = nodeIndex;
					break;
				}
				nodeIndex++;
			}

			if(index >= 0) {
				if(typeof openFn == "function") {
					openFn();
				}
				// open PhotoSwipe if valid index found
				openPhotoSwipe(index, clickedGallery);
			}
			return false;
		};

		// parse picture index and gallery index from URL (#&pid=1&gid=2)
		var photoswipeParseHash = function() {
			var hash = window.location.hash.substring(1),
				params = {};

			if(hash.length < 5) {
				return params;
			}

			var vars = hash.split('&');
			for(var i = 0; i < vars.length; i++) {
				if(!vars[i]) {
					continue;
				}
				var pair = vars[i].split('=');
				if(pair.length < 2) {
					continue;
				}
				params[pair[0]] = pair[1];
			}

			if(params.gid) {
				params.gid = parseInt(params.gid, 10);
			}

			return params;
		};

		var openPhotoSwipe = function(index, galleryElement, disableAnimation, fromURL) {
			var pswpElement = document.querySelectorAll('.pswp')[0],
				gallery,
				options,
				items;

			items = parseThumbnailElements(galleryElement);

			// define options (if needed)
			options = {

				// define gallery index (for URL)
				galleryUID: galleryElement.getAttribute('data-pswp-uid'),

				getThumbBoundsFn: function(index) {
					// See Options -> getThumbBoundsFn section of documentation for more info
					var thumbnail = items[index].el.getElementsByTagName('img')[0], // find thumbnail
						pageYScroll = window.pageYOffset || document.documentElement.scrollTop,
						rect = thumbnail.getBoundingClientRect();

					return {
						x: rect.left,
						y: rect.top + pageYScroll,
						w: rect.width
					};
				}

			};

			// PhotoSwipe opened from URL
			if(fromURL) {
				if(options.galleryPIDs) {
					// parse real index when custom PIDs are used 
					// http://photoswipe.com/documentation/faq.html#custom-pid-in-url
					for(var j = 0; j < items.length; j++) {
						if(items[j].pid == index) {
							options.index = j;
							break;
						}
					}
				} else {
					// in URL indexes start from 1
					options.index = parseInt(index, 10) - 1;
				}
			} else {
				options.index = parseInt(index, 10);
			}

			// exit if index not found
			if(isNaN(options.index)) {
				return;
			}

			if(disableAnimation) {
				options.showAnimationDuration = 0;
			}
			options.tapToClose = true;

			// Pass data to PhotoSwipe and initialize it
			gallery = new PhotoSwipe(pswpElement, PhotoSwipeUI_Default, items, options);
			//			gallery.listen('imageLoadComplete',
			//				function(index, item) {
			//					var linkEl = item.el.children[0];
			//
			////					if(!linkEl.getAttribute('data-size') || linkEl.getAttribute('data-size') == 'auto') {
			//						var img = new Image();
			//						img.src = linkEl.getAttribute('href');
			//
			//						linkEl.setAttribute('data-size', img.naturalWidth + 'x' + img.naturalHeight);
			//						item.w = parseInt(img.naturalWidth, 10);
			//						item.h = parseInt(img.naturalHeight, 10);
			//						gallery.invalidateCurrItems();
			//						gallery.updateSize(true);
			////					}
			//				});

			gallery.listen('close', function() {
				if(typeof closeFn == 'function') {
					closeFn(gallery);
				}
			});
			gallery.init();
		};

		// loop through all gallery elements and bind events
		var galleryElements = document.querySelectorAll(gallerySelector);

		for(var i = 0, l = galleryElements.length; i < l; i++) {
			galleryElements[i].setAttribute('data-pswp-uid', i + 1);
			galleryElements[i].onclick = onThumbnailsClick;
		}

		// Parse URL and open gallery if it contains #&pid=3&gid=1
		var hashData = photoswipeParseHash();
		if(hashData.pid && hashData.gid) {
			openPhotoSwipe(hashData.pid, galleryElements[hashData.gid - 1], true, true);
		}
	},
	autoTextarea: function(elem, extra, maxHeight, callback) {
		extra = extra || 0;
		var isFirefox = !!document.getBoxObjectFor || 'mozInnerScreenX' in window,
			isOpera = !!window.opera && !!window.opera.toString().indexOf('Opera'),
			addEvent = function(type, callback) {
				elem.addEventListener ?
					elem.addEventListener(type, callback, false) :
					elem.attachEvent('on' + type, callback);
			},
			removeEvent = function(type, callback) {
				elem.removeEventListener ?
					elem.removeEventListener(type, callback, false) :
					elem.detachEvent('on' + type, callback);
			},
			getStyle = elem.currentStyle ? function(name) {
				var val = elem.currentStyle[name];
				if(name === 'height' && val.search(/px/i) !== 1) {
					var rect = elem.getBoundingClientRect();
					return rect.bottom - rect.top -
						parseFloat(getStyle('paddingTop')) -
						parseFloat(getStyle('paddingBottom')) + 'px';
				};
				return val;
			} : function(name) {
				return getComputedStyle(elem, null)[name];
			},
			minHeight = parseFloat(getStyle('height'));
		elem.style.resize = 'none';

		function _addEvent() {
			addEvent('propertychange', change);
			addEvent('input', change);
			addEvent('focus', change);
		}

		function _removeEvent() {
			removeEvent('propertychange', change);
			removeEvent('input', change);
			removeEvent('focus', change);
		}
		var change = function() {
			var scrollTop, height,
				padding = 0,
				style = elem.style;
			if(elem._length === elem.value.length) return;
			elem._length = elem.value.length;
			if(!isFirefox && !isOpera) {
				padding = parseInt(getStyle('paddingTop')) + parseInt(getStyle('paddingBottom'));
			};
			scrollTop = document.body.scrollTop || document.documentElement.scrollTop;
			elem.style.height = minHeight + 'px';
			if(elem.scrollHeight > minHeight) {
				if(maxHeight && elem.scrollHeight > maxHeight) {
					height = maxHeight - padding;
					style.overflowY = 'auto';
				} else {
					height = elem.scrollHeight - padding;
					style.overflowY = 'hidden';
				};
				style.height = height + extra + 'px';
				scrollTop += parseInt(style.height) - elem.currHeight;
				document.body.scrollTop = scrollTop;
				document.documentElement.scrollTop = scrollTop;
				elem.currHeight = parseInt(style.height);
			};
			if(typeof callback == "function") {
				callback(elem.value.length, elem);
			}
		};
		_removeEvent();
		_addEvent();
		change();

	}
}